-- MySQL dump 8.23
--
-- Host: localhost    Database: NOXQS
---------------------------------------------------------
-- Server version	3.23.58

--
-- Table structure for table `active_sessions`
--

DROP TABLE IF EXISTS active_sessions;
CREATE TABLE active_sessions (
  sid varchar(32) NOT NULL default '',
  name varchar(32) NOT NULL default '',
  val text,
  changed varchar(14) NOT NULL default '',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (name,sid),
  KEY changed (changed)
) TYPE=MyISAM;

--
-- Table structure for table `active_sessions_split`
--

DROP TABLE IF EXISTS active_sessions_split;
CREATE TABLE active_sessions_split (
  ct_sid varchar(32) NOT NULL default '',
  ct_name varchar(32) NOT NULL default '',
  ct_pos varchar(6) NOT NULL default '',
  ct_val text,
  ct_changed varchar(14) NOT NULL default '',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (ct_name,ct_sid,ct_pos),
  KEY ct_changed (ct_changed)
) TYPE=MyISAM;

--
-- Table structure for table `article`
--

DROP TABLE IF EXISTS article;
CREATE TABLE article (
  code int(11) NOT NULL auto_increment,
  title varchar(80) default '',
  text text,
  bottom text,
  posted datetime default '0000-00-00 00:00:00',
  postedby varchar(40) default '',
  summary text,
  articlegroup varchar(20) NOT NULL default '',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (code,articlegroup)
) TYPE=MyISAM;

--
-- Table structure for table `auth_user`
--

DROP TABLE IF EXISTS auth_user;
CREATE TABLE auth_user (
  user_id varchar(32) NOT NULL default '',
  username varchar(32) NOT NULL default '',
  password varchar(32) NOT NULL default '',
  perms varchar(255) default NULL,
  system varchar(10) default 'NONE',
  PRIMARY KEY  (user_id),
  UNIQUE KEY k_username (username)
) TYPE=MyISAM;

--
-- Table structure for table `auth_user_md5`
--

DROP TABLE IF EXISTS auth_user_md5;
CREATE TABLE auth_user_md5 (
  user_id varchar(32) NOT NULL default '',
  username varchar(32) NOT NULL default '',
  password varchar(32) NOT NULL default '',
  perms varchar(255) default NULL,
  system varchar(10) default 'NONE',
  emp_grp varchar(10) default NULL,
  language char(1) default 'N',
  PRIMARY KEY  (user_id),
  UNIQUE KEY k_username (username)
) TYPE=MyISAM;

--
-- Table structure for table `browse`
--

DROP TABLE IF EXISTS browse;
CREATE TABLE browse (
  name varchar(20) NOT NULL default '',
  sql text,
  maxlines int(4) default NULL,
  deletesql text,
  pri_key varchar(20) default NULL,
  system varchar(10) default 'NONE',
  db varchar(20) default NULL,
  next_layout varchar(50) default NULL,
  PRIMARY KEY  (name)
) TYPE=MyISAM;

--
-- Table structure for table `browse_detail`
--

DROP TABLE IF EXISTS browse_detail;
CREATE TABLE browse_detail (
  name varchar(20) NOT NULL default '',
  fieldname varchar(50) NOT NULL default '',
  header varchar(50) default NULL,
  columnorder int(4) NOT NULL default '0',
  width int(4) default '10',
  system varchar(10) default 'NONE',
  align varchar(10) default NULL,
  fieldcode text,
  PRIMARY KEY  (name,columnorder)
) TYPE=MyISAM;

--
-- Table structure for table `db_sequence`
--

DROP TABLE IF EXISTS db_sequence;
CREATE TABLE db_sequence (
  seq_name varchar(127) NOT NULL default '',
  nextid int(10) unsigned NOT NULL default '0',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (seq_name)
) TYPE=MyISAM;

--
-- Table structure for table `form`
--

DROP TABLE IF EXISTS form;
CREATE TABLE form (
  name varchar(20) NOT NULL default '',
  sql text,
  title varchar(40) default NULL,
  type varchar(10) default NULL,
  system varchar(10) default 'NONE',
  db varchar(20) default NULL,
  onsubmit varchar(50) default NULL,
  PRIMARY KEY  (name)
) TYPE=MyISAM;

--
-- Table structure for table `form_detail`
--

DROP TABLE IF EXISTS form_detail;
CREATE TABLE form_detail (
  name varchar(20) NOT NULL default '',
  fieldname varchar(40) NOT NULL default '',
  posx int(4) default NULL,
  posy int(4) default NULL,
  width int(4) default NULL,
  height int(4) default '1',
  fieldtype varchar(10) default NULL,
  text varchar(40) default NULL,
  sql text,
  pri_key varchar(40) default NULL,
  system varchar(10) default 'NONE',
  class varchar(20) default NULL,
  code text,
  perms varchar(15) default NULL,
  groups varchar(15) default NULL,
  PRIMARY KEY  (fieldname,name)
) TYPE=MyISAM;

--
-- Table structure for table `gallery`
--

DROP TABLE IF EXISTS gallery;
CREATE TABLE gallery (
  name varchar(20) NOT NULL default '',
  title varchar(80) default NULL,
  description text,
  system varchar(10) default 'NONE',
  type varchar(10) default 'public',
  PRIMARY KEY  (name)
) TYPE=MyISAM;

--
-- Table structure for table `gallery_images`
--

DROP TABLE IF EXISTS gallery_images;
CREATE TABLE gallery_images (
  name varchar(20) NOT NULL default '',
  filename varchar(50) NOT NULL default '',
  system varchar(10) default 'NONE',
  caption text,
  username text,
  ownername text,
  PRIMARY KEY  (name,filename)
) TYPE=MyISAM;

--
-- Table structure for table `groups`
--

DROP TABLE IF EXISTS groups;
CREATE TABLE groups (
  groups varchar(32) NOT NULL default '',
  groupname varchar(32) default '',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (groups)
) TYPE=MyISAM;

--
-- Table structure for table `items`
--

DROP TABLE IF EXISTS items;
CREATE TABLE items (
  name varchar(20) NOT NULL default '',
  plugin varchar(20) default '',
  title varchar(80) default '',
  text text,
  link varchar(200) default NULL,
  perm varchar(30) default '',
  cached char(1) binary NOT NULL default 'N',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (name),
  KEY plugin (plugin)
) TYPE=MyISAM;

--
-- Table structure for table `layout`
--

DROP TABLE IF EXISTS layout;
CREATE TABLE layout (
  layoutgroup varchar(20) NOT NULL default '',
  layoutorder int(4) NOT NULL default '0',
  layoutparam varchar(40) default '',
  place varchar(20) default '',
  name varchar(20) NOT NULL default '',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (layoutgroup,layoutorder),
  KEY name (name)
) TYPE=MyISAM;

--
-- Table structure for table `links`
--

DROP TABLE IF EXISTS links;
CREATE TABLE links (
  linkgroup varchar(20) NOT NULL default '',
  name varchar(20) NOT NULL default '',
  description text,
  link text,
  title varchar(40) default '',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (linkgroup,name)
) TYPE=MyISAM;

--
-- Table structure for table `login_stats`
--

DROP TABLE IF EXISTS login_stats;
CREATE TABLE login_stats (
  user_id varchar(32) default NULL,
  login_time datetime default NULL,
  system varchar(10) default NULL
) TYPE=MyISAM;

--
-- Table structure for table `menuitems`
--

DROP TABLE IF EXISTS menuitems;
CREATE TABLE menuitems (
  name varchar(20) NOT NULL default '',
  menuorder int(4) NOT NULL default '0',
  menutext varchar(80) default '',
  page varchar(250) default NULL,
  param varchar(40) default '',
  level int(2) default NULL,
  system varchar(10) default 'NONE',
  PRIMARY KEY  (name,menuorder)
) TYPE=MyISAM;

--
-- Table structure for table `report`
--

DROP TABLE IF EXISTS report;
CREATE TABLE report (
  name varchar(20) NOT NULL default '',
  sql text,
  db varchar(20) default NULL,
  system varchar(10) default 'NONE',
  perm varchar(30) default NULL,
  title varchar(250) default NULL,
  PRIMARY KEY  (name)
) TYPE=MyISAM;

--
-- Table structure for table `report_detail`
--

DROP TABLE IF EXISTS report_detail;
CREATE TABLE report_detail (
  name varchar(20) NOT NULL default '',
  fieldname varchar(50) NOT NULL default '',
  header varchar(50) default NULL,
  columnorder int(4) NOT NULL default '0',
  width int(4) default '10',
  align varchar(10) default NULL,
  fieldcode text,
  system varchar(10) default 'NONE',
  fieldsql longtext,
  PRIMARY KEY  (name,columnorder)
) TYPE=MyISAM;

--
-- Table structure for table `user_group`
--

DROP TABLE IF EXISTS user_group;
CREATE TABLE user_group (
  username varchar(32) default NULL,
  groups varchar(32) default NULL,
  system varchar(10) default 'NONE'
) TYPE=MyISAM;

--
-- Table structure for table `user_ips`
--

DROP TABLE IF EXISTS user_ips;
CREATE TABLE user_ips (
  username varchar(32) default NULL,
  ip varchar(32) default NULL,
  system varchar(10) default 'NONE'
) TYPE=MyISAM;

