/*
 *  Browse Plugin Class
 *
 *  Copyright (c) 2002 Willy De la Court <wdl@linux-lovers.be>
 *
 */
?><?php
class Browse extends PlainPlugin {
	var $brw_width = 5;
	var $brw_query = "";
	var $brw_maxlines = 10;
	var $brw_charwidth = 10;
	var $brw_name = "";
	var $brw_fieldcount = 0;
	var $brw_widths = array();
	var $brw_headings = array();
	var $brw_fields = array();
	var $brw_align = array();
	var $brw_fieldcode = array();
	var $brw_posname = "brw_pos";
	var $brw_database = "";
	var $brw_next_layout = "";
	var $brw_field;
	var $brw_pri_key;
	var $global = array();

	function Browse($brw_name = "") {
		$this->brw_name = $brw_name;
		$this->add_global("HTTP_GET_VARS");
		$this->add_global("HTTP_POST_VARS");
		$this->add_global("sess");
		$this->add_global("brw_pos");
		$this->add_global("brw_" . $this->brw_name . "_pos");

	}

	function add_quotes($val) { return("\"" . $val . "\""); }

	function add_global($g) { $this->global[$g] = ""; }

	function get_global(&$g) {
		foreach($this->global as $k =>$v) {
			$g[$k] = "";
		}
	}

	function get_data() {
		$db = new DB_SDS;
		$db->query("select * from browse where name = '" . $this->brw_name . "'");
		if($db->next_record()) {
			$this->set_query($db->f("sql"), $db->f("maxlines"));
			$this->set_database($db->f("db"));
			$this->set_next_layout($db->f("next_layout"));
			$temp = $db->f('pri_key');
			if( !empty($temp) ) {
				$this->set_field_pri_key($db->f('pri_key'), $this->brw_name . "_prikey");
			}
			$db->query("select * from browse_detail where name = '" . $this->brw_name . "' order by columnorder");
			while($db->next_record()) {
				$this->add_column($db->f("header"), $db->f("fieldname"), $db->f("width"), $db->f("align"), $db->f("fieldcode"));
			}
		}
	}

	function set_field_pri_key($field, $pri_key) {
		$this->brw_field = $field;
		$this->brw_pri_key = $pri_key;
		$this->add_global($this->brw_name . "_prikey");
	}

	function get_width() {
		return $this->brw_width;
	}

	function get_height() {
		return($this->brw_maxlines + 2);
	}

	function set_posname($brw_posname) {
		$this->brw_posname = $brw_posname;
	}

	function set_database($brw_database) {
		$this->brw_database = $brw_database;
	}

	function set_query($query, $maxlines = 10) {
		$this->brw_query = $query;
		$this->brw_maxlines = $maxlines;
	}

	function set_next_layout($next_layout) {
		$this->brw_next_layout = $next_layout;
	}

	function add_column($header, $fieldname, $width, $align = "left", $fieldcode = "") {
		$this->brw_fieldcount++;
		$this->brw_headings[$this->brw_fieldcount] = $header;
		$this->brw_fields[$this->brw_fieldcount] = $fieldname;
		$this->brw_widths[$this->brw_fieldcount] = $width;
		$this->brw_align[$this->brw_fieldcount] = $align;
		$this->brw_fieldcode[$this->brw_fieldcount] = $fieldcode;
		$this->brw_width = $this->brw_width + $width;
	}

	function show() {
		global $brw_pos;

		$res = "";
		$res .= $this->show_headers();
		if( ! empty($this->brw_database) ) {
			$db = new DB_DATA;
			if( $this->brw_database != "%data%" ) {
				$db->query("USE " . $this->brw_database);
			}
		} else {
			$db = new DB_SDS;
		}
		eval("\$query = \"$this->brw_query\";");
		if( $this->brw_maxlines > 0 )
			$db->query($query . " limit " . $brw_pos . "," . $this->brw_maxlines);
		else
			$db->query($query);
		$cnt = 1;
		while($db->next_record()) {
			$res .= $this->show_line($db, $cnt);
			$cnt++;
		}
		if( $this->brw_maxlines > 0 ) {
			$brw_empty = 0;
			while($cnt <= $this->brw_maxlines) {
				$res .= $this->show_empty_line($cnt);
				$cnt++;
				$brw_empty = 1;
			}
		} else {
			$brw_empty = -1;
		}
		$res .= $this->show_footer($brw_empty);
		if( ! empty($this->brw_database) ) {
			$database = $db->SDS_Database;
			$db->query("USE " . $database);
		}
		return $res;
	}

	function show_headers() {
		global $brw_pos, $show;

		$res = "";
		$res .= "<table width=" . ($this->brw_width * $this->brw_charwidth) . " cellspacing=0 cellpadding=1 border=0>\n";
		$res .= "<tr class=browseheader>\n";
		for( $i = 1; $i <= $this->brw_fieldcount; $i++ ) {
			$res .= "<td class=browseheader nowrap width=" . ($this->brw_widths[$i] * $this->brw_charwidth) . " align=" . $this->brw_align[$i] . ">" . $this->brw_headings[$i] . "</td>\n";
		}
		if(empty($brw_pos) || $brw_pos < 0)
			$brw_pos = 0;
		if($brw_pos == 0)
			$res .= "<td class=browseheader width=50 align=right>&nbsp;</td>\n";
		else
			$res .= "<td class=browseheader width=50 align=right><a class=browseheader href=" . $PHP_SELF . "?show=" . $show . "&" . $this->brw_posname . "=" . ($brw_pos - $this->brw_maxlines). ">Prev</a></td>\n";
		$res .= "</tr>\n";
		return $res;
	}

	function show_line($db, $cnt) {
		global $PHP_SELF, $theme, $brw_pos, $show;

		$localshow = $show;
		if( ! empty($this->brw_next_layout) && $this->brw_next_layout != "default") {
			$localshow = $this->brw_next_layout;
		}

		$res = "";
		if(($cnt % 2) == 0)
			$res .= "<tr class=browse_even>\n";
		else
			$res .= "<tr class=browse_odd>\n";
		for( $i = 1; $i <= $this->brw_fieldcount; $i++ ) {
			if( ! empty($this->brw_fields[$i]) ) {
				$res .= "<td align=" . $this->brw_align[$i] . ">" . $db->f($this->brw_fields[$i]) . "</td>\n";
			} else {
				$res .= "<td align=" . $this->brw_align[$i] . ">";
				eval($this->brw_fieldcode[$i]);
				$res .= "</td>\n";
			}
		}
		if( !empty($this->brw_pri_key) ) {
			$res .= "<td align=right>";
			if( $GLOBALS[$this->brw_pri_key] == $db->f($this->brw_field) ) {
				$res .= "<a href=" . $PHP_SELF .
					"?show=" . $localshow . "&" . $this->brw_pri_key . "=>";
				$res .= "<img border=0 src=themes/images/tree_fopen.gif></a>";
			} else {
				$res .= "<a href=" . $this->add_quotes($PHP_SELF .
					"?show=" . $localshow . "&" . $this->brw_pri_key . "=" . str_replace("&", "%26", $db->f($this->brw_field))) . ">";
				$res .= "<img border=0 src=themes/images/tree_fclosed.gif></a>";
			}
			$res .= "</td>\n";
		} else {
			$res .= "<td>&nbsp;</td>\n";
		}
		$res .= "</tr>\n";
		return $res;
	}

	function show_empty_line($cnt) {
		$res = "";
		if(($cnt % 2) == 0)
			$res .= "<tr class=browse_even>\n";
		else
			$res .= "<tr class=browse_odd>\n";
		for( $i = 1; $i <= $this->brw_fieldcount; $i++ ) {
			$res .= "<td>&nbsp;</td>\n";
		}
		$res .= "<td>&nbsp;</td>\n";
		$res .= "</tr>\n";
		return $res;
	}

	function show_footer($brw_empty) {
		global $brw_pos, $show;

		$res = "";
		if( $brw_empty >= 0 ) {
			$res .= "<tr class=browsefooter>\n";
			for($i = 1;$i <= $this->brw_fieldcount; $i++) {
				$res .= "<td>&nbsp;</td>\n";
			}
			if($brw_empty == 0)
				$res .= "<td align=right><a class=browseheader href=" . $PHP_SELF . "?show=" . $show . "&" . $this->brw_posname . "=" . ($brw_pos + $this->brw_maxlines). ">Next</a></td>\n";
			else
				$res .= "<td align=right>&nbsp;</td>\n";
		}
		$res .= "</table>\n";
		return $res;
	}

	function generate_global() {
		$res = "";
		$prik = "";
		$name = "\$brw_" . $this->brw_name;
		$res .= "if( isset(\$HTTP_GET_VARS[" . $this->add_quotes("brw_" . $this->brw_name . "_pos") . "]) ) {";
		$res .= " " . $name . "_pos=\$HTTP_GET_VARS[" . $this->add_quotes("brw_" . $this->brw_name . "_pos") . "];";
		$res .= " }\n";
		$res .= "\$sess->register(" . $this->add_quotes("brw_" . $this->brw_name . "_pos") . ");\n";
		if( !empty($this->brw_pri_key) ) {
			$res .= "if( isset(\$HTTP_GET_VARS[" . $this->add_quotes($this->brw_pri_key) . "]) ) {";
			$res .= " \$" . $this->brw_pri_key . "=\$HTTP_GET_VARS[" . $this->add_quotes($this->brw_pri_key) . "];";
			$res .= " }\n";
			$res .= "\$sess->register(" . $this->add_quotes($this->brw_pri_key) . ");\n";
		}
		return $res;
	}

	function generate() {
		$res = "";
		$res .= "<?php\n";
		$name = "\$brw_" . $this->brw_name;
		$res .= "\$brw_pos=" . $name . "_pos;\n";
		$res .= $name . "= &new Browse();\n";
		$res .= $name . "->set_field_pri_key(" . $this->add_quotes($this->brw_field) . ", " . $this->add_quotes($this->brw_pri_key) . ");\n";
		$res .= $name . "->set_posname(" . $this->add_quotes("brw_" . $this->brw_name . "_pos") . ");\n";
		$res .= $name . "->set_next_layout(" . $this->add_quotes($this->brw_next_layout) . ");\n";

		for($cnt = 1 ; $cnt <= $this->brw_fieldcount; $cnt++) {
			$res .= $name . "->add_column(" . $this->add_quotes($this->brw_headings[$cnt]) . ", " .
					$this->add_quotes($this->brw_fields[$cnt]) . ", " .
					$this->brw_widths[$cnt] . ", " .
					$this->add_quotes($this->brw_align[$cnt]) . ", " .
					$this->add_quotes(str_replace("\$", "\\\\\$", addslashes($this->brw_fieldcode[$cnt]))) .
					");\n";
		}
		if( ! empty($this->brw_database) ) {
			$res .= $name . "->set_database(" . $this->add_quotes($this->brw_database) . ");\n";
		}
		$res .= $name . "->set_query(" . $this->add_quotes($this->brw_query) . ", " . $this->brw_maxlines . ");\n";
		$res .= "echo " . $name . "->show();\n";
		$res .= "?>";
		return $res;
	}
}



