/*
 *  Form Plugin Class
 *
 *  Copyright (c) 2002 Willy De la Court <wdl@linux-lovers.be>
 *
 */
?><?php
register_plugin("Form", "Y", "Y");
register_plugin("FormGroup", "Y", "Y");

function create_form($form_name, $table, $database = "") {
	if( ! empty($form_name) && ! empty($table) ) {
		$db = new DB_SDS;
		$db_data = new DB_DATA;
		$db->query("select name from form where name = '$form_name'");
		$db->next_record();
		$form_n = $db->f("name");
		if( $form_n != $form_name ) {
			$db->query("delete from form_detail where name = '$form_name'");
			if( ! empty($database) && $database != "%data%" ) {
				$db_data->query("USE " . $database);
			}
			$db_data->query("describe " . $table);
			if( ! empty($database) ) {
				$orig_database = $db->SDS_Database;
				$db->query("USE " . $orig_database);
			}
			$cnt = 1;
			$sql = "insert into form (name, type, title, db, sql) ";
			$sql .= "values ('$form_name', 'Form', 'Input form for table $table', '$database', 'select * from $table')";
			$db->query($sql);
			while($db_data->next_record()) {
				$fieldname = $db_data->f("Field");
				$type = $db_data->f("Type");
				ereg("\(([0-9]+)\)", $type, $width);
				$w = $width[1];
				$sql = "insert into form_detail (name, fieldname, fieldtype, text, posx, posy, width) ";
				$sql .= "values ('$form_name', 'lbl_$fieldname', 'label', '$fieldname', 1, $cnt, 10)";
				$db->query($sql);
				$sql = "insert into form_detail (name, fieldname, fieldtype, text, posx, posy, width) ";
				$sql .= "values ('$form_name', '$fieldname', 'input', '$fieldname', 11, $cnt, $w)";
				$db->query($sql);
				$cnt = $cnt + 1;
			}
			echo "Form " . $form_name . " created\n";
		} else {
			echo "Form " . $form_name . " Already exists\n";
		}
	}
}

class Form extends PlainPlugin {
	var $frm_name;
	var $frm_query;
	var $frm_formwidth = 0;
	var $frm_height = 0;
	var $frm_cellwidth = 10;
	var $frm_array = array();
	var $frm_type = "";
	var $onSubmit = "";
	var $var_fill = "";
	var $var_conv = "";
	var $var_fill_empty = "";
	var $var_fill_cond = "";
	var $processing = "";
	var $classname = "Form";
	var $adm_form = "form_itemedit";
	var $adm_var = "form_items_prikey";
	var $frm_database = "";
	var $form;
	var $title;
	var $link;
	var $file = "form.ihtml";
	var $cacheable = "Y";
	var $editable = "Y";


	function Form( $record = array(), $createcache = "N") { $this->PlainPlugin($record, $createcache); }

	function set_vars( $record ) {
		$this->frm_name = $record["name"];
		$this->frm_type = $record["link"];
		$this->title = $record["title"];
		$this->vars["TITLE"] = $record["title"];
		$this->vars["ADMIN"] = $this->admin_button();
	}

	function add_quotes($val) {
		return("\"" . $val . "\"");
	}

	function show() {
		if( $this->cached == "Y" ) {
			return($this->show_cache());
		} else {
			if($this->createcache == "Y") {
				$this->get_data();
				$res = "";
				$res .= "<?php\n";
				$res .= $this->make_global();
				$res .= $this->generate_global();
				$res .= "?>\n";
				$res .= $this->generate();
			} else {
				$res = "Warning: FORMS must be cached";
			}
			$this->vars["FORM"] = $res;
			$t =& new Template($this->theme, "remove");
			$t->set_file(array("layout" => $this->file));
			$t->set_var($this->vars);
			$t->parse("out", array("layout"));
			return $t->get("out");
		}
	}

	function get_data() {
		$db = new DB_SDS;
		$db->query("select * from form where name = '" . $this->frm_name . "'");
		if($db->next_record()) {
			$this->set_query($db->f('sql'));
			$this->set_title($db->f('title'));
			$this->set_database($db->f('db'));
			$this->onSubmit = $db->f('onsubmit');
			$db->query("select * from form_detail where name = '" . $this->frm_name . "' order by posy, posx");
			if( $db->num_rows()>0 ) {
				while($db->next_record()) {
					$this->add_field( $db->f("fieldname"),
									$db->f("perms"),
									$db->f("groups"),
									$db->f("posx"),
									$db->f("posy"),
									$db->f("width"),
									$db->f("height"),
									$db->f("text"),
									$db->f("fieldtype"),
									$db->f("sql"),
									$db->f("code"),
									$db->f("pri_key"),
									$db->f("class") );
				}
				$db->seek(0);
				while($db->next_record()) {
					$this->add_button_field( $db->f("fieldname"),
									$db->f("perms"),
									$db->f("groups"),
									$db->f("posx"),
									$db->f("posy"),
									$db->f("width"),
									$db->f("height"),
									$db->f("text"),
									$db->f("fieldtype"),
									$db->f("sql"),
									$db->f("code"),
									$db->f("pri_key"),
									$db->f("class") );
				}
			}
		}
	}

	function make_global() {
		$g = array();
		$this->get_global($g);
		$res = "global \$PHP_SELF, \$show, \$perm";
		$cnt = 1;
		foreach($g as $k => $v) {
			$res .= ", $" . $k;
			$cnt++;
			if($cnt > 3) {
				$res .= "\n";
				$cnt = 0;
			}
		}
		$res .= ";\n";
		return $res;
	}

	function start_row() {
		$res = "";
		$res .= "<tr class=formbody>\n";
		return $res;
	}

	function end_row() {
		$res = "";
		$res .= "</tr>\n";
		return $res;
	}

	function start_form() {
		global $PHP_SELF;

		$res = "";
		$res .= "<?php\n";
		if( !empty($this->frm_query) ) {
			$res .= "\$type = \"\";\n";
			if( ! empty($this->frm_database)  ) {
				$res .= "\$db = new DB_DATA;\n";
				if( $this->frm_database != "%data%") {
					$res .= "\$db->query(" . $this->add_quotes("USE " . $this->frm_database) . ");\n";
				}
			} else {
				$res .= "\$db = new DB_SDS;\n";
			}
			$res .= "\$db->query(" . $this->add_quotes($this->frm_query) . ");\n";
			$res .= "if( \$db->next_record() ) {\n";
			$res .= $this->var_fill;
			$res .= "	\$type = " . $this->add_quotes($this->frm_type) . ";\n";
			$res .= "}\n";
		} else {
			$res .= "\$type = \"edit\";\n";
			if( $this->frm_type != "noclear" ) {
				$res .= $this->var_fill_empty;
			}
		}
		$res .= "?>\n";
		$onSubmit = "";
		if( ! empty($this->onSubmit) ) {
			$onSubmit = " onSubmit=" . $this->add_quotes($this->onSubmit);
		}
		if( $this->frm_type == "edit" || $this->frm_type == "noclear") {
			$res .= "<form name=" . $this->frm_name . " action=" . $PHP_SELF . "?show=<?php echo \$show; ?> method=post" . $onSubmit . ">\n";
		}
		$res .= "<table valign=top cols=" . ($this->frm_formwidth) .
			" width=" . (($this->frm_formwidth) * $this->frm_cellwidth) .
			" border=0 cellspacing=0 cellpadding=0>\n";
		if( ! empty($this->title) ) {
			$res .= "<tr class=formheader>";
			$res .= "<td class=formheader nowrap colspan=" . $this->frm_formwidth . ">";
			$res .= $this->title;
			$res .= "</td>\n";
			$res .= "</tr>\n";
		}
		return $res;
	}

	function end_form() {
		$res = "";
		$res .= "<tr>\n";
		for($cnt = 1; $cnt <= $this->frm_formwidth; $cnt++) {
			$res .= "<td width=" . $this->frm_cellwidth . "></td>";
		}
		$res .= "</tr>\n";
		if( $this->frm_type == "edit" || $this->frm_type == "noclear") {
			$res .= "</form>\n";
		}
		$res .= "</table>\n";
		if( ! empty($this->frm_database) ) {
			$db = new DB_DATA;
			$database = $db->SDS_Database;
			$res .= "<?php\n";
			$res .= "\$db = new DB_DATA;\n";
			$res .= "\$db->query(" . $this->add_quotes("USE " . $database) . ");\n";
			$res .= "?>\n";
		}
		return $res;
	}

	function set_query($query) {
		$this->frm_query = $query;
	}

	function set_title($title) {
		$this->title = $title;
	}

	function set_database($db) {
		$this->frm_database = $db;
	}

	function fill_array(&$obj) {
		$posx = $obj->get_posx();
		$posy = $obj->get_posy();
		$width = $obj->get_width();
		$height = $obj->get_height();

		for( $y = $posy; $y < $posy + $height; $y++ ) {
			for( $x = $posx; $x < $posx + $width; $x++ ) {
				$this->frm_array[$y][$x] = "X";
			}
		}
		$this->frm_array[$posy][$posx] =& $obj;
	}

	function add_var_fill($var, $field) {
		$this->var_fill .= "	$" . $var . "=\$db->f(\"" . $field . "\");\n";
		$this->var_fill_empty .= "	$" . $var . "=\"\";\n";
	}
	
	function add_var_fill_cond($var, $field, $permission, $groups) {
		if( !empty($permission) || !empty($groups) ) {
				$cond = "";
			if( !empty($permission) )
				$cond = "! \$perm->have_perm(\"" . $permission . "\") ";
			if( !empty($groups) ) {
				if( !empty($cond) )
					$cond .= " || ";
				$cond .= "! \$groups->check(\"" . $this->groups . "\")";
			}
			$this->var_fill_cond .= "	if( " . $cond . " ) {\n";
			$this->var_fill_cond .= "		global \$_POST, $" . $var .";\n";
			$this->var_fill_cond .= "		$" . $var . "=\$db->f(\"" . $field . "\");\n";
			$this->var_fill_cond .= "		\$_POST[\"" . $var . "\"]=\$db->f(\"" . $field . "\");\n";
			$this->var_fill_cond .= "	}\n";
		}
	}

	function add_var_conv($var, $conv) {
		$this->var_conv .= "	$" . $var . "=" . $conv . ";\n";
	}

	function add_field($fieldname, $permission, $groups, $posx, $posy, $width, $height, $text, $fieldtype, $sql, $code, $pri_key, $ssclass) {
		switch ($fieldtype) {
			case "label":
				$this->fill_array(new Form_label($this->frm_name, $fieldname, $permission, $groups, $posx, $posy, $text, $ssclass, $width));
				break;
			case "input":
				if( !empty($pri_key) ) {
					$this->add_var_fill($pri_key, $fieldname);
				}
				$this->fill_array(new Form_input($this->frm_name, $fieldname, $permission, $groups, $posx, $posy, $pri_key, $ssclass, $width));
				$this->add_var_fill("thisform" . "_" . $fieldname, $fieldname);
				$this->add_var_fill_cond("thisform" . "_" . $fieldname, $fieldname, $permission, $groups);
				break;
			case "date":
				if( !empty($pri_key) ) {
					$this->add_var_fill($pri_key, $fieldname);
				}
				$this->fill_array(new Form_date($this->frm_name, $fieldname, $permission, $groups, $posx, $posy, $pri_key, $ssclass, $width));
				$this->add_var_fill("thisform" . "_" . $fieldname, $fieldname);
				$this->add_var_fill_cond("thisform" . "_" . $fieldname, $fieldname, $permission, $groups);
				$this->add_var_conv("thisform" . "_" . $fieldname, "cdate_sql($" . "thisform" . "_" . $fieldname . ")");
				break;
			case "password":
				if( !empty($pri_key) ) {
					$this->add_var_fill($pri_key, $fieldname);
				}
				$this->fill_array(new Form_password($this->frm_name, $fieldname, $permission, $groups, $posx, $posy, $pri_key, $ssclass, $width));
				$this->add_var_fill("thisform" . "_" . $fieldname, $fieldname);
				$this->add_var_fill_cond("thisform" . "_" . $fieldname, $fieldname, $permission, $groups);
				break;
			case "edit":
				$this->fill_array(new Form_edit($this->frm_name, $fieldname, $permission, $groups, $posx, $posy, $ssclass, $width, $height));
				$this->add_var_fill("thisform" . "_" . $fieldname, $fieldname);
				$this->add_var_fill_cond("thisform" . "_" . $fieldname, $fieldname, $permission, $groups);
				break;
			case "value":
				if( !empty($pri_key) ) {
					$this->add_var_fill($pri_key, $fieldname);
				}
				$this->fill_array(new Form_value($this->frm_name, $fieldname, $permission, $groups, $posx, $posy, $pri_key, $ssclass, $width));
				$this->add_var_fill("thisform" . "_" . $fieldname, $fieldname);
				break;
			case "valuedate":
				if( !empty($pri_key) ) {
					$this->add_var_fill($pri_key, $fieldname);
				}
				$this->fill_array(new Form_valuedate($this->frm_name, $fieldname, $permission, $groups, $posx, $posy, $pri_key, $ssclass, $width));
				$this->add_var_fill("thisform" . "_" . $fieldname, $fieldname);
				break;
			case "option":
				$this->fill_array(new Form_option($this->frm_name, $fieldname, $permission, $groups, $posx, $posy, $text, $sql, $ssclass, $width, 1, $this->frm_database));
				$this->add_var_fill("thisform" . "_" . $fieldname, $fieldname);
				$this->add_var_fill_cond("thisform" . "_" . $fieldname, $fieldname, $permission, $groups);
				break;
			case "browse":
				$b = &new Form_browse($this->frm_name, $fieldname, $permission, $groups, $posx, $posy, $ssclass, $width, $height);
				$width = $b->get_width();
				$height = $b->get_height();
				$this->fill_array($b);
				break;
			case "code":
				$this->fill_array(new Form_code($this->frm_name, $fieldname, $permission, $groups, $posx, $posy, $sql, $ssclass, $width, $height));
				break;
			case "g_code":
				$this->fill_array(new Form_g_code($this->frm_name, $fieldname, $permission, $groups, $posx, $posy, $sql, $ssclass, $width, $height));
				$this->add_processing_g_code($sql);
				break;
		}
		$this->frm_formwidth = max($this->frm_formwidth, $posx + $width - 1);
		$this->frm_formheight = max($this->frm_formheight, $posy + $height - 1);
	}

	function add_button_field($fieldname, $permission, $groups, $posx, $posy, $width, $height, $text, $fieldtype, $sql, $code, $pri_key, $ssclass) {
		switch ($fieldtype) {
			case "button":
				$this->fill_array(new Form_button($this->frm_name, $fieldname, $permission, $groups, $posx, $posy, $text, $ssclass, $width));
				$this->add_processing($this->frm_name . "_submit", $text, $sql);
				$this->add_processing_code($this->frm_name . "_submit", $text, $code);
				break;
			case "c_button":
				$this->fill_array(new Form_button($this->frm_name, $fieldname, $permission, $groups, $posx, $posy, $text, $ssclass, $width));
				$this->add_processing_code($this->frm_name . "_submit", $text, $sql);
				$this->add_processing_code($this->frm_name . "_submit", $text, $code);
				break;
		}
		$this->frm_formwidth = max($this->frm_formwidth, $posx + $width - 1);
		$this->frm_formheight = max($this->frm_formheight, $posy + $height - 1);
	}

	function get_width() {
		return $this->frm_formwidth;
	}

	function get_height() {
		return $this->frm_formheight;
	}

	function add_processing($var, $value, $sql) {
		if( !empty($sql) ) {
			$this->processing .= "if($" . $var . "==" . $this->add_quotes($value) . " ) {\n";
			$this->processing .= "	" . $this->var_conv;
			if( ! empty($this->frm_database) ) {
				$this->processing .= "	\$db = new DB_DATA;\n";
				if( $this->frm_database != "%data%" ) {
					$this->processing .= "	\$db->query(" . $this->add_quotes("USE " . $this->frm_database) . ");\n";
				}
			} else {
				$this->processing .= "	\$db = new DB_SDS;\n";
			}
			// Get the original record so we can fill in the fields that are not show on the form
			// due to permission or group restrictions
			if( ! empty($this->var_fill_cond) ) {
				$this->processing .= "	\$db->query(" . $this->add_quotes($this->frm_query) . ");\n";
				$this->processing .= "	\$db->next_record();\n";
				$this->processing .= "	" . $this->var_fill_cond;
			}
			$this->processing .= "	\$db->query(" . $this->add_quotes($sql) . ");\n";
			$this->processing .= "	\$db->show_msg(" . $this->add_quotes("%d record(s) updated") . ");\n";
			if( ! empty($this->frm_database) ) {
				$db = new DB_DATA;
				$database = $db->SDS_Database;
				$this->processing .= "	\$db->query(" . $this->add_quotes("USE " . $database) . ");\n";
			}
			$this->processing .= "}\n";
		}
	}

	function add_processing_code($var, $value, $code) {
		if( !empty($code) ) {
			$this->processing .= "if($" . $var . "==" . $this->add_quotes($value) . " ) {\n";
			// Get the original record so we can fill in the fields that are not show on the form
			// due to permission or group restrictions
			if( ! empty($this->var_fill_cond) ) {
				if( ! empty($this->frm_database) ) {
					$this->processing .= "	\$db = new DB_DATA;\n";
					if( $this->frm_database != "%data%" ) {
						$this->processing .= "	\$db->query(" . $this->add_quotes("USE " . $this->frm_database) . ");\n";
					}
				} else {
					$this->processing .= "	\$db = new DB_SDS;\n";
				}
				$this->processing .= "	\$db->query(" . $this->add_quotes($this->frm_query) . ");\n";
				$this->processing .= "	\$db->next_record();\n";
				$this->processing .= "	" . $this->var_fill_cond;
			}
			$this->processing .= "	" . $code . "\n";
			$this->processing .= "}\n";
		}
	}

	function add_processing_g_code($code) {
		$this->processing .= $code . "\n";
	}

	function get_global(&$g) {
		for($y = 1;$y <= $this->frm_formheight; $y++) {
			for($x = 1;$x <= $this->frm_formwidth; $x++) {
				if( is_object($this->frm_array[$y][$x]) ) {
					$this->frm_array[$y][$x]->get_global($g);
				}
			}
		}
	}

	function generate_global() {
		$res = "";
		$res .= $this->processing;
		for($y = 1;$y <= $this->frm_formheight; $y++) {
			for($x = 1;$x <= $this->frm_formwidth; $x++) {
				if( is_object($this->frm_array[$y][$x]) ) {
					$res .= $this->frm_array[$y][$x]->generate_global($this->frm_type);
				}
			}
		}
		return $res;
	}

	function generate() {
		$res = "";
		$res .= $this->start_form();
		for($y = 1;$y <= $this->frm_formheight; $y++) {
			$res .= $this->start_row();
			$cnt = 0;
			for($x = 1;$x <= $this->frm_formwidth; $x++) {
				if( isset($this->frm_array[$y][$x]) ) {
					if($cnt != 0) {
						$res .= "<td class=formbody colspan=" . $cnt . ">&nbsp;</td>\n";
						$cnt = 0;
					}
					if( is_object($this->frm_array[$y][$x]) ) {
						$res .= $this->frm_array[$y][$x]->generate_element($this->frm_type);
					}
				} else {
					$cnt++;
				}
			}
			if($cnt != 0) {
				$res .= "<td class=formbody colspan=" . $cnt . ">&nbsp;</td>\n";
				$cnt = 0;
			}
			$res .= $this->end_row();
		}
		$res .= $this->end_form();
		return $res;
	}

	function msg($msg) {
		$tmsg = "";
		$tmsg .= "<table border=1 bgcolor=#eeeeee align=center cellspacing=0 cellpadding=4 width=100%>\n";
		$tmsg .= "<tr>\n";
		$tmsg .= "<td><font color=#FF2020>" . $msg . "</font></td>\n";
		$tmsg .= "</tr>\n";
		$tmsg .= "</table>\n";
		echo $tmsg;
	}

}

class FormGroup extends Form {
	var $classname = "FormGroup";

	function FormGroup( $record = array(), $createcache = "N") { $this->Form($record, $createcache); }

	function add_field($fieldname, $permission, $groups, $posx, $posy, $width, $height, $text, $fieldtype, $sql, $code, $pri_key, $ssclass) {
		switch ($fieldtype) {
			case "label":
				$this->fill_array(new Form_label($this->frm_name, $fieldname, $permission, $groups, $posx, $posy, $text, $ssclass, $width));
				break;
			case "browse":
				$this->fill_array(new FormGroup_browse($this->frm_name, $fieldname, $permission, $groups, $posx, $posy, $ssclass, $width, $height));
				break;
			case "form":
				$this->fill_array(new FormGroup_form($this->frm_name, $fieldname, $permission, $groups, $posx, $posy, $text, $ssclass, $width, $height));
				break;
			case "formgroup":
				$this->fill_array(new FormGroup_formgroup($this->frm_name, $fieldname, $permission, $groups, $posx, $posy, $text, $ssclass, $width, $height));
				break;
			case "code":
				$this->fill_array(new Form_code($this->frm_name, $fieldname, $permission, $groups, $posx, $posy, $sql, $ssclass, $width, $height));
				break;
			case "g_code":
				$this->fill_array(new Form_g_code($this->frm_name, $fieldname, $permission, $groups, $posx, $posy, $sql, $ssclass, $width, $height));
				$this->add_processing_g_code($sql);
				break;
			case "case":
				$this->fill_array(new FormGroup_case($this->frm_name, $fieldname, $permission, $groups, $posx, $posy, $pri_key, $sql, $ssclass, $width, $height));
				break;
		}
		$this->frm_formwidth = max($this->frm_formwidth, $posx + $width - 1);
		$this->frm_formheight = max($this->frm_formheight, $posy + $height - 1);
	}

	function start_form() {
		$res = "";
		//$res .= "<table valign=top cols=" . ($this->frm_formwidth + 1) .
		//	" border=1 cellspacing=0 cellpadding=0>\n";
		$res .= "<table valign=top cols=" . ($this->frm_formwidth) .
			" border=0 cellspacing=0 cellpadding=0>\n";
		return $res;
	}

	function start_row() {
		$res = "";
		$res .= "<tr>\n";
		//$res .= "<td width=1><img src=themes/images/pixel.gif width=1 height=1></td>\n";
		return $res;
	}

	function end_form() {
		$res = "";
		$res .= "</table>\n";
		return $res;
	}
}

class Form_Manipulation extends Form {

	function Form_Manipulation( $name ) { $this->Form(array("name" => $name)); }

	function start_form() {
		$res = "";
		$res .= "<table cols=" . ($this->frm_formwidth + 1) .
			" border=1 cellspacing=0 cellpadding=2>\n";
		$res .= "<tr>\n";
		$res .= "<td>&nbsp;</td>\n";
		for($x = 1;$x <= $this->frm_formwidth + 1; $x++) {
			$res .= "<td>";
			$res .= "<a href=javascript:setxtoval(" . $x . ")>";
			$res .= "<img border=0 src=themes/images/empty.png></a></td>\n";
		}
		$res .= "</tr>\n";
		return $res;
	}

	function start_row(&$y) {
		$res = "";
		$res .= "<tr>\n";
		$res .= "<td>";
		$res .= "<a href=javascript:setytoval(" . $y . ")>";
		$res .= "<img border=0 src=themes/images/empty.png></a></td>\n";
		return $res;
	}

	function end_row($y) {
		$res = "";
		$res .= "<td>";
		$x = $this->frm_formwidth + 1;
		$res .= "<a href=javascript:settoval(" . $x . "," . $y . ")>";
		$res .= "<img border=0 src=themes/images/empty.png></a></td>\n";
		$res .= "</tr>\n";
		return $res;
	}
	
	function end_form() {
		$res = "";
		$res .= "<tr>\n";
		$res .= "<td>&nbsp;</td>\n";
		for($x = 1;$x <= $this->frm_formwidth + 1; $x++) {
			$res .= "<td>";
			$y = $this->frm_formheight + 1;
			$res .= "<a href=javascript:settoval(" . $x . "," . $y . ")>";
			$res .= "<img border=0 src=themes/images/empty.png></a></td>\n";
		}
		$res .= "</tr>\n";
		$res .= "</table>\n";
		return $res;
	}

	function show() {
		$res = "";
		$res .= $this->start_form();
		for($y = 1;$y <= $this->frm_formheight; $y++) {
			$res .= $this->start_row($y);
			$cnt = 0;
			for($x = 1;$x <= $this->frm_formwidth; $x++) {
				if( isset($this->frm_array[$y][$x]) ) {
					if( is_object($this->frm_array[$y][$x]) ) {
						$res .= $this->frm_array[$y][$x]->generate_admin($this->frm_type);
					}
				} else {
					$res .= "<td>";
					$res .= "<a href=javascript:settoval(" . $x . "," . $y . ")>";
					$res .= "<img border=0 src=themes/images/empty.png></a></td>\n";
				}
			}
			$res .= $this->end_row($y);
		}
		$res .= $this->end_form();
		return $res;
	}
}

class FormGroup_Manipulation extends FormGroup {

	function FormGroup_Manipulation( $name ) { $this->FormGroup(array("name" => $name)); }

	function start_form() {
		$res = "";
		$res .= "<table cols=" . ($this->frm_formwidth) .
			" border=1 cellspacing=0 cellpadding=2>\n";
		$res .= "<td>&nbsp;</td>\n";
		for($x = 1;$x <= $this->frm_formwidth + 1; $x++) {
			$res .= "<td>";
			$res .= "<a href=javascript:setxtoval(" . $x . ")>";
			$res .= "<img border=0 src=themes/images/empty.png></a></td>\n";
		}
		return $res;
	}

	function start_row(&$y) {
		$res = "";
		$res .= "<tr>\n";
		$res .= "<td>";
		$res .= "<a href=javascript:setytoval(" . $y . ")>";
		$res .= "<img border=0 src=themes/images/empty.png></a></td>\n";
		return $res;
	}

	function end_row($y) {
		$res = "";
		$res .= "<td>";
		$x = $this->frm_formwidth + 1;
		$res .= "<a href=javascript:settoval(" . $x . "," . $y . ")>";
		$res .= "<img border=0 src=themes/images/empty.png></a></td>\n";
		$res .= "</tr>\n";
		return $res;
	}
	
	function end_form() {
		$res = "";
		$res .= "<tr>\n";
		$res .= "<td>&nbsp;</td>\n";
		for($x = 1;$x <= $this->frm_formwidth + 1; $x++) {
			$res .= "<td>";
			$y = $this->frm_formheight + 1;
			$res .= "<a href=javascript:settoval(" . $x . "," . $y . ")>";
			$res .= "<img border=0 src=themes/images/empty.png></a></td>\n";
		}
		$res .= "</tr>\n";
		$res .= "</table>\n";
		return $res;
	}
	
	function show() {
		$res = "";
		$res .= $this->start_form();
		for($y = 1;$y <= $this->frm_formheight; $y++) {
			$res .= $this->start_row($y);
			$cnt = 0;
			for($x = 1;$x <= $this->frm_formwidth; $x++) {
				if( isset($this->frm_array[$y][$x]) ) {
					if( is_object($this->frm_array[$y][$x]) ) {
						$res .= $this->frm_array[$y][$x]->generate_admin($this->frm_type);
					}
				} else {
					$res .= "<td>";
					$res .= "<a href=javascript:settoval(" . $x . "," . $y . ")>";
					$res .= "<img border=0 src=themes/images/empty.png></a></td>\n";
				}
			}
			$res .= $this->end_row($y);
		}
		$res .= $this->end_form();
		return $res;
	}
}

