?><?php

class Form_element {
	var $posx = 1;
	var $posy = 1;
	var $width = 1;
	var $height = 1;
	var $name = "";
	var $permission = "";
	var $groups = "";
	var $frm_name = "";
	var $image = "";
	var $class = "";
	var $display = "";
	var $theme = "";
	var $ssclass = "";
	var $global = array();
	var $def_ssclass = "formbody";

	function Form_element($frm_name, $name, $permission, $groups, $posx, $posy, $ssclass, $width, $height) {
		global $theme;
		$this->theme = "themes/" . $theme;
		$this->frm_name = $frm_name;
		$this->name = $name;
		$this->permission = $permission;
		$this->groups = $groups;
		$this->posx = $posx;
		$this->posy = $posy;
		$this->width = $width;
		$this->height = $height;
		$this->display = $name;
		$this->ssclass = $ssclass;
		if( empty($this->ssclass) ) {
			$this->ssclass = $this->def_ssclass;
		}
	}

	function print_expr($expr) { return("<?php echo " . $expr . "; ?>"); }

	function add_quotes($val) { return("\"" . $val . "\""); }

	function generate_global() { return ""; }
	
	function generate_element($type = "") {
		if( !empty($this->permission) || !empty($this->groups) ) {
			$one_element = "";
			$one_element .= "<?php\n";
			$one_element .= "global \$perms, \$groups;\n";
			$cond = "";
			if( !empty($this->permission) )
				$cond = "\$perm->have_perm(\"" . $this->permission . "\") ";
			if( !empty($this->groups) ) {
				if( !empty($cond) )
					$cond .= " && ";
				$cond .= "\$groups->check(\"" . $this->groups . "\")";
			}
			$one_element .= "if( " . $cond . " ) {\n";
			$one_element .= "?>\n";
			$one_element .= $this->generate($type);
			$one_element .= "<?php\n";
			$one_element .= "}\n";
			$one_element .= "?>\n";
		} else {
			$one_element = $this->generate($type);
		}
		return $one_element;
	}

	function get_width() { return $this->width; }

	function get_height() { return $this->height; }

	function get_posx() { return $this->posx; }

	function get_posy() { return $this->posy; }

	function add_global($g) { $this->global[$g] = ""; }

	function get_global(&$g) {
		foreach($this->global as $k =>$v) {
			$g[$k] = "";
		}
	}

	function generate_admin() {
		global $PHP_SELF;
		$res = "";
		$res .= "<td valign=top colspan=" . $this->width . " rowspan=" . $this->height . ">";
		$res .= "<table border=1 cellspacing=0 cellpadding=0>\n";
		$res .= "<tr>";
		$res .= "<td><a href=javascript:setval(" .
				$this->add_quotes($this->frm_name) . "," .
				$this->add_quotes($this->name) . "," .
				$this->posx . "," .
				$this->posy .
				")>";

		$res .= "<img border=0 src=themes/images/" . $this->image . "></a></td>";
		$res .= "<td valign=top class=datatext>";
		$res .= "<a href=" . $PHP_SELF .
				"?form_name=" . $this->frm_name .
				"&form_field=" . $this->name .
				"&field_class=" . $this->class . ">";
		$res .= $this->display;
		$res .= "&nbsp;</a></td>\n";
		$res .= "</tr>\n";
		$res .= "</table>";
		$res .= "</td>\n";
		return $res;
	}
}

class Form_label extends Form_element {
	var $text;
	var $image = "label.png";
	var $class = "label";
	var $def_ssclass = "formtext";

	function Form_label($frm_name, $name, $permission, $groups, $posx, $posy, $text, $ssclass, $width, $height = 1) {
		$this->Form_element($frm_name, $name, $permission, $groups, $posx, $posy, $ssclass, $width, $height);
		$this->text = $text;
		$this->display = $text;
	}

	function generate($type = "") {
		$res = "<td nowrap valign=top class=" . $this->ssclass . " colspan=" . $this->width . ">" . $this->text . "</td>\n";
		return $res;
	}
}

class Form_input extends Form_element {
	var $fieldname;
	var $width;
	var $image = "input.png";
	var $class = "input";

	function Form_input($frm_name, $name, $permission, $groups, $posx, $posy, $pri_key, $ssclass, $width, $height = 1) {
		$this->Form_element($frm_name, $name, $permission, $groups, $posx, $posy, $ssclass, $width, $height);
		$this->fieldname = "thisform" . "_" . $name;
		$this->pri_key = $pri_key;
		$this->width = $width;
		if( !empty($pri_key) ) {
			$this->add_global($pri_key);
		}
		$this->add_global($this->fieldname);
	}

	function generate($type = "") {
		$res = "";
		// edit portion
		$res .= "<?php\n";
		$res .= "if( \$type == \"edit\" ) {\n";
		$res .= "?>";
		$res .= "<td class=" . $this->ssclass . " valign=top colspan=" . $this->width . ">" .
			"<input style=\"width:" . ($this->width * 10) . "px\" type=text" .
			" name=" . $this->fieldname .
			" value=" . $this->add_quotes($this->print_expr("htmlspecialchars($" . $this->fieldname . ")")) .
			" size=" . $this->width . ">";
		if( !empty($this->pri_key) ) {
			$res .= "<input type=hidden" .
					" name=" . $this->pri_key .
					" value=" . $this->add_quotes($this->print_expr("htmlspecialchars($" . $this->pri_key . ")")) . ">";
		}
		$res .= "</td>\n";
		// Display Portion
		$res .= "<?php\n";
		$res .= "} else {\n";
		$res .= "?>";
		$res .= "<td class=" . $this->ssclass . " valign=top colspan=" . $this->width . ">";
		$res .= "<table border=1 cellspacing=0 cellpadding=0 width=100%><tr><td class=datatext>";
		$res .= $this->print_expr("$" . $this->fieldname);
		$res .= "&nbsp;</td></tr></table>";
		$res .= "</td>\n";
		$res .= "<?php\n";
		$res .= "} // End input\n";
		$res .= "?>";
		return $res;
	}
}

class Form_date extends Form_element {
	var $fieldname;
	var $width;
	var $image = "input.png";
	var $class = "input";

	function Form_date($frm_name, $name, $permission, $groups, $posx, $posy, $pri_key, $ssclass, $width, $height = 1) {
		$this->Form_element($frm_name, $name, $permission, $groups, $posx, $posy, $ssclass, $width, $height);
		$this->fieldname = "thisform" . "_" . $name;
		$this->pri_key = $pri_key;
		$this->width = $width;
		if( !empty($pri_key) ) {
			$this->add_global($pri_key);
		}
		$this->add_global($this->fieldname);
	}

	function generate($type = "") {
		$res = "";
		// edit portion
		$res .= "<?php\n";
		$res .= "if( \$type == \"edit\" ) {\n";
		$res .= "?>";
		$res .= "<td class=" . $this->ssclass . " valign=top colspan=" . $this->width . ">" .
			"<input style=\"width:" . ($this->width * 10) . "px\" type=text" .
			" name=" . $this->fieldname .
			" value=" . $this->add_quotes($this->print_expr("htmlspecialchars(cdate($" . $this->fieldname . "))")) .
			" size=" . $this->width . ">";
		if( !empty($this->pri_key) ) {
			$res .= "<input type=hidden" .
					" name=" . $this->pri_key .
					" value=" . $this->add_quotes($this->print_expr("htmlspecialchars($" . $this->pri_key . ")")) . ">";
		}
		$res .= "</td>\n";
		// Display Portion
		$res .= "<?php\n";
		$res .= "} else {\n";
		$res .= "?>";
		$res .= "<td class=" . $this->ssclass . " valign=top colspan=" . $this->width . ">";
		$res .= "<table border=1 cellspacing=0 cellpadding=0 width=100%><tr><td class=datatext>";
		$res .= $this->print_expr("cdate($" . $this->fieldname . ")");
		$res .= "&nbsp;</td></tr></table>";
		$res .= "</td>\n";
		$res .= "<?php\n";
		$res .= "} // End input\n";
		$res .= "?>";
		return $res;
	}
}

class Form_password extends Form_element {
	var $fieldname;
	var $image = "input.png";
	var $class = "input";

	function Form_password($frm_name, $name, $permission, $groups, $posx, $posy, $pri_key, $ssclass, $width, $height = 1) {
		$this->Form_element($frm_name, $name, $permission, $groups, $posx, $posy, $ssclass, $width, $height);
		$this->fieldname = "thisform" . "_" . $name;
		$this->pri_key = $pri_key;
		if( !empty($pri_key) ) {
			$this->add_global($pri_key);
		}
		$this->add_global($this->fieldname);
	}

	function generate($type = "") {
		$res = "";
		// edit portion
		$res .= "<?php\n";
		$res .= "if( \$type == \"edit\" ) {\n";
		$res .= "?>";
		$res .= "<td class=" . $this->ssclass . " valign=top colspan=" . $this->width . ">" .
			"<input style=\"width:" . ($this->width * 10) . "px\" type=password" .
			" name=" . $this->fieldname .
			" value=" . $this->add_quotes($this->print_expr("htmlspecialchars($" . $this->fieldname . ")")) .
			" size=" . $this->width . ">";
		if( !empty($this->pri_key) ) {
			$res .= "<input type=hidden" .
					" name=" . $this->pri_key .
					" value=" . $this->add_quotes($this->print_expr("htmlspecialchars($" . $this->pri_key . ")")) . ">";
		}
		$res .= "</td>\n";
		// Display Portion
		$res .= "<?php\n";
		$res .= "} else {\n";
		$res .= "?>";
		$res .= "<td class=" . $this->ssclass . " valign=top colspan=" . $this->width . ">";
		$res .= "<table border=1 cellspacing=0 cellpadding=0 width=100%><tr><td class=datatext>";
		$res .= $this->print_expr("$" . $this->fieldname);
		$res .= "&nbsp;</td></tr></table>";
		$res .= "</td>\n";
		$res .= "<?php\n";
		$res .= "} // End input\n";
		$res .= "?>";
		return $res;
	}
}

class Form_edit extends Form_element {
	var $fieldname;
	var $image = "edit.png";
	var $class = "edit";

	function Form_edit($frm_name, $name, $permission, $groups, $posx, $posy, $ssclass, $width, $height) {
		$this->Form_element($frm_name, $name, $permission, $groups, $posx, $posy, $ssclass, $width, $height);
		$this->fieldname = "thisform" . "_" . $name;
		$this->add_global($this->fieldname);
	}

	function generate($type = "") {
		$res = "";
		// edit portion
		$res .= "<?php\n";
		$res .= "if( \$type == \"edit\" ) {\n";
		$res .= "?>";
		$res .= "<td class=" . $this->ssclass . " valign=top colspan=" . $this->width . " rowspan=" . $this->height . ">" .
			"<textarea style=\"width:" . ($this->width * 10) . "px\"" .
			" cols=" . $this->width .
			" rows=" . $this->height .
			" name=" . $this->fieldname . ">" .
			$this->print_expr("htmlspecialchars($" . $this->fieldname . ")") .
			"</textarea>";
		$res .= "</td>\n";
		// Display Portion
		$res .= "<?php\n";
		$res .= "} else {\n";
		$res .= "?>";
		$res .= "<td class=" . $this->ssclass . " valign=top colspan=" . $this->width . " rowspan=" . $this->height . ">";
		$res .= "<table border=1 cellspacing=0 cellpadding=0 width=100%><tr>";
		$res .= "<td class=datatext colspan=" . $this->width . " rowspan=" . $this->height . ">";
		$res .= $this->print_expr("$" . $this->fieldname);
		$res .= "&nbsp;</td></tr></table>";
		$res .= "</td>\n";
		$res .= "<?php\n";
		$res .= "}  // End Edit\n";
		$res .= "?>";
		return $res;
	}
}


class Form_value extends Form_element {
	var $fieldname;
	var $pri_key;
	var $image = "value.png";
	var $class = "value";

	function Form_value($frm_name, $name, $permission, $groups, $posx, $posy, $pri_key, $ssclass, $width, $height = 1) {
		$this->Form_element($frm_name, $name, $permission, $groups, $posx, $posy, $ssclass, $width, $height);
		$this->fieldname = "thisform" . "_" . $name;
		$this->pri_key = $pri_key;
		if( !empty($pri_key) ) {
			$this->add_global($pri_key);
		}
		$this->add_global($this->fieldname);
	}

	function generate($type = "") {
		$res = "";
		$res .= "<td class=" . $this->ssclass . " valign=top colspan=" . $this->width . ">";
		if( !empty($this->pri_key) ) {
			$res .= "<input type=hidden" .
					" name=" . $this->pri_key .
					" value=" . $this->add_quotes($this->print_expr("$" . $this->pri_key)) . ">";
		}
		$res .= "<table border=1 cellspacing=0 cellpadding=0 width=100%><tr><td class=datatext>";
		$res .= $this->print_expr("$" . $this->fieldname);
		$res .= "&nbsp;</td></tr></table>";
		$res .= "</td>\n";
		return $res;
	}
}

class Form_valuedate extends Form_element {
	var $fieldname;
	var $pri_key;
	var $image = "value.png";
	var $class = "value";

	function Form_valuedate($frm_name, $name, $permission, $groups, $posx, $posy, $pri_key, $ssclass, $width, $height = 1) {
		$this->Form_element($frm_name, $name, $permission, $groups, $posx, $posy, $ssclass, $width, $height);
		$this->fieldname = "thisform" . "_" . $name;
		$this->pri_key = $pri_key;
		if( !empty($pri_key) ) {
			$this->add_global($pri_key);
		}
		$this->add_global($this->fieldname);
	}

	function generate($type = "") {
		$res = "";
		$res .= "<td class=" . $this->ssclass . " valign=top colspan=" . $this->width . ">";
		if( !empty($this->pri_key) ) {
			$res .= "<input type=hidden" .
					" name=" . $this->pri_key .
					" value=" . $this->add_quotes($this->print_expr("$" . $this->pri_key)) . ">";
		}
		$res .= "<table border=1 cellspacing=0 cellpadding=0 width=100%><tr><td class=datatext>";
		$res .= $this->print_expr("cdate($" . $this->fieldname . ")");
		$res .= "&nbsp;</td></tr></table>";
		$res .= "</td>\n";
		return $res;
	}
}

class Form_button extends Form_element  {
	var $fieldname;
	var $text;
	var $image = "button.png";
	var $class = "button";

	function Form_button($frm_name, $name, $permission, $groups, $posx, $posy, $text, $ssclass, $width, $height = 1) {
		$this->Form_element($frm_name, $name, $permission, $groups, $posx, $posy, $ssclass, $width, $height);
		$this->fieldname = $frm_name . "_submit";
		$this->text = $text;
		$this->add_global($this->fieldname);
	}

	function generate($type = "") {
		$res = "";
		// edit portion
		$res .= "<?php\n";
		$res .= "if( \$type == \"edit\" ) {\n";
		$res .= "?>";
		$res .= "<td class=" . $this->ssclass . " valign=top colspan=" . $this->width . ">" .
					"<input type=submit" .
					" name=" . $this->fieldname .
					" value=" . $this->add_quotes($this->text) .
					"></td>\n";
		$res .= "<?php\n";
		$res .= "} else {\n";
		$res .= "?>";
		// Display Portion
		$res .= "<td class=" . $this->ssclass . " valign=top colspan=" . $this->width . ">&nbsp;</td>\n";
		$res .= "<?php\n";
		$res .= "} // End button\n";
		$res .= "?>";
		return $res;
	}
}

class Form_option extends Form_element {
	var $fieldname;
	var $options;
	var $image = "option.png";
	var $class = "option";
	var $sql;
	var $width;
	var $frm_database;

	function Form_option($frm_name, $name, $permission, $groups, $posx, $posy, $options, $sql, $ssclass, $width, $height = 1, $frm_database = "") {
		$this->Form_element($frm_name, $name, $permission, $groups, $posx, $posy, $ssclass, $width, $height);
		$this->fieldname = "thisform" . "_" . $name;
		$this->options = $options;
		$this->sql = $sql;
		$this->width = $width;
		$this->add_global($this->fieldname);
		$this->frm_database = $frm_database;
	}

	function generate($type = "") {
		$res = "";
		$res .= "<td class=" . $this->ssclass . " valign=top colspan=" . $this->width . ">";
		// edit portion
		$res .= "<?php\n";
		$res .= "if( \$type == \"edit\" ) {\n";
		$res .= "?>";
		$res .= "<select style=\"width:" . ($this->width * 10) . "px\" name=" . $this->fieldname . ">";
		switch($this->options) {
			case "perm":
				$res .= "<?php\n";
				$res .= "global \$permission_selectopt;\n";
				$res .= "\$permission_selectopt->set_default($" . $this->fieldname . ");\n";
				$res .= "echo \$permission_selectopt->show();\n";
				$res .= "?>";
				break;
			case "layoutgroup":
				$res .= "<?php\n";
				$res .= "global \$layoutgroup_selectopt;\n";
				$res .= "\$layoutgroup_selectopt=make_layoutgroup_selectopt();\n";
				$res .= "\$layoutgroup_selectopt->set_default($" . $this->fieldname . ");\n";
				$res .= "echo \$layoutgroup_selectopt->show();\n";
				$res .= "?>";
				break;
			case "items":
				$res .= "<?php\n";
				$res .= "global \$items_selectopt;\n";
				$res .= "\$items_selectopt=make_items_selectopt();\n";
				$res .= "\$items_selectopt->set_default($" . $this->fieldname . ");\n";
				$res .= "echo \$items_selectopt->show();\n";
				$res .= "?>";
				break;
			case "place":
				$res .= "<?php\n";
				$res .= "global \$place_selectopt;\n";
				$res .= "\$place_selectopt->set_default($" . $this->fieldname . ");\n";
				$res .= "echo \$place_selectopt->show();\n";
				$res .= "?>";
				break;
			case "control":
				$res .= "<?php\n";
				$res .= "global \$control_selectopt;\n";
				$res .= "\$control_selectopt->set_default($" . $this->fieldname . ");\n";
				$res .= "echo \$control_selectopt->show();\n";
				$res .= "?>";
				break;
			case "form":
				$res .= "<?php\n";
				$res .= "global \$form_selectopt;\n";
				$res .= "\$form_selectopt->set_default($" . $this->fieldname . ");\n";
				$res .= "echo \$form_selectopt->show();\n";
				$res .= "?>";
				break;
			case "menu":
				$res .= "<?php\n";
				$res .= "global \$menu_selectopt;\n";
				$res .= "\$menu_selectopt->set_default($" . $this->fieldname . ");\n";
				$res .= "echo \$menu_selectopt->show();\n";
				$res .= "?>";
				break;
			case "optiontype":
				$res .= "<?php\n";
				$res .= "global \$optiontype_selectopt;\n";
				$res .= "\$optiontype_selectopt->set_default($" . $this->fieldname . ");\n";
				$res .= "echo \$optiontype_selectopt->show();\n";
				$res .= "?>";
				break;
			case "publicprivate":
				$res .= "<?php\n";
				$res .= "global \$publicprivate_selectopt;\n";
				$res .= "\$publicprivate_selectopt->set_default($" . $this->fieldname . ");\n";
				$res .= "echo \$publicprivate_selectopt->show();\n";
				$res .= "?>";
				break;
			case "KEYTABLE":
				$res .= "<?php\n";
				$res .= "\$opt = get_keytable(" . $this->add_quotes($this->sql) . ", " . $this->add_quotes($this->frm_database) . ");\n";
				$res .= "\$opt->set_default($" . $this->fieldname . ");\n";
				$res .= "echo \$opt->show();\n";
				$res .= "?>";
				break;
			case "":
				$res .= "<?php\n";
				$res .= "\$opt =& new DB_HTMLOptions(" . $this->add_quotes($this->sql) . ", " . $this->add_quotes($this->frm_database) . ");\n";
				$res .= "\$opt->set_default($" . $this->fieldname . ");\n";
				$res .= "echo \$opt->show();\n";
				$res .= "?>";
				break;
		}
		$res .= "</select>";
		$res .= "<?php\n";
		$res .= "} else {\n";
		$res .= "?>";
		// Display Portion
		$res .= "<table border=1 cellspacing=0 cellpadding=0 width=100%><tr><td class=datatext>";
		$res .= $this->print_expr("$" . $this->fieldname);
		$res .= "&nbsp;</td></tr></table>";
		$res .= "<?php\n";
		$res .= "} // End Select\n";
		$res .= "?>";
		$res .= "</td>\n";
		return $res;
	}
}

class Form_browse extends Form_element {
	var $brw;
	var $image = "browse.png";
	var $class = "browse";

	function Form_browse($frm_name, $name, $permission, $groups, $posx, $posy, $ssclass, $width = 1, $height = 1) {
		$this->brw = & new Browse($name);
		$this->brw->get_data();
		$this->width = $this->brw->get_width();
		$this->height = $this->brw->get_height();
		$this->Form_element($frm_name, $name, $permission, $groups, $posx, $posy, $ssclass, $this->width, $this->height);
	}

	function generate_global($type = "") {
		return $this->brw->generate_global($type);
	}

	function get_global(&$g) {
		$this->brw->get_global($g);
	}

	function generate($type = "") {
		$res = "<td class=" . $this->ssclass . " valign=top colspan=" . $this->width . " rowspan=" . $this->height . ">";
		$res .= $this->brw->generate();
		$res .= "</td>\n";
		return $res;
	}
}

class Form_code extends form_element {
	var $code;
	var $image = "code.png";
	var $class = "code";

	function Form_code($frm_name, $name, $permission, $groups, $posx, $posy, $code, $ssclass, $width, $height) {
		$this->Form_element($frm_name, $name, $permission, $groups, $posx, $posy, $ssclass, $width, $height);
		$this->code = $code;
	}

	function generate($type = "") {
		$res = "<td valign=top colspan=" . $this->width . " rowspan=" . $this->height . ">";
		$res .= "<?php\n";
		$res .= $this->code;
		$res .= "\n?>";
		$res .= "</td>\n";
		return $res;
	}
}

class Form_g_code extends Form_element {
	var $code;
	var $image = "code.png";
	var $class = "g_code";

	function Form_g_code($frm_name, $name, $permission, $groups, $posx, $posy, $code, $ssclass, $width, $height) {
		$this->Form_element($frm_name, $name, $permission, $groups, $posx, $posy, $ssclass, $width, $height);
		$this->code = $code;
	}

	function generate($type = "") {
		$res = "<td class=" . $this->ssclass . " valign=top colspan=" . $this->width . " rowspan=" . $this->height . ">";
		$res .= "</td>\n";
		return $res;
	}
}

class FormGroup_browse extends Form_element {
	var $brw;
	var $image = "browse.png";
	var $class = "browse";

	function FormGroup_browse($frm_name, $name, $permission, $groups, $posx, $posy, $ssclass, $width, $height) {
		$this->Form_element($frm_name, $name, $permission, $groups, $posx, $posy, $ssclass, $width, $height);
		$this->brw = & new Browse($this->name);
		$this->brw->get_data();
		$this->width = $width;
		$this->height = $height;
	}

	function generate_global($type = "") {
		return $this->brw->generate_global($type);
	}

	function get_global(&$g) {
		$this->brw->get_global($g);
	}

	function generate($type = "") {
		$res = "<td valign=top colspan=" . $this->width . " rowspan=" . $this->height . ">";
		$res .= "<table border=0 cellspacing=0 cellpadding=5><tr><td>";
		$res .= "<table border=1 cellspacing=0 cellpadding=0><tr><td>";
		$res .= $this->brw->generate();
		$res .= "</td></tr></table>";
		$res .= "</td></tr></table>";
		$res .= "</td>\n";
		return $res;
	}
}

class FormGroup_form extends Form_element {
	var $frm;
	var $image = "form.png";
	var $class = "form";

	function FormGroup_form($frm_name, $name, $permission, $groups, $posx, $posy, $type, $ssclass, $width, $height) {
		$this->Form_element($frm_name, $name, $permission, $groups, $posx, $posy, $ssclass, $width, $height);
		$this->frm = & new Form(array("name" => $this->name, "link" => $type));
		$this->frm->get_data();
		$this->width = $width;
		$this->height = $height;
	}

	function generate_global($type = "") {
		return $this->frm->generate_global($type);
	}

	function get_global(&$g) {
		$this->frm->get_global($g);
	}

	function generate($type = "") {
		$res = "<td height=1 valign=top colspan=" . $this->width . " rowspan=" . $this->height . ">";
		$res .= "<table border=0 cellspacing=0 cellpadding=5><tr><td>";
		$res .= "<table border=1 cellspacing=0 cellpadding=0><tr><td>";
		$res .= $this->frm->generate($type);
		$res .= "</td></tr></table>";
		$res .= "</td></tr></table>";
		$res .= "</td>\n";
		return $res;
	}
}

class FormGroup_formgroup extends Form_element {
	var $frm;
	var $image = "form.png";
	var $class = "form";

	function FormGroup_formgroup($frm_name, $name, $permission, $groups, $posx, $posy, $type, $ssclass, $width, $height) {
		$this->Form_element($frm_name, $name, $permission, $groups, $posx, $posy, $ssclass, $width, $height);
		$this->frm = & new FormGroup(array("name" => $this->name, "link" => $type));
		$this->frm->get_data();
		$this->width = $width;
		$this->height = $height;
	}

	function generate_global($type = "") {
		return $this->frm->generate_global($type);
	}

	function get_global(&$g) {
		$this->frm->get_global($g);
	}

	function generate($type = "") {
		$res = "<td valign=top colspan=" . $this->width . " rowspan=" . $this->height . ">";
		$res .= "<table border=0 cellspacing=0 cellpadding=0><tr><td>";
		$res .= $this->frm->generate($type);
		$res .= "</td></tr></table>";
		$res .= "</td>\n";
		return $res;
	}
}
class FormGroup_case extends Form_element {
	var $pri_key = "";
	var $forms = array();
	var $image = "form.png";
	var $class = "case";

	function FormGroup_case($frm_name, $name, $permission, $groups, $posx, $posy, $pri_key, $list, $ssclass, $width, $height) {
		$this->Form_element($frm_name, $name, $permission, $groups, $posx, $posy, $ssclass, $width, $height);
		$this->pri_key = $pri_key;
		$this->add_global($this->pri_key);
		$temp = explode("\n", preg_replace("/\r/", "", $list));
		foreach($temp as $val) {
			list($k, $v) = explode(",", $val);
			if( !empty($k) ) {
				$this->forms[$k] = & new Form(array("name" => $v, "link" => "edit"));
				$this->forms[$k]->get_data();
			}
		}
	}

	function generate_global($type = "") {
		$res = "";
		$res .= "if( isset(\$HTTP_GET_VARS[" . $this->add_quotes($this->pri_key) . "]) ) {";
		$res .= " \$" . $this->pri_key . "=\$HTTP_GET_VARS[" . $this->add_quotes($this->pri_key) . "];";
		$res .= " }\n";
		$res .= "\$sess->register(" . $this->add_quotes($this->pri_key) . ");\n";
		foreach($this->forms as $k => $v) {
			$res .= $this->forms[$k]->generate_global("edit");
		}
		return $res;
	}

	function get_global(&$g) {
		foreach($this->forms as $k => $v) {
			$this->forms[$k]->get_global($g);
		}
		foreach($this->global as $k =>$v) {
			$g[$k] = "";
		}
	}

	function generate($type = "") {
		$res = "<td valign=top colspan=" . $this->width . " rowspan=" . $this->height . ">";
		$res .= "<table border=0 cellspacing=0 cellpadding=5><tr><td>";
		$res .= "<table border=1 cellspacing=0 cellpadding=0><tr><td>";
		$res .= "<?php\n";
		$res .= "switch($" . $this->pri_key . ") {\n";
		foreach($this->forms as $k => $v) {
			$res .= "	case " . $this->add_quotes($k) . ":\n?>";
			$res .= $this->forms[$k]->generate("edit");
			$res .= "<?php\n";
			$res .= "		break;\n";
		}
		$res .= "}\n";
		$res .= "?>";
		$res .= "</td></tr></table>";
		$res .= "</td></tr></table>";
		$res .= "</td>\n";
		return $res;
	}
}
