/*
 *  Links Plugin Class
 *
 *  Copyright (c) 2002 Willy De la Court <wdl@linux-lovers.be>
 *
 */
?><?php
register_plugin("Gallery", "N", "N");

class Gallery extends PlainPlugin {
	var $classname = "Gallery";
	var $file = "gallery.ihtml";
	var $text = array();
	var $gallery = array();
	var $description = array();
	var $title = "";
	var $name = "";
	var $cacheable = "N";
	var $editable = "N";

	function Gallery( $record = array(), $createcache = "N" ) {
		global $auth, $perm;

		$this->PlainPlugin($record, $createcache);
		if( ! empty($record) ) {
			if( $this->cached != "Y" ) {
				$this->title = $record["title"];
				$this->name = $record["name"];
				$mdb = new DB_SDS;
				//echo $auth->auth["uname"];
				//echo $auth->is_authenticated();
				if( $auth->is_authenticated() == "nobody") {
					$user = "%|(All)|%";
					$mdb->query("select distinct " . 
						"gallery.name, " .
						"gallery.title, " . 
						"gallery.description " .
					    "from " . 
						"gallery, gallery_images " . 
					    "where " . 
						"gallery.name = gallery_images.name and " . 
						"(gallery.type = 'public' or " . 
						"gallery_images.username like '$user' or " . 
						"gallery_images.ownername like '$user')");
						//$mdb->query("select * from gallery");
				} else {
					if( $perm->have_perm("supervisor") ) {
						$mdb->query("select * from gallery");
					} else {
						$user = "%|" . $auth->auth["uname"] . "|%";
						$mdb->query("select distinct " . 
							"gallery.name, " .
							"gallery.title, " . 
							"gallery.description " .
						    "from " . 
							"gallery, gallery_images " . 
						    "where " . 
							"gallery.name = gallery_images.name and " . 
							"(gallery.type = 'public' or " . 
							"gallery_images.username like '$user' or " . 
							"gallery_images.ownername like '$user')");
						//$mdb->query("select * from gallery");
					}
    				}
				if( $mdb->num_rows() > 0 ) {
					$cnt = $mdb->num_rows();
					$i = 1;
					while( $mdb->next_record()) {
						$t = $mdb->f("title");
						if( substr($t, 0, 1) != "~" || $perm->have_perm("admin")) {
							if( substr($t, 0, 1) != "~")
    								$this->text[$i] = $t;
							else
    								$this->text[$i] = substr($t, 1);
							$this->description[$i] = $mdb->f("description");
							$this->gallery[$i] = $mdb->f("name");
							$i++;
						}
					}
				}
			}
		}
	}

	function show() {
		global $show, $PHP_SELF, $gallery_name;

		if( $this->cached == "Y" ) {
			return($this->show_cache());
		} else {
			$cnt = count($this->text);
			$t =& new Template($this->theme, "remove");
			$t->set_file(array("layout" => $this->file));
			$admin_button = $this->admin_button();
			$t->set_var(array(	"TITLE" => $this->title,
								"SHOW" => $show,
								"ADMIN" => $admin_button));
			$t->set_block("layout", "row", "rows");
			$t->set_block("layout", "foto", "fotos");
			if( isset($gallery_name) ) {
				$g =& new foto_gallery($gallery_name);
				$res = $g->show();
				$t->set_var(array("FOTO" => $res));
				$t->parse("fotos", "foto", true);
			} else {
				for($i = 1; $i <= $cnt; $i++ ) {
					$t->set_var(array("LINK" => $PHP_SELF . "?show=" . $show . "&gallery_name=" . $this->gallery[$i],
							"LINKTITLE" => $this->text[$i],
							"DESCRIPTION" => $this->description[$i]));
					$t->parse("rows", "row", true);
				}
			}
			$t->parse("out", array("layout"));
			return $t->get("out");
		}
	}
}

include "image.php";


class ViewGallery {
	var $subdir;
	var $max_per_line;
	var $max_lines;
	var $query;
	var $db;
	var $border;

	function ViewGallery($gallery_name, $query, $thispagename, $max_per_line = 4, $max_lines = 10, $border = 0) {
		$this->subdir = $gallery_name;
		$this->max_per_line = $max_per_line;
		$this->max_lines = $max_lines;
		$this->query = $query;
		$this->thispagename = $thispagename;
		$this->border = $border;
	}

	function makebase($image) {
		$str = "";
		$str .= "\$gallery_name=\"" . $this->subdir . "\";";
		$str .= "\$image=\"" . $image . "\";";
		return htmlspecialchars(base64_encode($str));
	}

	function show($thispage) {
		global $PHP_SELF;

		$this->db =& new DB_SDS;
		$this->db->query($this->query);
		$cnt = 1;
		$max_page = $this->max_per_line * $this->max_lines;
		$page = 1;
		$res = "";
		$res .= "<table border=$this->border cellpadding=10>\n";
		$res .= "<tr>\n";
		$cnt2 = 1;
		while( $this->db->next_record() ) {
			if( $page == $thispage ) {
				$res .= $this->show_one($thispage, $cnt2);
				$cnt2 += 1;
				if( ($cnt % $this->max_per_line) == 0 ) {
					$res .= "</tr>\n";
					$res .= "<tr>\n";
				}
			}
			if( ($cnt % $max_page) == 0 ) {
				$page += 1;
			}
			$cnt += 1;
		}
		$res .= "</tr>\n";
		$res .= "</table>\n";
		$cnt -= 1;
		if( ($cnt % $max_page) == 0 ) {
			$page -= 1;
		}
		$result = "";
		$result .= "<center>\n";
		$pages .= $this->show_pages($page, $thispage, $this->thispagename);
		$result .= $pages;
		$result .= $res;
		$result .= $pages;
		$result .= "</center>\n";
		return $result;
	}

	function show_one($thispage, $cnt2) {
		global $PHP_SELF, $show;

		$file = $this->db->f("filename");
		$cap = $this->db->f("caption");
		$res .= "<td align=center valign=top>\n";
		$res .= "<a href=$PHP_SELF?show=$show&gallery_name=$this->subdir&$this->thispagename=$thispage&gallery=fullsize&gallery_image=$file>";
		$str = $this->makebase($file);
		$res .= "<img border=0 src=\"utils/show_th.php?image=$str\"></a><br>\n";
		$res .= $cap;
		$res .= "</td>\n";
		return $res;
	}

	function show_pages($page, $pagenr, $name) {
		global $PHP_SELF, $show;

		$res = "";
		$res .= "<table>\n";
		$res .= "<tr>\n";
		if( $pagenr > 1) {
			$pp = $pagenr - 1;
			$res .= "<td valign=middle>\n";
			$res .= "<a href=$PHP_SELF?show=$show&gallery_name=$this->subdir&$name=$pp><img border=0 src=themes/images/arrow_left.gif></a> ";
			$res .= "<td>\n";
		}
		for($p = 1; $p <= $page; $p++) {
			$res .= "<td valign=middle>\n";
			if( $p == $pagenr ) {
				$res .= "<b>$p</b> ";
			} else {
				$res .= "<a href=$PHP_SELF?show=$show&gallery_name=$this->subdir&$name=$p>$p</a> ";
			}
			$res .= "<td>\n";
		}
		if( $pagenr < $page) {
			$pp = $pagenr + 1;
			$res .= "<td valign=middle>\n";
			$res .= "<a href=$PHP_SELF?show=$show&gallery_name=$this->subdir&$name=$pp><img border=0 src=themes/images/arrow_right.gif></a> ";
			$res .= "<td>\n";
		}
		$res .= "</tr>\n";
		$res .= "</table>\n";
		return $res;
	}
}

class ViewCapGallery extends ViewGallery {

	function ViewCapGallery($gallery_name, $query, $thispagename, $max_per_line = 4, $max_lines = 10) {
		$this->ViewGallery($gallery_name, $query, $thispagename, $max_per_line, $max_lines, 1);
	}

	function show_one($thispage, $cnt2) {
		global $PHP_SELF, $show;
		$res .= "<td width=50%>\n";
		$res .= "<table width=100%>\n";
		$res .= "	<tr>\n";
		$res .= "		<td nowrap><b>" . $this->db->f("filename") . "</b></td>\n";
		$res .= "		<td>\n";
		$res .= "		<a href=$PHP_SELF?show=$show&gallery_action=delete&filename=" . $this->db->f("filename") . "><img align=right border=0 src=themes/images/delete.gif></a>\n";
		$res .= "		</td>\n";
		$res .= "	</tr>\n";
		$res .= "	<tr>\n";
		$res .= "		<td colspan=2 align=center valign=top>\n";
		$str = $this->makebase($this->db->f("filename"));
		$res .= "			<img src=\"utils/show_th.php?image=$str\">\n";
		$res .= "		</td>\n";
		$res .= "	</tr>\n";
		$res .= "	<tr>\n";
		$res .= "		<td colspan=2 align=center>\n";
		$res .= "			<input type=hidden name=" . $cnt2 . "_filename value=\"" . $this->db->f("filename") . "\">\n";
		$res .= "			<input type=text name=" . $cnt2 . "_caption value=\"" . $this->db->f("caption") . "\">\n";
		$res .= "		</td>";
		$res .= "	</tr>\n";
		$res .= "</table>\n";
		$res .= "</td>\n";
		return $res;
	}
}

class ViewUserGallery extends ViewGallery {

	function ViewUserGallery($gallery_name, $query, $thispagename, $max_per_line = 4, $max_lines = 10) {
		$this->ViewGallery($gallery_name, $query, $thispagename, $max_per_line, $max_lines, 1);
	}

	function show_one($thispage, $cnt2) {
		$res .= "<td>\n";
		$res .= "<table width=100%>\n";
		$res .= "	<tr>\n";
		$res .= "		<td>\n";
		$res .= "		<input type=checkbox name=row_" . $cnt2 . " value=" . $this->db->f("filename") . ">\n";
		$res .= "		</td>\n";
		$res .= "		<td align=center valign=top>\n";
		$str = $this->makebase($this->db->f("filename"));
		$res .= "			<img src=\"utils/show_th.php?image=$str\">\n";
		$res .= "		</td>\n";
		$res .= "	</tr>\n";
		$res .= "</table>\n";
		$res .= "</td>\n";
		return $res;
	}
}

class ViewSecGallery extends ViewGallery {

	function ViewSecGallery($gallery_name, $query, $thispagename, $max_per_line = 4, $max_lines = 10) {
		$this->ViewGallery($gallery_name, $query, $thispagename, $max_per_line, $max_lines, 1);
	}

	function show_one($thispage, $cnt2) {
		$res .= "<td>\n";
		$res .= "<table width=100%>\n";
		$res .= "	<tr>\n";
		$res .= "		<td>\n";
		$res .= "		<input type=checkbox name=delrow_" . $cnt2 . " value=" . $this->db->f("filename") . ">\n";
		$res .= "		</td>\n";
		$res .= "		<td align=center valign=top>\n";
		$str = $this->makebase($this->db->f("filename"));
		$res .= "			<img src=\"utils/show_th.php?image=$str\">\n";
		$res .= "		</td>\n";
		$res .= "	</tr>\n";
		$res .= "</table>\n";
		$res .= "</td>\n";
		return $res;
	}
}

class foto_gallery {
	var $subdir;
	var $directory;
	var $msg;
	var $msg2;
	var $sec = "private";
	var $desc = "";

	function foto_gallery($subdir) {
		global $gallery_dir;
		$this->subdir = $subdir;
		$this->directory = $gallery_dir . "/" . $subdir;
		$this->msg = "Image is resized for display";
		$this->msg2 = "Back to the Gallery";
		$db =& new DB_SDS;
		$db->query("select * from gallery where name = '$this->subdir'");
		$db->next_record();
		if( $db->f("type") == "public" ) {
			$this->sec = "public";
		}
		$this->desc = $db->f("description");
	}

	function show() {
		global $gallery, $gallery_name, $gallery_image, $gallery_page, $PHP_SELF, $auth, $perm, $show;

		$res = "";
		if( ! isset($gallery_page) ) {
			$gallery_page = 1;
		}
		if( $gallery == "fullsize" ) {
			$i = new image($this->directory . "/" . $gallery_image);
			$i->set_maxsize(400);
			$i->read_size();
			$width = $i->new_width;
			$height = $i->new_height;
			$db =& new DB_SDS;
			$db->query("select * from gallery_images where name = '$gallery_name' and filename = '$gallery_image'");
			$db->next_record();
			$p_desc = $db->f("caption");
			$str = "";
			$str .= "\$gallery_name=\"" . $this->subdir . "\";";
			$str .= "\$image=\"" . $gallery_image . "\";";
			$str .= "\$addtext=\"yes\";";
			if( $this->sec == "public" || $perm->have_perm("supervisor") ) {
				$str .= "\$addtext=\"no\";";
			} else {
				$user = "|" . $auth->auth["uname"] . "|";
				if( stristr($db->f("owneruser"), $user) ) {
					$str .= "\$addtext=\"no\";";
				}
			}
			$str = htmlspecialchars(base64_encode($str));
			$res .= "<center>\n";
			$res .= $this->desc . "<br>";
			$res .= "<img border=0 width=$width height=$height src=\"utils/show_image.php?image=$str\"><br>\n";
			$res .= $p_desc . "<br>\n";
			$res .= $this->msg . "<br>\n";
			$res .= "<a href=$PHP_SELF?show=$show&gallery_name=$gallery_name&gallery_page=$gallery_page>$this->msg2</a>\n";
			$res .= "</center>\n";
		} else {
			$res .= "<center>\n";
			$res .= $this->desc . "<br>";
			$res .= "</center>\n";
			if( $this->sec == "public" || $perm->have_perm("supervisor") ) {
				$g =& new ViewGallery(
					$this->subdir,
					"select * from gallery_images where name = '$this->subdir' order by filename",
					"gallery_page", 4, 10
					);
			} else {
				$user = "%|" . $auth->auth["uname"] . "|%";
				if( $user == "%||%" )
					$user = "%|(All)|%";
				$g =& new ViewGallery(
					$this->subdir,
					"select * from gallery_images where name = '$this->subdir' and (username like '$user' or ownername like '$user') order by filename",
					"gallery_page", 4, 10
					);
			}
			$res .= $g->show($gallery_page);
			$res .= "<a href=$PHP_SELF?show=$show>All Galleries</a>\n";
		}
		return $res;
	}

	function show_admin() {
		global $gallery_admin, $sess, $show, $HTTP_GET_VARS, $PHP_SELF;

		if( isset($HTTP_GET_VARS["gallery_admin"]) ) {
			$gallery_admin = $HTTP_GET_VARS["gallery_admin"];
		}
		if( !isset($gallery_admin) ) {
			$gallery_admin = "caption";
		}
		$sess->register("gallery_admin");
		$res = "";
		$res .= "<table width=100%>\n";
		$res .= "<tr>\n";
		$res .= "<td><a href=$PHP_SELF?show=$show&gallery_admin=caption>Edit Captions</a></td>\n";
		$res .= "<td><a href=$PHP_SELF?show=$show&gallery_admin=userview>Viewable by</a></td>\n";
		$res .= "<td><a href=$PHP_SELF?show=$show&gallery_admin=userown>Owned by</a></td>\n";
		$res .= "</tr>\n";
		$res .= "</table>\n";
		switch($gallery_admin) {
			case "caption" :
				$res .= $this->show_caption();
				break;
			case "userview" :
				$res .= $this->show_userview();
				break;
			case "userown" :
				$res .= $this->show_ownview();
				break;
		}
		return $res;
	}

	function show_userview() {
		global $gallery_viewpage, $gallery_uviewpage, $thisform_user, $show, $sess, $HTTP_GET_VARS;

		if( empty($thisform_user) )
			$thisform_user = "(All)";
		$res = "";
		if( isset($HTTP_GET_VARS["gallery_viewpage"]) ) {
			$gallery_viewpage = $HTTP_GET_VARS["gallery_viewpage"];
		}
		$sess->register("gallery_viewpage");
		if( isset($HTTP_GET_VARS["gallery_uviewpage"]) ) {
			$gallery_uviewpage = $HTTP_GET_VARS["gallery_uviewpage"];
		}
		$sess->register("gallery_uviewpage");
		if(! isset($gallery_viewpage) ) {
			$gallery_viewpage = 1;
		}
		if(! isset($gallery_uviewpage) ) {
			$gallery_uviewpage = 1;
		}
		$res .= "<table width=100%>\n";
		$res .= "<tr>\n";
		$res .= "<td nowrap align=center><b>All pictures</b></td>\n";
		$res .= "<td nowrap align=center><b>Pictures viewable by '$thisform_user'</b></td>\n";
		$res .= "</tr>\n";
		$res .= "<tr>\n";
		$res .= "<script language=\"javascript\">\n";
		$res .= "<!--\n";
		$res .= "function selall() {;\n";
		for($cnt = 1;$cnt <= 10; $cnt++) {
			$res .= "   document.gallery_sec.row_$cnt.checked = true;\n";
		}
		$res .= "}\n";
		$res .= "function selall2() {\n";
		for($cnt = 1;$cnt <= 10; $cnt++) {
			$res .= "   document.gallery_sec.delrow_$cnt.checked = true;\n";
		}
		$res .= "}\n";
		$res .= "// -->\n";
		$res .= "</script>\n";
		$res .= "<td nowrap align=center><a href=javascript:selall()>Select All</a></td>\n";
		$res .= "<td nowrap align=center><a href=javascript:selall2()>Select All</a></td>\n";
		$res .= "</tr>\n";
		$res .= "<tr>\n";
		$res .= "<td width=50% valign=top>\n";
		$g =& new ViewUserGallery(
			$this->subdir,
			"select filename, username, caption from gallery_images
				where name = '$this->subdir' order by filename",
			"gallery_viewpage", 2, 5
			);
		$res .= $g->show($gallery_viewpage);
		$res .= "</td>\n";
		$res .= "<td width=50% valign=top>\n";
		$g =& new ViewSecGallery(
			$this->subdir,
			"select filename, username, caption from gallery_images
				where name = '$this->subdir' and username like '%|$thisform_user|%' order by filename",
			"gallery_uviewpage", 2, 5
			);
		$res .= $g->show($gallery_uviewpage);

		$res .= "</td>\n";
		$res .= "</tr>\n";
		$res .= "</table>\n";
		return $res;
	}

	function show_ownview() {
		global $gallery_viewpage, $gallery_oviewpage, $thisform_user, $show, $sess, $HTTP_GET_VARS;

		if( empty($thisform_user) )
			$thisform_user = "(All)";
		$res = "";
		if( isset($HTTP_GET_VARS["gallery_viewpage"]) ) {
			$gallery_viewpage = $HTTP_GET_VARS["gallery_viewpage"];
		}
		$sess->register("gallery_viewpage");
		if( isset($HTTP_GET_VARS["gallery_oviewpage"]) ) {
			$gallery_oviewpage = $HTTP_GET_VARS["gallery_oviewpage"];
		}
		$sess->register("gallery_oviewpage");
		if(! isset($gallery_viewpage) ) {
			$gallery_viewpage = 1;
		}
		if(! isset($gallery_oviewpage) ) {
			$gallery_oviewpage = 1;
		}
		$res .= "<table width=100%>\n";
		$res .= "<tr>\n";
		$res .= "<td nowrap align=center><b>All pictures</b></td>\n";
		$res .= "<td nowrap align=center><b>Pictures owned by '$thisform_user'</b></td>\n";
		$res .= "</tr>\n";
		$res .= "<tr>\n";
		$res .= "<script language=\"javascript\">\n";
		$res .= "<!--\n";
		$res .= "function selall() {;\n";
		for($cnt = 1;$cnt <= 10; $cnt++) {
			$res .= "   document.gallery_sec.row_$cnt.checked = true;\n";
		}
		$res .= "}\n";
		$res .= "function selall2() {\n";
		for($cnt = 1;$cnt <= 10; $cnt++) {
			$res .= "   document.gallery_sec.delrow_$cnt.checked = true;\n";
		}
		$res .= "}\n";
		$res .= "// -->\n";
		$res .= "</script>\n";
		$res .= "<td nowrap align=center><a href=javascript:selall()>Select All</a></td>\n";
		$res .= "<td nowrap align=center><a href=javascript:selall2()>Select All</a></td>\n";
		$res .= "</tr>\n";
		$res .= "<tr>\n";
		$res .= "<td width=50% valign=top>\n";
		$g =& new ViewUserGallery(
			$this->subdir,
			"select filename, username, caption from gallery_images
				where name = '$this->subdir' order by filename",
			"gallery_viewpage", 2, 5
			);
		$res .= $g->show($gallery_viewpage);
		$res .= "</td>\n";
		$res .= "<td width=50% valign=top>\n";
		$g =& new ViewSecGallery(
			$this->subdir,
			"select filename, username, caption from gallery_images
				where name = '$this->subdir' and ownername like '%|$thisform_user|%' order by filename",
			"gallery_oviewpage", 2, 5
			);
		$res .= $g->show($gallery_oviewpage);

		$res .= "</td>\n";
		$res .= "</tr>\n";
		$res .= "</table>\n";
		return $res;
	}


	function show_caption() {
		global $gallery_cappage, $show, $sess, $HTTP_GET_VARS;

		$res = "";
		if( isset($HTTP_GET_VARS["gallery_cappage"]) ) {
			$gallery_cappage = $HTTP_GET_VARS["gallery_cappage"];
		}
		$sess->register("gallery_cappage");

		if( isset($HTTP_GET_VARS["gallery_action"]) ) {
			$gallery_action = $HTTP_GET_VARS["gallery_action"];
		}
		switch($gallery_action) {
			case "delete" :
				$file = $HTTP_GET_VARS["filename"];
				$db =& new DB_SDS;
				$db->query("delete from gallery_images where name = '$this->subdir' and filename = '$file'");
				unlink($this->directory . "/" . $file);
				break;
		}
		if(! isset($gallery_cappage) ) {
			$gallery_cappage = 1;
		}
		$g =& new ViewCapGallery(
				$this->subdir,
				"select filename, username, caption from gallery_images
					where name = '$this->subdir' order by filename",
				"gallery_cappage", 2, 5
				);
		$res .= $g->show($gallery_cappage);
		return $res;
	}

	function update_admin() {
		global $gallery_admin, $thisform_user, $HTTP_POST_VARS;

		if( empty($thisform_user) )
			$thisform_user = "(All)";
		switch($gallery_admin) {
			case "caption" :
				$cnt = 1;
				$db =& new DB_SDS;
				while( isset($HTTP_POST_VARS[$cnt . "_filename"]) ) {
					$file = $HTTP_POST_VARS[$cnt . "_filename"];
					$cap = $HTTP_POST_VARS[$cnt . "_caption"];
					$db->query("update gallery_images set caption = '$cap' where name = '$this->subdir' and filename = '$file'");
					$cnt += 1;
				}
				break;
			case "userview" :
				$db =& new DB_SDS;
				for($cnt = 1; $cnt <= 10; $cnt++ ) {
					if( isset($HTTP_POST_VARS["row_" . $cnt]) ) {
						$file = $HTTP_POST_VARS["row_" . $cnt];
						$db->query("update gallery_images set username = concat_ws('', username, '|$thisform_user|') where name = '$this->subdir' and filename = '$file'");
					}
				}
				for($cnt = 1; $cnt <= 10; $cnt++ ) {
					if( isset($HTTP_POST_VARS["delrow_" . $cnt]) ) {
						$file = $HTTP_POST_VARS["delrow_" . $cnt];
						$db->query("update gallery_images set username = replace(username, '|$thisform_user|', '') where name = '$this->subdir' and filename = '$file'");
					}
				}
				break;
			case "userown" :
				$db =& new DB_SDS;
				for($cnt = 1; $cnt <= 10; $cnt++ ) {
					if( isset($HTTP_POST_VARS["row_" . $cnt]) ) {
						$file = $HTTP_POST_VARS["row_" . $cnt];
						$db->query("update gallery_images set ownername = concat_ws('', ownername, '|$thisform_user|') where name = '$this->subdir' and filename = '$file'");
					}
				}
				for($cnt = 1; $cnt <= 10; $cnt++ ) {
					if( isset($HTTP_POST_VARS["delrow_" . $cnt]) ) {
						$file = $HTTP_POST_VARS["delrow_" . $cnt];
						$db->query("update gallery_images set ownername = replace(ownername, '|$thisform_user|', '') where name = '$this->subdir' and filename = '$file'");
					}
				}
				break;
		}
		return $res;

	}
}



/*
		$db->query("select username from auth_user_md5 order by username");
		$s =& new MULTISELECTOptions();
		$s->add_element("*", "*");
		while($db->next_record()) {
			$u = $db->f("username");
			$s->add_element($u, $u);
		}

				$res .= "	<tr>\n";
				$res .= "		<td>\n";
				$res .= "			<select multiple size=4 name=" . $cnt2 . "_username[]>\n";
				$s->clear_default();
				$u = $db->f("username");
				$sec = split("\n", $u);
				$m = count($sec);
				for($i = 0; $i < $m; $i++) {
					$opt = $sec[$i];
					$opt = str_replace("|", "", $opt);
					$s->set_default($opt);
				}
				$res .= $s->show();
				$res .= "			</select>\n";
				$res .= "		</td>\n";
				$res .= "	</tr>\n";
*/
