/*
 *  HTML Options Class
 *
 *  Copyright (c) 2002 Willy De la Court <wdl@linux-lovers.be>
 *
 */
?><?php
class HTMLOptions {
	var $options = array();
	var $default = "";

	function add_element( $key, $value ) {
		$this->options[$key] = $value;
	}

	function set_default( $key ) {
		$this->default = $key;
	}

	function set_options( $opt ) {
		$this->options = $opt;
	}

	function show() {
		$ret = "";
		foreach( $this->options as $key => $value ) {
			$ret .= "<OPTION VALUE=\"$key\"";
			// Some weird stuff going on here it seems "0" == ""
			if( ("x" . $key) == ("x" . $this->default) ) {
				$ret .= " SELECTED";
			}
			$ret .= ">" . $value . "</OPTION>\n";
		}
		return( $ret );
	}
}

class DB_HTMLOptions extends HTMLOptions {
	function DB_HTMLOptions($sql, $database = "") {
		if( ! empty($database) ) {
			$db = new DB_DATA;
			if( $database != "%data%" ) {
				$db->query("USE " . $database);
			}
		} else {
			$db = new DB_SDS;
		}
		$db->query($sql);
		while( $db->next_record() ) {
			$k = $db->f("k");
			$v = $db->f("v");
			$this->add_element($k, $v);
		}
	}
}

class MULTISELECTOptions {
	var $options = array();
	var $default = array();

	function add_element( $key, $value ) {
		$this->options[$key] = $value;
	}

	function set_default( $key ) {
		$this->default[$key] = $key;
	}
	
	function clear_default() {
		$this->default = array();
	}

	function show() {
		$ret = "";
		foreach( $this->options as $key => $value ) {
			$ret .= "<OPTION VALUE=\"$key\"";
			if( $key == $this->default[$key] ) {
				$ret .= " SELECTED";
			}
			$ret .= ">" . $value . "</OPTION>\n";
		}
		return( $ret );
	}
}
