<?php

define(NETPBM_DIR, 		"/usr/bin/");
define(TH_DIR,			"/th");
define(TH_MAX_HEIGHT,	"100");
define(TH_MAX_WIDTH,	"100");

//IMAGE_TEST = "false";

class image {
	var $filename;
	var $tmp_file;
	var $th_tmp_file;
	var $type;
	var $thumbnail;
	var $height;
	var $width;
	var $fname;
	var $IMG_MAX_HEIGHT = 350;
	var $IMG_MAX_WIDTH = 350;

	function image($filename = "-1") {
		if($filename == "-1") {
			echo "ERROR: You must use a filename in new image()\n";
			exit;
		}
		$this->filename = $filename;
		if( !(eregi("\.(jpg|jpeg|gif)$",$this->filename)) ) {
			echo "ERROR: file [$filename] is an invalid type.\n";
			exit;
		}
		if(!(file_exists($this->filename))) {
			echo "ERROR: file [$filename] does not exist.\n";
			exit;
		}
		srand((double) microtime() * 1000000);
		$random = rand();

		$parts			= split("\.",$this->filename);
		$this->type		= $parts[(count($parts)-1)];

		$parts			= split("/",$this->filename);
		for($i=1; $i<count($parts); $i++){
			($i==(count($parts)-1)) ? $this->fname = $parts[$i] :$dname .= "/".$parts[$i];
		}
		$parts			= split("\.",$this->fname);
		$name			= $parts[(count($parts)-2)];

		$this->thumbnail	=  $dname . TH_DIR . "/th_" . $name . ".jpg";
		$this->tmp_file		=  $dname . TH_DIR . "/". $random . ".pnm";
		$this->th_tmp_file	=  $dname . TH_DIR . "/th_". $random . ".pnm";

		if( isset($MIMAGE_TEST) ) {
			echo "filename[".$this->filename."]\n";
			echo "directory = $dname\n";
			echo "filename  = $fname<br>\n";
			echo "thumbnail[".$this->thumbnail."]\n";
			echo "tmp_file[".$this->tmp_file."]\n";
			echo "th_tmp_file[".$this->th_tmp_file."]\n";
			echo "type[".$this->type."]\n";
		}
	}

	function create_thumbnail($thumbnail="-1") {
		if($thumbnail != "-1") {
			$this->thumbnail = $thumbnail;
		}

		$sizes = getimagesize($this->filename);
		$this->width	= $sizes[0];
		$this->height	= $sizes[1];

		if(($this->width <= 0) || ($this->height <= 0)){
			echo "ERROR: could not get size of imape[$filename]\n";
			exit;
		}

		if( ($this->width <= TH_MAX_WIDTH) && ($this->height <= TH_MAX_HEIGHT) ) {
			$resize_cmd = "/bin/cp ".$this->filename." ".$this->thumbnail;
			system($resize_cmd);
			return;
		}
		(eregi("(jpeg|jpg)",$this->type))? $pnm_cmd = "jpegtopnm" :	$pnm_cmd = "giftopnm";
		$tmp_cmd = NETPBM_DIR . $pnm_cmd . " " . $this->filename . " > ". $this->tmp_file;

		if($this->width > $this->height) {
			$new_height = (TH_MAX_WIDTH/$this->width) * $this->height;
			if($new_height > TH_MAX_HEIGHT) {
				$resize_cmd  = NETPBM_DIR. "pnmscale -height=" . TH_MAX_HEIGHT ." ".$this->tmp_file."  > ".$this->th_tmp_file;
			} else {
				$resize_cmd  = NETPBM_DIR. "pnmscale -width=". TH_MAX_WIDTH ." ".$this->tmp_file."  > 	".$this->th_tmp_file;
			}
		} else {
			$new_width = (TH_MAX_HEIGHT/$this->height) * $this->width;
			if($new_width > TH_MAX_WIDTH) {
				$resize_cmd  = NETPBM_DIR. "pnmscale -width=". TH_MAX_WIDTH ." ".$this->tmp_file."  > 	".$this->th_tmp_file;
			} else {
				$resize_cmd  = NETPBM_DIR. "pnmscale -height=" . TH_MAX_HEIGHT ." ".$this->tmp_file."  > ".$this->th_tmp_file;
			}
		}

		$thumb_cmd = NETPBM_DIR. "ppmtojpeg ". $this->th_tmp_file ." > ".$this->thumbnail;

		if( isset($MIMAGE_TEST) ) {
			echo $tmp_cmd . "\n";
			echo $resize_cmd . "\n";
			echo $thumb_cmd . "\n";
		}
		$junk = `$tmp_cmd`;
		$junk = `$resize_cmd`;
		$junk = `$thumb_cmd`;

		if(file_exists($this->tmp_file)){
			unlink($this->tmp_file);
		}
		if(file_exists($this->th_tmp_file)){
			unlink($this->th_tmp_file);
		}
	}

	function show_thumbnail() {
		if(!file_exists($this->thumbnail)){
			$this->create_thumbnail();
		}
		if( stristr($this->thumbnail, ".gif") ) {
			header("Content-type: image/gif");
		} else {
			header("Content-type: image/jpeg");
		}
		$ts = date('D, d M Y H:i:s T', gmmktime(0, 0 ,0 ,gmdate("m"), (gmdate("d")+30), gmdate("Y")));

		header("Expires: $ts");
		header("Cache-Control: max-age=2592000, min-fresh=2592000, max-stale=0");
		readfile($this->thumbnail);
	}

	function show_image($addtext) {
		if( $addtext == "no" ) {
			if( stristr($this->filename, ".gif") ) {
				header("Content-type: image/gif");
			} else {
				header("Content-type: image/jpeg");
			}
			readfile($this->filename);
		} else {
			$s = getimagesize($this->filename);
			$w = $s[0];
			$h = $s[1];
			$image = imagecreatefromjpeg($this->filename);
			$white = imagecolorclosest($image, 255,255,255);
			if( $w > $h )
				$x = $h / $w;
			else
				$x = $w / $h;
			imagettftext($image, $h / 7, rad2deg(acos($x)), $h / 7, $h, $white, "/var/www/sds/utils/arial.ttf", "Copyright 2003");
			header("Content-type: image/jpeg");
			imagejpeg($image);
			imagedestroy($image);
		}
	}
	
	function read_size() {
		$sizes = getimagesize($this->filename);
		$this->width	= $sizes[0];
		$this->height	= $sizes[1];
		if( $this->width > $this->height ) {
			$this->new_width = $this->IMG_MAX_WIDTH;
			$this->new_height = ($this->IMG_MAX_WIDTH/$this->width) * $this->height;
		} else {
			$this->new_height = $this->IMG_MAX_HEIGHT;
			$this->new_width = ($this->IMG_MAX_HEIGHT/$this->height) * $this->width;
		}
	}
	
	function set_maxsize($size) {
		$this->IMG_MAX_WIDTH = $size;
		$this->IMG_MAX_HEIGHT = $size;
	}
}

