/*
 * Ip Class
 *
 *  Copyright (c) 2004 Willy De la Court <wdl@linux-lovers.be>
 */
?><?php

class Ips {
	var $ips = array();
	
	function Ips() {
		global $auth;
		$db = new DB_SDS;
		
		$user_id = $auth->auth["uid"];
		$db->query("select user_ips.ip from auth_user_md5 inner join user_ips on auth_user_md5.username = user_ips.username where auth_user_md5.user_id = '$user_id'");
		while( $db->next_record() ) {
			$val = $db->f("ip");
			$this->ips[$val] = $val;
		}
	}

	function has_ips() {
		return( count($this->ips) > 0 );
	}

	function has_access() {
		global $REMOTE_ADDR;

		$result = false;
		# Check to see if an access list exists
		if( $this->has_ips() ) {
			# yep check all ips
			foreach($this->ips as $val) {
				$result = $result || $this->testip( $val, $REMOTE_ADDR );
			}
		} else {
			# nope so let the user in
			$result = true;
		}
		return( $result );
	}

	function testip($range,$ip) {
		$result = true;

		# IP Pattern Matcher
		# J.Adams <jna@retina.net>
		#
		# Matches:
		#
		# xxx.xxx.xxx.xxx        (exact)
		# xxx.xxx.xxx.[yyy-zzz]  (range)
		# xxx.xxx.xxx.xxx/nn    (nn = # bits, cisco style -- i.e. /24 = class C)
		#
		# Does not match:
		# xxx.xxx.xxx.xx[yyy-zzz]  (range, partial octets not supported)


		if (ereg("([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)/([0-9]+)",$range,$regs)) {

			# perform a mask match
			$ipl = ip2long($ip);
			$rangel = ip2long($regs[1] . "." . $regs[2] . "." . $regs[3] . "." . $regs[4]);

			$maskl = 0;

			for ($i = 0; $i< 31; $i++) {
				if ($i < $regs[5]-1) {
					$maskl = $maskl + pow(2,(30-$i));
				}
			}

			if (($maskl & $rangel) == ($maskl & $ipl)) {
				return true;
			} else {
				return false;
			}
		} else {

			# range based
			$maskocts = split("\.",$range);
			$ipocts = split("\.",$ip);

			# perform a range match
			for ($i=0; $i<4; $i++) {
				if (ereg("\[([0-9]+)\-([0-9]+)\]",$maskocts[$i],$regs)) {
					if ( ($ipocts[$i] > $regs[2]) || ($ipocts[$i] < $regs[1])) {
						$result = false;
					}
				}
				else
				{
					if ($maskocts[$i] <> $ipocts[$i]) {
						$result = false;
					}
				}
			}
		}
		return $result;
	}
}
