/*
 * Keytable support functions
 *
 *  Copyright (c) 2003 Willy De la Court <wdl@linux-lovers.be>
 */
?><?php

if( file_exists("cache/key_tables.php") ) {
	include "cache/key_tables.php";
} else {
	$key_tables = array();
}

function get_keytable($tablename, $database = "") {
	global $key_tables;

	$table = $key_tables[$tablename];
	if( isset($table) ) {
		$opt =& new HTMLOptions;
		$opt->set_options($table);
	} else {
		$opt =& new DB_HTMLOptions("select key_code, key_value from keytable where key_type = ' ' and key_table = '" . $tablename . "' order by key_code", $database);
	}
	return $opt;
}

function get_keytable_value($tablename, $value, $database = "") {
	global $key_tables;

	$val = "";
	$table = $key_tables[$tablename];
	if( isset($table) ) {
		$val = $table[$value];
	} else {
	}
	return $val;
}

function add_quotes($val) {
	return("\"" . $val . "\"");
}

function add_s_quotes($val) {
	return("'" . $val . "'");
}


function create_keytable_cache($database = "") {
	global $theme;

	if( ! empty($database) ) {
		$xdb = new DB_DATA;
		$db = new DB_DATA;
		if( $database != "%data%" ) {
			$db->query("USE " . $database);
			$xdb->query("USE " . $database);
		}
	} else {
		$xdb = new DB_SDS;
		$db = new DB_SDS;
	}
	$db->query("select key_table from keytable where key_type = 'T'");
	$c = "<?php\n";
	$c .= "\$key_tables = array(";
	$f = 1;
	while($db->next_record()) {
		$t = $db->f("key_table");
		if($f == 0)
			$c .= ",";
		$f = 0;
		$c .= "\n";
		$c .= "	" . add_quotes($t) . " => \n";
		$c .= "		array(";
		$xdb->query("select key_code, key_value from keytable where key_type = ' ' and key_table = '" . $t . "' order by key_code");
		$f2 = 1;
		while($xdb->next_record()) {
			$k = $xdb->f("key_code");
			$v = $xdb->f("key_value");
			if($f2 == 0)
				$c .= ",";
			$f2 = 0;
			$c .= "\n";
			$c .= "		" . add_quotes($k) . " => " . add_quotes($v);
		}
		$c .= "\n";
		$c .= "		)";
	}
	$c .= "\n";
	$c .= ");\n";
	$c .= "?>";
	$fh = fopen("cache/key_tables.php", "w");
	fwrite($fh, $c);
	fclose($fh);
	echo "Keytables cached!<BR>";
}

