/*
 *  Layout Class
 *
 *  Copyright (c) 2002 Willy De la Court <wdl@linux-lovers.be>
 *
 */
?><?php
class Layout extends Plugin {
	var $classname = "Layout";
	var $obj    = array();
	var $param  = array();
	var $place  = array();
	var $file   = "layout.ihtml";
	var $cnt    = 0;

	function Layout() { $this->Plugin(); }

	function add_element( &$obj, $param = "", $place = "" ) {
		$this->obj[$this->cnt] =& $obj;
		$this->param[$this->cnt] = $param;
		$this->place[$this->cnt] = $place;
		$this->cnt++;
	}

	function clear() {
		unset($this->obj);
		unset($this->param);
		unset($this->place);
		$this->obj = array();
		$this->param = array();
		$this->place = array();
	}

	function show() {
		$t =& new template($this->theme, "remove");
		$t->set_file(array("layout" => $this->file));
		$t->set_block("layout", "row", "rows");
		$t->set_block("layout", "row1", "rows1");
		$t->set_block("layout", "row2", "rows2");
		$t->set_block("layout", "row3", "rows3");
		$cnt = count($this->obj);
		foreach( array_keys($this->obj) as $k ) {
			$param = $this->param[$k];
			$place = $this->place[$k];
			$var =& $this->obj[$k];
			$body = $var->show();
			$t->set_var(array("BODY" => $body,
					"PARAM" => $param));
			$t->parse("rows" . $place, "row" . $place, true);
		}
		$t->set_var("COLS", $cnt);
		$t->parse("out", array("layout"));
		return $t->get("out");
	}

	function admin() {
		global $submit, $layoutgroup, $layoutorder, $layoutparam, $place, $oldgroup, $oldorder, $item;
		global $itemname, $itemplugin, $itemtitle, $itemlink, $permissions, $olditemname;
		
		switch( $submit ) {
			case "save" :
				$mdb = new DB_SDS;
				$mdb->query("update layout set "
					."layoutgroup='$layoutgroup', "
					."layoutorder='$layoutorder', "
					."layoutparam='$layoutparam', "
					."name='$item', "
					."place='$place' "
					."where "
					."layoutgroup='$oldgroup' and "
					."layoutorder='$oldorder'");
				break;
			case "new" :
				$mdb = new DB_SDS;
				$mdb->query("insert into layout ("
					."layoutgroup, "
					."layoutorder, "
					."layoutparam, "
					."name, "
					."place"
					.") values ("
					."'$layoutgroup', "
					."'$layoutorder', "
					."'$layoutparam', "
					."'$item', "
					."'$place')");
				break;
			case "delete" :
				$mdb = new DB_SDS;
				$mdb->query("delete from layout "
					."where "
					."layoutgroup='$oldgroup' and "
					."layoutorder='$oldorder'");
				break;
			case "itemsave" :
				$mdb = new DB_SDS;
				$mdb->query("update items set "
					."name='$itemname', "
					."plugin='$itemplugin', "
					."title='$itemtitle', "
					."link='$itemlink', "
					."perm='$permissions' "
					."where "
					."name='$olditemname'");
				break;
			case "itemnew" :
				$mdb = new DB_SDS;
				$mdb->query("insert into items ("
					."name, "
					."plugin, "
					."title, "
					."link, "
					."perm"
					.") values ("
					."'$itemname', "
					."'$itemplugin', "
					."'$itemtitle', "
					."'$itemlink', "
					."'$permissions')");
				break;
			case "itemdelete" :
				$mdb = new DB_SDS;
				$mdb->query("delete from items "
					."where "
					."name='$olditemname'");
				break;
		}
		$this->show_admin();
	}

	function show_admin() {
		global $group;

		if( empty($group) ) {
			$group = "default";
		}
		$permissions = new HTMLOptions;
		$permissions->add_element("",           "");
		$permissions->add_element("user",       "User");
		$permissions->add_element("author",     "Author");
		$permissions->add_element("editor",     "Editor");
		$permissions->add_element("supervisor", "Supervisor");
		$permissions->add_element("admin",      "Admin");

		$plug = new HTMLOptions;
		$plug->add_element("",           "");
		$plug->add_element("Article",    "Article");
		$plug->add_element("Articles",   "Articles");
		$plug->add_element("Copyright",  "Copyright");
		$plug->add_element("Links",      "Links");
		$plug->add_element("Login",      "Login");
		$plug->add_element("Logo",       "Logo");
		$plug->add_element("Menu",       "Menu");
		$plug->add_element("Search",     "Search");
		$plug->add_element("Text",       "Text");
		$plug->add_element("Headlines",  "Headlines");
		$plug->add_element("Headermenu", "Headermenu");
		$plug->add_element("Date", "Date");
		$plug->add_element("Time", "Time");
		$plug->add_element("Form", "Form");
		$plug->add_element("TreeMenu", "TreeMenu");
		$plug->add_element("UserEdit", "UserEdit");
		$plug->add_element("Admin_AddItem", "Admin_AddItem");
		$plugframe = $plug->show();
		$options = new HTMLOptions;
		$options->add_element("",        "");
		$options->add_element("header1", "Top header");
		$options->add_element("header2", "Middle header");
		$options->add_element("header3", "Bottom header");
		$options->add_element("left",    "Left");
		$options->add_element("middle",  "Middle");
		$options->add_element("right",   "Right");
		$options->add_element("footer",  "Footer");
		$optframe = $options->show();
		$db = new DB_SDS;
		$db->query("select distinct layoutgroup from layout order by layoutgroup");
		$layout = new HTMLOptions;
		$layout->set_default($group);
		$layout->add_element("default", "default");
		$cnt = $db->num_rows();
		for( $i = 1; $i <= $cnt; $i++ ) {
			$db->next_record();
			$p = $db->f("layoutgroup");
			$layout->add_element($p, $p);
		}
		$optgroup = $layout->show();

		$db = new DB_SDS;
		$db->query("select distinct name from items");
		$items = new HTMLOptions;
		$cnt = $db->num_rows();
		for( $i = 1; $i <= $cnt; $i++ ) {
			$db->next_record();
			$p = $db->f("name");
			$items->add_element($p, $p);
		}

		$t =& new Template($this->admin, "remove");
		$t->set_file(array("layout" => $this->file));
		$t->set_var(array("CLASS" => $this->classname,
				"OPTFRAME" => $optframe,
				"OPTGROUP" => $optgroup,
				"GROUP" => $group));

		$t->set_block("layout", "row", "rows");
		$db->query("select * from layout where layoutgroup = '$group' order by layoutorder");
		$cnt = $db->num_rows();
		for( $i = 1; $i <= $cnt; $i++ ) {
			$db->next_record();
			$options->set_default($db->f("place"));
			$items->set_default($db->f("name"));
			$layout->set_default($db->f("layoutgroup"));
			$t->set_var(array("CLASS" => $this->classname,
					"LAYOUTORDER" => $db->f("layoutorder"),
					"LAYOUTPARAM" => $db->f("layoutparam"),
					"PLACE" => $options->show(),
					"ITEM" => $items->show(),
					"LAYOUTGROUP" => $layout->show(),
					"GROUP" => $group));
			$t->parse("rows", "row", true);
		}

		$t->set_block("layout", "itemsrow", "itemsrows");
		$db->query("select items.name, items.plugin, items.title, items.link, items.perm from layout, items where layoutgroup = '$group' and layout.name = items.name order by layoutorder");
		$cnt = $db->num_rows();
		for( $i = 1; $i <= $cnt; $i++ ) {
			$db->next_record();
			$plug->set_default($db->f("plugin"));
			$permissions->set_default($db->f("perm"));
			$t->set_var(array("CLASS" => $this->classname,
					"ITEMNAME" => $db->f("name"),
					"ITEMTITLE" => $db->f("title"),
					"ITEMLINK" => $db->f("link"),
					"PERMISSIONS" => $permissions->show(),
					"PLUGIN" => $plug->show(),
					"GROUP" => $group));
			$t->parse("itemsrows", "itemsrow", true);
		}
		$t->parse("out", array("layout"));
		echo $t->get("out");
	}
}
