/*
 *  Page Class
 *
 *  Copyright (c) 2002 Willy De la Court <wdl@linux-lovers.be>
 *
 */
?><?php
class Page extends Plugin {
	var $classname = "Page";
	var $header;
	var $left;
	var $middle;
	var $right;
	var $footer;
	var $title = "Title";

	function Page() {
		$this->Plugin();
		$this->header =& new Header;
		$this->left   =& new Column;
		$this->middle =& new Column;
		$this->right  =& new Column;
		$this->footer =& new Footer;
	}

	function set_title( $t ) { $this->title = $t; }

	function add_element( $where, &$obj, $param = "" ) {
		switch( $where ) {
			case "header1":
				$this->header->add_element($obj, $param, "1");
				break;
			case "header2":
				$this->header->add_element($obj, $param, "2");
				break;
			case "header3":
				$this->header->add_element($obj, $param, "3");
				break;
			case "left":
				$this->left->add_element($obj, $param);
				break;
			case "middle":
				$this->middle->add_element($obj, $param);
				break;
			case "right":
				$this->right->add_element($obj, $param);
				break;
			case "footer":
				$this->footer->add_element($obj, $param);
				break;
		}
	}

	function get_layout() {
		global $PHP_SELF, $sess, $auth, $perm, $show, $showreg, $oldshow, $name, $class, $admin_func, $layoutgroup, $place;

		if( !isset($show) && isset($showreg) )
			$show = $showreg;
		if( !isset($show) )
			$show = "home";
		$oldshow = $showreg;
		$showreg = $show;
		$sess->register("showreg");
		$sess->register("oldshow");

		$db = new DB_SDS;
		if( $perm->have_perm("editor") ) {
			switch( $admin_func ) {
				case "cacheon":
					$db->query("select * from items where name = '$name'");
					if( $db->num_rows() == 1 ) {
						$db->next_record();
						$db->Record["cached"] = "N";
						$c =& new $class($db->Record, "Y");
						$c->create_cache();
					}
					break;

			}
		}
		if( $perm->have_perm("admin") ) {
			switch( $admin_func ) {
				case "delete":
					$db->query("delete from layout where name = '$name' and layoutgroup = '$layoutgroup' and place = '$place'");
					break;

				case "cacheoff":
					$db->query("update items set cached='N' where name = '$name'");
					break;

				case "moveup":
					$db->query("select name, layoutorder from layout where layoutgroup = '$layoutgroup' and place = '$place'");
					$nr = $db->num_rows();
					$db->next_record();
					$name2 = $db->f("name");
					$pos2 = $db->f("layoutorder");
					for($i = 1;$i <= $nr; $i++) {
						if( $db->f("name") == $name ) {
							$pos = $db->f("layoutorder");
							/* Found position now get next item */
							if($i == 1) {
								/* are already at the first item so do nothing */
								break;
							}
							/* get name and position of next item */
							$db->next_record();
							/* move next record to end by giving it position 9999 */
							$db->query("update layout set layoutorder = 9999 where layoutgroup = '$layoutgroup' and name = '$name2' and layoutorder = $pos2");
							/* move the record to be move into the correct place */
							$db->query("update layout set layoutorder = $pos2 where layoutgroup = '$layoutgroup' and name = '$name' and layoutorder = $pos");
							/* move the next record into the place of the first */
							$db->query("update layout set layoutorder = $pos where layoutgroup = '$layoutgroup' and name = '$name2' and layoutorder = 9999");
							break;
						}
						$name2 = $db->f("name");
						$pos2 = $db->f("layoutorder");
						$db->next_record();
					}
					break;

				case "movedown":
					$db->query("select name, layoutorder from layout where layoutgroup = '$layoutgroup' and place = '$place'");
					$nr = $db->num_rows();
					for($i = 1;$i <= $nr; $i++) {
						$db->next_record();
						if( $db->f("name") == $name ) {
							$pos = $db->f("layoutorder");
							/* Found position now get next item */
							if($i == $nr) {
								/* are already at the last item so do nothing */
								break;
							}
							/* get name and position of next item */
							$db->next_record();
							$name2 = $db->f("name");
							$pos2 = $db->f("layoutorder");
							/* move next record to end by giving it position 9999 */
							$db->query("update layout set layoutorder = 9999 where layoutgroup = '$layoutgroup' and name = '$name2' and layoutorder = $pos2");
							/* move the record to be move into the correct place */
							$db->query("update layout set layoutorder = $pos2 where layoutgroup = '$layoutgroup' and name = '$name' and layoutorder = $pos");
							/* move the next record into the place of the first */
							$db->query("update layout set layoutorder = $pos where layoutgroup = '$layoutgroup' and name = '$name2' and layoutorder = 9999");
							break;
						}
					}
					break;
			}
		}
		$db->query("select * from layout, items where layout.name = items.name and (layoutgroup = 'default' or layoutgroup = '$show') order by layoutorder");
		if( $db->num_rows() > 0 ) {
			$cnt = $db->num_rows();
			for( $i = 1; $i <= $cnt; $i++ ) {
				$db->next_record();
				$side = $db->f("place");
				$class = $db->f("plugin");
				$lparam = $db->f("layoutparam");
				$permissions = trim($db->f("perm"));
				if( $perm->have_perm($permissions) || empty($permissions) ) {
					$obj =& new $class($db->Record);
					$this->add_element($side, $obj, $lparam);
				}
			}
		}
	}

	function show() {
		global $pagetitle;
		$t =& new template($this->theme, "remove");
		$t->set_file(array("page" => "page.ihtml"));
		$header = $this->header->show();
		$left   = $this->left->show();
		$middle = $this->middle->show();
		$right  = $this->right->show();
		$footer = $this->footer->show();
		$t->set_var(array("TITLE" => $pagetitle,
				"HEADER"  => $header,
				"LEFT" => $left,
				"MIDDLE" => $middle,
				"RIGHT" => $right,
				"FOOTER" => $footer,
				"STYLE" => $this->theme . "/style.css"));
		$t->parse("out", array("page"));
		$t->p("out");
	}
}

class admin_pageitem {
	var $cnt = 0;
	var $items = array();

	function add_element($name, $order) {
		$this->items[$this->cnt] = $order . "-" . $name;
		$this->cnt++;
	}
}

class admin_pagecol extends admin_pageitem {

	function show($display, $name) {
		$res = "";
		$res .= "<table border=1 width=100%>\n";
		$res .= "<tr class=itemheader><td class=itemheader align=center>";
		$res .= "<a href=javascript:setval(\"" . $name . "\")>" . $display . "</b></td></tr>\n";
		$res .= "</table>\n";
		$res .= "<table border=1 width=100%>\n";
		for($i = 0;$i < $this->cnt;$i++) {
			$res .= "<tr><td>";
			$res .= $this->items[$i] . "&nbsp;";
			$res .= "</td></tr>\n";
		}
		$res .= "</table>\n";
		return $res;
	}
}

class admin_pagerow extends admin_pageitem {

	function show($display, $name) {
		$res = "";
		$res .= "<table border=1 width=100%>\n";
		$res .= "<tr class=itemheader><td class=itemheader align=center>";
		$res .= "<a href=javascript:setval(\"" . $name . "\")>" . $display . "</a></td></tr>\n";
		$res .= "</table>\n";
		$res .= "<table border=1 width=100%>\n";
		$res .= "<tr>";
		for($i = 0;$i < $this->cnt;$i++) {
			$res .= "<td>";
			$res .= $this->items[$i] . "&nbsp;";
			$res .= "</td>";
		}
		$res .= "</tr>\n";
		$res .= "</table>\n";
		return $res;
	}
}

class admin_page {
	var $header1;
	var $header2;
	var $header3;
	var $left;
	var $middle;
	var $right;
	var $footer;

	function admin_page($name) {
		$this->header1 =& new admin_pagerow();
		$this->header2 =& new admin_pagerow();
		$this->header3 =& new admin_pagerow();
		$this->left =& new admin_pagecol();
		$this->middle =& new admin_pagecol();
		$this->right =& new admin_pagecol();
		$this->footer =& new admin_pagerow();
		$db =& new DB_SDS;
		$db->query("select items.name, layout.place, layout.layoutorder from layout, items where layout.name = items.name and layoutgroup = '$name' order by layoutorder");
		if( $db->num_rows() > 0 ) {
			$cnt = $db->num_rows();
			for( $i = 1; $i <= $cnt; $i++ ) {
				$db->next_record();
				$place = $db->f("place");
				$itemname = $db->f("name");
				$order = $db->f("layoutorder");
				$this->add_element($itemname, $place, $order);
			}
		}
	}

	function add_element($name, $where, $order) {
		switch( $where ) {
			case "header1":
				$this->header1->add_element($name, $order);
				break;
			case "header2":
				$this->header2->add_element($name, $order);
				break;
			case "header3":
				$this->header3->add_element($name, $order);
				break;
			case "left":
				$this->left->add_element($name, $order);
				break;
			case "middle":
				$this->middle->add_element($name, $order);
				break;
			case "right":
				$this->right->add_element($name, $order);
				break;
			case "footer":
				$this->footer->add_element($name, $order);
				break;
		}
	}

	function show() {
		$res = "";
		$res .= "<SCRIPT language=\"javascript\">\n";
		$res .= "<!--\n";
		$res .= "function setval(v) {\n";
		$res .= "document.layout_add.thisform_place.value = v;\n";
		$res .= "}\n";
		$res .= "-->\n";
		$res .= "</SCRIPT>\n";
		$res .= "<table border=1 width=100%>\n";
		$res .= "<tr><td valign=top colspan=3>" . $this->header1->show("Top Header", "header1") . "</td></tr>\n";
		$res .= "<tr><td valign=top colspan=3>" . $this->header2->show("Middle Header", "header2") . "</td></tr>\n";
		$res .= "<tr><td valign=top colspan=3>" . $this->header3->show("Bottom Header", "header3") . "</td></tr>\n";
		$res .= "<tr>";
		$res .= "<td valign=top width=100>" . $this->left->show("Left", "left") . "</td>";
		$res .= "<td valign=top width=500>" . $this->middle->show("Middle", "middle") . "</td>";
		$res .= "<td valign=top width=100>" . $this->right->show("Right", "right") . "</td>";
		$res .= "</tr>\n";
		$res .= "<tr><td valign=top colspan=3>" . $this->footer->show("Footer", "footer") . "</td></tr>\n";
		$res .= "</table>\n";
		return $res;
	}
}
