/*
 *  Base class for data Plugins
 *
 *  Copyright (c) 2002 Willy De la Court <wdl@linux-lovers.be>
 *
 */
?><?php
class PlainPlugin extends Plugin {
	var $classname = "PlainPlugin";
	var $adm_form = "";
	var $adm_var = "";
	var $vars = array();
	var $name = "";
	var $adminvars = array();
	var $cached = "N";
	var $cachedfile = "";
	var $createcache = "N";
	var $editable = "N";
	var $cacheable = "N";
	var $layoutgroup = "";
	var $place = "";

	function set_vars( $record = array() ) {}

	function PlainPlugin( $record = array(), $createcache = "N" ) {
		global $show, $PHP_SELF;

		$this->Plugin();
		$this->createcache = $createcache;
		if( ! empty($record) ) {
			$this->name = $record["name"];
			$this->layoutgroup = $record["layoutgroup"];
			$this->place = $record["place"];
			$this->cached = $record["cached"];
			$this->cachedfile = $this->cache_dir . "/" . $this->name . "_" . $this->file;
			if( $this->cached == "Y" )
				if( ! file_exists($this->cachedfile) )
					$this->cached = "N";
			$this->adminvars["FORM"] = "show=" . $this->adm_form;
			$this->adminvars["FORM_EDITOR"] = "show=editor_" . $this->adm_form;
			$this->adminvars["VAR_EDITOR"] = "&" . "editor_" . $this->adm_var . "=" . $this->name;
			$this->adminvars["VAR"] = "&" . $this->adm_var . "=" . $this->name;
			$this->adminvars["CLASS"] = $this->classname;
			$this->adminvars["NAME"] = $this->name;
			$this->adminvars["URL"] = $PHP_SELF;
			$this->adminvars["THEME"] = $this->theme;
			if($this->createcache == "Y") {
				$this->adminvars["ONOFFIMAGE"] = "cacheon.gif";
				$this->adminvars["ONOFF"] = "cacheoff";
				$this->adminvars["BC"] = "<?php global \$perm, \$show; if(\$perm->have_perm(\"admin\")) { ?>";
				$this->adminvars["EC"] = "<?php } ?>";
				$this->adminvars["BM"] = "<?php global \$perm, \$show; if((\$perm->have_perm(\"editor\") && $this->classname == \"Text\") || \$perm->have_perm(\"admin\")) { ?>";
				$this->adminvars["EM"] = "<?php } ?>";
				$this->adminvars["LAYOUTGROUP"] = "<?php echo \$this->layoutgroup; ?>";
				$this->adminvars["PLACE"] = "<?php echo \$this->place; ?>";
				$this->adminvars["SHOW"] = "<?php echo \$show;; ?>";
			} else {
				$this->adminvars["ONOFFIMAGE"] = "cacheoff.gif";
				$this->adminvars["ONOFF"] = "cacheon";
				$this->adminvars["LAYOUTGROUP"] = $this->layoutgroup;
				$this->adminvars["PLACE"] = $this->place;
				$this->adminvars["SHOW"] = $show;
			}
			$this->set_vars($record);
		}
	}

	function show_cache() {
			$cachedresult = "";
			ob_start();
			include($this->cachedfile);
			$cachedresult = ob_get_contents();
			ob_end_clean();
			return($cachedresult);
	}

	function show() {
		if( $this->cached == "Y" ) {
			return($this->show_cache());
		} else {
			$t =& new Template($this->theme, "remove");
			$t->set_file(array("layout" => $this->file));
			$t->set_var($this->vars);
			$t->parse("out", array("layout"));
			return $t->get("out");
		}
	}

	function create_cache() {
		if( $this->cacheable == "Y") {
			$mdb = new DB_SDS;
			$r = $this->show();
			$fh = fopen($this->cachedfile, "w");
			fwrite($fh, "<!-- cached -->\n");
			fwrite($fh, $r);
			fclose($fh);
			$mdb->query("update items set cached='Y' where name = '" . $this->name . "'");
		}
	}

	function add_adminvar( $key, $value ) {
		$this->adminvars[$key] = $value;
	}

	function admin_button() {
		global $perm;

		if( $perm->have_perm("editor") || $perm->have_perm("admin") || $this->createcache == "Y" ) {
			$t =& new Template($this->theme, "remove");
			$t->set_file(array("layout" => "admin_button.ihtml"));
			$t->set_var($this->adminvars);
			$t->set_block("layout", "modify", "modifybutton");
			$t->set_block("layout", "edit", "editbutton");
			$t->set_block("layout", "cache", "cachebutton");
			$t->set_block("layout", "delete", "deletebutton");
			$t->set_block("layout", "move", "movebutton");
			if( $this->classname == "Text") {
				if( $this->editable == "Y" ) {
					$t->parse("modifybutton", "modify", true);
				}
			}
			if( $perm->have_perm("admin") || $this->classname == "Text") {
				if( $this->cacheable == "Y" ) {
					$t->parse("cachebutton", "cache", true);
				}
			}
			if( $perm->have_perm("admin") ) {
				if( $this->editable == "Y" ) {
					$t->parse("editbutton", "edit", true);
				}
				$t->parse("deletebutton", "delete", true);
				$t->parse("movebutton", "move", true);
			}
			$t->parse("out", array("layout"));
			return $t->get("out");
		} else {
			return "";
		}
	}
}
