/*
 *  Report Plugin Class
 *
 *  Copyright (c) 2004 Willy De la Court <wdl@linux-lovers.be>
 *
 */
?><?php

define('FPDF_FONTPATH','utils/font/');
require('utils/fpdf.php');

class Report extends FPDF {
	var $rep_width = 0;
	var $rep_query = "";
	var $rep_name = "";
	var $rep_title = "";
	var $rep_fieldcount = 0;
	var $rep_widths = array();
	var $rep_headings = array();
	var $rep_fields = array();
	var $rep_align = array();
	var $rep_fieldcode = array();
	var $rep_database = "";
	var $rep_field;

	function Report($rep_name = "") {
		$this->rep_name = $rep_name;
		//$this->FPDF($orientation, $unit, $format);
		$this->FPDF("P", "mm", "A4");
	}

	function Header()
	{
		//$this->Image('logo_pb.png',10,8,33);
		$this->SetFont('Arial', 'B', 15);
		//$this->Cell(40);
		// Report Title
		$this->Cell(0, 10, $this->rep_title, 1, 1, 'C');

		// Column Headers
		$this->SetFont('Courier','B',10);
		$this->Cell(0, 5, $this->show_headers(), 'B', 1);
		$this->Ln();

	}
	
	//Page footer
	function Footer()
	{
		//Position at 1.5 cm from bottom
		$this->SetY(-15);
		//Arial italic 8
		$this->SetFont('Arial', 'I', 8);
		//Page number
		$this->Cell(0, 10, 'Page ' . $this->PageNo() . '/{nb}', 0, 0, 'C');
	}

	function add_quotes($val) { return("\"" . $val . "\""); }

	function get_data() {
		$db = new DB_SDS;
		$db->query("select * from report where name = '" . $this->rep_name . "'");
		if($db->next_record()) {
			$this->set_query($db->f("sql"));
			$this->set_database($db->f("db"));
			$this->set_title($db->f("title"));
			$db->query("select * from report_detail where name = '" . $this->rep_name . "' order by columnorder");
			while($db->next_record()) {
				$this->add_column($db->f("header"), $db->f("fieldname"), $db->f("width"), $db->f("align"), $db->f("fieldcode"));
			}
		}
	}

	function set_database($rep_database) {
		$this->rep_database = $rep_database;
	}

	function set_query($query) {
		$this->rep_query = $query;
	}

	function set_title($title) {
		$this->rep_title = $title;
	}

	function add_column($header, $fieldname, $width, $align = "left", $fieldcode = "") {
		$this->rep_fieldcount++;
		$this->rep_headings[$this->rep_fieldcount] = $header;
		$this->rep_fields[$this->rep_fieldcount] = $fieldname;
		$this->rep_widths[$this->rep_fieldcount] = $width;
		$this->rep_align[$this->rep_fieldcount] = $align;
		$this->rep_fieldcode[$this->rep_fieldcount] = $fieldcode;
		$this->rep_width = $this->rep_width + $width;
	}

	function show() {
		global $rep_cond;

		$this->AliasNbPages();
		$this->AddPage();
		$this->SetFont('Courier','',10);

		if( ! empty($this->rep_database) ) {
			$db = new DB_DATA;
			if( $this->rep_database != "%data%" ) {
				$db->query("USE " . $this->rep_database);
			}
		} else {
			$db = new DB_SDS;
		}
		eval("\$query = \"$this->rep_query\";");
		$db->query($query);
		$cnt = 1;
		while($db->next_record()) {
			$this->show_line($db, $cnt);
			$cnt++;
		}
		if( ! empty($this->rep_database) ) {
			$database = $db->SDS_Database;
			$db->query("USE " . $database);
		}
		$this->Output();
		exit;
	}

	function show_headers() {

		$res = "";
		for( $i = 1; $i <= $this->rep_fieldcount; $i++ ) {
			$res .= padr($this->rep_headings[$i], $this->rep_widths[$i]);
		}
		return $res;
	}

	function show_line($db, $cnt) {
		$line = "";
		for( $i = 1; $i <= $this->rep_fieldcount; $i++ ) {
			if( ! empty($this->rep_fields[$i]) ) {
				$res = $db->f($this->rep_fields[$i]);
			} else {
				eval($this->rep_fieldcode[$i]);
			}
			$line .= padr($res, $this->rep_widths[$i]);
		}
		$this->Cell(0, 5, $line);
		$this->Ln();
	}
}
