/*
 *  Search Plugin Class
 *
 *  Copyright (c) 2002 Willy De la Court <wdl@linux-lovers.be>
 *
 */
?><?php
register_plugin("Search", "N", "N");

require("htdig.php");

class Search extends PlainPlugin {
	var $classname = "Search";
	var $file = "search.ihtml";

	function Search( $record = array()) {
		$this->PlainPlugin($record);
	}

	function set_vars( $record ) {
		global $PHP_SELF, $words, $method;
		$this->vars["ADMIN"] = $this->admin_button();
		$this->vars["URL"] = $PHP_SELF;
		$this->vars["WORDS"] = HtmlEntities($words);
		if($method == "or")
			$this->vars["OR"] = "SELECTED";
		if($method == "and")
			$this->vars["AND"] = "SELECTED";
		$this->vars["TITLE"] = $record["title"];
	}

	function show() {
		global $PHP_SELF, $show, $words, $method, $go_search, $htdigpage;

		$t =& new Template($this->theme, "remove");
		$t->set_file(array("layout" => $this->file));
		//$t->debug=7;
		$t->set_block("layout", "nrpages", "nrpages2");
		$t->set_block("layout", "pagelinks", "pagelinks2");
		$t->set_block("layout", "result", "result2");
		$t->set_block("layout", "notfound", "notfound2");
		$t->set_block("layout", "error", "error2");
		$t->set_block("pagelinks", "onelink", "onelink2");
		$t->set_block("pagelinks", "onepage", "onepage2");
		$t->set_var($this->vars);
		$htdig = new htdig_class;

		if(isset($go_search)) {
			if(isset($htdigpage) && intval($htdigpage) > 0)
				$htdigpage = intval($htdigpage);
			else
				$htdigpage = 1;

			/* How many matches per page? */
			$matchesperpage = 10;

			/* What is the limit of Next and Previous result page links ? */
			$listpages = 4;

			$options=array(
				"matchesperpage" => $matchesperpage,
				"page" => $htdigpage,
				"method" => $method
			);
			$words = ereg_replace("[ ]+", "|", $words);
			if(!strcmp($error = $htdig->Search($words, $options, &$results), "")) {
				$maximum_page = intval(($results["MatchCount"] + $matchesperpage - 1) / $matchesperpage);
				if($results["MatchCount"]) {
					if($htdigpage > $maximum_page) {
						$options["htdigpage"] = $htdigpage = $maximum_page;
						$error = $htdig->Search($words, $options, &$results);
					}
				}
				if(!strcmp($error, "")) {
					if($results["MatchCount"] > 0) {
						$t->set_var(array("MATCHCOUNT" => $results["MatchCount"]));
						$t->parse("nrpages2", "nrpages", true);
						if($results["MatchCount"] > $matchesperpage) {
							$link_values = "words=" . UrlEncode($words) . "&method=$method&go_search=1";
							if($htdigpage > 1) {
								// display previous
								$temp = $htdigpage - 1;
								$url = "$PHP_SELF?show=$show&htdigpage=$temp&$link_values";
								$t->set_var(array(
										"PAGEURL" => $url,
										"PAGEURLTEXT" => "&lt;&lt; Previous"));
								$t->parse("onelink2", "onelink", true);
							}
							$link_page = 1;
							for($link_page = 1; $link_page <= $maximum_page; $link_page++) {
								if( $link_page == $htdigpage ) {
									$htdigpage_range = (($htdigpage - 1) * $matchesperpage + 1) . "-" . min($htdigpage * $matchesperpage, $results["MatchCount"]);
									$t->set_var(array(
											"PAGEURLTEXT" => $htdigpage_range));
									$t->parse("onelink2", "onepage", true);
								} else {
									$htdigpage_range = (($link_page - 1) * $matchesperpage + 1) . "-" . min($link_page * $matchesperpage, $results["MatchCount"]);
									$url = "$PHP_SELF?show=$show&htdigpage=$link_page&$link_values";
									$t->set_var(array(
											"PAGEURL" => $url,
											"PAGEURLTEXT" => $htdigpage_range));
									$t->parse("onelink2", "onelink", true);
								}
							}
							if($htdigpage < $maximum_page) {
								$link_page = $htdigpage + 1;
								$url = "$PHP_SELF?show=$show&htdigpage=$link_page&$link_values";
								$t->set_var(array(
										"PAGEURL" => $url,
										"PAGEURLTEXT" => "Next &gt;&gt;"));
								$t->parse("onelink2", "onelink", true);
							}
							$t->parse("pagelinks2", "pagelinks", true);
						}
						$temp = $t->get("pagelinks2");
						$t->set_var(array("BOTTOM" => $temp));
						$first = $results["FirstMatch"];
						$last = $results["LastMatch"];
						for($match = $first; $match <= $last; $match++) {
							$t->set_var(array(
								"MATCH" => $match,
								"MATCHURL" => $results["Matches"][$match]["URL"], 
								"MATCHURLTEXT" => $results["Matches"][$match]["Title"], 
								"MATCHPERCENT" => $results["Matches"][$match]["Percent"], 
								"EXCERPT" => $results["Matches"][$match]["Excerpt"]
								));
							$t->parse("result2", "result", true);
						}
					} else {
						$t->parse("notfound2", "notfound", true);
					}
				}
			} else {
				if(strcmp($error, "")) {
					$t->set_var(array("ERRORMSG" => HtmlEntities($error)));
					$t->parse("error2", "error", true);
				}
			}
		}
		$t->parse("out", array("layout"));
		return $t->get("out");

	}
}
