/*
 *  UserEdit Plugin Class
 *
 *  Copyright (c) 2002 Willy De la Court <wdl@linux-lovers.be>
 *
 */
?><?php
register_plugin("UserEdit");

class UserEdit Extends PlainPlugin {
	var $classname = "UserEdit";
	var $username = array();
	var $uid = array();
	var $userperm = array();
	var $userperm2 = array();
	var $title = "";
	var $file = "useredit.ihtml";
	var $msg = "";

	function UserEdit( $record = array(), $createcache = "N" ) { $this->PlainPlugin($record, $createcache); }

	function set_vars( $record = array() ) {

		if( ! empty($record) ) {
			$this->title = $record["title"];
		}
	}

	function my_msg($msg) {
		$this->msg .= "<table border=1 bgcolor=#eeeeee align=center cellspacing=0 cellpadding=4 width=100%>\n";
		$this->msg .= "<tr>\n";
		$this->msg .= "<td><font color=#FF2020>" . $msg . "</font></td>\n";
		$this->msg .= "</tr>\n";
		$this->msg .= "</table>\n";
	}

	function process_submit() {
		global $PHP_SELF, $HTTP_POST_VARS, $perm, $perms, $auth, $hashpass, $password, $username, $u_id;

		$hash_secret = "JaBbErWoCkY...";
		$this->msg = "";
		if(!empty($password)) {
			$this->my_msg("<b>Warning:</b> plain text password received. Is Javascript enabled?");
		}

		## Hash the password if we need to
		if (empty($hashpass)) {
			if(isset($password)) {
				$password = md5($password);
			} else {
				$password = "";
			}
		} else {
			$password = $hashpass;
		}

		## Find out if a new password was entered
		if ($password == md5("*******")) {
			$new_password = false;
		} else {
			$new_password = true;
		}

		$db = new DB_SDS;

		## Check if there was a submission
		while ( is_array($HTTP_POST_VARS) && list($key, $val) = each($HTTP_POST_VARS)) {
			switch ($key) {

				## Create a new user
				case "create":
					## Do we have permission to do so?
					if (!$perm->have_perm("supervisor")) {
						$this->my_msg("Error: You do not have permission to create users.");
						break;
					}

					## Do we have all necessary data?
					if (empty($username) || empty($password)) {
						$this->my_msg("Error: Please fill out <B>Username</B> and <B>Password</B>!");
						break;
					}

					## Does the user already exist?
					## NOTE: This should be a transaction, but it is not...
					$db->query("select * from auth_user_md5 where username='$username'");
					if ($db->nf()>0) {
						$this->my_msg("Error: User <B>$username</B> already exists!");
						break;
					}

					## Create a uid and insert the user...
					$u_id=md5(uniqid($hash_secret));
					$permlist = $perms;
					$query = "insert into auth_user_md5 (user_id, username, password, perms)values('$u_id','$username','$password','$permlist')";
					$db->query($query);
					if ($db->affected_rows() == 0) {
						$this->my_msg("<b>Failed:</b> $query");
						break;
					}

					$this->my_msg("User \"$username\" created.");
					break;

				## Change user parameters
				case "u_edit":
					## Do we have permission to do so?
					if (!$perm->have_perm("supervisor") && ($auth->auth["uid"] != $u_id)) {
						$this->my_msg("You do not have permission to change users.");
						break;
					}

					## Handle users changing their own password...
					if (!$perm->have_perm("supervisor")) {
						if (!$new_password) {
							$this->my_msg("Please fill out a new <b>Password</b> ");
							break;
						}
						$query = "update auth_user_md5 set password='$password' where user_id='$u_id'";
						$db->query($query);
						if ($db->affected_rows() == 0) {
							$this->my_msg("<b>Failed:</b> $query");
							break;
						}

						$this->my_msg("Password of ". $auth->auth["uname"] ." changed.<BR>");
						break;
					}

					## Do we have all necessary data?
					if (empty($username) || empty($password)) {
						$this->my_msg("Please fill out <B>Username</B> and <B>Password</B>!");
						break;
					}

					## Update user information.
					$permlist = $perms;
					if (!$new_password) {
						$password_query = "";
					} else {
						$password_query = "password='$password',";
					}
					$query = "update auth_user_md5 set username='$username', $password_query perms='$permlist' where user_id='$u_id'";
					$db->query($query);
					if ($db->affected_rows() == 0) {
						$this->my_msg("<b>Failed:</b> $query");
						break;
					}

					$this->my_msg("User \"$username\" changed.<BR>");
				break;

				## Delete the user
				case "u_kill":
					## Do we have permission to do so?
					if (!$perm->have_perm("supervisor")) {
						$this->my_msg("You do not have permission to delete users.");
						break;
					}

					## Delete that user.
					$query = "delete from auth_user_md5 where user_id='$u_id' and username='$username'";
					$db->query($query);
					if ($db->affected_rows() == 0) {
						$this->my_msg("<b>Failed:</b> $query");
						break;
					}

					$this->my_msg("User \"$username\" deleted.<BR>");
				break;

				default:
					break;
			}
		}
	}

	function show() {
		global $PHP_SELF, $perm, $auth;

		$this->process_submit();

		$mdb = new DB_SDS;
		$mdb->query("select * from auth_user_md5 order by username");
		$cnt = 1;
		while( $mdb->next_record() ) {
			$this->username[$cnt] = $mdb->f("username");
			$this->uid[$cnt] = $mdb->f("user_id");
			$this->userperm[$cnt] = $perm->perm_opt("perms", $mdb->f("perms"));
			$this->userperm2[$cnt] = $mdb->f("perms");
			$cnt++;
		}

		$cnt = count($this->username);
		$t =& new Template($this->theme, "remove");
		$t->set_file(array("layout" => $this->file));
		$admin_button = $this->admin_button();
		$t->set_var(array("TITLE" => $this->title,
						  "URL" => $PHP_SELF,
						  "ERR" => $this->msg,
						  "ADMIN" => $admin_button));
		$t->set_block("layout", "new", "newuser");
		$t->set_block("layout", "row", "rows");
		$t->set_block("layout", "oneuser", "oneusers");
		if( $perm->have_perm("supervisor") ) {
			$t->set_var(array("PERM" => $perm->perm_opt("perms", "user")));
			$t->parse("newuser", "new", true);
			for($i = 1; $i <= $cnt; $i++ ) {
				$t->set_var(array("USERNAME" => $this->username[$i],
							  	"UID" => $this->uid[$i],
							  	"USERPERM" => $this->userperm[$i]));
				$t->parse("rows", "row", true);
			}
		} else {
			for($i = 1; $i <= $cnt; $i++ ) {
				if( $auth->auth["uname"] == $this->username[$i] ) {
					$t->set_var(array("USERNAME" => $this->username[$i],
									"UID" => $this->uid[$i],
									"USERPERM" => $this->userperm2[$i]));
					$t->parse("oneusers", "oneuser", true);
				}
			}
		}
		$t->parse("out", array("layout"));
		return $t->get("out");
	}
}
