-- MySQL dump 8.23
--
-- Host: localhost    Database: NOXQS
---------------------------------------------------------
-- Server version	3.23.58

--
-- Table structure for table `active_sessions`
--

DROP TABLE IF EXISTS active_sessions;
CREATE TABLE active_sessions (
  sid varchar(32) NOT NULL default '',
  name varchar(32) NOT NULL default '',
  val text,
  changed varchar(14) NOT NULL default '',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (name,sid),
  KEY changed (changed)
) TYPE=MyISAM;

--
-- Dumping data for table `active_sessions`
--
-- WHERE:  system='SDS'



--
-- Table structure for table `active_sessions_split`
--

DROP TABLE IF EXISTS active_sessions_split;
CREATE TABLE active_sessions_split (
  ct_sid varchar(32) NOT NULL default '',
  ct_name varchar(32) NOT NULL default '',
  ct_pos varchar(6) NOT NULL default '',
  ct_val text,
  ct_changed varchar(14) NOT NULL default '',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (ct_name,ct_sid,ct_pos),
  KEY ct_changed (ct_changed)
) TYPE=MyISAM;

--
-- Dumping data for table `active_sessions_split`
--
-- WHERE:  system='SDS'



--
-- Table structure for table `article`
--

DROP TABLE IF EXISTS article;
CREATE TABLE article (
  code int(11) NOT NULL auto_increment,
  title varchar(80) default '',
  text text,
  bottom text,
  posted datetime default '0000-00-00 00:00:00',
  postedby varchar(40) default '',
  summary text,
  articlegroup varchar(20) NOT NULL default '',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (code,articlegroup)
) TYPE=MyISAM;

--
-- Dumping data for table `article`
--
-- WHERE:  system='SDS'



--
-- Table structure for table `auth_user`
--

DROP TABLE IF EXISTS auth_user;
CREATE TABLE auth_user (
  user_id varchar(32) NOT NULL default '',
  username varchar(32) NOT NULL default '',
  password varchar(32) NOT NULL default '',
  perms varchar(255) default NULL,
  system varchar(10) default 'NONE',
  PRIMARY KEY  (user_id),
  UNIQUE KEY k_username (username)
) TYPE=MyISAM;

--
-- Dumping data for table `auth_user`
--
-- WHERE:  system='SDS'



--
-- Table structure for table `auth_user_md5`
--

DROP TABLE IF EXISTS auth_user_md5;
CREATE TABLE auth_user_md5 (
  user_id varchar(32) NOT NULL default '',
  username varchar(32) NOT NULL default '',
  password varchar(32) NOT NULL default '',
  perms varchar(255) default NULL,
  system varchar(10) default 'NONE',
  emp_grp varchar(10) default NULL,
  language char(1) default 'N',
  PRIMARY KEY  (user_id),
  UNIQUE KEY k_username (username)
) TYPE=MyISAM;

--
-- Dumping data for table `auth_user_md5`
--
-- WHERE:  system='SDS'



--
-- Table structure for table `browse`
--

DROP TABLE IF EXISTS browse;
CREATE TABLE browse (
  name varchar(20) NOT NULL default '',
  sql text,
  maxlines int(4) default NULL,
  deletesql text,
  pri_key varchar(20) default NULL,
  system varchar(10) default 'NONE',
  db varchar(20) default NULL,
  next_layout varchar(50) default NULL,
  PRIMARY KEY  (name)
) TYPE=MyISAM;

--
-- Dumping data for table `browse`
--
-- WHERE:  system='SDS'


INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('form_all','select * from form $form_all_filter order by name',20,NULL,'name','SDS','',NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('browse_col','select * from browse_detail where name = \'$browse_all_prikey\' order by columnorder',5,NULL,'columnorder','SDS',NULL,NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('logo_all','select * from items where plugin=\'Logo\' or plugin=\'Copyright\' order by name',10,NULL,'name','SDS','',NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('menu_items','select * from items where (plugin=\'Menu\' or plugin=\'HeaderMenu\') $menu_items_filter order by name',14,NULL,'name','SDS',NULL,NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('menu_detail','select * from menuitems where name=\'$menu_items_prikey\' order by menuorder',8,NULL,'menuorder','SDS',NULL,NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('form_items','select * from items where (plugin=\'Form\' or plugin=\'FormGroup\') $form_items_filter order by name',20,NULL,'name','SDS','','default');
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('browse_art','select * from article where articlegroup = \'$articles_all_prikey\'',5,NULL,'code','SDS','',NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('articles_all','select * from items where plugin=\'Articles\' order by name',20,NULL,'name','SDS',NULL,NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('layout_all','select distinct layoutgroup from layout order by layoutgroup',20,NULL,'layoutgroup','SDS',NULL,NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('link_detail','select * from links where linkgroup=\'$links_all_prikey\' order by name',8,NULL,'name','SDS',NULL,NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('links_all','select * from items where plugin=\'Links\' $links_all_filter order by name',20,NULL,'name','SDS','',NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('text_items','select * from items where plugin=\'Text\' $text_items_filter order by name',20,NULL,'name','SDS','',NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('gallery_all','select * from gallery order by name',10,NULL,'name','SDS','',NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('browse_all','select * from browse $browse_all_filter order by name',20,NULL,'name','SDS','',NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('login_stats','select user_id, count(*) as cnt, max(login_time) as last_login from login_stats group by user_id',0,NULL,'','SDS','',NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('browse_useredit','select * from auth_user_md5 order by username',0,NULL,'user_id','SDS','','default');
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('browse_group','select * from groups order by groups.groups',5,NULL,'group','SDS','','default');
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('browse_usergroup','select user_group.username, groups.groupname from auth_user_md5 inner join user_group on auth_user_md5.username = user_group.username inner join groups on user_group.groups = groups.groups where auth_user_md5.user_id = \'$browse_useredit_prikey\'',5,NULL,'','SDS','','default');
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('browse_userips','select user_ips.ip from auth_user_md5 inner join user_ips on auth_user_md5.username = user_ips.username where auth_user_md5.user_id = \'$browse_useredit_prikey\'',5,NULL,'','SDS','','default');

--
-- Table structure for table `browse_detail`
--

DROP TABLE IF EXISTS browse_detail;
CREATE TABLE browse_detail (
  name varchar(20) NOT NULL default '',
  fieldname varchar(50) NOT NULL default '',
  header varchar(50) default NULL,
  columnorder int(4) NOT NULL default '0',
  width int(4) default '10',
  system varchar(10) default 'NONE',
  align varchar(10) default NULL,
  fieldcode text,
  PRIMARY KEY  (name,columnorder)
) TYPE=MyISAM;

--
-- Dumping data for table `browse_detail`
--
-- WHERE:  system='SDS'


INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('menu_detail','menuorder','Order',10,5,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_col','header','Header',30,20,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_col','fieldname','Fieldname',20,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('menu_detail','page','Page',30,20,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_all','name','Name',10,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_col','columnorder','Order',10,5,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('menu_detail','param','Layout Group',40,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('menu_items','name','Name',10,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('menu_detail','menutext','Text',20,20,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('logo_all','name','Name',10,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('form_items','name','Name',10,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('form_all','name','Name',10,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_col','width','Width',40,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('text_items','name','Name',10,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_art','title','Title',10,50,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('link_detail','name','Name',10,10,'SDS','left',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('link_detail','title','Title',20,30,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('gallery_all','name','Name',10,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('layout_all','layoutgroup','Group',10,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_col','align','Align',50,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('articles_all','name','Name',10,10,'SDS','left',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('links_all','name','Name',10,10,'SDS','left',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('login_stats','user_id','User',10,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('login_stats','cnt','Count',20,5,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('login_stats','last_login','Last Login',30,20,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_useredit','username','User Name',10,15,'SDS','','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_useredit','perms','Security Level',20,15,'SDS','',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_group','group','Group',10,15,'SDS','','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_group','groupname','Name',20,15,'SDS','',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_usergroup','groupname','Group',10,15,'SDS','',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_userips','ip','IP or Range',10,15,'SDS','',NULL);

--
-- Table structure for table `db_sequence`
--

DROP TABLE IF EXISTS db_sequence;
CREATE TABLE db_sequence (
  seq_name varchar(127) NOT NULL default '',
  nextid int(10) unsigned NOT NULL default '0',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (seq_name)
) TYPE=MyISAM;

--
-- Dumping data for table `db_sequence`
--
-- WHERE:  system='SDS'



--
-- Table structure for table `form`
--

DROP TABLE IF EXISTS form;
CREATE TABLE form (
  name varchar(20) NOT NULL default '',
  sql text,
  title varchar(40) default NULL,
  type varchar(10) default NULL,
  system varchar(10) default 'NONE',
  db varchar(20) default NULL,
  onsubmit varchar(50) default NULL,
  PRIMARY KEY  (name)
) TYPE=MyISAM;

--
-- Dumping data for table `form`
--
-- WHERE:  system='SDS'


INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('logo_new','','Add a Logo','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('menu_item','select * from items where name = \'$menu_items_prikey\'','Edit Menu Title and Permissions','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_item','select * from items where name = \'$form_items_prikey\'','Edit Form Title and Permissions','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('menu_newdetail','','Add a new Menu Item','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('browse_all','','','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('browse_onecol','select * from browse_detail where name=\'$browse_all_prikey\' and columnorder=\'$browse_col_prikey\'','Edit one Browse Column','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('browse_new','','Add a new Browse','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('browse_one','select * from browse where name=\'$browse_all_prikey\'','Edit Browse Info','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_edit_value','select * from form_detail where name=\'$form_name\' and fieldname=\'$form_field\'','Edit value Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('browse_newcol','','Add a new Browse Column','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_add','','Add a Form','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_all','','','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_one','select * from form where name=\'$form_all_prikey\'','Edit Form Title & Code','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('text_item','select * from items where name = \'$text_items_prikey\'','Edit Text Info','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_edit_code','select * from form_detail where name=\'$form_name\' and fieldname=\'$form_field\'','Edit code Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('layout_all','','','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_add_control',NULL,'Add a new Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_edit_edit','select * from form_detail where name=\'$form_name\' and fieldname=\'$form_field\'','Edit text Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_move',NULL,'Move a Form Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_edit_label','select * from form_detail where name=\'$form_name\' and fieldname=\'$form_field\'','Edit label Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_edit_button','select * from form_detail where name=\'$form_name\' and fieldname=\'$form_field\'','Edit button Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('text_new','','Add a new Text','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_edit_browse','select * from form_detail where name=\'$form_name\' and fieldname=\'$form_field\'','Edit browse Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('link_item','select * from items where name = \'$links_all_prikey\'','Edit Link Title and Permissions','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('link_newdetail',NULL,'Add a new Link Item','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('link_itemedit',NULL,'','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('link_new','','Add a new Links Widget','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('art_new',NULL,'Add a new Article to a Group','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('art_item','select * from items where name = \'$articles_all_prikey\'','Edit Articles Info','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('art_editone','select * from article where code = \'$browse_art_prikey\'','Edit One Article','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_new','','Add a new Form Widget','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('art_newitem',NULL,'Add a new Articles Group','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('art_edit',NULL,'','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_edit_form','select * from form_detail where name=\'$form_name\' and fieldname=\'$form_field\'','Edit form Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('cache',NULL,NULL,'Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_edit_option','select * from form_detail where name=\'$form_name\' and fieldname=\'$form_field\'','Edit option Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('upd_cache',NULL,NULL,'FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_filter',NULL,'Form Filter','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('link_onedetail','select * from links where linkgroup = \'$links_all_prikey\' and name = \'$link_detail_prikey\'','Edit one Link Item','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('browse_filter','','Browse Filter','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_itemfilter',NULL,'Form Filter','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('text_filter',NULL,'Text Filter','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('menu_filter',NULL,'Menu Filter','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('link_filter',NULL,'Link Filter','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('gallery_item','select * from gallery where name = \'$gallery_all_prikey\'','Edit Gallery Info','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('gallery_all','','Gallery Management','FormGroup','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('gallery_upload','','Upload an Image','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('gallery_sec',NULL,NULL,'Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('gallery_new','','New Gallery','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('editor_text_item','select * from items where name = \'$editor_text_items_prikey\'','Edit Text Info','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('editor_text_itemedit','',NULL,'FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_browse',NULL,'','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('gallery_user','','User Selection','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('text_browse',NULL,'','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_edit_input','select * from form_detail where name=\'$form_name\' and fieldname=\'$form_field\'','Edit input Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('layout_add','','Add a new Layout Item','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('menu_onedetail','select * from menuitems where name = \'$menu_items_prikey\' and menuorder = \'$menu_detail_prikey\'','Edit one Menu Item','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_itemedit','','','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('menu_itemedit','','','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('text_itemedit','','','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('menu_new','','Add a new Menu','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('logo_itemedit','','','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('articles_itemedit',NULL,'','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('logo_item','select * from items where name=\'$logo_all_prikey\'','Edit Logo and Site Title','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('login_stats',NULL,NULL,'FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_add_table','','Create form from table','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_useredit','','User Management','FormGroup','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_useredit_one','select language, emp_grp, username, perms, \'*******\' as password from auth_user_md5 where user_id=\'$browse_useredit_prikey\'','Edit One User','Form','SDS','','doHashPass(this)');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_useredit_add','','Add User','Form','SDS','','doHashPass(this)');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_group_one','select * from groups where groups.groups = \'$browse_group_prikey\'','Edit One Group','Form','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_group','','Group Management','FormGroup','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_group_add','','Add a Group','Form','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_usergroup_add','','Add a Group to this user','Form','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_usergroup_del','','Remove Group from this user','Form','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_userips_add','','Add an IP to this user','Form','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_userips_del','','Delete an IP from this user','Form','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('report_all','','Report Management','FormGroup','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('report_filter','','Report Filter','Form','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('report_one','select * from report where name = \'$report_all_prikey\'','Edit Report Title & Code','Form','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('report_new','','Add a new Report','Form','SDS','','');

--
-- Table structure for table `form_detail`
--

DROP TABLE IF EXISTS form_detail;
CREATE TABLE form_detail (
  name varchar(20) NOT NULL default '',
  fieldname varchar(40) NOT NULL default '',
  posx int(4) default NULL,
  posy int(4) default NULL,
  width int(4) default NULL,
  height int(4) default '1',
  fieldtype varchar(10) default NULL,
  text varchar(40) default NULL,
  sql text,
  pri_key varchar(40) default NULL,
  system varchar(10) default 'NONE',
  class varchar(20) default NULL,
  code text,
  perms varchar(15) default NULL,
  groups varchar(15) default NULL,
  PRIMARY KEY  (fieldname,name)
) TYPE=MyISAM;

--
-- Dumping data for table `form_detail`
--
-- WHERE:  system='SDS'


INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','lbl_param',1,3,13,1,'label','Layout Parameter',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','width',8,4,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','lbl_fieldname',1,3,5,1,'label','Fieldname',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','layoutparam',14,3,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_new','pri_key',8,3,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_new','lbl_db',1,4,7,1,'label','Database',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_new','db',8,4,10,1,'input',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','lbl_header',1,2,5,1,'label','Header',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','header',8,2,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','lbl_width',1,4,5,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_all','code',2,2,2,1,'code',NULL,'global $form_name, $form_field;\r\nif( isset($HTTP_GET_VARS[\"form_name\"]) ) { $form_name=$HTTP_GET_VARS[\"form_name\"]; }\r\n$sess->register(\"form_name\");\r\nif( isset($HTTP_GET_VARS[\"form_field\"]) ) { $form_field=$HTTP_GET_VARS[\"form_field\"]; }\r\n$sess->register(\"form_field\");\r\n\r\n$mdb = new DB_SDS;\r\n$mdb->query(\"select * from form where name=\'$form_all_prikey\'\");\r\n$mdb->next_record();\r\nif($mdb->f(\"type\") == \"Form\") {\r\n	$f =& new Form_Manipulation($form_all_prikey);\r\n	$f->get_data();\r\n	echo $f->show();\r\n} else {\r\n	$f =& new FormGroup_Manipulation($form_all_prikey);\r\n	$f->get_data();\r\n	echo $f->show();\r\n}',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_new','lbl_form',1,1,6,1,'label','Name',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_new','name',8,1,20,1,'option','','select name as k, name as v from form where type = \'FormGroup\' order by name',NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','code',1,3,1,1,'code','','echo \'\r\n<script language=\"javascript\">\r\n	<!--\r\n	function setval(form, name, x, y) {\r\n		document.form_move.thisform_inp_from_x.value = x;\r\n		document.form_move.thisform_inp_from_y.value = y;\r\n		document.form_move.thisform_inp_form.value = form;\r\n		document.form_move.thisform_inp_control.value = name;\r\n	}\r\n	function settoval(x, y) {\r\n		document.form_move.thisform_inp_to_x.value = x;\r\n		document.form_move.thisform_inp_to_y.value = y;\r\n		document.form_add_control.thisform_x.value = x;\r\n		document.form_add_control.thisform_y.value = y;\r\n	}\r\n	function setxtoval(x) {\r\n		document.form_move.thisform_inp_to_x.value = x;\r\n		document.form_add_control.thisform_x.value = x;\r\n	}\r\n	function setytoval(y) {\r\n		document.form_move.thisform_inp_to_y.value = y;\r\n		document.form_add_control.thisform_y.value = y;\r\n	}\r\n	// -->\r\n</script>\r\n\';','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_onedetail','btn_delete',47,2,6,1,'button','Delete','delete from menuitems where name = \'$menu_items_prikey\' and menuorder = \'$menu_detail_prikey\'','','SDS',NULL,'global $sess;\r\n$db =& new DB_SDS;\r\n$db->query(\"select min(menuorder) as val from menuitems where name = \'$menu_items_prikey\'\");\r\n$db->next_record();\r\n$menu_detail_prikey = $db->f(\"val\");\r\n$sess->register(\"$menu_detail_prikey\");\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','height',19,2,6,1,'input',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','btn_save',47,1,6,1,'button','Save','update browse_detail set columnorder = \'$thisform_columnorder\', header = \'$thisform_header\', width = \'$thisform_width\', fieldname = \'$thisform_fieldname\', align = \'$thisform_align\', fieldcode = \'$thisform_fieldcode\' where name = \'$browse_all_prikey\' and columnorder = \'$browse_col_prikey\'','','SDS',NULL,'global $sess;\r\n$browse_col_prikey = $thisform_columnorder;\r\n$sess->register(\"browse_col_prikey\");\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','inp_control',7,2,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','width',7,2,4,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add','type',7,2,10,1,'option','form','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','lbl_height',12,2,6,1,'label','Height',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_all','browse_onecol',2,3,2,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add','lbl_type',1,2,6,1,'label','Type',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','lbl_width',1,2,6,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','fieldname',26,2,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','width',7,2,4,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','lbl_name',1,1,6,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','fieldname',7,1,10,1,'value','',NULL,'form_field','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','lbl_type',17,2,6,1,'label','Type',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','sql',1,5,48,5,'edit',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','type',23,2,10,1,'option','form','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','height',19,2,6,1,'input',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','btn_save',38,1,6,1,'button','Save','update form_detail set height = \'$thisform_height\', width = \'$thisform_width\', perms = \'$thisform_perms\', groups = \'$thisform_groups\' where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,'','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','lbl_width',1,2,6,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','btn_delete',38,2,6,1,'button','Delete','delete from form_detail where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','lbl_height',11,2,6,1,'label','Height',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','fieldname',7,1,10,1,'value','',NULL,'form_field','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','height',17,2,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','lbl_name',1,1,6,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','lbl_type',20,1,6,1,'label','Mode',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','btn_save',38,1,6,1,'button','Save','update form_detail set height = \'$thisform_height\', width = \'$thisform_width\', sql = \'$thisform_sql\', text = \'$thisform_text\', perms = \'$thisform_perms\', groups = \'$thisform_groups\' where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,'','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','btn_delete',38,2,6,1,'button','Delete','delete from form_detail where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','btn_save',38,1,6,1,'button','Save','update form_detail set height = \'$thisform_height\', width = \'$thisform_width\', sql = \'$thisform_sql\', perms = \'$thisform_perms\', groups = \'$thisform_groups\' where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,'','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','name',7,1,10,1,'value','',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_control','x',3,3,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_sql',1,4,6,1,'label','SQL',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_control','type',8,2,10,1,'option','control',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','lbl_name',1,1,6,1,'label','Name',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','lbl_title',17,1,6,1,'label','Title',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_all','form_browse',1,1,1,2,'formgroup','edit','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_control','lbl_posx',1,3,1,1,'label','X',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','fieldname',7,1,10,1,'value','',NULL,'form_field','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','lbl_name',1,1,6,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_text',1,2,6,1,'label','Text',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','sql',1,5,45,4,'edit','',NULL,'','SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_control','lbl_posy',6,3,1,1,'label','Y',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','width',33,2,4,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add','name',7,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add','btn_new',7,3,6,1,'button','New','insert into form (name, type) values (\'$thisform_name\', \'$thisform_type\')',NULL,'SDS',NULL,'global $sess;\r\n$form_all_prikey = $thisform_name;\r\n$sess->register(\'form_all_prikey\');',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','lbl_type',1,2,6,1,'label','Type',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','btn_save',38,1,6,1,'button','Save','update form_detail set text = \'$thisform_text\', width = \'$thisform_width\', sql = \'$thisform_sql\', perms = \'$thisform_perms\', groups = \'$thisform_groups\' where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,'','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','btn_save',38,1,6,1,'button','Save','update form_detail set height = \'$thisform_height\', width = \'$thisform_width\', perms = \'$thisform_perms\', groups = \'$thisform_groups\' where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,'','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','btn_delete',38,2,6,1,'button','Delete','delete from form_detail where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','text',7,2,20,1,'option','optiontype','',NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','sql',1,5,44,4,'edit','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','lbl_width',27,2,6,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','sql',1,4,44,4,'edit','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','fieldname',7,1,10,1,'value','',NULL,'form_field','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','lbl_name',1,1,6,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add','lbl_name',1,1,6,1,'label','Name',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','text',7,2,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','lbl_sql',1,4,6,1,'label','SQL',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','width',34,2,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','lbl_width',28,2,6,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','height',34,1,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','btn_delete',38,2,6,1,'button','Delete','delete from form_detail where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','btn_save',43,1,6,1,'button','Save','update form set title = \'$thisform_title\', db = \'$thisform_db\', sql = \'$thisform_sql\', type = \'$thisform_type\', onsubmit = \'$thisform_onsubmit\' where name = \'$form_all_prikey\'',NULL,'SDS',NULL,'','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','lbl_height',28,1,6,1,'label','Height',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_control','y',8,3,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','title',23,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','lbl_sql',1,4,6,1,'label','SQL',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','text',26,1,6,1,'input',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','lbl_width',27,2,6,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','lbl_pri_key',1,2,6,1,'label','PriKey',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','btn_delete',38,2,6,1,'button','Delete','delete from form_detail where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','btn_save',38,1,6,1,'button','Save','update form_detail set text = \'$thisform_text\', width = \'$thisform_width\', sql = \'$thisform_sql\', code = \'$thisform_code\', perms = \'$thisform_perms\', groups = \'$thisform_groups\' where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS','','','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_control','lbl_type',1,2,7,1,'label','Control',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','pri_key',7,2,20,1,'input','',NULL,'','SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','width',33,2,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','fieldname',7,1,10,1,'value','',NULL,'form_field','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_width',27,2,6,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_control','name',8,1,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_new','perm',8,2,20,1,'option','perm','',NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_new','lbl_perm',1,2,6,1,'label','Permission',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_control','lbl_name',1,1,6,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','width',33,2,4,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','btn_delete',38,2,6,1,'button','Delete','delete from form_detail where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_itemedit','text_new',2,2,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_new','title',36,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','btn_delete',38,2,6,1,'button','Delete','delete from form_detail where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_control','btn_new',12,3,6,1,'button','New','insert into form_detail (name, fieldname, fieldtype, posx, posy, width) values (\'$form_all_prikey\', \'$thisform_name\', \'$thisform_type\', \'$thisform_x\', \'$thisform_y\', 6)','','SDS',NULL,'global $sess, $form_name, $form_field, $form_class;\r\n$form_field = $thisform_name;\r\n$field_class = $thisform_type;\r\n$form_name = $form_all_prikey;\r\n$sess->register(\'form_name\');\r\n$sess->register(\'form_field\');\r\n$sess->register(\'field_class\');\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_new','btn_new',56,2,6,1,'button','New','insert into items (name, title, perm, plugin) values (\'$thisform_name\', \'$thisform_title\', \'$thisform_perm\', \'FormGroup\')',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','btn_delete',38,2,6,1,'button','Delete','delete from form_detail where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','fieldname',7,1,10,1,'value','',NULL,'form_field','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_name',1,1,6,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','lbl_name',1,1,6,1,'label','Name',NULL,'','SDS','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','lbl_name',1,1,6,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','pri_key',7,2,20,1,'input','',NULL,'','SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_item','perm',8,2,10,1,'option','perm',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','lbl_width',27,2,6,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','lbl_pri_key',1,2,6,1,'label','PriKey',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','btn_save',38,1,6,1,'button','Save','update form_detail set pri_key = \'$thisform_pri_key\', width = \'$thisform_width\', perms = \'$thisform_perms\', groups = \'$thisform_groups\' where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,'','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_item','btn_save',45,1,6,1,'button','Save','update items set perm = \'$thisform_perm\', title = \'$thisform_title\', text = \'$thisform_text\' where name = \'$text_items_prikey\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','fieldname',7,1,10,1,'value','',NULL,'form_field','SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','btn_delete',47,2,6,1,'button','Delete','delete from browse where name = \'$browse_all_prikey\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','width',33,2,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','btn_save',38,1,6,1,'button','Save','update form_detail set pri_key = \'$thisform_pri_key\', width = $thisform_width, perms = \'$thisform_perms\', groups = \'$thisform_groups\' where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,'','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_itemedit','demo_menu',1,4,1,1,'code','','if($menu_item_plugin==\'Menu\') {\r\n$c =& new Column();\r\n$m =& new Menu(array(\"name\" => \"$menu_items_prikey\", \"title\" => \"$menu_item_title\"));\r\n$c->add_element($m);\r\necho $c->show();\r\n}','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','btn_delete',47,2,6,1,'button','Delete','delete from browse_detail  where name = \'$browse_all_prikey\' and columnorder = \'$browse_col_prikey\'','','SDS',NULL,'global $sess;\r\n$db =& new DB_SDS;\r\n$db->query(\"select min(columnorder) as val from browse_detail where name = \'$browse_all_prikey\'\");\r\n$db->next_record();\r\n$browse_col_prikey = $db->f(\"val\");\r\n$sess->register(\"$browse_col_prikey\");',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_item','lbl_perm',1,2,6,1,'label','Permission',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','btn_delete',45,2,6,1,'button','Delete','delete from items where name = \'$menu_items_prikey\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_item','name',8,1,10,1,'value',NULL,NULL,'text_items_prikey','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_item','btn_delete',45,2,6,1,'button','Delete','delete from items where name = \'$text_items_prikey\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_item','lbl_title',19,1,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_item','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_item','text',1,3,70,20,'edit',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','width',33,2,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('editor_text_itemedit','editor_text_item',1,1,1,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_itemedit','form_new',2,3,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','lbl_y2',10,5,1,1,'label','Y',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','lbl_width',27,2,6,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_itemedit','text_item',2,1,1,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','inp_to_y',12,5,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','lbl_x1',1,4,1,1,'label','X',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','lbl_x2',10,4,1,1,'label','X',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_itemedit','demo_headmenu',1,5,3,1,'code',NULL,'if($menu_item_plugin==\'Headermenu\') {\r\n$c =& new Column();\r\n$m =& new HeaderMenu(array(\"name\" => \"$menu_items_prikey\", \"title\" => \"$menu_item_title\"));\r\n$c->add_element($m);\r\necho $c->show();\r\n}',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','lbl_y1',1,5,1,1,'label','Y',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_item','lbl_name',1,1,6,1,'label','Name',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','inp_to_x',12,4,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','lbl_type',19,2,5,1,'label','Type',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_new','lbl_name',1,1,6,1,'label','Name',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','layoutgroup',8,2,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','inp_from_y',3,5,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','lbl_to',12,3,2,1,'label','To',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','inp_from_x',3,4,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_all','form_add',1,3,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','plugin',24,2,10,1,'option','menu','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','lbl_group',1,2,6,1,'label','Group',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','lbl_from',3,3,6,1,'label','From',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_all','case',2,3,1,2,'case','','label,form_edit_label\r\ninput,form_edit_input\r\nvalue,form_edit_value\r\nbutton,form_edit_button\r\ncase,form_edit_code\r\ncode,form_edit_code\r\ng_code,form_edit_code\r\nedit,form_edit_edit\r\noption,form_edit_option\r\nform,form_edit_form\r\nbrowse,form_edit_browse','field_class','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','lbl_position',28,1,7,1,'label','Position',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_all','layout_all',1,1,1,4,'browse','','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_all','code',2,1,1,3,'code','','$l =& new admin_page($layout_all_prikey);\r\necho $l->show();\r\n\r\n','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_item','btn_delete',56,2,6,1,'button','Delete','delete from items where name = \'$form_items_prikey\'',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_itemedit','code',1,3,2,1,'code','','$c =& new Column();\r\n$db =& new DB_SDS();\r\n$db->query(\"select * from items where name = \'$text_items_prikey\'\");\r\n$db->next_record();\r\n$m =& new Text($db->Record);\r\n$c->add_element($m);\r\necho $c->show();','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_all','layout_add',2,4,1,1,'form','edit','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_new','lbl_title',29,1,6,1,'label','Title',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_new','btn_new',27,1,6,1,'button','New','insert into items (\r\nname, \r\ntitle, \r\nperm, \r\nplugin) values (\r\n\'$thisform_name\', \r\n\'$thisform_title\', \r\n\'$thisform_perm\', \r\n\'Text\')',NULL,'SDS',NULL,'global $sess;\r\n$text_items_prikey = $thisform_name;\r\n$sess->register(\"text_items_prikey\");',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_itemedit','logo_all',1,1,1,2,'browse',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_item','title',24,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_new','name',7,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_item','btn_delete',43,2,6,1,'button','Delete','delete from items where name=\'$logo_all_prikey\'',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_item','name',8,1,6,1,'value',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','layoutorder',26,2,4,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_item','link',22,2,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_item','lbl_text',1,2,6,1,'label','Text',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_itemedit','logo_item',2,1,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_new','name',7,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','lbl_order',19,2,6,1,'label','Order',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_item','lbl_title',15,1,6,1,'label','Title',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_item','lbl_link',15,2,6,1,'label','Link',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_new','btn_new',7,2,6,1,'button','New','insert into items (name, plugin) values (\'$thisform_name\', \'Logo\')',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_item','btn_save',43,1,6,1,'button','Save','update items set title = \'$thisform_title\', text = \'$thisform_text\', link = \'$thisform_link\' where name=\'$logo_all_prikey\'',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','class',11,4,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_upd',1,15,6,1,'label','Update',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','lbl_class',1,4,10,1,'label','css Class',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','sql_upd',1,16,15,4,'edit',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','lbl_align',20,3,5,1,'label','Align',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','align',26,3,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','lbl_fcode',1,3,10,1,'label','Field Code',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','btn_del',43,2,6,1,'button','Delete','delete from form where name = \'$form_all_prikey\'',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_itemedit','logo_new',2,2,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','lbl_db',17,2,7,1,'label','Database',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','db',25,2,10,1,'input',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','fieldcode',1,4,52,4,'edit',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_new','lbl_name',1,1,6,1,'label','Name',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_item','title',22,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_item','text',1,3,48,3,'edit',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_editone','lbl_sum',1,3,10,1,'label','Summary',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','cde_gen',7,15,6,1,'code',NULL,'$sql_w = \"\";\r\n$sql_ins = \"insert into TABLE \";\r\n$sql_i1 = \"\";\r\n$sql_i2 = \"\";\r\n$sql_del = \"delete from TABLE where \";\r\n$sql_upd = \"update TABLE set \";\r\n$sql_u = \"\";\r\n$gdb = new DB_SDS;\r\n$gdb->query(\"select * from form_detail where name=\'$form_name\' order by posy, posx\");\r\nwhile($gdb->next_record()) {\r\n	if( $gdb->f(\"fieldtype\") == \"input\" || $gdb->f(\"fieldtype\") == \"edit\" || $gdb->f(\"fieldtype\") == \"option\" || $gdb->f(\"fieldtype\") == \"value\") {\r\n		if( ! empty($sql_u) ) { $sql_u .= \", \"; }\r\n		$sql_u .= \"\r\n\" . $gdb->f(\"fieldname\") . \" = \'$\" . \"thisform_\" . $gdb->f(\"fieldname\") . \"\'\";\r\n		if( ! empty($sql_i1) ) { $sql_i1 .= \", \"; }\r\n		$sql_i1 .= \"\r\n\" . $gdb->f(\"fieldname\");\r\n		if( ! empty($sql_i2) ) { $sql_i2 .= \", \"; }\r\n		$sql_i2 .= \"\r\n\'$\" . \"thisform_\" . $gdb->f(\"fieldname\") . \"\'\";\r\n		$p = $gdb->f(\"pri_key\");\r\n		if( ! empty($p) ) {\r\n			if( ! empty($sql_w) ) { $sql_w .= \" and \"; }\r\n			$sql_w .= $gdb->f(\"fieldname\") . \" = \'$\" . $gdb->f(\"pri_key\") . \"\'\";\r\n		}\r\n	}\r\n}\r\n\r\n$sql_upd .= $sql_u . \" where \" . $sql_w;\r\n$sql_ins .= \"(\" . $sql_i1 . \") values (\" . $sql_i2 . \")\";\r\n$sql_del .= $sql_w;\r\n$thisform_sql_upd = $sql_upd;\r\n$thisform_sql_ins = $sql_ins;\r\n$thisform_sql_del = $sql_del;\r\n',NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_ins',16,15,6,1,'label','Insert',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','lbl_control',1,2,5,1,'label','Control',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','lbl_code',1,2,6,1,'label','Code',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','inp_form',7,1,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','btn_delete',38,2,6,1,'button','Delete','delete from form_detail where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','btn_move',1,6,5,1,'button','Move','update form_detail set posx=$thisform_inp_to_x, posy=$thisform_inp_to_y where name=\'$thisform_inp_form\' and fieldname=\'$thisform_inp_control\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','lbl_form',1,1,5,1,'label','Form',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','lbl_height',12,2,6,1,'label','Height',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','lbl_name',1,1,6,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_newitem','btn_new',18,1,6,1,'button','New','insert into items (name, plugin) values (\'$thisform_name\', \'Articles\')',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_edit','art_editone',2,2,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','fieldname',7,1,10,1,'value','',NULL,'form_field','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_edit','articles_all',1,1,1,2,'browse','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_editone','title',6,2,40,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_editone','lbl_code',1,1,5,1,'label','Code',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_editone','code',6,1,10,1,'value',NULL,NULL,'browse_art_prikey','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_edit','browse_art',2,1,1,1,'browse',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_newitem','name',7,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_item','btn_save',45,2,6,1,'button','Save','update items set perm = \'$thisform_perm\', title = \'$thisform_title\', text = \'$thisform_text\' where name = \'$art_items_prikey\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_newitem','lbl_name',1,1,6,1,'label','Name',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_editone','lbl_title',1,2,5,1,'label','Title',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_item','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_item','lbl_text',19,1,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_item','name',8,1,10,1,'value',NULL,NULL,'art_items_prikey','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','sql_ins',16,16,15,4,'edit',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_item','title',24,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','sql_del',31,16,15,4,'edit',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('articles_itemedit','articles_all',1,1,1,2,'browse','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('articles_itemedit','art_item',2,1,1,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','lbl_db',1,2,6,1,'label','Database',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','name',8,1,20,1,'option','items','','','SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_editone','text',1,10,50,10,'edit',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_editone','lbl_txt',1,9,10,1,'label','Text',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','place',35,1,10,1,'option','place','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_new','btn_new',47,1,6,1,'button','New','insert into article (articlegroup, posted, title) values (\'$articles_all_prikey\', now(), \'$thisform_title\')',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_sqlgen',1,14,45,1,'label','Autogenerated SQL Statements',NULL,NULL,'SDS','formheader',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_del',31,15,6,1,'label','Delete',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_item','btn_delete',45,1,6,1,'button','Delete','delete from items where name = \'$art_items_prikey\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_item','lbl_perm',1,2,6,1,'label','Permission',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('articles_itemedit','art_newitem',2,2,1,1,'form','edit',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_item','perm',8,2,10,1,'option','perm',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','db',7,2,10,1,'input',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_all','code',1,5,3,1,'code',NULL,'if(! empty($browse_all_prikey) ){\n$b =& new Browse($browse_all_prikey);\n$b->get_data();\necho $b->show();\n}',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','lbl_item',1,1,6,1,'label','Item',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','brn_save',45,1,6,1,'c_button','Save','if( !empty($thisform_layoutgroup)) {\r\n	$layout_all_prikey = $thisform_layoutgroup;\r\n}\r\n$mdb = new DB_SDS;\r\nif( empty($thisform_layoutorder) ) {\r\n	$mdb->query(\"select max(layoutorder) as o from layout where layoutgroup = \'$layout_all_prikey\'\");\r\n	$mdb->next_record();\r\n	$thisform_layoutorder = $mdb->f(\"o\") + 10;\r\n}\r\n$mdb->query(\"insert into layout (\r\n	layoutgroup, \r\n	layoutorder, \r\n	layoutparam, \r\n	name, \r\n	place\r\n	) values (\r\n	\'$layout_all_prikey\', \r\n	$thisform_layoutorder, \r\n	\'$thisform_layoutparam\', \r\n	\'$thisform_name\', \r\n	\'$thisform_place\')\r\n\");\r\n',NULL,'SDS',NULL,'',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_editone','summary',1,4,50,5,'edit',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_editone','btn_save',46,1,6,1,'button','Save','update article set \r\ntitle = \'$thisform_title\', \r\nsummary = \'$thisform_summary\', \r\ntext = \'$thisform_text\' where code = \'$browse_art_prikey\'',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_new','plugin',8,4,10,1,'option','menu',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_newdetail','menutext',6,2,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_edit','art_new',2,3,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_new','lbl_title',1,1,5,1,'label','Title',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_new','lbl_type',1,4,5,1,'label','Type',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_newdetail','param',6,3,20,1,'option','layoutgroup','','','SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_newdetail','lbl_text',1,2,5,1,'label','Text',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_new','lbl_perm',1,3,6,1,'label','Permission',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_new','perm',8,3,10,1,'option','perm',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_new','title',8,2,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_new','title',6,1,40,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_new','lbl_title',1,2,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_editone','btn_delete',46,2,6,1,'button','Delete','delete from article where code = \'$browse_art_prikey\'',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_newdetail','page',6,4,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_newdetail','lbl_group',1,3,5,1,'label','Group',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_newdetail','lbl_page',1,4,5,1,'label','Page',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_new','maxlines',8,2,4,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_new','lbl_prikey',1,3,5,1,'label','PriKey',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_new','title',8,2,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_new','lbl_title',1,2,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_newdetail','name',6,1,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_newdetail','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_item','name',8,1,10,1,'value',NULL,NULL,'link_items_prikey','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_item','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_new','perm',7,3,10,1,'option','perm',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_new','lbl_maxlines',1,2,7,1,'label','MaxLines',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_code',1,9,6,1,'label','Code',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','code',1,10,45,4,'edit','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_new','lbl_title',1,2,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_new','title',7,2,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_new','lbl_perm',1,3,6,1,'label','Permission',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_new','lbl_perm',1,3,6,1,'label','Permission',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_new','perm',8,3,10,1,'option','perm',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_newdetail','btn_new',21,1,5,1,'button','New','insert into links (\r\nlinkgroup, \r\nname, \r\ntitle, \r\nlink) values (\r\n\'$links_all_prikey\', \r\n\'$thisform_name\', \r\n\'$thisform_title\', \r\n\'$thisform_link\')','','SDS',NULL,'global $sess;\r\n$link_detail_prikey = $thisform_name;\r\n$sess->register(\"link_detail_prikey\");\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_newdetail','lbl_title',1,2,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_itemedit','link_newdetail',3,4,1,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_item','title',24,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_item','lbl_title',19,1,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_newdetail','title',6,2,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_newdetail','lbl_link',1,3,5,1,'label','Link',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_item','btn_save',45,1,6,1,'button','Save','update items set perm = \'$thisform_perm\', title = \'$thisform_title\' where name = \'$link_items_prikey\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('cache','btn_cacheall',1,1,6,1,'button','Cache All','',NULL,'SDS',NULL,'$db =& new DB_SDS;\r\n$db->query(\"select * from items\");\r\nwhile( $db->next_record()) {\r\n	echo $db->f(\"name\") . \" ... \";\r\n	$db->Record[\"cached\"] = \"N\";\r\n	$class = $db->f(\"plugin\");\r\n	$c =& new $class($db->Record, \"Y\");\r\n	$c->create_cache();\r\n	echo \"Cached<BR>\r\n\";\r\n	flush();\r\n}',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_item','lbl_perm',1,2,6,1,'label','Permission',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_newdetail','link',6,3,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_item','link_detail',1,4,60,7,'browse','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_item','perm',8,2,10,1,'option','perm',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_item','btn_delete',45,2,6,1,'button','Delete','delete from items where name = \'$link_items_prikey\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('upd_cache','cache',1,1,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','title',24,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_filter','code_search',13,1,1,1,'g_code',NULL,'if( isset($HTTP_POST_VARS[\"thisform_brw_search\"]) ) {\r\n	$thisform_brw_search=$HTTP_POST_VARS[\"thisform_brw_search\"];\r\n	$brw_browse_all_pos = 0;\r\n}\r\n$sess->register(\"thisform_brw_search\");\r\nif( ! empty($thisform_brw_search) ) {\r\n	$browse_all_filter = \"where name like \'%$thisform_brw_search%\'\";\r\n} else {\r\n	$browse_all_filter = \"\";\r\n}',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_onedetail','title',26,1,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_onedetail','name',8,1,10,1,'input',NULL,NULL,'link_one_prikey','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_onedetail','link',8,2,40,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_onedetail','lbl_link',1,2,5,1,'label','Link',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_onedetail','description',1,4,55,4,'edit','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_onedetail','btn_delete',50,2,6,1,'button','Delete','delete from links where \r\nlinkgroup = \'$links_all_prikey\' and \r\nname = \'$link_one_prikey\'','','SDS',NULL,'global $sess;\r\n$db =& new DB_SDS;\r\n$db->query(\"select name as val from links where linkgroup = \'$links_all_prikey\' limit 0,1\");\r\n$db->next_record();\r\n$link_detail_prikey = $db->f(\"val\");\r\n$sess->register(\"$link_detail_prikey\");\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_onedetail','btn_save',50,1,6,1,'button','Save','update links set \r\nname = \'$thisform_name\', \r\ntitle = \'$thisform_title\', \r\nlink = \'$thisform_link\', \r\ndescription = \'$thisform_description\' where linkgroup = \'$links_all_prikey\' and \r\nname = \'$link_one_prikey\'','','SDS',NULL,'global $sess;\r\n$link_detail_prikey = $thisform_name;\r\n$sess->register(\"link_detail_prikey\");\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_filter','brw_search',1,1,12,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_onedetail','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_all','gallery_all',1,1,1,2,'browse',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','name',8,1,10,1,'value',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_onedetail','lbl_text',20,1,5,1,'label','Text',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('cache','btn_clearcache',8,1,6,1,'button','Clear Cache','update items set cached = \'N\' where name != \'upd_cache\'',NULL,'SDS',NULL,'',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_onedetail','lbl_desc',1,3,5,1,'label','Description',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_filter','code_search',13,1,1,1,'g_code',NULL,'if( isset($HTTP_POST_VARS[\"thisform_frm_search\"]) ) {\r\n	$thisform_frm_search=$HTTP_POST_VARS[\"thisform_frm_search\"];\r\n	$brw_form_all_pos = 0;\r\n}\r\n$sess->register(\"thisform_frm_search\");\r\nif( ! empty($thisform_frm_search) ) {\r\n	$form_all_filter = \"where name like \'%$thisform_frm_search%\'\";\r\n} else {\r\n	$form_all_filter = \"\";\r\n}',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('cache','btn_cachesystem',15,1,6,1,'button','Cache System','',NULL,'SDS',NULL,'$db =& new DB_SDS;\r\n$db->query(\"select * from items where system = \'SDS\'\");\r\nwhile( $db->next_record()) {\r\n	echo $db->f(\"name\") . \" ... \";\r\n	$db->Record[\"cached\"] = \"N\";\r\n	$class = $db->f(\"plugin\");\r\n	$c =& new $class($db->Record, \"Y\");\r\n	$c->create_cache();\r\n	echo \"Cached<BR>\r\n\";\r\n	flush();\r\n}',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_filter','code_search',13,1,1,1,'g_code',NULL,'if( isset($HTTP_POST_VARS[\"thisform_txt_search\"]) ) {\r\n	$thisform_txt_search=$HTTP_POST_VARS[\"thisform_txt_search\"];\r\n	$brw_text_items_pos = 0;\r\n}\r\n$sess->register(\"thisform_txt_search\");\r\nif( ! empty($thisform_txt_search) ) {\r\n	$text_items_filter = \"and name like \'%$thisform_txt_search%\'\";\r\n} else {\r\n	$text_items_filter = \"\";\r\n}',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_filter','frm_search',1,1,12,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_all','form_add_control',3,3,1,2,'form','edit','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_filter','txt_search',1,1,12,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_all','browse_filter',1,1,1,1,'form','noclear','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','description',1,5,50,3,'edit',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_all','gallery_item',2,1,2,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','type',8,2,10,1,'option','publicprivate',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','btn_delete',45,2,6,1,'button','Delete','delete from gallery where name = \'$gallery_all_prikey\'','','SDS',NULL,'',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_itemfilter','code_search',13,1,1,1,'g_code',NULL,'if( isset($HTTP_POST_VARS[\"thisform_frmi_search\"]) ) {\r\n	$thisform_frmi_search=$HTTP_POST_VARS[\"thisform_frmi_search\"];\r\n	$brw_form_items_pos = 0;\r\n}\r\n$sess->register(\"thisform_frmi_search\");\r\nif( ! empty($thisform_frmi_search) ) {\r\n	$form_items_filter = \"and name like \'%$thisform_frmi_search%\'\";\r\n} else {\r\n	$form_items_filter = \"\";\r\n}',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_itemfilter','frmi_search',1,1,12,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_itemedit','menu_filter',1,1,1,1,'form','noclear',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','btn_update',45,3,6,1,'button','Update','',NULL,'SDS',NULL,'global $gallery_dir;\r\n$db =& new DB_SDS;\r\n$mdb =& new DB_SDS;\r\n//$db->query(\"delete from gallery_images where name = \'$gallery_all_prikey\'\");\r\n$dir = $gallery_dir . \"/\" . $gallery_all_prikey;\r\nif ($handle = opendir($dir)) {\r\n	while (false !== ($file = readdir($handle))) {\r\n		if( stristr($file, \".jpg\") || stristr($file, \".gif\") ) {\r\n			$mdb->query(\"select * from gallery_images where name = \'$gallery_all_prikey\' and filename = \'$file\'\");\r\n			if($mdb->num_rows() == 0) {\r\n				$db->query(\"insert into gallery_images (name, filename) values (\'$gallery_all_prikey\', \'$file\')\");\r\n			}\r\n		}\r\n	}\r\n}\r\n$db->query(\"select * from gallery_images where name = \'$gallery_all_prikey\'\");\r\nwhile($db->next_record()) {\r\n	$file = $db->f(\"filename\");\r\n	if( ! file_exists($dir . \"/\" . $file) ) {\r\n		$mdb->query(\"delete from gallery_images where name = \'$gallery_all_prikey\' and filename = \'$file\'\");\r\n	}\r\n}\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_filter','code_search',13,1,1,1,'g_code',NULL,'if( isset($HTTP_POST_VARS[\"thisform_mnu_search\"]) ) {\r\n	$thisform_mnu_search=$HTTP_POST_VARS[\"thisform_mnu_search\"];\r\n	$brw_menu_items_pos = 0;\r\n}\r\n$sess->register(\"thisform_mnu_search\");\r\nif( ! empty($thisform_mnu_search) ) {\r\n	$menu_items_filter = \"and name like \'%$thisform_mnu_search%\'\";\r\n} else {\r\n	$menu_items_filter = \"\";\r\n}',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_filter','lnk_search',1,1,12,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_filter','mnu_search',1,1,12,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_itemedit','text_browse',1,1,1,2,'formgroup','noclear',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_filter','code_search',13,1,1,1,'g_code',NULL,'if( isset($HTTP_POST_VARS[\"thisform_lnk_search\"]) ) {\r\n	$thisform_lnk_search=$HTTP_POST_VARS[\"thisform_lnk_search\"];\r\n	$brw_link_items_pos = 0;\r\n}\r\n$sess->register(\"thisform_lnk_search\");\r\nif( ! empty($thisform_lnk_search) ) {\r\n	$links_all_filter = \"and name like \'%$thisform_lnk_search%\'\";\r\n} else {\r\n	$links_all_filter = \"\";\r\n}',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_itemedit','form_itemfilter',1,1,1,1,'form','noclear','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','btn_save',45,1,6,1,'button','Save','update gallery set type = \'$thisform_type\', title = \'$thisform_title\', description = \'$thisform_description\' where name = \'$gallery_all_prikey\'','','SDS',NULL,'',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_all','gallery_user',2,3,2,1,'form','noclear','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_user','code2',50,1,1,1,'code',NULL,'',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_user','btn_select',19,1,6,1,'button','Select','',NULL,'SDS',NULL,'global $HTTP_POST_VARS, $sess, $thisform_user;\r\nif( isset($HTTP_POST_VARS[\"thisform_user\"]) ) {\r\n$thisform_user = $HTTP_POST_VARS[\"thisform_user\"];\r\n}\r\n$sess->register(\"thisform_user\");',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_sec','btn_save',51,1,1,1,'button','Save','',NULL,'SDS',NULL,'$g =& new foto_gallery($gallery_all_prikey);\r\n$g->update_admin();',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_itemedit','link_filter',1,1,1,1,'form','noclear',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_sec','code',1,1,50,1,'code',NULL,'$g =& new foto_gallery($gallery_all_prikey);\r\necho $g->show_admin();',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','lbl_type',1,2,6,1,'label','Type',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_user','lbl_user',1,1,6,1,'label','User',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','btn_read',45,4,6,1,'button','ReadIn','',NULL,'SDS',NULL,'global $image_dir, $gallery_dir;\r\n$db =& new DB_SDS;\r\n$dir = $image_dir . \"/incoming\";\r\n$dir2 = $gallery_dir . \"/\" . $gallery_all_prikey;\r\nif ($handle = opendir($dir)) {\r\n	while (false !== ($file = readdir($handle))) {\r\n		if( stristr($file, \".jpg\") || stristr($file, \".gif\") ) {\r\n			$cp_cmd = \"/bin/cp \" . $dir . \"/\" . $file . \" \" . $dir2;\r\n			system($cp_cmd);\r\n			$db->query(\"insert into gallery_images (name, filename) values (\'$gallery_all_prikey\', \'$file\')\");\r\n		}\r\n	}\r\n}\r\necho \"<B>All images copied: Please remove all uploaded images from the incoming dir</B>\";\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_upload','code',1,1,50,1,'code',NULL,'global $gallery_dir;\r\nupload_image($gallery_dir, $gallery_all_prikey);',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_user','code',8,1,10,1,'code',NULL,'global $thisform_user;\r\n$res = \"\";\r\n$users =& new HTMLOptions();\r\n$users->add_element(\"*\", \"*\");\r\n$db =& new DB_SDS;\r\n$db->query(\"select username from auth_user_md5 order by username\");\r\nwhile($db->next_record()) {\r\n	$users->add_element($db->f(\"username\"), $db->f(\"username\"));\r\n}\r\n$res .= \"<select name=thisform_user>\\n\";\r\n$users->set_default($thisform_user);\r\n$res .= $users->show();\r\necho $res;',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_all','gallery_upload',2,2,2,1,'form','','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_all','gallery_new',1,3,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_all','gallery_sec',1,4,3,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('editor_text_itemedit','code',1,3,1,1,'code','','$c =& new Column();\r\n$db =& new DB_SDS();\r\n$db->query(\"select * from items where name = \'$editor_text_items_prikey\'\");\r\n$db->next_record();\r\n$m =& new Text($db->Record);\r\n$c->add_element($m);\r\necho $c->show();','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_browse','text_filter',1,1,1,1,'form','noclear',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_browse','form_filter',1,1,1,1,'form','noclear',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_browse','form_all',1,2,1,1,'browse',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_browse','text_items',1,2,1,1,'browse','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_new','btn_new',11,1,4,1,'button','New','insert into gallery (name, type) values (\'$thisform_new\', \'public\')',NULL,'SDS',NULL,'global $gallery_dir, $sess;\r\n$mkdir = \"mkdir -p \" . $gallery_dir . \"/\" . $thisform_new . \"/th\";\r\nsystem($mkdir);\r\n$gallery_all_prikey = $thisform_new;\r\n$sess->register(\"gallery_all_prikey\");',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('editor_text_item','title',24,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('editor_text_item','lbl_title',19,1,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_new','new',1,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('editor_text_item','btn_save',45,1,6,1,'button','Save','update items set title = \'$thisform_title\', text = \'$thisform_text\', cached = \'N\' where name = \'$editor_text_items_prikey\'','','SDS',NULL,'',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('editor_text_item','name',8,1,10,1,'value','',NULL,'editor_text_items_prikey','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('editor_text_item','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('editor_text_item','text',1,3,70,20,'edit',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','fieldname',8,3,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','lbl_align',1,5,5,1,'label','Align',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','align',8,5,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_itemedit','link_new',2,4,1,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','lbl_text',1,2,6,1,'label','Text',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','lbl_columnorder',1,1,7,1,'label','Order',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','pri_key',36,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_all','form_move',3,1,1,1,'form','edit','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','text',7,2,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','fieldname',7,1,10,1,'value','',NULL,'form_field','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','lbl_title',19,1,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','btn_save',38,1,6,1,'button','Save','update form_detail set text = \'$thisform_text\', width = \'$thisform_width\', class = \'$thisform_class\', perms = \'$thisform_perms\', groups = \'$thisform_groups\' where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,'','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_all','form_one',2,1,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','lbl_width',1,2,6,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','lbl_name',1,1,6,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','columnorder',8,1,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','width',7,2,4,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','btn_new',19,1,5,1,'button','New','insert into browse_detail (\r\nname, \r\ncolumnorder, \r\nheader, \r\nfieldname, \r\nwidth, \r\nalign) values (\r\n\'$browse_all_prikey\', \'$thisform_columnorder\', \r\n\'$thisform_header\', \r\n\'$thisform_fieldname\', \r\n\'$thisform_width\', \r\n\'$thisform_align\')','','SDS',NULL,'global $sess;\r\n$browse_col_prikey = $thisform_columnorder;\r\n$sess->register(\"browse_col_prikey\");',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','width',8,2,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','lbl_fieldname',20,2,5,1,'label','Fieldname',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','lbl_width',1,2,5,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_new','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','header',26,1,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','btn_save',47,1,6,1,'button','Save','update browse set \r\nmaxlines = \'$thisform_maxlines\', \r\npri_key = \'$thisform_pri_key\', \r\ndb = \'$thisform_db\', \r\nsql = \'$thisform_sql\',\r\nnext_layout = \'$thisform_next_layout\' where \r\nname = \'$browse_all_prikey\'','','SDS',NULL,'',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_all','browse_newcol',3,4,1,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','maxlines',25,1,4,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','lbl_prikey',30,1,5,1,'label','PriKey',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','lbl_header',20,1,5,1,'label','Header',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','lbl_sql',1,3,10,1,'label','Browse SQL',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_all','browse_new',2,4,1,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','columnorder',8,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','name',6,1,10,1,'value',NULL,NULL,'browse_all_prikey','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','sql',1,4,52,3,'edit',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','lbl_order',1,1,5,1,'label','Order',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_all','browse_one',2,1,2,2,'form','edit','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_new','name',8,1,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','lbl_maxlines',17,1,7,1,'label','MaxLines',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','browse_col',1,7,60,7,'browse','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_newdetail','menuorder2',6,1,5,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_newdetail','btn_new',21,1,5,1,'button','New','insert into menuitems (\r\nname, \r\nmenuorder, \r\nmenutext, \r\nparam, \r\npage) values (\r\n\'$menu_items_prikey\', \r\n\'$thisform_menuorder2\', \r\n\'$thisform_menutext\', \r\n\'$thisform_param\', \r\n\'$thisform_page\')','','SDS',NULL,'global $sess;\r\n$menu_detail_prikey = $thisform_menuorder2;\r\n$sess->register(\"menu_detail_prikey\");\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_itemedit','menu_newdetail',3,4,1,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_new','name',8,1,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_new','btn_new',22,1,6,1,'button','New','insert into items (\r\nname, \r\ntitle, \r\nperm, \r\nplugin) values (\r\n\'$thisform_name\', \r\n\'$thisform_title\', \r\n\'$thisform_perm\', \r\n\'$thisform_plugin\')\r\n\r\n','','SDS',NULL,'global $sess;\r\n$menu_items_prikey = $thisform_name;\r\n$sess->register(\"menu_items_prikey\");',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_new','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_new','btn_new',18,1,6,1,'button','New','insert into browse (\r\nname, \r\nmaxlines, \r\npri_key, \r\ndb) values (\r\n\'$thisform_name\', \r\n\'$thisform_maxlines\', \r\n\'$thisform_pri_key\', \r\n\'$thisform_db\')','','SDS',NULL,'global $sess;\r\n$browse_all_prikey = $thisform_name;\r\n$sess->register(\"browse_all_prikey\");',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_onedetail','btn_save',47,1,6,1,'button','Save','update menuitems set menuorder = \'$thisform_menuorder\', menutext = \'$thisform_menutext\', page = \'$thisform_page\', param = \'$thisform_param\' where name = \'$menu_items_prikey\' and menuorder = \'$menu_detail_prikey\'','','SDS',NULL,'global $sess;\r\n$menu_detail_prikey = $thisform_menuorder;\r\n$sess->register(\"menu_detail_prikey\");\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_newdetail','lbl_order',1,1,5,1,'label','Order',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_onedetail','lbl_menuorder',1,1,5,1,'label','Order',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_onedetail','lbl_text',20,1,5,1,'label','Text',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_itemedit','menu_onedetail',2,3,2,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_onedetail','param',8,2,10,1,'option','layoutgroup',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_onedetail','page',26,2,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_onedetail','menutext',26,1,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_onedetail','lbl_group',1,2,5,1,'label','Group',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_onedetail','lbl_page',20,2,5,1,'label','Page',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_itemedit','menu_new',2,4,1,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_onedetail','menuorder',8,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_itemedit','form_item',2,1,1,2,'form','edit','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','btn_save',45,1,6,1,'button','Save','update items set perm = \'$thisform_perm\', title = \'$thisform_title\', plugin=\'$thisform_plugin\' where name = \'$menu_items_prikey\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','lbl_title',19,1,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','name',8,1,10,1,'value',NULL,NULL,'menu_items_prikey','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_item','title',35,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_all','browse_all',1,2,1,3,'browse',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_item','btn_save',56,1,6,1,'button','Save','update items set perm = \'$thisform_perm\', title = \'$thisform_title\' where name = \'$form_items_prikey\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_item','name',8,1,10,1,'value',NULL,NULL,'items_forms_prikey','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_item','lbl_text',29,1,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_item','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_itemedit','form_items',1,2,1,3,'browse','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_itemedit','menu_item',2,1,2,2,'form','edit','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_itemedit','menu_items',1,2,1,2,'browse','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','lbl_perm',1,2,6,1,'label','Permission',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_item','perm',8,2,20,1,'option','perm','','','SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','menu_detail',1,4,60,7,'browse','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','perm',8,2,10,1,'option','perm',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_item','lbl_perm',1,2,6,1,'label','Permission',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','title',24,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_itemedit','link_onedetail',2,3,2,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_itemedit','link_item',2,1,2,2,'form','edit','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_itemedit','demo_link',1,5,3,1,'code','','$c =& new Column();\r\n$m =& new Links(array(\"name\" => \"$links_all_prikey\", \"title\" => \"$link_item_title\"));\r\n$c->add_element($m);\r\necho $c->show();\r\n','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_new','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_itemedit','links_all',1,2,1,3,'browse','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_new','name',8,1,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_new','btn_new',22,1,6,1,'button','New','insert into items (\r\nname, \r\ntitle, \r\nperm, \r\nplugin) values (\r\n\'$thisform_name\', \r\n\'$thisform_title\', \r\n\'$thisform_perm\', \r\n\'Links\')\r\n','','SDS',NULL,'global $sess;\r\n$links_all_prikey = $thisform_name;\r\n$sess->register(\"links_all_prikey\");',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('login_stats','login_stats',1,1,1,1,'browse',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_table','btn_new',7,4,6,1,'button','New','',NULL,'SDS',NULL,'global $sess;\r\n$form_all_prikey = $thisform_name;\r\n$sess->register(\'form_all_prikey\');\r\ncreate_form($thisform_name, $thisform_tablename, $thisform_database);\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_table','lbl_name',1,1,6,1,'label','Name',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_table','lbl_table',1,3,6,1,'label','Table',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_table','name',7,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_table','tablename',7,3,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_table','lbl_database',1,2,6,1,'label','Database',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_table','database',7,2,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_all','form_add_table',1,4,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','perms',7,5,15,1,'option','perm','',NULL,'SDS',NULL,NULL,'supervisor',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit','form_useredit_one',2,1,2,1,'form','edit','',NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','username',7,1,15,1,'value','','','username','SDS','','','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','lbl_user',1,1,6,1,'label','User',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit','browse_useredit',1,1,1,2,'browse',NULL,NULL,NULL,'SDS',NULL,NULL,'supervisor','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','lbl_next',1,2,5,1,'label','Next',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','next_layout',6,2,10,1,'option','layoutgroup','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','btn_movedown',6,6,6,1,'button','Move Down','update form_detail set posy=posy+1 where name=\'$thisform_inp_form\' and posy>=$thisform_inp_to_y',NULL,'SDS',NULL,'',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','lbl_sec',1,5,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,'supervisor',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','lbl_password',1,2,6,1,'label','Password',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','password',7,2,15,1,'password',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','lbl_perms',1,3,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','perms',7,3,15,1,'option','perm','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_perms',1,3,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','perms',7,3,15,1,'option','perm','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','lbl_perms',1,3,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','perms',7,3,15,1,'option','perm','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','lbl_perms',1,3,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','perms',7,3,15,1,'option','perm','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','lbl_perms',1,3,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','perms',7,3,15,1,'option','perm','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','lbl_perms',1,3,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','perms',7,3,15,1,'option','perm','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','lbl_perms',1,3,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','perms',7,3,15,1,'option','perm','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','lbl_perms',1,3,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','perms',7,3,15,1,'option','perm','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','lbl_perms',1,3,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','perms',7,3,15,1,'option','perm','',NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','btn_save',22,5,6,1,'button','Save','',NULL,'SDS',NULL,'global $sess, $thisform_hashpass, $u_id;\r\n$db = new DB_SDS;\r\n\r\nif(!empty($thisform_password)) {\r\n	$this->msg(\"<b>Warning:</b> plain text password received. Is Javascript enabled?\");\r\n}\r\n\r\n## Hash the password if we need to\r\nif (empty($thisform_hashpass)) {\r\n	if(isset($thisform_password)) {\r\n		$thisform_password = md5($thisform_password);\r\n	} else {\r\n		$thisform_password = \"\";\r\n	}\r\n} else {\r\n	$thisform_password = $thisform_hashpass;\r\n}\r\n\r\n## Find out if a new password was entered\r\nif ($thisform_password == md5(\"*******\")) {\r\n	$new_password = false;\r\n} else {\r\n	$new_password = true;\r\n}\r\n\r\nif ($perm->have_perm(\"supervisor\")) {\r\n	## Supervisor can change permissions and password\r\n	if( $new_password ) {\r\n		$query = \"update auth_user_md5 set password=\'$thisform_password\', perms=\'$thisform_perms\', emp_grp=\'$thisform_emp_grp\', language=\'$thisform_language\' where user_id=\'$u_id\'\";\r\n	} else {\r\n		$query = \"update auth_user_md5 set perms=\'$thisform_perms\', emp_grp=\'$thisform_emp_grp\', language=\'$thisform_language\' where user_id=\'$u_id\'\";\r\n	}\r\n	$db->query($query);\r\n	$this->msg($db->affected_rows() . \" Records Updated\");\r\n} else {\r\n	## only change password\r\n	if( $new_password ) {\r\n		$query = \"update auth_user_md5 set password=\'$thisform_password\', emp_grp=\'$thisform_emp_grp\', language=\'$thisform_language\' where user_id=\'$u_id\'\";\r\n		$db->query($query);\r\n		$this->msg($db->affected_rows() . \" Records Updated\");\r\n	}\r\n}','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','btn_delete',22,6,6,1,'button','Delete','delete from auth_user_md5 where user_id = \'$browse_useredit_prikey\'',NULL,'SDS',NULL,'global $sess;\r\n$xdb= new DB_SDS;\r\n$xdb->query(\"select user_id from auth_user_md5 order by username\");\r\n$xdb->next_record();\r\n$browse_useredit_prikey = $xdb->f(\"user_id\");\r\n$sess->register(\"browse_useredit_prikey\");\r\n','supervisor',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_add','lbl_user',1,1,6,1,'label','User',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_add','username',7,1,15,1,'input',NULL,NULL,'','SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_add','btn_add',22,1,6,1,'button','Add','',NULL,'SDS',NULL,'global $sess, $thisform_hashpass;\r\n$db = new DB_SDS;\r\n$hash_secret = \"JaBbErWoCkY...\";\r\n\r\nif(!empty($thisform_password)) {\r\n	$this->msg(\"<b>Warning:</b> plain text password received. Is Javascript enabled?\");\r\n}\r\n\r\n## Hash the password if we need to\r\nif (empty($thisform_hashpass)) {\r\n	if(isset($thisform_password)) {\r\n		$thisform_password = md5($thisform_password);\r\n	} else {\r\n		$thisform_password = \"\";\r\n	}\r\n} else {\r\n	$thisform_password = $thisform_hashpass;\r\n}\r\n\r\n## Find out if a new password was entered\r\nif ($thisform_password == md5(\"*******\")) {\r\n	$new_password = false;\r\n} else {\r\n	$new_password = true;\r\n}\r\n\r\n## Do we have permission to do so?\r\nif (!$perm->have_perm(\"supervisor\")) {\r\n	$this->msg(\"Error: You do not have permission to create users.\");\r\n} else {\r\n	## Do we have all necessary data?\r\n	if (empty($thisform_username) || empty($thisform_password)) {\r\n		$this->msg(\"Error: Please fill out <B>Username</B> and <B>Password</B>!\");\r\n	} else {\r\n	\r\n		## Does the user already exist?\r\n		## NOTE: This should be a transaction, but it is not...\r\n		$db->query(\"select * from auth_user_md5 where username=\'$thisform_username\'\");\r\n		if ($db->nf()>0) {\r\n			$this->msg(\"Error: User <B>$thisform_username</B> already exists!\");\r\n		} else {\r\n		\r\n			## Create a uid and insert the user...\r\n			$u_id = md5( uniqid( $hash_secret ) );\r\n			$permlist = $thisform_perms;\r\n			$query = \"insert into auth_user_md5 (user_id, username, password, perms) values (\'$u_id\',\'$thisform_username\',\'$thisform_password\',\'$thisform_perms\')\";\r\n			$db->query($query);\r\n			if ($db->affected_rows() == 0) {\r\n				$this->msg(\"<b>Failed:</b> $query\");\r\n			} else {\r\n				$this->msg(\"User \\\"$thisform_username\\\" created.\");\r\n				$browse_useredit_prikey = $u_id;\r\n				$sess->register(\"browse_useredit_prikey\");\r\n			}\r\n		}\r\n	}\r\n}\r\n','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit','form_useredit_add',2,2,2,1,'form','edit','',NULL,'SDS',NULL,NULL,'supervisor',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_add','lbl_perms',1,3,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_add','perms',7,3,15,1,'option','perm','',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_add','lbl_password',1,2,6,1,'label','Password',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_add','password',7,2,15,1,'password',NULL,NULL,'','SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','cde_hashpass',22,1,6,1,'code',NULL,'?><input type=\"hidden\" name=\"thisform_hashpass\" value=\"\">\r\n<input type=\"hidden\" name=\"u_id\" value=\"<?php echo $browse_useredit_prikey; ?>\">\r\n<?php',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit','cde_glb',4,6,1,1,'code',NULL,'?><script language=\"javascript\" src=\"md5.js\"></script>\r\n<script language=\"javascript\">\r\n	<!--\r\n	function doHashPass(theForm) {\r\n		theForm.thisform_hashpass.value = MD5(theForm.thisform_password.value);\r\n		theForm.thisform_password.value = \"\";\r\n		return true;\r\n	}\r\n	// -->\r\n</script>\r\n<?php\r\nglobal $browse_useredit_prikey, $auth;\r\nif( empty($browse_useredit_prikey) ) {\r\n	$browse_useredit_prikey = $auth->auth[\"uid\"];\r\n}',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','lbl_onSubmit',1,3,6,1,'label','onSubmit',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','onsubmit',7,3,42,1,'input',NULL,NULL,'','SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_add','cde_hashpass',22,3,6,1,'code',NULL,'?><input type=\"hidden\" name=\"thisform_hashpass\" value=\"\"><?php',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_one','lbl_group',1,1,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_one','groups',7,1,15,1,'value','','','','SDS','','','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_one','lbl_name',1,2,6,1,'label','Name',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_one','groupname',7,2,15,1,'input',NULL,NULL,'','SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_one','btn_save',22,1,6,1,'button','Save','update groups set \r\ngroupname = \'$thisform_groupname\' where groups.groups = \'$browse_group_prikey\'',NULL,'SDS',NULL,'','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_one','btn_delete',22,2,6,1,'button','Delete','delete from groups where groups.group = \'$browse_group_prikey\'',NULL,'SDS',NULL,'global $browse_group_prikey, $sess;\r\n$browse_group_prikey = \"\";\r\n$sess->register(\'browse_group_prikey\');','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group','browse_group',1,1,1,2,'browse',NULL,NULL,NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group','form_group_one',2,1,1,1,'form','edit','',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_add','lbl_group',1,1,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_add','group',7,1,15,1,'input',NULL,NULL,'','SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_add','lbl_name',1,2,6,1,'label','Name',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_add','groupname',7,2,15,1,'input',NULL,NULL,'','SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_add','btn_add',22,1,6,1,'button','Add','insert into groups (groups.groups, groups.groupname) values (\'$thisform_group\', \'$thisform_groupname\')',NULL,'SDS',NULL,'global $browse_group_prikey, $sess;\r\n$browse_group_prikey = $thisform_group;\r\n$sess->register(\'browse_group_prikey\');','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group','form_group_add',2,2,1,1,'form','edit','',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit','browse_usergroup',1,3,1,2,'browse',NULL,NULL,NULL,'SDS',NULL,NULL,'supervisor',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_usergroup_add','lbl_group',1,1,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_usergroup_add','group',7,1,15,1,'option','','select groups.group as k, groups.groupname as v from groups order by groupname',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit','form_usergroup_add',2,3,1,1,'form','noclear','',NULL,'SDS',NULL,NULL,'supervisor',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_usergroup_add','btn_add',22,1,6,1,'button','Add','',NULL,'SDS',NULL,'$db = new DB_SDS;\r\n$db->query(\"select username from auth_user_md5 where user_id=\'$browse_useredit_prikey\'\");\r\nif( $db->num_rows() > 0) {\r\n	$db->next_record();\r\n	$username = $db->f(\"username\");\r\n	$db->query(\"insert into user_group (user_group.username, user_group.group) values (\'$username\', \'$thisform_group\')\");\r\n	if( $db->affected_rows() > 0 ) {\r\n		$this->msg(\"Group \'\" . $thisform_group . \"\' added to user \'\" . $username . \"\'\");\r\n	}\r\n}','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_usergroup_del','lbl_group',1,1,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_usergroup_del','group',7,1,6,1,'option','','select groups.group as k, groups.groupname as v from auth_user_md5 inner join user_group on auth_user_md5.username = user_group.username inner join groups on user_group.group = groups.group where auth_user_md5.user_id = \'$browse_useredit_prikey\'',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_usergroup_del','btn_remove',13,1,6,1,'button','Remove','',NULL,'SDS',NULL,'$db = new DB_SDS;\r\n$db->query(\"select username from auth_user_md5 where user_id=\'$browse_useredit_prikey\'\");\r\nif( $db->num_rows() > 0) {\r\n	$db->next_record();\r\n	$username = $db->f(\"username\");\r\n	$db->query(\"delete from user_group where user_group.username = \'$username\' and user_group.group = \'$thisform_group\'\");\r\n	if( $db->affected_rows() > 0 ) {\r\n		$this->msg(\"Group \'\" . $thisform_group . \"\' removed from user \'\" . $username . \"\'\");\r\n	}\r\n}','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit','form_usergroup_del',2,4,1,1,'form','noclear','',NULL,'SDS',NULL,NULL,'supervisor',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','lbl_group',22,3,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','groups',28,3,15,1,'option','','select groups.group as k, groups.groupname as v from groups order by groupname',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_group',22,3,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','groups',28,3,15,1,'option','','select groups.group as k, groups.groupname as v from groups order by groupname',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','lbl_group',22,3,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','groups',28,3,15,1,'option','','select groups.group as k, groups.groupname as v from groups order by groupname',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','lbl_group',22,3,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','groups',28,3,15,1,'option','','select groups.group as k, groups.groupname as v from groups order by groupname',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','lbl_group',22,3,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','groups',28,3,6,1,'option','','select groups.group as k, groups.groupname as v from groups order by groupname',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','lbl_group',22,3,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','groups',28,3,15,1,'option','','select groups.group as k, groups.groupname as v from groups order by groupname',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','lbl_group',22,3,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','groups',28,3,15,1,'option','','select groups.group as k, groups.groupname as v from groups order by groupname',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','lbl_group',22,3,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','groups',28,3,15,1,'option','','select groups.group as k, groups.groupname as v from groups order by groupname',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','lbl_group',22,3,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','groups',28,3,15,1,'option','','select groups.group as k, groups.groupname as v from groups order by groupname',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit','browse_userips',1,5,1,2,'browse',NULL,NULL,NULL,'SDS',NULL,NULL,'supervisor','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_userips_add','lbl_ip',1,1,6,1,'label','IP',NULL,NULL,'SDS','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_userips_add','ip',7,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_userips_add','btn_add',27,1,6,1,'button','Add','',NULL,'SDS',NULL,'$db = new DB_SDS;\r\n$db->query(\"select username from auth_user_md5 where user_id=\'$browse_useredit_prikey\'\");\r\nif( $db->num_rows() > 0) {\r\n	$db->next_record();\r\n	$username = $db->f(\"username\");\r\n	$db->query(\"insert into user_ips (user_ips.username, user_ips.ip) values (\'$username\', \'$thisform_ip\')\");\r\n	if( $db->affected_rows() > 0 ) {\r\n		$this->msg(\"IP \'\" . $thisform_ip . \"\' added to user \'\" . $username . \"\'\");\r\n	}\r\n}','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit','form_userips_add',2,5,1,1,'form','noclear','',NULL,'SDS',NULL,NULL,'supervisor','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_userips_del','lbl_ip',1,1,6,1,'label','IP',NULL,NULL,'SDS','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_userips_del','ip',7,1,20,1,'option','','select user_ips.ip as k, user_ips.ip as v from auth_user_md5 inner join user_ips on auth_user_md5.username = user_ips.username where auth_user_md5.user_id = \'$browse_useredit_prikey\'',NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_userips_del','btn_remove',27,1,6,1,'button','Remove','',NULL,'SDS',NULL,'$db = new DB_SDS;\r\n$db->query(\"select username from auth_user_md5 where user_id=\'$browse_useredit_prikey\'\");\r\nif( $db->num_rows() > 0) {\r\n	$db->next_record();\r\n	$username = $db->f(\"username\");\r\n	$db->query(\"delete from user_ips where user_ips.username = \'$username\' and user_ips.ip = \'$thisform_ip\'\");\r\n	if( $db->affected_rows() > 0 ) {\r\n		$this->msg(\"IP \'\" . $thisform_ip . \"\' removed from user \'\" . $username . \"\'\");\r\n	}\r\n}','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit','form_userips_del',2,6,1,1,'form','noclear','',NULL,'SDS',NULL,NULL,'supervisor','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_filter','rep_search',1,1,12,1,'input',NULL,NULL,'','SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_filter','code_search',13,1,1,1,'g_code',NULL,'global $sess;\r\nif( isset($_POST[\"thisform_rep_search\"]) ) {\r\n	$thisform_rep_search=$_POST[\"thisform_rep_search\"];\r\n	$brw_report_all_pos = 0;\r\n}\r\n$sess->register(\"thisform_rep_search\");\r\nif( ! empty($thisform_rep_search) ) {\r\n	$report_all_filter = \"where name like \'%$thisform_rep_search%\'\";\r\n} else {\r\n	$report_all_filter = \"\";\r\n}',NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_all','report_filter',1,1,1,1,'form','noclear','',NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_all','report_all',1,2,1,3,'browse',NULL,NULL,NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_one','lbl_name',1,1,6,1,'label','Name',NULL,NULL,'SDS','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_one','name',7,1,10,1,'value',NULL,NULL,'','SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_all','report_one',2,1,2,2,'form','edit','',NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_one','lbl_database',18,1,6,1,'label','Database',NULL,NULL,'SDS','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_one','db',25,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_one','lbl_report',1,4,15,1,'label','Report SQL',NULL,NULL,'SDS','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_one','sql',1,5,52,3,'edit',NULL,NULL,NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_one','btn_save',54,1,6,1,'button','Save','update report set \r\ndb = \'$thisform_db\', \r\nperm = \'$thisform_perm\',\r\ntitle = \'$thisform_title\', \r\nsql = \'$thisform_sql\' where\r\nname = \'$report_all_prikey\'',NULL,'SDS',NULL,'','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','width',8,4,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','lbl_fieldname',1,3,5,1,'label','Fieldname',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','lbl_header',1,2,5,1,'label','Header',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','header',8,2,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','lbl_width',1,4,5,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','fieldname',8,3,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','lbl_align',1,5,5,1,'label','Align',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','align',8,5,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','lbl_columnorder',1,1,7,1,'label','Order',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','columnorder',8,1,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','btn_new',19,1,5,1,'button','New','insert into report_detail (\r\nname, \r\ncolumnorder, \r\nheader, \r\nfieldname, \r\nwidth, \r\nalign) values (\r\n\'$report_all_prikey\', \'$thisform_columnorder\', \r\n\'$thisform_header\', \r\n\'$thisform_fieldname\', \r\n\'$thisform_width\', \r\n\'$thisform_align\')','','SDS',NULL,'global $sess;\r\n$report_col_prikey = $thisform_columnorder;\r\n$sess->register(\"report_col_prikey\");','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','btn_save',47,1,6,1,'button','Save','update report_detail set \r\ncolumnorder = \'$thisform_columnorder\', \r\nheader = \'$thisform_header\', \r\nwidth = \'$thisform_width\', \r\nfieldname = \'$thisform_fieldname\', \r\nalign = \'$thisform_align\', \r\nfieldcode = \'$thisform_fieldcode\' \r\nwhere name = \'$report_all_prikey\' and \r\ncolumnorder = \'$report_col_prikey\'','','SDS',NULL,'global $sess;\r\n$report_col_prikey = $thisform_columnorder;\r\n$sess->register(\"report_col_prikey\");\r\n','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','fieldname',26,2,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','btn_delete',47,2,6,1,'button','Delete','delete from report_detail  where name = \'$report_all_prikey\' and columnorder = \'$report_col_prikey\'','','SDS',NULL,'global $sess;\r\n$db =& new DB_SDS;\r\n$db->query(\"select min(columnorder) as val from report_detail where name = \'$report_all_prikey\'\");\r\n$db->next_record();\r\n$report_col_prikey = $db->f(\"val\");\r\n$sess->register(\"$report_col_prikey\");','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','lbl_align',20,3,5,1,'label','Align',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','align',26,3,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','lbl_fcode',1,3,10,1,'label','Field Code',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','fieldcode',1,4,52,4,'edit',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','width',8,2,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','lbl_fieldname',20,2,5,1,'label','Fieldname',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','lbl_width',1,2,5,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','header',26,1,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','lbl_header',20,1,5,1,'label','Header',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','columnorder',8,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','lbl_order',1,1,5,1,'label','Order',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_new','lbl_db',1,2,7,1,'label','Database',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_new','db',8,2,10,1,'input',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_new','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_new','name',8,1,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_new','btn_new',25,1,6,1,'button','New','insert into report (\r\nname, \r\ndb,\r\nperm,\r\nsql) values (\r\n\'$thisform_name\', \r\n\'$thisform_db\',\r\n\'$thisform_perm\',\r\n\'$thisform_sql\')','','SDS',NULL,'global $sess;\r\n$report_all_prikey = $thisform_name;\r\n$sess->register(\"report_all_prikey\");','','');

--
-- Table structure for table `gallery`
--

DROP TABLE IF EXISTS gallery;
CREATE TABLE gallery (
  name varchar(20) NOT NULL default '',
  title varchar(80) default NULL,
  description text,
  system varchar(10) default 'NONE',
  type varchar(10) default 'public',
  PRIMARY KEY  (name)
) TYPE=MyISAM;

--
-- Dumping data for table `gallery`
--
-- WHERE:  system='SDS'



--
-- Table structure for table `gallery_images`
--

DROP TABLE IF EXISTS gallery_images;
CREATE TABLE gallery_images (
  name varchar(20) NOT NULL default '',
  filename varchar(50) NOT NULL default '',
  system varchar(10) default 'NONE',
  caption text,
  username text,
  ownername text,
  PRIMARY KEY  (name,filename)
) TYPE=MyISAM;

--
-- Dumping data for table `gallery_images`
--
-- WHERE:  system='SDS'



--
-- Table structure for table `groups`
--

DROP TABLE IF EXISTS groups;
CREATE TABLE groups (
  groups varchar(32) NOT NULL default '',
  groupname varchar(32) default '',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (groups)
) TYPE=MyISAM;

--
-- Dumping data for table `groups`
--
-- WHERE:  system='SDS'



--
-- Table structure for table `items`
--

DROP TABLE IF EXISTS items;
CREATE TABLE items (
  name varchar(20) NOT NULL default '',
  plugin varchar(20) default '',
  title varchar(80) default '',
  text text,
  link varchar(200) default NULL,
  perm varchar(30) default '',
  cached char(1) binary NOT NULL default 'N',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (name),
  KEY plugin (plugin)
) TYPE=MyISAM;

--
-- Dumping data for table `items`
--
-- WHERE:  system='SDS'


INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('date','Date','',NULL,'','','N','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('time','Time','',NULL,'','','N','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('logo_itemedit','FormGroup','Edit Widget (Logo)',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('useredit','UserEdit','User Management',NULL,NULL,NULL,'N','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('browse_all','FormGroup','Browse Manipulation',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('login','Login','',NULL,'','','N','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('layout_all','FormGroup','Layout Edit',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('admin','Menu','Administration',NULL,'','supervisor','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('link_itemedit','FormGroup','Edit Widget (Links)',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('siteedit','Menu','Site Edit',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('article','Article','',NULL,'','','N','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('articles_itemedit','FormGroup','Edit Widget (Articles)',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('search','Search','Search',NULL,NULL,NULL,'N','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('art_edit','FormGroup','Edit Articles',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('headsearch','HeadSearch',NULL,NULL,NULL,NULL,'N','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('form_itemedit','FormGroup','Edit Widget (Form)',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('editor_text_itemedit','FormGroup','Edit Widget (Text)',NULL,'','editor','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('gallery','Gallery','Photo Galleries',NULL,NULL,NULL,'N','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('gallery_all','FormGroup','Gallery Management',NULL,NULL,'supervisor','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('text_itemedit','FormGroup','Edit Widget (Text)',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('form_all','FormGroup','Forms Manipulation',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('upd_cache','FormGroup','Update Cache',NULL,NULL,'admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('menu_itemedit','FormGroup','Edit Widget (Menu)',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('login_stats','FormGroup','Login Statistics',NULL,NULL,'supervisor','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('txt_Debug','Text','Debug All Session Variables','<?php\r\nglobal $sess;\r\n$db = new DB_SDS;\r\n$name = $sess->name;\r\n$id = $sess->id;\r\n$db->query(\"select * from active_sessions where name = \'$name\' and sid = \'$id\'\");\r\n$db->next_record();\r\n$str = base64_decode($db->f(\"val\"));\r\necho ereg_replace(\"; \", \"; <BR>\", $str);\r\n?>',NULL,'admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('form_useredit','FormGroup','User Management',NULL,NULL,'user','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('form_group','FormGroup','Group Management',NULL,NULL,'supervisor','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('report_all','FormGroup','Report Management',NULL,NULL,'supervisor','Y','SDS');

--
-- Table structure for table `layout`
--

DROP TABLE IF EXISTS layout;
CREATE TABLE layout (
  layoutgroup varchar(20) NOT NULL default '',
  layoutorder int(4) NOT NULL default '0',
  layoutparam varchar(40) default '',
  place varchar(20) default '',
  name varchar(20) NOT NULL default '',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (layoutgroup,layoutorder),
  KEY name (name)
) TYPE=MyISAM;

--
-- Dumping data for table `layout`
--
-- WHERE:  system='SDS'


INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('form_all',10,'','middle','form_all','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('link_itemedit',10,'','middle','link_itemedit','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('form_itemedit',10,'','middle','form_itemedit','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('browse_all',10,'','middle','browse_all','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('text_itemedit',10,'','middle','text_itemedit','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('layout_all',10,'','middle','layout_all','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('logo_itemedit',10,'','middle','logo_itemedit','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('useredit',30,'','middle','form_group','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('default',140,NULL,'right','siteedit','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('default',1,'','right','login','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('upd_cache',10,NULL,'middle','upd_cache','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('articles_itemedit',10,'','middle','articles_itemedit','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('art_edit',10,'','middle','art_edit','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('editor_text_itemedit',10,'','middle','editor_text_itemedit','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('default',130,NULL,'right','admin','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('article',10,'','middle','article','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('gallery_all',10,'','middle','gallery_all','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('gallery',10,'','middle','gallery','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('menu_itemedit',10,'','middle','menu_itemedit','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('login_stats',10,'','middle','login_stats','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('debug',10,'','middle','txt_Debug','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('useredit',20,'','middle','form_useredit','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('report_all',10,'','middle','report_all','SDS');

--
-- Table structure for table `links`
--

DROP TABLE IF EXISTS links;
CREATE TABLE links (
  linkgroup varchar(20) NOT NULL default '',
  name varchar(20) NOT NULL default '',
  description text,
  link text,
  title varchar(40) default '',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (linkgroup,name)
) TYPE=MyISAM;

--
-- Dumping data for table `links`
--
-- WHERE:  system='SDS'



--
-- Table structure for table `login_stats`
--

DROP TABLE IF EXISTS login_stats;
CREATE TABLE login_stats (
  user_id varchar(32) default NULL,
  login_time datetime default NULL,
  system varchar(10) default NULL
) TYPE=MyISAM;

--
-- Dumping data for table `login_stats`
--
-- WHERE:  system='SDS'



--
-- Table structure for table `menuitems`
--

DROP TABLE IF EXISTS menuitems;
CREATE TABLE menuitems (
  name varchar(20) NOT NULL default '',
  menuorder int(4) NOT NULL default '0',
  menutext varchar(80) default '',
  page varchar(250) default NULL,
  param varchar(40) default '',
  level int(2) default NULL,
  system varchar(10) default 'NONE',
  PRIMARY KEY  (name,menuorder)
) TYPE=MyISAM;

--
-- Dumping data for table `menuitems`
--
-- WHERE:  system='SDS'


INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',70,'-',NULL,'default',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',1,'Layout Edit','','layout_all',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',30,'Form Widget Edit','','form_itemedit',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',20,'Text Widget Edit','','text_itemedit',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('admin',20,'User Management','','useredit',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',80,'Update Cache',NULL,'upd_cache',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',5,'-','','default',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',50,'Browse Edit','','browse_all',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',10,'Menu Widget Edit','','menu_itemedit',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',60,'Form Edit','','form_all',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('admin',50,'Gallery Management','','gallery_all',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('admin',30,'Articles Management','','art_edit',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',35,'Logo Widget Edit','','logo_itemedit',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',37,'Articles Widget Edit','','articles_itemedit',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',45,'-','','default',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',39,'Links Widget Edit','','link_itemedit',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('admin',60,'Login Statistics','','login_stats',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',90,'Debug','','debug',NULL,'SDS');

--
-- Table structure for table `report`
--

DROP TABLE IF EXISTS report;
CREATE TABLE report (
  name varchar(20) NOT NULL default '',
  sql text,
  db varchar(20) default NULL,
  system varchar(10) default 'NONE',
  perm varchar(30) default NULL,
  title varchar(250) default NULL,
  PRIMARY KEY  (name)
) TYPE=MyISAM;

--
-- Dumping data for table `report`
--
-- WHERE:  system='SDS'



--
-- Table structure for table `report_detail`
--

DROP TABLE IF EXISTS report_detail;
CREATE TABLE report_detail (
  name varchar(20) NOT NULL default '',
  fieldname varchar(50) NOT NULL default '',
  header varchar(50) default NULL,
  columnorder int(4) NOT NULL default '0',
  width int(4) default '10',
  align varchar(10) default NULL,
  fieldcode text,
  system varchar(10) default 'NONE',
  fieldsql longtext,
  PRIMARY KEY  (name,columnorder)
) TYPE=MyISAM;

--
-- Dumping data for table `report_detail`
--
-- WHERE:  system='SDS'



--
-- Table structure for table `user_group`
--

DROP TABLE IF EXISTS user_group;
CREATE TABLE user_group (
  username varchar(32) default NULL,
  groups varchar(32) default NULL,
  system varchar(10) default 'NONE'
) TYPE=MyISAM;

--
-- Dumping data for table `user_group`
--
-- WHERE:  system='SDS'



--
-- Table structure for table `user_ips`
--

DROP TABLE IF EXISTS user_ips;
CREATE TABLE user_ips (
  username varchar(32) default NULL,
  ip varchar(32) default NULL,
  system varchar(10) default 'NONE'
) TYPE=MyISAM;

--
-- Dumping data for table `user_ips`
--
-- WHERE:  system='SDS'



