-- MySQL dump 8.23
--
-- Host: localhost    Database: NOXQS_DUMP
---------------------------------------------------------
-- Server version	3.23.58

--
-- Table structure for table `active_sessions`
--

DROP TABLE IF EXISTS active_sessions;
CREATE TABLE active_sessions (
  sid varchar(32) NOT NULL default '',
  name varchar(32) NOT NULL default '',
  val text,
  changed varchar(14) NOT NULL default '',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (name,sid),
  KEY changed (changed)
) TYPE=MyISAM;

--
-- Dumping data for table `active_sessions`
--



--
-- Table structure for table `active_sessions_split`
--

DROP TABLE IF EXISTS active_sessions_split;
CREATE TABLE active_sessions_split (
  ct_sid varchar(32) NOT NULL default '',
  ct_name varchar(32) NOT NULL default '',
  ct_pos varchar(6) NOT NULL default '',
  ct_val text,
  ct_changed varchar(14) NOT NULL default '',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (ct_name,ct_sid,ct_pos),
  KEY ct_changed (ct_changed)
) TYPE=MyISAM;

--
-- Dumping data for table `active_sessions_split`
--



--
-- Table structure for table `article`
--

DROP TABLE IF EXISTS article;
CREATE TABLE article (
  code int(11) NOT NULL auto_increment,
  title varchar(80) default '',
  text text,
  bottom text,
  posted datetime default '0000-00-00 00:00:00',
  postedby varchar(40) default '',
  summary text,
  articlegroup varchar(20) NOT NULL default '',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (code,articlegroup)
) TYPE=MyISAM;

--
-- Dumping data for table `article`
--



--
-- Table structure for table `auth_user`
--

DROP TABLE IF EXISTS auth_user;
CREATE TABLE auth_user (
  user_id varchar(32) NOT NULL default '',
  username varchar(32) NOT NULL default '',
  password varchar(32) NOT NULL default '',
  perms varchar(255) default NULL,
  system varchar(10) default 'NONE',
  PRIMARY KEY  (user_id),
  UNIQUE KEY k_username (username)
) TYPE=MyISAM;

--
-- Dumping data for table `auth_user`
--



--
-- Table structure for table `auth_user_md5`
--

DROP TABLE IF EXISTS auth_user_md5;
CREATE TABLE auth_user_md5 (
  user_id varchar(32) NOT NULL default '',
  username varchar(32) NOT NULL default '',
  password varchar(32) NOT NULL default '',
  perms varchar(255) default NULL,
  system varchar(10) default 'NONE',
  emp_grp varchar(10) default NULL,
  language char(1) default 'N',
  PRIMARY KEY  (user_id),
  UNIQUE KEY k_username (username)
) TYPE=MyISAM;

--
-- Dumping data for table `auth_user_md5`
--


INSERT INTO auth_user_md5 (user_id, username, password, perms, system, emp_grp, language) VALUES ('a83264cdffeb9b7c041a11c6099535ed','dummy','275876e34cf609db118f3d84b799a790','user','NONE','OFFC','N');
INSERT INTO auth_user_md5 (user_id, username, password, perms, system, emp_grp, language) VALUES ('17ce64add16c34a5494b238ce4f6c51c','admin','21232f297a57a5a743894a0e4a801fc3','admin','NONE',NULL,'N');

--
-- Table structure for table `browse`
--

DROP TABLE IF EXISTS browse;
CREATE TABLE browse (
  name varchar(20) NOT NULL default '',
  sql text,
  maxlines int(4) default NULL,
  deletesql text,
  pri_key varchar(20) default NULL,
  system varchar(10) default 'NONE',
  db varchar(20) default NULL,
  next_layout varchar(50) default NULL,
  PRIMARY KEY  (name)
) TYPE=MyISAM;

--
-- Dumping data for table `browse`
--


INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('form_all','select * from form $form_all_filter order by name',20,NULL,'name','SDS','',NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('browse_col','select * from browse_detail where name = \'$browse_all_prikey\' order by columnorder',5,NULL,'columnorder','SDS',NULL,NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('logo_all','select * from items where plugin=\'Logo\' or plugin=\'Copyright\' order by name',10,NULL,'name','SDS','',NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('menu_items','select * from items where (plugin=\'Menu\' or plugin=\'HeaderMenu\') $menu_items_filter order by name',14,NULL,'name','SDS',NULL,NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('menu_detail','select * from menuitems where name=\'$menu_items_prikey\' order by menuorder',8,NULL,'menuorder','SDS',NULL,NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('form_items','select * from items where (plugin=\'Form\' or plugin=\'FormGroup\') $form_items_filter order by name',20,NULL,'name','SDS','','default');
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('browse_art','select * from article where articlegroup = \'$articles_all_prikey\'',5,NULL,'code','SDS','',NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('articles_all','select * from items where plugin=\'Articles\' order by name',20,NULL,'name','SDS',NULL,NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('layout_all','select distinct layoutgroup from layout order by layoutgroup',20,NULL,'layoutgroup','SDS',NULL,NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('link_detail','select * from links where linkgroup=\'$links_all_prikey\' order by name',8,NULL,'name','SDS',NULL,NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('links_all','select * from items where plugin=\'Links\' $links_all_filter order by name',20,NULL,'name','SDS','',NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('text_items','select * from items where plugin=\'Text\' $text_items_filter order by name',20,NULL,'name','SDS','',NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('gallery_all','select * from gallery order by name',10,NULL,'name','SDS','',NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('browse_all','select * from browse $browse_all_filter order by name',20,NULL,'name','SDS','',NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('login_stats','select user_id, count(*) as cnt, max(login_time) as last_login from login_stats group by user_id',0,NULL,'','SDS','',NULL);
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('browse_useredit','select * from auth_user_md5 order by username',0,NULL,'user_id','SDS','','default');
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('browse_group','select * from groups order by groups.groups',5,NULL,'group','SDS','','default');
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('browse_usergroup','select user_group.username, groups.groupname from auth_user_md5 inner join user_group on auth_user_md5.username = user_group.username inner join groups on user_group.groups = groups.groups where auth_user_md5.user_id = \'$browse_useredit_prikey\'',5,NULL,'','SDS','','default');
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('browse_userips','select user_ips.ip from auth_user_md5 inner join user_ips on auth_user_md5.username = user_ips.username where auth_user_md5.user_id = \'$browse_useredit_prikey\'',5,NULL,'','SDS','','default');
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('brw_keytable','select * from keytable where key_table = \'$brw_keytable_table\' and key_type = \' \' order by key_code',20,NULL,'prikey','KEYTABLE','%data%','default');
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('brw_emp','select * from emp order by emp_id',0,NULL,'emp_id','NONE','%data%','default');
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('brw_reg','select * from reg where reg_type = \'U\' and emp_id = \'$select_emp_id\' and to_days(curdate()) - to_days(reg_start) <= 1 order by reg_start desc ',10,NULL,'reg_id','NONE','%data%','default');
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('brw_emp_grp','select grp_id, key_value from emp_grp, keytable where keytable.key_table = \'GROUP\' and keytable.key_code = emp_grp.grp_id and emp_id = \'$brw_emp_prikey\'',5,NULL,'','NONE','%data%','default');
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('brw_reg_mgr','select * from reg where reg_type = \'U\' $brw_cond order by reg_start desc',20,NULL,'reg_id','NONE','%data%','default');
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('brw_key_grp','select * from key_grp where key_table = \'$brw_keytable_table\' order by key_code',20,NULL,'','NONE','%data%','default');
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('brw_controle','select * from reg where reg_type = \'U\' $brw_cond order by reg_start desc',60,NULL,'','NONE','%data%','default');
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('report_all','select * from report $report_all_filter',20,NULL,'name','NONE','','default');
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('report_col','select * from report_detail where name = \'$report_all_prikey\' order by columnorder',5,NULL,'columnorder','NONE','','default');
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('brw_reg_prd','select reg.reg_id, prd.prd_desc, reg.reg_mat_quant from reg left join prd on reg.prd_code = prd.prd_code where reg_type = \'M\' $brw_cond',10,NULL,'reg_id','NONE','%data%','default');
INSERT INTO browse (name, sql, maxlines, deletesql, pri_key, system, db, next_layout) VALUES ('brw_reg_dcp','select reg.reg_id, dcp.dcp_desc, reg.reg_mat_quant from reg left join dcp on reg.dcp_code = dcp.dcp_code where reg_type = \'P\' $brw_cond',10,NULL,'reg_id','NONE','%data%','default');

--
-- Table structure for table `browse_detail`
--

DROP TABLE IF EXISTS browse_detail;
CREATE TABLE browse_detail (
  name varchar(20) NOT NULL default '',
  fieldname varchar(50) NOT NULL default '',
  header varchar(50) default NULL,
  columnorder int(4) NOT NULL default '0',
  width int(4) default '10',
  system varchar(10) default 'NONE',
  align varchar(10) default NULL,
  fieldcode text,
  PRIMARY KEY  (name,columnorder)
) TYPE=MyISAM;

--
-- Dumping data for table `browse_detail`
--


INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('menu_detail','menuorder','Order',10,5,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_col','header','Header',30,20,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_col','fieldname','Fieldname',20,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('menu_detail','page','Page',30,20,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_all','name','Name',10,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_col','columnorder','Order',10,5,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('menu_detail','param','Layout Group',40,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('menu_items','name','Name',10,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('menu_detail','menutext','Text',20,20,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('logo_all','name','Name',10,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('form_items','name','Name',10,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('form_all','name','Name',10,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_col','width','Width',40,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('text_items','name','Name',10,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_art','title','Title',10,50,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('link_detail','name','Name',10,10,'SDS','left',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('link_detail','title','Title',20,30,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('gallery_all','name','Name',10,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('layout_all','layoutgroup','Group',10,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_col','align','Align',50,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('articles_all','name','Name',10,10,'SDS','left',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('links_all','name','Name',10,10,'SDS','left',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('login_stats','user_id','User',10,10,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('login_stats','cnt','Count',20,5,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('login_stats','last_login','Last Login',30,20,'SDS','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_useredit','username','User Name',10,15,'SDS','','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_useredit','perms','Security Level',20,15,'SDS','',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_group','group','Group',10,15,'SDS','','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_group','groupname','Name',20,15,'SDS','',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_usergroup','groupname','Group',10,15,'SDS','',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('browse_userips','ip','IP or Range',10,15,'SDS','',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_keytable','key_code','Code',10,10,'KEYTABLE','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_keytable','key_value','Value',20,20,'KEYTABLE','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_emp','emp_id','Id',10,5,'NONE','',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_emp','emp_firstname','Firstname',20,5,'NONE','','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_emp','emp_lastname','Lastname',30,5,'NONE','','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg','','Start',10,5,'NONE','','$res .= ctime($db->f(\"reg_start\"));');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg','','Stop',20,5,'NONE','','$stop = cdate($db->f(\"reg_stop\"));\r\n$start = cdate($db->f(\"reg_start\"));\r\nif($stop == \"  /  /    \") {\r\n	$res .= \"\";\r\n} else {\r\n	if($start != $stop) {\r\n		$res .= \"<B>\" . ctime($db->f(\"reg_stop\")) . \"</B>\";\r\n	} else {\r\n		$res .= ctime($db->f(\"reg_stop\"));\r\n	}\r\n}');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg','reg_activity','Act',30,5,'NONE','',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg','reg_workplace','Wpl',40,5,'NONE','','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg','ord_code','Order',50,5,'NONE','',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg','reg_shift','Shift',45,7,'NONE','','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_emp_grp','key_value','Group',10,10,'NONE','','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg_mgr','','Start',10,4,'NONE','','$res .= ctime($db->f(\"reg_start\"));\r\n');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg_mgr','','Stop',20,4,'NONE','','$stop = cdate($db->f(\"reg_stop\"));\r\n$start = cdate($db->f(\"reg_start\"));\r\nif($stop == \"  /  /    \") {\r\n	$res .= \"\";\r\n} else {\r\n	if($start != $stop) {\r\n		$res .= \"<B>\" . ctime($db->f(\"reg_stop\")) . \"</B>\";\r\n	} else {\r\n		$res .= ctime($db->f(\"reg_stop\"));\r\n	}\r\n}');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg_mgr','','Date',5,7,'NONE','','$res .= cdate($db->f(\"reg_start\"));');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg_mgr','reg_shift','Shift',30,5,'NONE','','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg_mgr','reg_activity','Activity',40,5,'NONE','','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg_mgr','reg_workplace','Wrk',50,5,'NONE','','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg_mgr','emp_id','Emp',25,3,'NONE','',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg','','',60,1,'NONE','','global $key_tables;\r\n$t = $key_tables[\"ORDCHECK\"];\r\n$v = $t[$db->f(\"reg_activity\")];\r\n$o = $db->f(\"ord_code\");\r\nif( !empty($v) && empty($o) ) {\r\n	$res .= \"<IMG SRC=images/nok.png ALT=\" . add_quotes($v) . \" TITLE=\" . add_quotes($v) . \">\";\r\n} else {\r\n	if(!empty($o)) {\r\n		$cdb = new DB_DATA();\r\n		$cdb->query(\"select ord_code, ord_name from ord where ord_code = \" . add_s_quotes($db->f(\"ord_code\")) );\r\n		if($cdb->num_rows() >= 1) {\r\n			$cdb->next_record();\r\n			$name = add_quotes($cdb->f(\"ord_name\"));\r\n			$res .= \"<IMG SRC=images/ok.png ALT=\" . $name . \" TITLE=\" . $name . \">\";\r\n		} else {\r\n			$res .= \"<IMG SRC=images/nok.png ALT=\" . add_quotes(\"Order nummer bestaat niet\") . \" TITLE=\" . add_quotes(\"Order nummer bestaat niet\") . \">\";\r\n		}\r\n	} else {\r\n		$res .= \"<IMG SRC=images/ok.png>\";\r\n	}\r\n}\r\n');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg_mgr','','',60,1,'NONE','','global $key_tables;\r\n$t = $key_tables[\"ORDCHECK\"];\r\n$v = $t[$db->f(\"reg_activity\")];\r\n$o = $db->f(\"ord_code\");\r\nif( !empty($v) && empty($o) ) {\r\n	$res .= \"<IMG SRC=images/nok.png ALT=\" . add_quotes($v) . \" TITLE=\" . add_quotes($v) . \">\";\r\n} else {\r\n	if(!empty($o)) {\r\n		$cdb = new DB_DATA();\r\n		$cdb->query(\"select ord_code, ord_name from ord where ord_code = \" . add_s_quotes($db->f(\"ord_code\")) );\r\n		if($cdb->num_rows() >= 1) {\r\n			$cdb->next_record();\r\n			$name = add_quotes($cdb->f(\"ord_name\"));\r\n			$res .= \"<IMG SRC=images/ok.png ALT=\" . $name . \" TITLE=\" . $name . \">\";\r\n		} else {\r\n			$res .= \"<IMG SRC=images/nok.png ALT=\" . add_quotes(\"Order nummer bestaat niet\") . \" TITLE=\" . add_quotes(\"Order nummer bestaat niet\") . \">\";\r\n		}\r\n	} else {\r\n		$res .= \"<IMG SRC=images/ok.png>\";\r\n	}\r\n}');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg','','Date',5,7,'NONE','','$res .= cdate($db->f(\"reg_start\"));');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg_mgr','ord_code','Order',55,5,'NONE','',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_key_grp','key_code','Code',10,10,'NONE','',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_key_grp','grp_id','Group',20,10,'NONE','',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_key_grp','','',30,1,'NONE','','global $show, $PHP_SELF;\r\n$res .= \"<A HREF=\" . $PHP_SELF . \"?show=\" . $show . \"&del_record=yes&del_record_prikey=\" . $db->f(\"prikey\") . \"><IMG SRC=images/del.png BORDER=0 ALT=\" . add_quotes(\"Delete this record\") . \" TITLE=\" . add_quotes(\"Delete this record\") . \"></a>\";');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_controle','ord_code','Ord',10,5,'NONE','',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_controle','emp_id','Emp',20,5,'NONE','',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg','','Desc',55,3,'NONE','','$o = substr($db->f(\"reg_desc\"), 0, 3);\r\nif(!empty($o)) {\r\n	$res .= $o . \"...\";\r\n}\r\n');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg_mgr','','Desc',57,3,'NONE','','$o = substr($db->f(\"reg_desc\"), 0, 3);\r\nif(!empty($o)) {\r\n	$res .= $o . \"...\";\r\n}\r\n');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('report_all','name','Name',10,10,'NONE','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('report_col','columnorder','Order',10,5,'NONE','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('report_col','fieldname','Fieldname',20,10,'NONE','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('report_col','header','Header',30,20,'NONE','left','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('report_col','width','Width',40,10,'NONE','left',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('report_col','align','Align',50,10,'NONE','left',NULL);
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_emp','emp_workplace','Workplace',40,5,'NONE','','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_emp','emp_activity','Activity',50,5,'NONE','','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_emp','emp_shift','Shift',60,5,'NONE','','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg_prd','prd_desc','Description',10,20,'NONE','','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg_prd','reg_mat_quant','Quant',20,5,'NONE','','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg_dcp','dcp_desc','Description',10,20,'NONE','','');
INSERT INTO browse_detail (name, fieldname, header, columnorder, width, system, align, fieldcode) VALUES ('brw_reg_dcp','reg_mat_quant','Quant',20,5,'NONE','','');

--
-- Table structure for table `db_sequence`
--

DROP TABLE IF EXISTS db_sequence;
CREATE TABLE db_sequence (
  seq_name varchar(127) NOT NULL default '',
  nextid int(10) unsigned NOT NULL default '0',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (seq_name)
) TYPE=MyISAM;

--
-- Dumping data for table `db_sequence`
--



--
-- Table structure for table `form`
--

DROP TABLE IF EXISTS form;
CREATE TABLE form (
  name varchar(20) NOT NULL default '',
  sql text,
  title varchar(40) default NULL,
  type varchar(10) default NULL,
  system varchar(10) default 'NONE',
  db varchar(20) default NULL,
  onsubmit varchar(50) default NULL,
  PRIMARY KEY  (name)
) TYPE=MyISAM;

--
-- Dumping data for table `form`
--


INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('logo_new','','Add a Logo','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('menu_item','select * from items where name = \'$menu_items_prikey\'','Edit Menu Title and Permissions','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_item','select * from items where name = \'$form_items_prikey\'','Edit Form Title and Permissions','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('menu_newdetail','','Add a new Menu Item','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('browse_all','','','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('browse_onecol','select * from browse_detail where name=\'$browse_all_prikey\' and columnorder=\'$browse_col_prikey\'','Edit one Browse Column','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('browse_new','','Add a new Browse','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('browse_one','select * from browse where name=\'$browse_all_prikey\'','Edit Browse Info','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_edit_value','select * from form_detail where name=\'$form_name\' and fieldname=\'$form_field\'','Edit value Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('browse_newcol','','Add a new Browse Column','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_add','','Add a Form','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_all','','','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_one','select * from form where name=\'$form_all_prikey\'','Edit Form Title & Code','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('text_item','select * from items where name = \'$text_items_prikey\'','Edit Text Info','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_edit_code','select * from form_detail where name=\'$form_name\' and fieldname=\'$form_field\'','Edit code Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('layout_all','','','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_add_control',NULL,'Add a new Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_edit_edit','select * from form_detail where name=\'$form_name\' and fieldname=\'$form_field\'','Edit text Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_move',NULL,'Move a Form Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_edit_label','select * from form_detail where name=\'$form_name\' and fieldname=\'$form_field\'','Edit label Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_edit_button','select * from form_detail where name=\'$form_name\' and fieldname=\'$form_field\'','Edit button Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('text_new','','Add a new Text','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_edit_browse','select * from form_detail where name=\'$form_name\' and fieldname=\'$form_field\'','Edit browse Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('link_item','select * from items where name = \'$links_all_prikey\'','Edit Link Title and Permissions','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('link_newdetail',NULL,'Add a new Link Item','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('link_itemedit',NULL,'','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('link_new','','Add a new Links Widget','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('art_new',NULL,'Add a new Article to a Group','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('art_item','select * from items where name = \'$articles_all_prikey\'','Edit Articles Info','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('art_editone','select * from article where code = \'$browse_art_prikey\'','Edit One Article','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_new','','Add a new Form Widget','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('art_newitem',NULL,'Add a new Articles Group','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('art_edit',NULL,'','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_edit_form','select * from form_detail where name=\'$form_name\' and fieldname=\'$form_field\'','Edit form Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('cache',NULL,NULL,'Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_edit_option','select * from form_detail where name=\'$form_name\' and fieldname=\'$form_field\'','Edit option Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('upd_cache',NULL,NULL,'FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_filter',NULL,'Form Filter','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('link_onedetail','select * from links where linkgroup = \'$links_all_prikey\' and name = \'$link_detail_prikey\'','Edit one Link Item','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('browse_filter','','Browse Filter','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_itemfilter',NULL,'Form Filter','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('text_filter',NULL,'Text Filter','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('menu_filter',NULL,'Menu Filter','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('link_filter',NULL,'Link Filter','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('gallery_item','select * from gallery where name = \'$gallery_all_prikey\'','Edit Gallery Info','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('gallery_all','','Gallery Management','FormGroup','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('gallery_upload','','Upload an Image','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('gallery_sec',NULL,NULL,'Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('gallery_new','','New Gallery','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('editor_text_item','select * from items where name = \'$editor_text_items_prikey\'','Edit Text Info','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('editor_text_itemedit','',NULL,'FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_browse',NULL,'','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('gallery_user','','User Selection','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('text_browse',NULL,'','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_edit_input','select * from form_detail where name=\'$form_name\' and fieldname=\'$form_field\'','Edit input Control','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('layout_add','','Add a new Layout Item','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('menu_onedetail','select * from menuitems where name = \'$menu_items_prikey\' and menuorder = \'$menu_detail_prikey\'','Edit one Menu Item','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_itemedit','','','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('menu_itemedit','','','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('text_itemedit','','','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('menu_new','','Add a new Menu','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('logo_itemedit','','','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('articles_itemedit',NULL,'','FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('logo_item','select * from items where name=\'$logo_all_prikey\'','Edit Logo and Site Title','Form','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('login_stats',NULL,NULL,'FormGroup','SDS',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_add_table','','Create form from table','Form','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_useredit','','User Management','FormGroup','SDS','',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_useredit_one','select language, emp_grp, username, perms, \'*******\' as password from auth_user_md5 where user_id=\'$browse_useredit_prikey\'','Edit One User','Form','SDS','','doHashPass(this)');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_useredit_add','','Add User','Form','SDS','','doHashPass(this)');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_group_one','select * from groups where groups.groups = \'$browse_group_prikey\'','Edit One Group','Form','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_group','','Group Management','FormGroup','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_group_add','','Add a Group','Form','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_usergroup_add','','Add a Group to this user','Form','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_usergroup_del','','Remove Group from this user','Form','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_userips_add','','Add an IP to this user','Form','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('form_userips_del','','Delete an IP from this user','Form','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_selkey','','Select Keytable','Form','KEYTABLE','%data%',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_keytable','','','FormGroup','KEYTABLE','%data%',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_onekey','select * from keytable where prikey=$brw_keytable_prikey','Edit One Keytable entry','Form','KEYTABLE','%data%',NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_emp',NULL,NULL,'FormGroup','NONE',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_emp_one','select * from emp where emp_id = \'$brw_emp_prikey\'','Employee data','Form','NONE','%data%','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_emp_add','','Add a new Employee','Form','NONE','%data%','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_reg',NULL,NULL,'FormGroup','NONE',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_reg_add','','Start a new time periode','Form','NONE','%data%','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_emp_grp_add','','Add a Group to an Employee','Form','NONE','%data%','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_emp_grp_del','','Remove a Group from an Employee','Form','NONE','%data%','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_selemp','','Select Employee','Form','NONE','%data%','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_time_all',NULL,NULL,'FormGroup','NONE',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_reg_mgr_all',NULL,NULL,'FormGroup','NONE',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_addkey','','Add a new keytable key','Form','NONE','%data%','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_reg_mod','select * from reg where reg_id=\'$brw_reg_mgr_prikey\'','Edit one Time Registration','Form','NONE','%data%','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_reg_mod_one','select * from reg where reg_id=\'$brw_reg_prikey\'','Modify Registration','Form','NONE','%data%','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_reg_mgr_add','select * from reg where reg_id=\'$brw_reg_mgr_prikey\'','Add a new Time Registration','Form','NONE','%data%','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_selemp_mgr','','Select Employee','Form','NONE','%data%','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_keygrp_all',NULL,NULL,'FormGroup','NONE',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_keygrp_add','','Add a Code Group Combination','Form','NONE','%data%','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_time_sel','','Employee Selection','Form','NONE','%data%','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_controle',NULL,NULL,'FormGroup','NONE',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_reg_chk_all',NULL,NULL,'FormGroup','NONE',NULL,NULL);
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('report_all','','Report Management','FormGroup','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('report_filter','','Report Filter','Form','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('report_one','select * from report where name = \'$report_all_prikey\'','Edit Report Title & Code','Form','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('report_newcol','','Add a new Report Column','Form','NONE','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('report_onecol','select * from report_detail where name=\'$report_all_prikey\' and columnorder=\'$report_col_prikey\'','Edit one Report Column','Form','NONE','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('report_new','','Add a new Report','Form','SDS','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_reg_mat_all','','Material Registration','FormGroup','NONE','%data%','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_rep_dag','','Reporting','Form','NONE','','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_selord','','Select an Order','Form','NONE','%data%','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_reg_mat_add','','Add a Material','Form','NONE','%data%','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_reg_mat_one','select reg_id, prd_code, reg_mat_quant from reg where reg_id = \'$brw_reg_prd_prikey\'','Edit a Material','Form','NONE','%data%','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_reg_cst_all','','Cost Registration','FormGroup','NONE','%data%','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_reg_cst_add','','Add a Cost','Form','NONE','%data%','');
INSERT INTO form (name, sql, title, type, system, db, onsubmit) VALUES ('frm_reg_cst_one','select reg_id, dcp_code, reg_mat_quant from reg where reg_id = \'$brw_reg_dcp_prikey\'','Edit a Cost','Form','NONE','%data%','');

--
-- Table structure for table `form_detail`
--

DROP TABLE IF EXISTS form_detail;
CREATE TABLE form_detail (
  name varchar(20) NOT NULL default '',
  fieldname varchar(40) NOT NULL default '',
  posx int(4) default NULL,
  posy int(4) default NULL,
  width int(4) default NULL,
  height int(4) default '1',
  fieldtype varchar(10) default NULL,
  text varchar(40) default NULL,
  sql text,
  pri_key varchar(40) default NULL,
  system varchar(10) default 'NONE',
  class varchar(20) default NULL,
  code text,
  perms varchar(15) default NULL,
  groups varchar(15) default NULL,
  PRIMARY KEY  (fieldname,name)
) TYPE=MyISAM;

--
-- Dumping data for table `form_detail`
--


INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','lbl_param',1,3,13,1,'label','Layout Parameter',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','width',8,4,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','lbl_fieldname',1,3,5,1,'label','Fieldname',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','layoutparam',14,3,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_new','pri_key',8,3,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_new','lbl_db',1,4,7,1,'label','Database',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_new','db',8,4,10,1,'input',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','lbl_header',1,2,5,1,'label','Header',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','header',8,2,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','lbl_width',1,4,5,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_all','code',2,2,2,1,'code',NULL,'global $form_name, $form_field;\r\nif( isset($HTTP_GET_VARS[\"form_name\"]) ) { $form_name=$HTTP_GET_VARS[\"form_name\"]; }\r\n$sess->register(\"form_name\");\r\nif( isset($HTTP_GET_VARS[\"form_field\"]) ) { $form_field=$HTTP_GET_VARS[\"form_field\"]; }\r\n$sess->register(\"form_field\");\r\n\r\n$mdb = new DB_SDS;\r\n$mdb->query(\"select * from form where name=\'$form_all_prikey\'\");\r\n$mdb->next_record();\r\nif($mdb->f(\"type\") == \"Form\") {\r\n	$f =& new Form_Manipulation($form_all_prikey);\r\n	$f->get_data();\r\n	echo $f->show();\r\n} else {\r\n	$f =& new FormGroup_Manipulation($form_all_prikey);\r\n	$f->get_data();\r\n	echo $f->show();\r\n}',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_new','lbl_form',1,1,6,1,'label','Name',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_new','name',8,1,20,1,'option','','select name as k, name as v from form where type = \'FormGroup\' order by name',NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','code',1,3,1,1,'code','','echo \'\r\n<script language=\"javascript\">\r\n	<!--\r\n	function setval(form, name, x, y) {\r\n		document.form_move.thisform_inp_from_x.value = x;\r\n		document.form_move.thisform_inp_from_y.value = y;\r\n		document.form_move.thisform_inp_form.value = form;\r\n		document.form_move.thisform_inp_control.value = name;\r\n	}\r\n	function settoval(x, y) {\r\n		document.form_move.thisform_inp_to_x.value = x;\r\n		document.form_move.thisform_inp_to_y.value = y;\r\n		document.form_add_control.thisform_x.value = x;\r\n		document.form_add_control.thisform_y.value = y;\r\n	}\r\n	function setxtoval(x) {\r\n		document.form_move.thisform_inp_to_x.value = x;\r\n		document.form_add_control.thisform_x.value = x;\r\n	}\r\n	function setytoval(y) {\r\n		document.form_move.thisform_inp_to_y.value = y;\r\n		document.form_add_control.thisform_y.value = y;\r\n	}\r\n	// -->\r\n</script>\r\n\';','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_onedetail','btn_delete',47,2,6,1,'button','Delete','delete from menuitems where name = \'$menu_items_prikey\' and menuorder = \'$menu_detail_prikey\'','','SDS',NULL,'global $sess;\r\n$db =& new DB_SDS;\r\n$db->query(\"select min(menuorder) as val from menuitems where name = \'$menu_items_prikey\'\");\r\n$db->next_record();\r\n$menu_detail_prikey = $db->f(\"val\");\r\n$sess->register(\"$menu_detail_prikey\");\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','height',19,2,6,1,'input',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','btn_save',47,1,6,1,'button','Save','update browse_detail set columnorder = \'$thisform_columnorder\', header = \'$thisform_header\', width = \'$thisform_width\', fieldname = \'$thisform_fieldname\', align = \'$thisform_align\', fieldcode = \'$thisform_fieldcode\' where name = \'$browse_all_prikey\' and columnorder = \'$browse_col_prikey\'','','SDS',NULL,'global $sess;\r\n$browse_col_prikey = $thisform_columnorder;\r\n$sess->register(\"browse_col_prikey\");\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','inp_control',7,2,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','width',7,2,4,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add','type',7,2,10,1,'option','form','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','lbl_height',12,2,6,1,'label','Height',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_all','browse_onecol',2,3,2,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add','lbl_type',1,2,6,1,'label','Type',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','lbl_width',1,2,6,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','fieldname',26,2,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','width',7,2,4,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','lbl_name',1,1,6,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','fieldname',7,1,10,1,'value','',NULL,'form_field','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','lbl_type',17,2,6,1,'label','Type',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','sql',1,5,48,5,'edit',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','type',23,2,10,1,'option','form','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','height',19,2,6,1,'input',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','btn_save',38,1,6,1,'button','Save','update form_detail set height = \'$thisform_height\', width = \'$thisform_width\', perms = \'$thisform_perms\', groups = \'$thisform_groups\' where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,'','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','lbl_width',1,2,6,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','btn_delete',38,2,6,1,'button','Delete','delete from form_detail where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','lbl_height',11,2,6,1,'label','Height',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','fieldname',7,1,10,1,'value','',NULL,'form_field','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','height',17,2,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','lbl_name',1,1,6,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','lbl_type',20,1,6,1,'label','Mode',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','btn_save',38,1,6,1,'button','Save','update form_detail set height = \'$thisform_height\', width = \'$thisform_width\', sql = \'$thisform_sql\', text = \'$thisform_text\', perms = \'$thisform_perms\', groups = \'$thisform_groups\' where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,'','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','btn_delete',38,2,6,1,'button','Delete','delete from form_detail where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','btn_save',38,1,6,1,'button','Save','update form_detail set height = \'$thisform_height\', width = \'$thisform_width\', sql = \'$thisform_sql\', perms = \'$thisform_perms\', groups = \'$thisform_groups\' where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,'','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','name',7,1,10,1,'value','',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_control','x',3,3,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_sql',1,4,6,1,'label','SQL',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_control','type',8,2,10,1,'option','control',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','lbl_name',1,1,6,1,'label','Name',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','lbl_title',17,1,6,1,'label','Title',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_all','form_browse',1,1,1,2,'formgroup','edit','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_control','lbl_posx',1,3,1,1,'label','X',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','fieldname',7,1,10,1,'value','',NULL,'form_field','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','lbl_name',1,1,6,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_text',1,2,6,1,'label','Text',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','sql',1,5,45,4,'edit','',NULL,'','SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_control','lbl_posy',6,3,1,1,'label','Y',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','width',33,2,4,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add','name',7,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add','btn_new',7,3,6,1,'button','New','insert into form (name, type) values (\'$thisform_name\', \'$thisform_type\')',NULL,'SDS',NULL,'global $sess;\r\n$form_all_prikey = $thisform_name;\r\n$sess->register(\'form_all_prikey\');',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','lbl_type',1,2,6,1,'label','Type',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','btn_save',38,1,6,1,'button','Save','update form_detail set text = \'$thisform_text\', width = \'$thisform_width\', sql = \'$thisform_sql\', perms = \'$thisform_perms\', groups = \'$thisform_groups\' where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,'','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','btn_save',38,1,6,1,'button','Save','update form_detail set height = \'$thisform_height\', width = \'$thisform_width\', perms = \'$thisform_perms\', groups = \'$thisform_groups\' where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,'','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','btn_delete',38,2,6,1,'button','Delete','delete from form_detail where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','text',7,2,20,1,'option','optiontype','',NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','sql',1,5,44,4,'edit','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','lbl_width',27,2,6,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','sql',1,4,44,4,'edit','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','fieldname',7,1,10,1,'value','',NULL,'form_field','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','lbl_name',1,1,6,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add','lbl_name',1,1,6,1,'label','Name',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','text',7,2,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','lbl_sql',1,4,6,1,'label','SQL',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','width',34,2,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','lbl_width',28,2,6,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','height',34,1,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','btn_delete',38,2,6,1,'button','Delete','delete from form_detail where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','btn_save',43,1,6,1,'button','Save','update form set title = \'$thisform_title\', db = \'$thisform_db\', sql = \'$thisform_sql\', type = \'$thisform_type\', onsubmit = \'$thisform_onsubmit\' where name = \'$form_all_prikey\'',NULL,'SDS',NULL,'','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','lbl_height',28,1,6,1,'label','Height',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_control','y',8,3,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','title',23,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','lbl_sql',1,4,6,1,'label','SQL',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','text',26,1,6,1,'input',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','lbl_width',27,2,6,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','lbl_pri_key',1,2,6,1,'label','PriKey',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','btn_delete',38,2,6,1,'button','Delete','delete from form_detail where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','btn_save',38,1,6,1,'button','Save','update form_detail set text = \'$thisform_text\', width = \'$thisform_width\', sql = \'$thisform_sql\', code = \'$thisform_code\', perms = \'$thisform_perms\', groups = \'$thisform_groups\' where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS','','','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_control','lbl_type',1,2,7,1,'label','Control',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','pri_key',7,2,20,1,'input','',NULL,'','SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','width',33,2,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','fieldname',7,1,10,1,'value','',NULL,'form_field','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_width',27,2,6,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_control','name',8,1,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_new','perm',8,2,20,1,'option','perm','',NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_new','lbl_perm',1,2,6,1,'label','Permission',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_control','lbl_name',1,1,6,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','width',33,2,4,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','btn_delete',38,2,6,1,'button','Delete','delete from form_detail where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_itemedit','text_new',2,2,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_new','title',36,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','btn_delete',38,2,6,1,'button','Delete','delete from form_detail where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_control','btn_new',12,3,6,1,'button','New','insert into form_detail (name, fieldname, fieldtype, posx, posy, width) values (\'$form_all_prikey\', \'$thisform_name\', \'$thisform_type\', \'$thisform_x\', \'$thisform_y\', 6)','','SDS',NULL,'global $sess, $form_name, $form_field, $form_class;\r\n$form_field = $thisform_name;\r\n$field_class = $thisform_type;\r\n$form_name = $form_all_prikey;\r\n$sess->register(\'form_name\');\r\n$sess->register(\'form_field\');\r\n$sess->register(\'field_class\');\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_new','btn_new',56,2,6,1,'button','New','insert into items (name, title, perm, plugin) values (\'$thisform_name\', \'$thisform_title\', \'$thisform_perm\', \'FormGroup\')',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','btn_delete',38,2,6,1,'button','Delete','delete from form_detail where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','fieldname',7,1,10,1,'value','',NULL,'form_field','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_name',1,1,6,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','lbl_name',1,1,6,1,'label','Name',NULL,'','SDS','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','lbl_name',1,1,6,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','pri_key',7,2,20,1,'input','',NULL,'','SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_item','perm',8,2,10,1,'option','perm',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','lbl_width',27,2,6,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','lbl_pri_key',1,2,6,1,'label','PriKey',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','btn_save',38,1,6,1,'button','Save','update form_detail set pri_key = \'$thisform_pri_key\', width = \'$thisform_width\', perms = \'$thisform_perms\', groups = \'$thisform_groups\' where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,'','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_item','btn_save',45,1,6,1,'button','Save','update items set perm = \'$thisform_perm\', title = \'$thisform_title\', text = \'$thisform_text\' where name = \'$text_items_prikey\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','fieldname',7,1,10,1,'value','',NULL,'form_field','SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','btn_delete',47,2,6,1,'button','Delete','delete from browse where name = \'$browse_all_prikey\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','width',33,2,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','btn_save',38,1,6,1,'button','Save','update form_detail set pri_key = \'$thisform_pri_key\', width = $thisform_width, perms = \'$thisform_perms\', groups = \'$thisform_groups\' where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,'','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_itemedit','demo_menu',1,4,1,1,'code','','if($menu_item_plugin==\'Menu\') {\r\n$c =& new Column();\r\n$m =& new Menu(array(\"name\" => \"$menu_items_prikey\", \"title\" => \"$menu_item_title\"));\r\n$c->add_element($m);\r\necho $c->show();\r\n}','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','btn_delete',47,2,6,1,'button','Delete','delete from browse_detail  where name = \'$browse_all_prikey\' and columnorder = \'$browse_col_prikey\'','','SDS',NULL,'global $sess;\r\n$db =& new DB_SDS;\r\n$db->query(\"select min(columnorder) as val from browse_detail where name = \'$browse_all_prikey\'\");\r\n$db->next_record();\r\n$browse_col_prikey = $db->f(\"val\");\r\n$sess->register(\"$browse_col_prikey\");',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_item','lbl_perm',1,2,6,1,'label','Permission',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','btn_delete',45,2,6,1,'button','Delete','delete from items where name = \'$menu_items_prikey\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_item','name',8,1,10,1,'value',NULL,NULL,'text_items_prikey','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_item','btn_delete',45,2,6,1,'button','Delete','delete from items where name = \'$text_items_prikey\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_item','lbl_title',19,1,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_item','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_item','text',1,3,70,20,'edit',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','width',33,2,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('editor_text_itemedit','editor_text_item',1,1,1,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_itemedit','form_new',2,3,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','lbl_y2',10,5,1,1,'label','Y',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','lbl_width',27,2,6,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_itemedit','text_item',2,1,1,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','inp_to_y',12,5,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','lbl_x1',1,4,1,1,'label','X',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','lbl_x2',10,4,1,1,'label','X',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_itemedit','demo_headmenu',1,5,3,1,'code',NULL,'if($menu_item_plugin==\'Headermenu\') {\r\n$c =& new Column();\r\n$m =& new HeaderMenu(array(\"name\" => \"$menu_items_prikey\", \"title\" => \"$menu_item_title\"));\r\n$c->add_element($m);\r\necho $c->show();\r\n}',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','lbl_y1',1,5,1,1,'label','Y',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_item','lbl_name',1,1,6,1,'label','Name',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','inp_to_x',12,4,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','lbl_type',19,2,5,1,'label','Type',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_new','lbl_name',1,1,6,1,'label','Name',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','layoutgroup',8,2,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','inp_from_y',3,5,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','lbl_to',12,3,2,1,'label','To',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','inp_from_x',3,4,3,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_all','form_add',1,3,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','plugin',24,2,10,1,'option','menu','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','lbl_group',1,2,6,1,'label','Group',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','lbl_from',3,3,6,1,'label','From',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_all','case',2,3,1,2,'case','','label,form_edit_label\r\ninput,form_edit_input\r\nvalue,form_edit_value\r\nbutton,form_edit_button\r\ncase,form_edit_code\r\ncode,form_edit_code\r\ng_code,form_edit_code\r\nedit,form_edit_edit\r\noption,form_edit_option\r\nform,form_edit_form\r\nbrowse,form_edit_browse','field_class','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','lbl_position',28,1,7,1,'label','Position',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_all','layout_all',1,1,1,4,'browse','','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_all','code',2,1,1,3,'code','','$l =& new admin_page($layout_all_prikey);\r\necho $l->show();\r\n\r\n','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_item','btn_delete',56,2,6,1,'button','Delete','delete from items where name = \'$form_items_prikey\'',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_itemedit','code',1,3,2,1,'code','','$c =& new Column();\r\n$db =& new DB_SDS();\r\n$db->query(\"select * from items where name = \'$text_items_prikey\'\");\r\n$db->next_record();\r\n$m =& new Text($db->Record);\r\n$c->add_element($m);\r\necho $c->show();','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_all','layout_add',2,4,1,1,'form','edit','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_new','lbl_title',29,1,6,1,'label','Title',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_new','btn_new',27,1,6,1,'button','New','insert into items (\r\nname, \r\ntitle, \r\nperm, \r\nplugin) values (\r\n\'$thisform_name\', \r\n\'$thisform_title\', \r\n\'$thisform_perm\', \r\n\'Text\')',NULL,'SDS',NULL,'global $sess;\r\n$text_items_prikey = $thisform_name;\r\n$sess->register(\"text_items_prikey\");',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_itemedit','logo_all',1,1,1,2,'browse',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_item','title',24,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_new','name',7,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_item','btn_delete',43,2,6,1,'button','Delete','delete from items where name=\'$logo_all_prikey\'',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_item','name',8,1,6,1,'value',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','layoutorder',26,2,4,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_item','link',22,2,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_item','lbl_text',1,2,6,1,'label','Text',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_itemedit','logo_item',2,1,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_new','name',7,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','lbl_order',19,2,6,1,'label','Order',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_item','lbl_title',15,1,6,1,'label','Title',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_item','lbl_link',15,2,6,1,'label','Link',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_new','btn_new',7,2,6,1,'button','New','insert into items (name, plugin) values (\'$thisform_name\', \'Logo\')',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_item','btn_save',43,1,6,1,'button','Save','update items set title = \'$thisform_title\', text = \'$thisform_text\', link = \'$thisform_link\' where name=\'$logo_all_prikey\'',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','class',11,4,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_upd',1,15,6,1,'label','Update',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','lbl_class',1,4,10,1,'label','css Class',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','sql_upd',1,16,15,4,'edit',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','lbl_align',20,3,5,1,'label','Align',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','align',26,3,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','lbl_fcode',1,3,10,1,'label','Field Code',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','btn_del',43,2,6,1,'button','Delete','delete from form where name = \'$form_all_prikey\'',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_itemedit','logo_new',2,2,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','lbl_db',17,2,7,1,'label','Database',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','db',25,2,10,1,'input',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','fieldcode',1,4,52,4,'edit',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_new','lbl_name',1,1,6,1,'label','Name',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_item','title',22,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('logo_item','text',1,3,48,3,'edit',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_editone','lbl_sum',1,3,10,1,'label','Summary',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','cde_gen',7,15,6,1,'code',NULL,'$sql_w = \"\";\r\n$sql_ins = \"insert into TABLE \";\r\n$sql_i1 = \"\";\r\n$sql_i2 = \"\";\r\n$sql_del = \"delete from TABLE where \";\r\n$sql_upd = \"update TABLE set \";\r\n$sql_u = \"\";\r\n$gdb = new DB_SDS;\r\n$gdb->query(\"select * from form_detail where name=\'$form_name\' order by posy, posx\");\r\nwhile($gdb->next_record()) {\r\n	if( $gdb->f(\"fieldtype\") == \"input\" || $gdb->f(\"fieldtype\") == \"edit\" || $gdb->f(\"fieldtype\") == \"option\" || $gdb->f(\"fieldtype\") == \"value\") {\r\n		if( ! empty($sql_u) ) { $sql_u .= \", \"; }\r\n		$sql_u .= \"\r\n\" . $gdb->f(\"fieldname\") . \" = \'$\" . \"thisform_\" . $gdb->f(\"fieldname\") . \"\'\";\r\n		if( ! empty($sql_i1) ) { $sql_i1 .= \", \"; }\r\n		$sql_i1 .= \"\r\n\" . $gdb->f(\"fieldname\");\r\n		if( ! empty($sql_i2) ) { $sql_i2 .= \", \"; }\r\n		$sql_i2 .= \"\r\n\'$\" . \"thisform_\" . $gdb->f(\"fieldname\") . \"\'\";\r\n		$p = $gdb->f(\"pri_key\");\r\n		if( ! empty($p) ) {\r\n			if( ! empty($sql_w) ) { $sql_w .= \" and \"; }\r\n			$sql_w .= $gdb->f(\"fieldname\") . \" = \'$\" . $gdb->f(\"pri_key\") . \"\'\";\r\n		}\r\n	}\r\n}\r\n\r\n$sql_upd .= $sql_u . \" where \" . $sql_w;\r\n$sql_ins .= \"(\" . $sql_i1 . \") values (\" . $sql_i2 . \")\";\r\n$sql_del .= $sql_w;\r\n$thisform_sql_upd = $sql_upd;\r\n$thisform_sql_ins = $sql_ins;\r\n$thisform_sql_del = $sql_del;\r\n',NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_ins',16,15,6,1,'label','Insert',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','lbl_control',1,2,5,1,'label','Control',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','lbl_code',1,2,6,1,'label','Code',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','inp_form',7,1,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','btn_delete',38,2,6,1,'button','Delete','delete from form_detail where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','btn_move',1,6,5,1,'button','Move','update form_detail set posx=$thisform_inp_to_x, posy=$thisform_inp_to_y where name=\'$thisform_inp_form\' and fieldname=\'$thisform_inp_control\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','lbl_form',1,1,5,1,'label','Form',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','lbl_height',12,2,6,1,'label','Height',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','lbl_name',1,1,6,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_newitem','btn_new',18,1,6,1,'button','New','insert into items (name, plugin) values (\'$thisform_name\', \'Articles\')',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_edit','art_editone',2,2,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','fieldname',7,1,10,1,'value','',NULL,'form_field','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_edit','articles_all',1,1,1,2,'browse','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_editone','title',6,2,40,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_editone','lbl_code',1,1,5,1,'label','Code',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_editone','code',6,1,10,1,'value',NULL,NULL,'browse_art_prikey','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_edit','browse_art',2,1,1,1,'browse',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_newitem','name',7,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_item','btn_save',45,2,6,1,'button','Save','update items set perm = \'$thisform_perm\', title = \'$thisform_title\', text = \'$thisform_text\' where name = \'$art_items_prikey\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_newitem','lbl_name',1,1,6,1,'label','Name',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_editone','lbl_title',1,2,5,1,'label','Title',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_item','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_item','lbl_text',19,1,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_item','name',8,1,10,1,'value',NULL,NULL,'art_items_prikey','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','sql_ins',16,16,15,4,'edit',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_item','title',24,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','sql_del',31,16,15,4,'edit',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('articles_itemedit','articles_all',1,1,1,2,'browse','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('articles_itemedit','art_item',2,1,1,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','lbl_db',1,2,6,1,'label','Database',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','name',8,1,20,1,'option','items','','','SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_editone','text',1,10,50,10,'edit',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_editone','lbl_txt',1,9,10,1,'label','Text',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','place',35,1,10,1,'option','place','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_new','btn_new',47,1,6,1,'button','New','insert into article (articlegroup, posted, title) values (\'$articles_all_prikey\', now(), \'$thisform_title\')',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_sqlgen',1,14,45,1,'label','Autogenerated SQL Statements',NULL,NULL,'SDS','formheader',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_del',31,15,6,1,'label','Delete',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_item','btn_delete',45,1,6,1,'button','Delete','delete from items where name = \'$art_items_prikey\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_item','lbl_perm',1,2,6,1,'label','Permission',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('articles_itemedit','art_newitem',2,2,1,1,'form','edit',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_item','perm',8,2,10,1,'option','perm',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','db',7,2,10,1,'input',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_all','code',1,5,3,1,'code',NULL,'if(! empty($browse_all_prikey) ){\n$b =& new Browse($browse_all_prikey);\n$b->get_data();\necho $b->show();\n}',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','lbl_item',1,1,6,1,'label','Item',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('layout_add','brn_save',45,1,6,1,'c_button','Save','if( !empty($thisform_layoutgroup)) {\r\n	$layout_all_prikey = $thisform_layoutgroup;\r\n}\r\n$mdb = new DB_SDS;\r\nif( empty($thisform_layoutorder) ) {\r\n	$mdb->query(\"select max(layoutorder) as o from layout where layoutgroup = \'$layout_all_prikey\'\");\r\n	$mdb->next_record();\r\n	$thisform_layoutorder = $mdb->f(\"o\") + 10;\r\n}\r\n$mdb->query(\"insert into layout (\r\n	layoutgroup, \r\n	layoutorder, \r\n	layoutparam, \r\n	name, \r\n	place\r\n	) values (\r\n	\'$layout_all_prikey\', \r\n	$thisform_layoutorder, \r\n	\'$thisform_layoutparam\', \r\n	\'$thisform_name\', \r\n	\'$thisform_place\')\r\n\");\r\n',NULL,'SDS',NULL,'',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_editone','summary',1,4,50,5,'edit',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_editone','btn_save',46,1,6,1,'button','Save','update article set \r\ntitle = \'$thisform_title\', \r\nsummary = \'$thisform_summary\', \r\ntext = \'$thisform_text\' where code = \'$browse_art_prikey\'',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_new','plugin',8,4,10,1,'option','menu',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_newdetail','menutext',6,2,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_edit','art_new',2,3,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_new','lbl_title',1,1,5,1,'label','Title',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_new','lbl_type',1,4,5,1,'label','Type',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_newdetail','param',6,3,20,1,'option','layoutgroup','','','SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_newdetail','lbl_text',1,2,5,1,'label','Text',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_new','lbl_perm',1,3,6,1,'label','Permission',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_new','perm',8,3,10,1,'option','perm',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_new','title',8,2,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_new','title',6,1,40,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_new','lbl_title',1,2,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('art_editone','btn_delete',46,2,6,1,'button','Delete','delete from article where code = \'$browse_art_prikey\'',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_newdetail','page',6,4,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_newdetail','lbl_group',1,3,5,1,'label','Group',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_newdetail','lbl_page',1,4,5,1,'label','Page',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_new','maxlines',8,2,4,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_new','lbl_prikey',1,3,5,1,'label','PriKey',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_new','title',8,2,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_new','lbl_title',1,2,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_newdetail','name',6,1,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_newdetail','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_item','name',8,1,10,1,'value',NULL,NULL,'link_items_prikey','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_item','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_new','perm',7,3,10,1,'option','perm',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_new','lbl_maxlines',1,2,7,1,'label','MaxLines',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_code',1,9,6,1,'label','Code',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','code',1,10,45,4,'edit','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_new','lbl_title',1,2,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_new','title',7,2,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_new','lbl_perm',1,3,6,1,'label','Permission',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_new','lbl_perm',1,3,6,1,'label','Permission',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_new','perm',8,3,10,1,'option','perm',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_newdetail','btn_new',21,1,5,1,'button','New','insert into links (\r\nlinkgroup, \r\nname, \r\ntitle, \r\nlink) values (\r\n\'$links_all_prikey\', \r\n\'$thisform_name\', \r\n\'$thisform_title\', \r\n\'$thisform_link\')','','SDS',NULL,'global $sess;\r\n$link_detail_prikey = $thisform_name;\r\n$sess->register(\"link_detail_prikey\");\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_newdetail','lbl_title',1,2,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_itemedit','link_newdetail',3,4,1,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_item','title',24,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_item','lbl_title',19,1,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_newdetail','title',6,2,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_newdetail','lbl_link',1,3,5,1,'label','Link',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_item','btn_save',45,1,6,1,'button','Save','update items set perm = \'$thisform_perm\', title = \'$thisform_title\' where name = \'$link_items_prikey\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('cache','btn_cacheall',1,1,6,1,'button','Cache All','',NULL,'SDS',NULL,'$db =& new DB_SDS;\r\n$db->query(\"select * from items\");\r\nwhile( $db->next_record()) {\r\n	echo $db->f(\"name\") . \" ... \";\r\n	$db->Record[\"cached\"] = \"N\";\r\n	$class = $db->f(\"plugin\");\r\n	$c =& new $class($db->Record, \"Y\");\r\n	$c->create_cache();\r\n	echo \"Cached<BR>\r\n\";\r\n	flush();\r\n}',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_item','lbl_perm',1,2,6,1,'label','Permission',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_newdetail','link',6,3,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_item','link_detail',1,4,60,7,'browse','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_item','perm',8,2,10,1,'option','perm',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_item','btn_delete',45,2,6,1,'button','Delete','delete from items where name = \'$link_items_prikey\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('upd_cache','cache',1,1,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','title',24,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_filter','code_search',13,1,1,1,'g_code',NULL,'if( isset($HTTP_POST_VARS[\"thisform_brw_search\"]) ) {\r\n	$thisform_brw_search=$HTTP_POST_VARS[\"thisform_brw_search\"];\r\n	$brw_browse_all_pos = 0;\r\n}\r\n$sess->register(\"thisform_brw_search\");\r\nif( ! empty($thisform_brw_search) ) {\r\n	$browse_all_filter = \"where name like \'%$thisform_brw_search%\'\";\r\n} else {\r\n	$browse_all_filter = \"\";\r\n}',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_onedetail','title',26,1,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_onedetail','name',8,1,10,1,'input',NULL,NULL,'link_one_prikey','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_onedetail','link',8,2,40,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_onedetail','lbl_link',1,2,5,1,'label','Link',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_onedetail','description',1,4,55,4,'edit','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_onedetail','btn_delete',50,2,6,1,'button','Delete','delete from links where \r\nlinkgroup = \'$links_all_prikey\' and \r\nname = \'$link_one_prikey\'','','SDS',NULL,'global $sess;\r\n$db =& new DB_SDS;\r\n$db->query(\"select name as val from links where linkgroup = \'$links_all_prikey\' limit 0,1\");\r\n$db->next_record();\r\n$link_detail_prikey = $db->f(\"val\");\r\n$sess->register(\"$link_detail_prikey\");\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_onedetail','btn_save',50,1,6,1,'button','Save','update links set \r\nname = \'$thisform_name\', \r\ntitle = \'$thisform_title\', \r\nlink = \'$thisform_link\', \r\ndescription = \'$thisform_description\' where linkgroup = \'$links_all_prikey\' and \r\nname = \'$link_one_prikey\'','','SDS',NULL,'global $sess;\r\n$link_detail_prikey = $thisform_name;\r\n$sess->register(\"link_detail_prikey\");\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_filter','brw_search',1,1,12,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_onedetail','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_all','gallery_all',1,1,1,2,'browse',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','name',8,1,10,1,'value',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_onedetail','lbl_text',20,1,5,1,'label','Text',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('cache','btn_clearcache',8,1,6,1,'button','Clear Cache','update items set cached = \'N\' where name != \'upd_cache\'',NULL,'SDS',NULL,'',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_onedetail','lbl_desc',1,3,5,1,'label','Description',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_filter','code_search',13,1,1,1,'g_code',NULL,'if( isset($HTTP_POST_VARS[\"thisform_frm_search\"]) ) {\r\n	$thisform_frm_search=$HTTP_POST_VARS[\"thisform_frm_search\"];\r\n	$brw_form_all_pos = 0;\r\n}\r\n$sess->register(\"thisform_frm_search\");\r\nif( ! empty($thisform_frm_search) ) {\r\n	$form_all_filter = \"where name like \'%$thisform_frm_search%\'\";\r\n} else {\r\n	$form_all_filter = \"\";\r\n}',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('cache','btn_cachesystem',15,1,6,1,'button','Cache System','',NULL,'SDS',NULL,'$db =& new DB_SDS;\r\n$db->query(\"select * from items where system = \'SDS\'\");\r\nwhile( $db->next_record()) {\r\n	echo $db->f(\"name\") . \" ... \";\r\n	$db->Record[\"cached\"] = \"N\";\r\n	$class = $db->f(\"plugin\");\r\n	$c =& new $class($db->Record, \"Y\");\r\n	$c->create_cache();\r\n	echo \"Cached<BR>\r\n\";\r\n	flush();\r\n}',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_filter','code_search',13,1,1,1,'g_code',NULL,'if( isset($HTTP_POST_VARS[\"thisform_txt_search\"]) ) {\r\n	$thisform_txt_search=$HTTP_POST_VARS[\"thisform_txt_search\"];\r\n	$brw_text_items_pos = 0;\r\n}\r\n$sess->register(\"thisform_txt_search\");\r\nif( ! empty($thisform_txt_search) ) {\r\n	$text_items_filter = \"and name like \'%$thisform_txt_search%\'\";\r\n} else {\r\n	$text_items_filter = \"\";\r\n}',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_filter','frm_search',1,1,12,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_all','form_add_control',3,3,1,2,'form','edit','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_filter','txt_search',1,1,12,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_all','browse_filter',1,1,1,1,'form','noclear','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','description',1,5,50,3,'edit',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_all','gallery_item',2,1,2,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','type',8,2,10,1,'option','publicprivate',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','btn_delete',45,2,6,1,'button','Delete','delete from gallery where name = \'$gallery_all_prikey\'','','SDS',NULL,'',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_itemfilter','code_search',13,1,1,1,'g_code',NULL,'if( isset($HTTP_POST_VARS[\"thisform_frmi_search\"]) ) {\r\n	$thisform_frmi_search=$HTTP_POST_VARS[\"thisform_frmi_search\"];\r\n	$brw_form_items_pos = 0;\r\n}\r\n$sess->register(\"thisform_frmi_search\");\r\nif( ! empty($thisform_frmi_search) ) {\r\n	$form_items_filter = \"and name like \'%$thisform_frmi_search%\'\";\r\n} else {\r\n	$form_items_filter = \"\";\r\n}',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_itemfilter','frmi_search',1,1,12,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_itemedit','menu_filter',1,1,1,1,'form','noclear',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','btn_update',45,3,6,1,'button','Update','',NULL,'SDS',NULL,'global $gallery_dir;\r\n$db =& new DB_SDS;\r\n$mdb =& new DB_SDS;\r\n//$db->query(\"delete from gallery_images where name = \'$gallery_all_prikey\'\");\r\n$dir = $gallery_dir . \"/\" . $gallery_all_prikey;\r\nif ($handle = opendir($dir)) {\r\n	while (false !== ($file = readdir($handle))) {\r\n		if( stristr($file, \".jpg\") || stristr($file, \".gif\") ) {\r\n			$mdb->query(\"select * from gallery_images where name = \'$gallery_all_prikey\' and filename = \'$file\'\");\r\n			if($mdb->num_rows() == 0) {\r\n				$db->query(\"insert into gallery_images (name, filename) values (\'$gallery_all_prikey\', \'$file\')\");\r\n			}\r\n		}\r\n	}\r\n}\r\n$db->query(\"select * from gallery_images where name = \'$gallery_all_prikey\'\");\r\nwhile($db->next_record()) {\r\n	$file = $db->f(\"filename\");\r\n	if( ! file_exists($dir . \"/\" . $file) ) {\r\n		$mdb->query(\"delete from gallery_images where name = \'$gallery_all_prikey\' and filename = \'$file\'\");\r\n	}\r\n}\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_filter','code_search',13,1,1,1,'g_code',NULL,'if( isset($HTTP_POST_VARS[\"thisform_mnu_search\"]) ) {\r\n	$thisform_mnu_search=$HTTP_POST_VARS[\"thisform_mnu_search\"];\r\n	$brw_menu_items_pos = 0;\r\n}\r\n$sess->register(\"thisform_mnu_search\");\r\nif( ! empty($thisform_mnu_search) ) {\r\n	$menu_items_filter = \"and name like \'%$thisform_mnu_search%\'\";\r\n} else {\r\n	$menu_items_filter = \"\";\r\n}',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_filter','lnk_search',1,1,12,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_filter','mnu_search',1,1,12,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_itemedit','text_browse',1,1,1,2,'formgroup','noclear',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_filter','code_search',13,1,1,1,'g_code',NULL,'if( isset($HTTP_POST_VARS[\"thisform_lnk_search\"]) ) {\r\n	$thisform_lnk_search=$HTTP_POST_VARS[\"thisform_lnk_search\"];\r\n	$brw_link_items_pos = 0;\r\n}\r\n$sess->register(\"thisform_lnk_search\");\r\nif( ! empty($thisform_lnk_search) ) {\r\n	$links_all_filter = \"and name like \'%$thisform_lnk_search%\'\";\r\n} else {\r\n	$links_all_filter = \"\";\r\n}',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_itemedit','form_itemfilter',1,1,1,1,'form','noclear','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','btn_save',45,1,6,1,'button','Save','update gallery set type = \'$thisform_type\', title = \'$thisform_title\', description = \'$thisform_description\' where name = \'$gallery_all_prikey\'','','SDS',NULL,'',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_all','gallery_user',2,3,2,1,'form','noclear','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_user','code2',50,1,1,1,'code',NULL,'',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_user','btn_select',19,1,6,1,'button','Select','',NULL,'SDS',NULL,'global $HTTP_POST_VARS, $sess, $thisform_user;\r\nif( isset($HTTP_POST_VARS[\"thisform_user\"]) ) {\r\n$thisform_user = $HTTP_POST_VARS[\"thisform_user\"];\r\n}\r\n$sess->register(\"thisform_user\");',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_sec','btn_save',51,1,1,1,'button','Save','',NULL,'SDS',NULL,'$g =& new foto_gallery($gallery_all_prikey);\r\n$g->update_admin();',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_itemedit','link_filter',1,1,1,1,'form','noclear',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_sec','code',1,1,50,1,'code',NULL,'$g =& new foto_gallery($gallery_all_prikey);\r\necho $g->show_admin();',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','lbl_type',1,2,6,1,'label','Type',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_user','lbl_user',1,1,6,1,'label','User',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','btn_read',45,4,6,1,'button','ReadIn','',NULL,'SDS',NULL,'global $image_dir, $gallery_dir;\r\n$db =& new DB_SDS;\r\n$dir = $image_dir . \"/incoming\";\r\n$dir2 = $gallery_dir . \"/\" . $gallery_all_prikey;\r\nif ($handle = opendir($dir)) {\r\n	while (false !== ($file = readdir($handle))) {\r\n		if( stristr($file, \".jpg\") || stristr($file, \".gif\") ) {\r\n			$cp_cmd = \"/bin/cp \" . $dir . \"/\" . $file . \" \" . $dir2;\r\n			system($cp_cmd);\r\n			$db->query(\"insert into gallery_images (name, filename) values (\'$gallery_all_prikey\', \'$file\')\");\r\n		}\r\n	}\r\n}\r\necho \"<B>All images copied: Please remove all uploaded images from the incoming dir</B>\";\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_upload','code',1,1,50,1,'code',NULL,'global $gallery_dir;\r\nupload_image($gallery_dir, $gallery_all_prikey);',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_user','code',8,1,10,1,'code',NULL,'global $thisform_user;\r\n$res = \"\";\r\n$users =& new HTMLOptions();\r\n$users->add_element(\"*\", \"*\");\r\n$db =& new DB_SDS;\r\n$db->query(\"select username from auth_user_md5 order by username\");\r\nwhile($db->next_record()) {\r\n	$users->add_element($db->f(\"username\"), $db->f(\"username\"));\r\n}\r\n$res .= \"<select name=thisform_user>\\n\";\r\n$users->set_default($thisform_user);\r\n$res .= $users->show();\r\necho $res;',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_all','gallery_upload',2,2,2,1,'form','','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_all','gallery_new',1,3,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_all','gallery_sec',1,4,3,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('editor_text_itemedit','code',1,3,1,1,'code','','$c =& new Column();\r\n$db =& new DB_SDS();\r\n$db->query(\"select * from items where name = \'$editor_text_items_prikey\'\");\r\n$db->next_record();\r\n$m =& new Text($db->Record);\r\n$c->add_element($m);\r\necho $c->show();','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_browse','text_filter',1,1,1,1,'form','noclear',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_browse','form_filter',1,1,1,1,'form','noclear',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_browse','form_all',1,2,1,1,'browse',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('text_browse','text_items',1,2,1,1,'browse','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_new','btn_new',11,1,4,1,'button','New','insert into gallery (name, type) values (\'$thisform_new\', \'public\')',NULL,'SDS',NULL,'global $gallery_dir, $sess;\r\n$mkdir = \"mkdir -p \" . $gallery_dir . \"/\" . $thisform_new . \"/th\";\r\nsystem($mkdir);\r\n$gallery_all_prikey = $thisform_new;\r\n$sess->register(\"gallery_all_prikey\");',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('editor_text_item','title',24,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('editor_text_item','lbl_title',19,1,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_new','new',1,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('editor_text_item','btn_save',45,1,6,1,'button','Save','update items set title = \'$thisform_title\', text = \'$thisform_text\', cached = \'N\' where name = \'$editor_text_items_prikey\'','','SDS',NULL,'',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('editor_text_item','name',8,1,10,1,'value','',NULL,'editor_text_items_prikey','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('editor_text_item','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('editor_text_item','text',1,3,70,20,'edit',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','fieldname',8,3,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','lbl_align',1,5,5,1,'label','Align',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','align',8,5,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_itemedit','link_new',2,4,1,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','lbl_text',1,2,6,1,'label','Text',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','lbl_columnorder',1,1,7,1,'label','Order',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','pri_key',36,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_all','form_move',3,1,1,1,'form','edit','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','text',7,2,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','fieldname',7,1,10,1,'value','',NULL,'form_field','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','lbl_title',19,1,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','btn_save',38,1,6,1,'button','Save','update form_detail set text = \'$thisform_text\', width = \'$thisform_width\', class = \'$thisform_class\', perms = \'$thisform_perms\', groups = \'$thisform_groups\' where name = \'$form_all_prikey\' and fieldname=\'$form_field\'','','SDS',NULL,'','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_all','form_one',2,1,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','lbl_width',1,2,6,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','lbl_name',1,1,6,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','columnorder',8,1,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','width',7,2,4,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_newcol','btn_new',19,1,5,1,'button','New','insert into browse_detail (\r\nname, \r\ncolumnorder, \r\nheader, \r\nfieldname, \r\nwidth, \r\nalign) values (\r\n\'$browse_all_prikey\', \'$thisform_columnorder\', \r\n\'$thisform_header\', \r\n\'$thisform_fieldname\', \r\n\'$thisform_width\', \r\n\'$thisform_align\')','','SDS',NULL,'global $sess;\r\n$browse_col_prikey = $thisform_columnorder;\r\n$sess->register(\"browse_col_prikey\");',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','width',8,2,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','lbl_fieldname',20,2,5,1,'label','Fieldname',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','lbl_width',1,2,5,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_new','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','header',26,1,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','btn_save',47,1,6,1,'button','Save','update browse set \r\nmaxlines = \'$thisform_maxlines\', \r\npri_key = \'$thisform_pri_key\', \r\ndb = \'$thisform_db\', \r\nsql = \'$thisform_sql\',\r\nnext_layout = \'$thisform_next_layout\' where \r\nname = \'$browse_all_prikey\'','','SDS',NULL,'',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_all','browse_newcol',3,4,1,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','maxlines',25,1,4,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','lbl_prikey',30,1,5,1,'label','PriKey',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','lbl_header',20,1,5,1,'label','Header',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','lbl_sql',1,3,10,1,'label','Browse SQL',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_all','browse_new',2,4,1,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','columnorder',8,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','name',6,1,10,1,'value',NULL,NULL,'browse_all_prikey','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','sql',1,4,52,3,'edit',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_onecol','lbl_order',1,1,5,1,'label','Order',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_all','browse_one',2,1,2,2,'form','edit','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_new','name',8,1,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','lbl_maxlines',17,1,7,1,'label','MaxLines',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','browse_col',1,7,60,7,'browse','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_newdetail','menuorder2',6,1,5,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_newdetail','btn_new',21,1,5,1,'button','New','insert into menuitems (\r\nname, \r\nmenuorder, \r\nmenutext, \r\nparam, \r\npage) values (\r\n\'$menu_items_prikey\', \r\n\'$thisform_menuorder2\', \r\n\'$thisform_menutext\', \r\n\'$thisform_param\', \r\n\'$thisform_page\')','','SDS',NULL,'global $sess;\r\n$menu_detail_prikey = $thisform_menuorder2;\r\n$sess->register(\"menu_detail_prikey\");\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_itemedit','menu_newdetail',3,4,1,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_new','name',8,1,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_new','btn_new',22,1,6,1,'button','New','insert into items (\r\nname, \r\ntitle, \r\nperm, \r\nplugin) values (\r\n\'$thisform_name\', \r\n\'$thisform_title\', \r\n\'$thisform_perm\', \r\n\'$thisform_plugin\')\r\n\r\n','','SDS',NULL,'global $sess;\r\n$menu_items_prikey = $thisform_name;\r\n$sess->register(\"menu_items_prikey\");',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_new','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_new','btn_new',18,1,6,1,'button','New','insert into browse (\r\nname, \r\nmaxlines, \r\npri_key, \r\ndb) values (\r\n\'$thisform_name\', \r\n\'$thisform_maxlines\', \r\n\'$thisform_pri_key\', \r\n\'$thisform_db\')','','SDS',NULL,'global $sess;\r\n$browse_all_prikey = $thisform_name;\r\n$sess->register(\"browse_all_prikey\");',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_onedetail','btn_save',47,1,6,1,'button','Save','update menuitems set menuorder = \'$thisform_menuorder\', menutext = \'$thisform_menutext\', page = \'$thisform_page\', param = \'$thisform_param\' where name = \'$menu_items_prikey\' and menuorder = \'$menu_detail_prikey\'','','SDS',NULL,'global $sess;\r\n$menu_detail_prikey = $thisform_menuorder;\r\n$sess->register(\"menu_detail_prikey\");\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_newdetail','lbl_order',1,1,5,1,'label','Order',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_onedetail','lbl_menuorder',1,1,5,1,'label','Order',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_onedetail','lbl_text',20,1,5,1,'label','Text',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_itemedit','menu_onedetail',2,3,2,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_onedetail','param',8,2,10,1,'option','layoutgroup',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_onedetail','page',26,2,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('gallery_item','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_onedetail','menutext',26,1,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_onedetail','lbl_group',1,2,5,1,'label','Group',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_onedetail','lbl_page',20,2,5,1,'label','Page',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_itemedit','menu_new',2,4,1,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_onedetail','menuorder',8,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_itemedit','form_item',2,1,1,2,'form','edit','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','btn_save',45,1,6,1,'button','Save','update items set perm = \'$thisform_perm\', title = \'$thisform_title\', plugin=\'$thisform_plugin\' where name = \'$menu_items_prikey\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','lbl_title',19,1,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','name',8,1,10,1,'value',NULL,NULL,'menu_items_prikey','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_item','title',35,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_all','browse_all',1,2,1,3,'browse',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_item','btn_save',56,1,6,1,'button','Save','update items set perm = \'$thisform_perm\', title = \'$thisform_title\' where name = \'$form_items_prikey\'','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_item','name',8,1,10,1,'value',NULL,NULL,'items_forms_prikey','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_item','lbl_text',29,1,5,1,'label','Title',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_item','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_itemedit','form_items',1,2,1,3,'browse','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_itemedit','menu_item',2,1,2,2,'form','edit','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_itemedit','menu_items',1,2,1,2,'browse','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','lbl_perm',1,2,6,1,'label','Permission',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_item','perm',8,2,20,1,'option','perm','','','SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','menu_detail',1,4,60,7,'browse','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','perm',8,2,10,1,'option','perm',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_item','lbl_perm',1,2,6,1,'label','Permission',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('menu_item','title',24,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_itemedit','link_onedetail',2,3,2,1,'form','edit',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_itemedit','link_item',2,1,2,2,'form','edit','','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_itemedit','demo_link',1,5,3,1,'code','','$c =& new Column();\r\n$m =& new Links(array(\"name\" => \"$links_all_prikey\", \"title\" => \"$link_item_title\"));\r\n$c->add_element($m);\r\necho $c->show();\r\n','','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_new','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_itemedit','links_all',1,2,1,3,'browse','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_new','name',8,1,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('link_new','btn_new',22,1,6,1,'button','New','insert into items (\r\nname, \r\ntitle, \r\nperm, \r\nplugin) values (\r\n\'$thisform_name\', \r\n\'$thisform_title\', \r\n\'$thisform_perm\', \r\n\'Links\')\r\n','','SDS',NULL,'global $sess;\r\n$links_all_prikey = $thisform_name;\r\n$sess->register(\"links_all_prikey\");',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('login_stats','login_stats',1,1,1,1,'browse',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_table','btn_new',7,4,6,1,'button','New','',NULL,'SDS',NULL,'global $sess;\r\n$form_all_prikey = $thisform_name;\r\n$sess->register(\'form_all_prikey\');\r\ncreate_form($thisform_name, $thisform_tablename, $thisform_database);\r\n',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_table','lbl_name',1,1,6,1,'label','Name',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_table','lbl_table',1,3,6,1,'label','Table',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_table','name',7,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_table','tablename',7,3,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_table','lbl_database',1,2,6,1,'label','Database',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_add_table','database',7,2,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_all','form_add_table',1,4,1,1,'form','edit','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','perms',7,5,15,1,'option','perm','',NULL,'SDS',NULL,NULL,'supervisor',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit','form_useredit_one',2,1,2,1,'form','edit','',NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','username',7,1,15,1,'value','','','username','SDS','','','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','lbl_user',1,1,6,1,'label','User',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit','browse_useredit',1,1,1,2,'browse',NULL,NULL,NULL,'SDS',NULL,NULL,'supervisor','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','lbl_next',1,2,5,1,'label','Next',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('browse_one','next_layout',6,2,10,1,'option','layoutgroup','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_move','btn_movedown',6,6,6,1,'button','Move Down','update form_detail set posy=posy+1 where name=\'$thisform_inp_form\' and posy>=$thisform_inp_to_y',NULL,'SDS',NULL,'',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','lbl_sec',1,5,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,'supervisor',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','lbl_password',1,2,6,1,'label','Password',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','password',7,2,15,1,'password',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','lbl_perms',1,3,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','perms',7,3,15,1,'option','perm','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_perms',1,3,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','perms',7,3,15,1,'option','perm','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','lbl_perms',1,3,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','perms',7,3,15,1,'option','perm','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','lbl_perms',1,3,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','perms',7,3,15,1,'option','perm','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','lbl_perms',1,3,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','perms',7,3,15,1,'option','perm','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','lbl_perms',1,3,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','perms',7,3,15,1,'option','perm','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','lbl_perms',1,3,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','perms',7,3,15,1,'option','perm','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','lbl_perms',1,3,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','perms',7,3,15,1,'option','perm','',NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','lbl_perms',1,3,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','perms',7,3,15,1,'option','perm','',NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','btn_save',22,5,6,1,'button','Save','',NULL,'SDS',NULL,'global $sess, $thisform_hashpass, $u_id;\r\n$db = new DB_SDS;\r\n\r\nif(!empty($thisform_password)) {\r\n	$this->msg(\"<b>Warning:</b> plain text password received. Is Javascript enabled?\");\r\n}\r\n\r\n## Hash the password if we need to\r\nif (empty($thisform_hashpass)) {\r\n	if(isset($thisform_password)) {\r\n		$thisform_password = md5($thisform_password);\r\n	} else {\r\n		$thisform_password = \"\";\r\n	}\r\n} else {\r\n	$thisform_password = $thisform_hashpass;\r\n}\r\n\r\n## Find out if a new password was entered\r\nif ($thisform_password == md5(\"*******\")) {\r\n	$new_password = false;\r\n} else {\r\n	$new_password = true;\r\n}\r\n\r\nif ($perm->have_perm(\"supervisor\")) {\r\n	## Supervisor can change permissions and password\r\n	if( $new_password ) {\r\n		$query = \"update auth_user_md5 set password=\'$thisform_password\', perms=\'$thisform_perms\', emp_grp=\'$thisform_emp_grp\', language=\'$thisform_language\' where user_id=\'$u_id\'\";\r\n	} else {\r\n		$query = \"update auth_user_md5 set perms=\'$thisform_perms\', emp_grp=\'$thisform_emp_grp\', language=\'$thisform_language\' where user_id=\'$u_id\'\";\r\n	}\r\n	$db->query($query);\r\n	$this->msg($db->affected_rows() . \" Records Updated\");\r\n} else {\r\n	## only change password\r\n	if( $new_password ) {\r\n		$query = \"update auth_user_md5 set password=\'$thisform_password\', emp_grp=\'$thisform_emp_grp\', language=\'$thisform_language\' where user_id=\'$u_id\'\";\r\n		$db->query($query);\r\n		$this->msg($db->affected_rows() . \" Records Updated\");\r\n	}\r\n}','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','btn_delete',22,6,6,1,'button','Delete','delete from auth_user_md5 where user_id = \'$browse_useredit_prikey\'',NULL,'SDS',NULL,'global $sess;\r\n$xdb= new DB_SDS;\r\n$xdb->query(\"select user_id from auth_user_md5 order by username\");\r\n$xdb->next_record();\r\n$browse_useredit_prikey = $xdb->f(\"user_id\");\r\n$sess->register(\"browse_useredit_prikey\");\r\n','supervisor',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_add','lbl_user',1,1,6,1,'label','User',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_add','username',7,1,15,1,'input',NULL,NULL,'','SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_add','btn_add',22,1,6,1,'button','Add','',NULL,'SDS',NULL,'global $sess, $thisform_hashpass;\r\n$db = new DB_SDS;\r\n$hash_secret = \"JaBbErWoCkY...\";\r\n\r\nif(!empty($thisform_password)) {\r\n	$this->msg(\"<b>Warning:</b> plain text password received. Is Javascript enabled?\");\r\n}\r\n\r\n## Hash the password if we need to\r\nif (empty($thisform_hashpass)) {\r\n	if(isset($thisform_password)) {\r\n		$thisform_password = md5($thisform_password);\r\n	} else {\r\n		$thisform_password = \"\";\r\n	}\r\n} else {\r\n	$thisform_password = $thisform_hashpass;\r\n}\r\n\r\n## Find out if a new password was entered\r\nif ($thisform_password == md5(\"*******\")) {\r\n	$new_password = false;\r\n} else {\r\n	$new_password = true;\r\n}\r\n\r\n## Do we have permission to do so?\r\nif (!$perm->have_perm(\"supervisor\")) {\r\n	$this->msg(\"Error: You do not have permission to create users.\");\r\n} else {\r\n	## Do we have all necessary data?\r\n	if (empty($thisform_username) || empty($thisform_password)) {\r\n		$this->msg(\"Error: Please fill out <B>Username</B> and <B>Password</B>!\");\r\n	} else {\r\n	\r\n		## Does the user already exist?\r\n		## NOTE: This should be a transaction, but it is not...\r\n		$db->query(\"select * from auth_user_md5 where username=\'$thisform_username\'\");\r\n		if ($db->nf()>0) {\r\n			$this->msg(\"Error: User <B>$thisform_username</B> already exists!\");\r\n		} else {\r\n		\r\n			## Create a uid and insert the user...\r\n			$u_id = md5( uniqid( $hash_secret ) );\r\n			$permlist = $thisform_perms;\r\n			$query = \"insert into auth_user_md5 (user_id, username, password, perms) values (\'$u_id\',\'$thisform_username\',\'$thisform_password\',\'$thisform_perms\')\";\r\n			$db->query($query);\r\n			if ($db->affected_rows() == 0) {\r\n				$this->msg(\"<b>Failed:</b> $query\");\r\n			} else {\r\n				$this->msg(\"User \\\"$thisform_username\\\" created.\");\r\n				$browse_useredit_prikey = $u_id;\r\n				$sess->register(\"browse_useredit_prikey\");\r\n			}\r\n		}\r\n	}\r\n}\r\n','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit','form_useredit_add',2,2,2,1,'form','edit','',NULL,'SDS',NULL,NULL,'supervisor',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_add','lbl_perms',1,3,6,1,'label','Permission',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_add','perms',7,3,15,1,'option','perm','',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_add','lbl_password',1,2,6,1,'label','Password',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_add','password',7,2,15,1,'password',NULL,NULL,'','SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','cde_hashpass',22,1,6,1,'code',NULL,'?><input type=\"hidden\" name=\"thisform_hashpass\" value=\"\">\r\n<input type=\"hidden\" name=\"u_id\" value=\"<?php echo $browse_useredit_prikey; ?>\">\r\n<?php',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit','cde_glb',4,6,1,1,'code',NULL,'?><script language=\"javascript\" src=\"md5.js\"></script>\r\n<script language=\"javascript\">\r\n	<!--\r\n	function doHashPass(theForm) {\r\n		theForm.thisform_hashpass.value = MD5(theForm.thisform_password.value);\r\n		theForm.thisform_password.value = \"\";\r\n		return true;\r\n	}\r\n	// -->\r\n</script>\r\n<?php\r\nglobal $browse_useredit_prikey, $auth;\r\nif( empty($browse_useredit_prikey) ) {\r\n	$browse_useredit_prikey = $auth->auth[\"uid\"];\r\n}',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','lbl_onSubmit',1,3,6,1,'label','onSubmit',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_one','onsubmit',7,3,42,1,'input',NULL,NULL,'','SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_add','cde_hashpass',22,3,6,1,'code',NULL,'?><input type=\"hidden\" name=\"thisform_hashpass\" value=\"\"><?php',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_one','lbl_group',1,1,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_one','groups',7,1,15,1,'value','','','','SDS','','','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_one','lbl_name',1,2,6,1,'label','Name',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_one','groupname',7,2,15,1,'input',NULL,NULL,'','SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_one','btn_save',22,1,6,1,'button','Save','update groups set \r\ngroupname = \'$thisform_groupname\' where groups.groups = \'$browse_group_prikey\'',NULL,'SDS',NULL,'','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_one','btn_delete',22,2,6,1,'button','Delete','delete from groups where groups.group = \'$browse_group_prikey\'',NULL,'SDS',NULL,'global $browse_group_prikey, $sess;\r\n$browse_group_prikey = \"\";\r\n$sess->register(\'browse_group_prikey\');','',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group','browse_group',1,1,1,2,'browse',NULL,NULL,NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group','form_group_one',2,1,1,1,'form','edit','',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_add','lbl_group',1,1,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_add','group',7,1,15,1,'input',NULL,NULL,'','SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_add','lbl_name',1,2,6,1,'label','Name',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_add','groupname',7,2,15,1,'input',NULL,NULL,'','SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group_add','btn_add',22,1,6,1,'button','Add','insert into groups (groups.groups, groups.groupname) values (\'$thisform_group\', \'$thisform_groupname\')',NULL,'SDS',NULL,'global $browse_group_prikey, $sess;\r\n$browse_group_prikey = $thisform_group;\r\n$sess->register(\'browse_group_prikey\');','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_group','form_group_add',2,2,1,1,'form','edit','',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit','browse_usergroup',1,3,1,2,'browse',NULL,NULL,NULL,'SDS',NULL,NULL,'supervisor',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_usergroup_add','lbl_group',1,1,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_usergroup_add','group',7,1,15,1,'option','','select groups.group as k, groups.groupname as v from groups order by groupname',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit','form_usergroup_add',2,3,1,1,'form','noclear','',NULL,'SDS',NULL,NULL,'supervisor',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_usergroup_add','btn_add',22,1,6,1,'button','Add','',NULL,'SDS',NULL,'$db = new DB_SDS;\r\n$db->query(\"select username from auth_user_md5 where user_id=\'$browse_useredit_prikey\'\");\r\nif( $db->num_rows() > 0) {\r\n	$db->next_record();\r\n	$username = $db->f(\"username\");\r\n	$db->query(\"insert into user_group (user_group.username, user_group.group) values (\'$username\', \'$thisform_group\')\");\r\n	if( $db->affected_rows() > 0 ) {\r\n		$this->msg(\"Group \'\" . $thisform_group . \"\' added to user \'\" . $username . \"\'\");\r\n	}\r\n}','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_usergroup_del','lbl_group',1,1,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_usergroup_del','group',7,1,6,1,'option','','select groups.group as k, groups.groupname as v from auth_user_md5 inner join user_group on auth_user_md5.username = user_group.username inner join groups on user_group.group = groups.group where auth_user_md5.user_id = \'$browse_useredit_prikey\'',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_usergroup_del','btn_remove',13,1,6,1,'button','Remove','',NULL,'SDS',NULL,'$db = new DB_SDS;\r\n$db->query(\"select username from auth_user_md5 where user_id=\'$browse_useredit_prikey\'\");\r\nif( $db->num_rows() > 0) {\r\n	$db->next_record();\r\n	$username = $db->f(\"username\");\r\n	$db->query(\"delete from user_group where user_group.username = \'$username\' and user_group.group = \'$thisform_group\'\");\r\n	if( $db->affected_rows() > 0 ) {\r\n		$this->msg(\"Group \'\" . $thisform_group . \"\' removed from user \'\" . $username . \"\'\");\r\n	}\r\n}','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit','form_usergroup_del',2,4,1,1,'form','noclear','',NULL,'SDS',NULL,NULL,'supervisor',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','lbl_group',22,3,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_browse','groups',28,3,15,1,'option','','select groups.group as k, groups.groupname as v from groups order by groupname',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','lbl_group',22,3,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_button','groups',28,3,15,1,'option','','select groups.group as k, groups.groupname as v from groups order by groupname',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','lbl_group',22,3,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_code','groups',28,3,15,1,'option','','select groups.group as k, groups.groupname as v from groups order by groupname',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','lbl_group',22,3,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_edit','groups',28,3,15,1,'option','','select groups.group as k, groups.groupname as v from groups order by groupname',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','lbl_group',22,3,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_form','groups',28,3,6,1,'option','','select groups.group as k, groups.groupname as v from groups order by groupname',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','lbl_group',22,3,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_input','groups',28,3,15,1,'option','','select groups.group as k, groups.groupname as v from groups order by groupname',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','lbl_group',22,3,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_label','groups',28,3,15,1,'option','','select groups.group as k, groups.groupname as v from groups order by groupname',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','lbl_group',22,3,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_option','groups',28,3,15,1,'option','','select groups.group as k, groups.groupname as v from groups order by groupname',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','lbl_group',22,3,6,1,'label','Group',NULL,NULL,'SDS','',NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_edit_value','groups',28,3,15,1,'option','','select groups.group as k, groups.groupname as v from groups order by groupname',NULL,'SDS',NULL,NULL,'',NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit','browse_userips',1,5,1,2,'browse',NULL,NULL,NULL,'SDS',NULL,NULL,'supervisor','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_userips_add','lbl_ip',1,1,6,1,'label','IP',NULL,NULL,'SDS','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_userips_add','ip',7,1,20,1,'input',NULL,NULL,'','SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_userips_add','btn_add',27,1,6,1,'button','Add','',NULL,'SDS',NULL,'$db = new DB_SDS;\r\n$db->query(\"select username from auth_user_md5 where user_id=\'$browse_useredit_prikey\'\");\r\nif( $db->num_rows() > 0) {\r\n	$db->next_record();\r\n	$username = $db->f(\"username\");\r\n	$db->query(\"insert into user_ips (user_ips.username, user_ips.ip) values (\'$username\', \'$thisform_ip\')\");\r\n	if( $db->affected_rows() > 0 ) {\r\n		$this->msg(\"IP \'\" . $thisform_ip . \"\' added to user \'\" . $username . \"\'\");\r\n	}\r\n}','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit','form_userips_add',2,5,1,1,'form','noclear','',NULL,'SDS',NULL,NULL,'supervisor','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_userips_del','lbl_ip',1,1,6,1,'label','IP',NULL,NULL,'SDS','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_userips_del','ip',7,1,20,1,'option','','select user_ips.ip as k, user_ips.ip as v from auth_user_md5 inner join user_ips on auth_user_md5.username = user_ips.username where auth_user_md5.user_id = \'$browse_useredit_prikey\'',NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_userips_del','btn_remove',27,1,6,1,'button','Remove','',NULL,'SDS',NULL,'$db = new DB_SDS;\r\n$db->query(\"select username from auth_user_md5 where user_id=\'$browse_useredit_prikey\'\");\r\nif( $db->num_rows() > 0) {\r\n	$db->next_record();\r\n	$username = $db->f(\"username\");\r\n	$db->query(\"delete from user_ips where user_ips.username = \'$username\' and user_ips.ip = \'$thisform_ip\'\");\r\n	if( $db->affected_rows() > 0 ) {\r\n		$this->msg(\"IP \'\" . $thisform_ip . \"\' removed from user \'\" . $username . \"\'\");\r\n	}\r\n}','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit','form_userips_del',2,6,1,1,'form','noclear','',NULL,'SDS',NULL,NULL,'supervisor','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selkey','sel_key',2,1,15,1,'option','','select key_table as k, key_value as v from keytable where key_type = \'T\' order by key_value',NULL,'KEYTABLE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_keytable','frm_selkey',1,1,1,1,'form','noclear','',NULL,'KEYTABLE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selkey','btn_go',18,1,6,1,'button','Select','',NULL,'KEYTABLE',NULL,'global $brw_keytable_table;\r\nfix_POST(\"thisform_sel_key\", \"brw_keytable_table\");\r\nfix_global(\"brw_keytable_prikey\", \"\", \"NOXQS_DB\", \"select prikey from keytable where key_type=\' \' and key_table = \'$brw_keytable_table\' order by key_value\", \"prikey\", \"true\");',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_keytable','brw_keytable',1,2,1,2,'browse',NULL,NULL,NULL,'KEYTABLE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selkey','cde_sel',1,1,1,1,'code',NULL,'global $brw_keytable_table;\r\nfix_global(\"thisform_sel_key\", \"brw_keytable_table\", \"NOXQS_DB\", \"select key_table from keytable where key_type=\'T\' order by key_value\", \"key_table\");\r\nfix_global(\"brw_keytable_prikey\", \"\", \"NOXQS_DB\", \"select prikey from keytable where key_type=\' \' and key_table = \'$brw_keytable_table\' order by key_value\", \"prikey\")',NULL,'KEYTABLE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_onekey','lbl_code',1,1,6,1,'label','Code',NULL,NULL,'KEYTABLE','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_onekey','key_code',7,1,10,1,'value','','','','KEYTABLE','','',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_keytable','frm_onekey',2,2,1,1,'form','edit','',NULL,'KEYTABLE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_onekey','lbl_value',1,2,6,1,'label','Value',NULL,NULL,'KEYTABLE','',NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_onekey','key_value',7,2,20,1,'input',NULL,NULL,'','KEYTABLE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_onekey','btn_save',27,1,6,1,'button','Save','update keytable set \r\nkey_value = \'$thisform_key_value\' where  prikey = \'$brw_keytable_prikey\'',NULL,'KEYTABLE',NULL,'',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_onekey','btn_create_cache',1,4,6,1,'button','Create Cache','',NULL,'KEYTABLE',NULL,'create_keytable_cache(\"NOXQS_DB\");',NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_one','lbl_id',1,1,2,1,'label','ID',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_one','emp_id',7,1,6,1,'value',NULL,NULL,NULL,'NONE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp','brw_emp',1,1,1,6,'browse',NULL,NULL,NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp','frm_emp_one',2,2,1,1,'form','edit','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_one','lbl_firstn',1,2,6,1,'label','First name',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_one','emp_firstname',7,2,10,1,'input',NULL,NULL,'','NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_one','lbl_lastname',1,3,6,1,'label','Last name',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_one','emp_lastname',7,3,20,1,'input','','','','NONE','','','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_one','lbl_work',1,6,6,1,'label','Workplace',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_one','emp_workplace',7,6,15,1,'option','KEYTABLE','WORKPLACE',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_one','btn_save',23,8,6,1,'button','Save','update emp set \r\nemp_firstname = \'$thisform_emp_firstname\', \r\nemp_lastname = \'$thisform_emp_lastname\', \r\nemp_workplace = \'$thisform_emp_workplace\', emp_activity = \'$thisform_emp_activity\',\r\nemp_shift = \'$thisform_emp_shift\', emp_passwd = \'$thisform_emp_passwd\', mod_updusr = \'$glb_usercode\', mod_updtime = now() where emp_id = \'$brw_emp_prikey\'',NULL,'NONE',NULL,'','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_add','lbl_id',1,1,2,1,'label','ID',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_add','add_emp_id',3,1,6,1,'input',NULL,NULL,NULL,'NONE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_add','btn_add',9,1,6,1,'button','Add','insert into emp ( emp_id, mod_crtime, mod_crusr) values (\'$thisform_add_emp_id\', now(), \'$glb_usercode\')',NULL,'NONE',NULL,'global $sess, $brw_emp_prikey;\r\n$brw_emp_prikey = $thisform_add_emp_id;\r\n$sess->register(\"brw_emp_prikey\");','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp','frm_emp_add',2,1,1,1,'form','edit','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_add','glb_cde',15,1,1,1,'g_code',NULL,'global $glb_usercode;\r\n',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_one','glb_code',20,2,6,1,'g_code',NULL,'global $glb_usercode, $sess;\r\n$sess->unregister(\'thisform_emp_workplace\');\r\n$sess->unregister(\'thisform_emp_activity\');\r\n$sess->unregister(\'thisform_emp_shift\');',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg','brw_reg',1,3,1,1,'browse',NULL,NULL,NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_one','lbl_activity',1,7,6,1,'label','Activity',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_one','emp_activity',7,7,15,1,'option','KEYTABLE','ACTIVITY',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_one','lbl_shift',1,8,6,1,'label','Shift',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_one','emp_shift',7,8,15,1,'option','KEYTABLE','SHIFT',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_add','cde_progress',35,3,25,5,'code',NULL,'global $select_emp_id;\r\n\r\nif( !empty($select_emp_id) ) {\r\n	$xdb = new DB_DATA;\r\n	$xdb->query(\"select * from reg where emp_id = \'$select_emp_id\' and to_days(curdate()) - to_days(reg_start) <= 1 and reg_stop = \'0000-00-00 00:00:00\' order by reg_start desc\");\r\n	if( $xdb->num_rows() > 0 ) {\r\n		$xdb->query(\"select keytable.key_code as k, keytable.key_value as v from keytable left join key_grp on keytable.key_table = key_grp.key_table and keytable.key_code = key_grp.key_code where keytable.key_type = \' \' and keytable.key_table = \'ACTIVITY\' and key_grp.grp_id = \'$glb_emp_grp\' and keytable.key_code = \'PAUSEPYD\' order by keytable.key_code\");\r\n		echo \"<input type=image src=images/switch.png name=switch alt=\" . add_quotes(\"Volgend Werk\") .     \" title=\" . add_quotes(\"Volgend Werk\") . \">\";\r\n		if( $xdb->num_rows() > 0 ) {\r\n			echo \"<input type=image src=images/bpause.png name=bpause alt=\" . add_quotes(\"Betaalde Pauze\") .   \" title=\" . add_quotes(\"Betaalde Pauze\") . \">\";\r\n		}\r\n		echo \"<br>\";\r\n		echo \"<input type=image src=images/stop.png   name=stop   alt=\" . add_quotes(\"Stop Einde\") .       \" title=\" . add_quotes(\"Stop Einde\") . \">\";\r\n		echo \"<input type=image src=images/opause.png name=opause alt=\" . add_quotes(\"Onbetaalde Pauze\") . \" title=\" . add_quotes(\"Onbetaalde Pauze\") . \">\";\r\n	} else {\r\n		echo \"<input type=image src=images/start.png name=start alt=\" . add_quotes(\"Start Werk\") . \" title=\" . add_quotes(\"Start Werk\") . \">\";\r\n	}\r\n	$xdb->restore_db();\r\n}',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg','frm_reg_add',1,2,2,1,'form','noclear','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg','glb_cde',1,4,1,1,'g_code',NULL,'global $glb_usercode, $glb_emp_grp, $select_emp_id;\r\n',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_add','lbl_shift',1,4,10,1,'label','Shift',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_add','emp_shift',11,4,20,1,'option','','select keytable.key_code as k, keytable.key_value as v from keytable left join key_grp on keytable.key_table = key_grp.key_table and keytable.key_code = key_grp.key_code where keytable.key_type = \' \' and keytable.key_table = \'SHIFT\' and key_grp.grp_id = \'$glb_emp_grp\' order by keytable.key_code',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_add','lbl_activity',1,5,10,1,'label','Activity',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_add','emp_activity',11,5,20,1,'option','','select keytable.key_code as k, keytable.key_value as v from keytable left join key_grp on keytable.key_table = key_grp.key_table and keytable.key_code = key_grp.key_code where keytable.key_type = \' \' and keytable.key_table = \'ACTIVITY\' and key_grp.grp_id = \'$glb_emp_grp\' order by keytable.key_code',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_add','lbl_workplace',1,6,10,1,'label','Workplace',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_add','emp_workplace',11,6,20,1,'option','','select keytable.key_code as k, keytable.key_value as v from keytable left join key_grp on keytable.key_table = key_grp.key_table and keytable.key_code = key_grp.key_code where keytable.key_type = \' \' and keytable.key_table = \'WORKPLACE\' and key_grp.grp_id = \'$glb_emp_grp\' order by keytable.key_code',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_grp_add','lbl_group',1,1,6,1,'label','Group',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_grp_add','group',7,1,20,1,'option','KEYTABLE','GROUP',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_grp_del','lbl_group',1,1,6,1,'label','Group',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp','frm_emp_grp_add',2,5,1,1,'form','edit','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp','brw_emp_grp',2,3,1,2,'browse',NULL,NULL,NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_grp_add','btn_add',28,1,6,1,'button','Add','insert into emp_grp (emp_id, grp_id) values (\'$brw_emp_prikey\', \'$thisform_group\')',NULL,'NONE',NULL,'','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_grp_del','group',7,1,20,1,'option','','select grp_id as k, key_value as v from emp_grp, keytable where keytable.key_table = \'GROUP\' and keytable.key_code = emp_grp.grp_id and emp_id = \'$brw_emp_prikey\'',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_grp_del','btn_remove',28,1,6,1,'button','Remove','delete from emp_grp where emp_id = \'$brw_emp_prikey\' and grp_id = \'$thisform_group\'',NULL,'NONE',NULL,'','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp','frm_emp_grp_del',2,6,1,1,'form','edit','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','lbl_group',1,4,6,1,'label','Group',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','emp_grp',7,4,15,1,'option','KEYTABLE','GROUP',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','lbl_language',1,3,6,1,'label','Language',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('form_useredit_one','language',7,3,15,1,'option','KEYTABLE','LANGUAGE',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_add','cde_emp_id',1,1,55,1,'code',NULL,'global $select_emp_id, $thisform_ord_code, $thisform_emp_shift, $thisform_emp_activity, $thisform_emp_workplace;\r\n\r\nif(!empty($thisform_ord_code)) {\r\n	$cdb = new DB_DATA();\r\n	$cdb->query(\"select ord_code, ord_name from ord where ord_code = \" . add_s_quotes($thisform_ord_code) );\r\n	if($cdb->num_rows() >= 1) {\r\n		$cdb->next_record();\r\n		$name = $cdb->f(\"ord_name\");\r\n		echo \"<DIV style=\" . add_quotes(\"white-space:nowrap;\") . \"><FONT SIZE=+5>\" . $name . \"</FONT></DIV>\";\r\n	} else {\r\n		echo \"<DIV style=\" . add_quotes(\"white-space:nowrap;\") . \"><FONT COLOR=#FF0000 SIZE=+5>Order \" . $thisform_ord_code . \" bestaat niet</FONT></DIV>\";\r\n	}\r\n	$cdb->restore_db();\r\n}',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selemp','select_emp_id',8,1,20,1,'option','','select emp.emp_id as k, concat(emp.emp_id, \' - \', emp.emp_firstname, \' \', emp.emp_lastname) as v from emp, emp_grp where emp.emp_id = emp_grp.emp_id and emp_grp.grp_id = \'$glb_emp_grp\' order by emp.emp_id','','NONE','','','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selemp','btn_select',28,1,6,1,'button','Select','',NULL,'NONE',NULL,'global $sess, $thisform_select_emp_id2, $brw_reg_mgr_prikey, $thisform_ord_code, $thisform_emp_shift, $thisform_emp_activity, $thisform_emp_workplace;\r\n\r\nfix_POST(\"thisform_select_emp_id\", \"select_emp_id\");\r\nif( !empty($thisform_select_emp_id2) ) {\r\n	$thisform_select_emp_id = $thisform_select_emp_id2;\r\n	$select_emp_id = $thisform_select_emp_id2;\r\n	$thisform_select_emp_id2 = \"\";\r\n}\r\n$brw_reg_mgr_prikey=\"\";\r\n$brw_reg_prikey=\"\";\r\n$xdb = new DB_SDS;\r\n$xdb->query(\"USE NOXQS_DB\");\r\n$xdb->query(\"select * from emp where emp_id = \'$select_emp_id\'\");\r\n$xdb->next_record();\r\n$thisform_ord_code = \"\";\r\n$thisform_emp_shift = $xdb->f(\"emp_shift\");\r\n$thisform_emp_activity = $xdb->f(\"emp_activity\");\r\n$thisform_emp_workplace = $xdb->f(\"emp_workplace\");\r\n$sess->register(\"thisform_ord_code\");\r\n$sess->register(\"thisform_emp_shift\");\r\n$sess->register(\"thisform_emp_activity\");\r\n$sess->register(\"thisform_emp_workplace\");\r\n$xdb->query(\"USE NOXQS\");\r\n','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg','frm_selemp',1,1,2,1,'form','noclear','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_add','cde',26,2,5,1,'code',NULL,'$thisform_select_emp_id = $select_emp_id;',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selemp','cde_glb',34,1,1,1,'g_code',NULL,'global $thisform_select_emp_id, $select_emp_id, $glb_emp_grp, $glb_usercode;\r\nfix_global(\"thisform_select_emp_id\", \"select_emp_id\", \"NOXQS_DB\", \"select emp.emp_id as k from emp where emp.emp_id = \'$glb_usercode\'\", \"k\");\r\nfix_global(\"thisform_emp_shift\", \"\", \"NOXQS_DB\", \"select emp_shift from emp where emp_id = \'$thisform_select_emp_id\'\", \"emp_shift\");\r\nfix_global(\"thisform_emp_activity\", \"\", \"NOXQS_DB\", \"select emp_activity from emp where emp_id = \'$thisform_select_emp_id\'\", \"emp_activity\");\r\nfix_global(\"thisform_emp_workplace\", \"\", \"NOXQS_DB\", \"select emp_workplace from emp where emp_id = \'$thisform_select_emp_id\'\", \"emp_workplace\");\r\n',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_all','brw_reg_mgr',1,2,1,2,'browse',NULL,NULL,NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_addkey','lbl_code',1,1,6,1,'label','Code',NULL,NULL,'KEYTABLE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_addkey','add_key_code',7,1,10,1,'input','','','','KEYTABLE','','','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_addkey','lbl_value',1,2,6,1,'label','Value',NULL,NULL,'KEYTABLE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_addkey','add_key_value',7,2,15,1,'input','','','','KEYTABLE','','','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_add','lbl_order',1,3,6,1,'label','Order Nr',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_add','ord_code',11,3,15,1,'input',NULL,NULL,'','NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_all','frm_selemp_mgr',1,1,1,1,'form','noclear','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_add','cde_glb',1,2,6,1,'g_code',NULL,'global $_POST, $select_emp_id, $glb_emp_grp, $glb_usercode;\r\nglobal $thisform_ord_code, $thisform_emp_shift, $thisform_emp_activity, $thisform_emp_workplace;\r\nfix_POST(\"thisform_ord_code\");\r\nfix_POST(\"thisform_emp_shift\");\r\nfix_POST(\"thisform_emp_activity\");\r\nfix_POST(\"thisform_emp_workplace\");\r\nif( !empty($_POST[\"stop_x\"]) || !empty($_POST[\"switch_x\"]) || !empty($_POST[\"bpause_x\"]) || !empty($_POST[\"opause_x\"]) ) {\r\n	$xdb = new DB_DATA;\r\n	$xdb->query(\"select * from reg where emp_id = \'$select_emp_id\' and to_days(curdate()) - to_days(reg_start) <= 1 and reg_stop = \'0000-00-00 00:00:00\' order by reg_start desc\");\r\n	if( $xdb->num_rows() > 0 ) {\r\n		$xdb->next_record();\r\n		$reg_id = $xdb->f(\"reg_id\");\r\n		$reg_activity = $xdb->f(\"reg_activity\");\r\n		$xdb->query(\"select * from keytable where key_type = \' \' and key_table = \'ACTIVITY\' and key_inte1 # 0\");\r\n		$period = 0;\r\n		while( $xdb->next_record() ) {\r\n			if( $xdb->f(\"key_code\") == $reg_activity ) {\r\n				$period = $xdb->f(\"key_inte1\") * 60;\r\n			}\r\n		}\r\n		$xdb->query(\"update reg set reg_a_stop=now(), reg_stop=now() where reg_id = \'$reg_id\'\");\r\n		if( $period != 0 ) {\r\n			$xdb->query(\"select * from reg where reg_id = \'$reg_id\' and (UNIX_TIMESTAMP(reg_stop) - UNIX_TIMESTAMP(reg_start)) > $period\");\r\n			if( $xdb->num_rows() > 0 ) {\r\n				$xdb->query(\"update reg set reg_a_stop=now(), reg_stop=DATE_ADD(reg_start, INTERVAL $period SECOND) where reg_id = \'$reg_id\'\");\r\n			}\r\n			\r\n		}\r\n		upd_mod_mod($glb_usercode, $xdb, \"reg\", \"reg_id\", $reg_id);\r\n	}\r\n	$xdb->restore_db();\r\n}\r\nif( !empty($_POST[\"start_x\"]) || !empty($_POST[\"switch_x\"]) ) {\r\n	$xdb = new DB_DATA;\r\n	$xdb->query(\"insert into reg (emp_id, reg_type, reg_shift, reg_activity, reg_workplace, ord_code, reg_a_start, reg_start, reg_a_stop, reg_stop, reg_desc) values (\'$select_emp_id\', \'U\', \'$thisform_emp_shift\', \'$thisform_emp_activity\', \'$thisform_emp_workplace\', \'$thisform_ord_code\', now(), now(), \'0000-00-00 00:00:00\', \'0000-00-00 00:00:00\', \'$thisform_reg_desc\')\");\r\n	upd_mod_cre($glb_usercode, $xdb, \"reg\", \"reg_id\");\r\n	$xdb->restore_db();\r\n}\r\n\r\nif( !empty($_POST[\"bpause_x\"]) ) {\r\n	$xdb = new DB_DATA;\r\n	$xdb->query(\"insert into reg (emp_id, reg_type, reg_shift, reg_activity, reg_workplace, ord_code, reg_a_start, reg_start, reg_a_stop, reg_stop, reg_desc) values (\'$select_emp_id\', \'U\', \'$thisform_emp_shift\', \'PAUSEPYD\', \'$thisform_emp_workplace\', \'\', now(), now(), \'0000-00-00 00:00:00\', \'0000-00-00 00:00:00\', \'$thisform_reg_desc\')\");\r\n	upd_mod_cre($glb_usercode, $xdb, \"reg\", \"reg_id\");\r\n	$xdb->restore_db();\r\n}\r\n\r\nif( !empty($_POST[\"opause_x\"]) ) {\r\n	$xdb = new DB_DATA;\r\n	$xdb->query(\"insert into reg (emp_id, reg_type, reg_shift, reg_activity, reg_workplace, ord_code, reg_a_start, reg_start, reg_a_stop, reg_stop, reg_desc) values (\'$select_emp_id\', \'U\', \'$thisform_emp_shift\', \'PAUSEUNP\', \'$thisform_emp_workplace\', \'\', now(), now(), \'0000-00-00 00:00:00\', \'0000-00-00 00:00:00\', \'$thisform_reg_desc\')\");\r\n	upd_mod_cre($glb_usercode, $xdb, \"reg\", \"reg_id\");\r\n	$xdb->restore_db();\r\n}\r\n',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_addkey','btn_add',22,1,6,1,'button','Add','insert into keytable (\r\nkey_type,\r\nkey_table,\r\nkey_code, \r\nkey_value\r\n) values (\r\n\' \',\r\n\'$thisform_sel_key\',\r\n\'$thisform_add_key_code\', \r\n\'$thisform_add_key_value\'\r\n)',NULL,'KEYTABLE',NULL,'','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_keytable','frm_addkey',2,3,1,1,'form','noclear','',NULL,'KEYTABLE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','lbl_Start',1,2,6,1,'label','Start',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','lbl_stop',1,4,6,1,'label','Stop',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','reg_dstart',7,3,8,1,'input',NULL,NULL,'','NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','reg_dstop',7,5,8,1,'input',NULL,NULL,'','NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','reg_tstart',15,3,6,1,'input',NULL,NULL,NULL,'NONE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','reg_tstop',15,5,6,1,'input',NULL,NULL,NULL,'NONE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','cde_fix_data',1,1,6,1,'code',NULL,'global $sess, $thisform_emp_id;\r\n$sess->unregister(\"thisform_ord_code\");\r\n$thisform_reg_dstart = cdate($db->f(\"reg_start\"));\r\n$thisform_reg_tstart = ctime($db->f(\"reg_start\"));\r\n$thisform_reg_dstop = cdate($db->f(\"reg_stop\"));\r\n$thisform_reg_tstop = ctime($db->f(\"reg_stop\"));\r\n\r\n$thisform_reg_a_dstart = cdate($db->f(\"reg_a_start\"));\r\n$thisform_reg_a_tstart = ctime($db->f(\"reg_a_start\"));\r\n$thisform_reg_a_dstop = cdate($db->f(\"reg_a_stop\"));\r\n$thisform_reg_a_tstop = ctime($db->f(\"reg_a_stop\"));\r\n\r\n$thisform_emp_id = $db->f(\"emp_id\");',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_all','frm_reg_mod',2,3,1,1,'form','edit','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','lbl_shift',1,7,6,1,'label','Shift',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','lbl_activity',1,8,6,1,'label','Activity',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','lbl_workplace',1,9,6,1,'label','Workplace',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','reg_shift',7,7,20,1,'option','KEYTABLE','SHIFT',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','reg_activity',7,8,20,1,'option','KEYTABLE','ACTIVITY',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','reg_workplace',7,9,20,1,'option','KEYTABLE','WORKPLACE',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','btn_save',27,9,6,1,'button','Save','',NULL,'NONE',NULL,'global $thisform_reg_dstart, $thisform_reg_tstart, $thisform_reg_dstop, $thisform_reg_tstop, $glb_usercode;\r\n$reg_start = cdate_sql($thisform_reg_dstart) . \" \" . $thisform_reg_tstart . \":00\";\r\n$reg_stop =  cdate_sql($thisform_reg_dstop) . \" \" . $thisform_reg_tstop . \":00\";\r\n\r\n$xdb = new DB_SDS;\r\n$xdb->query(\"USE NOXQS_DB\");\r\n$xdb->query(\"update reg \r\nset \r\nord_code = \'$thisform_ord_code\', \r\nreg_start = \'$reg_start\', \r\nreg_stop = \'$reg_stop\', \r\nreg_activity = \'$thisform_reg_activity\', \r\nreg_shift = \'$thisform_reg_shift\', \r\nreg_workplace = \'$thisform_reg_workplace\', \r\nreg_desc = \'$thisform_reg_desc\'\r\nwhere reg_id = \'$brw_reg_mgr_prikey\'\");\r\nupd_mod_mod($glb_usercode, $xdb, \"reg\", \"reg_id\", $brw_reg_mgr_prikey);\r\n','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selemp','select_emp_id2',1,1,6,1,'input',NULL,NULL,NULL,'NONE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selemp','cde_loc',1,2,34,1,'code',NULL,'?><script language=\"JavaScript\">\r\n        <!--\r\n        // Activate the appropriate input form field.\r\n        document.frm_selemp.thisform_select_emp_id2.focus();\r\n        // -->\r\n</script>\r\n<?php\r\nglobal $select_emp_id, $thisform_ord_code, $thisform_emp_shift, $thisform_emp_activity, $thisform_emp_workplace;\r\n$xdb = new DB_DATA;\r\n$xdb->query(\"select * from emp where emp_id = \'$select_emp_id\'\");\r\n$xdb->next_record();\r\necho \"<DIV style=\" . add_quotes(\"white-space:nowrap;\") . \"><FONT SIZE=+5>\" . $select_emp_id . \" - \" . $xdb->f(\"emp_firstname\") . \" \" . $xdb->f(\"emp_lastname\") . \"</FONT></DIV>\";\r\n$xdb->restore_db();\r\n',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','reg_a_dstart',7,2,8,1,'value',NULL,NULL,'','NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','reg_a_tstart',15,2,6,1,'value',NULL,NULL,NULL,'NONE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','reg_a_dstop',7,4,8,1,'value',NULL,NULL,'','NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','reg_a_tstop',15,4,6,1,'value',NULL,NULL,NULL,'NONE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod_one','lbl_shift',1,3,6,1,'label','Shift',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod_one','lbl_acitvity',1,4,6,1,'label','Activity',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod_one','lbl_workplace',1,5,6,1,'label','Workplace',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod_one','reg_shift',7,3,15,1,'option','KEYTABLE','SHIFT',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod_one','reg_activity',7,4,15,1,'option','KEYTABLE','ACTIVITY',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod_one','reg_workplace',7,5,15,1,'option','KEYTABLE','WORKPLACE',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod_one','btn_save',22,5,6,1,'button','Save','update reg set \r\nord_code = \'$thisform_ord_code\', \r\nreg_shift = \'$thisform_reg_shift\', \r\nreg_activity = \'$thisform_reg_activity\', \r\nreg_workplace = \'$thisform_reg_workplace\',\r\nreg_desc = \'$thisform_reg_desc\',\r\nmod_updtime = now(),\r\nmod_updusr = \'$glb_usercode\' where \r\nreg_id=\'$brw_reg_prikey\'',NULL,'NONE',NULL,'','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg','frm_reg_mod_one',2,3,1,2,'form','edit','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod_one','lbl_order',1,2,6,1,'label','Order',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod_one','ord_code',7,2,10,1,'input',NULL,NULL,'','NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod_one','cde_fix_data',1,1,6,1,'code',NULL,'$thisform_reg_dstart = cdate($db->f(\"reg_start\"));\r\n$thisform_reg_tstart = ctime($db->f(\"reg_start\"));\r\n$thisform_reg_dstop = cdate($db->f(\"reg_stop\"));\r\n$thisform_reg_tstop = ctime($db->f(\"reg_stop\"));\r\n',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod_one','reg_dstart',7,1,6,1,'value',NULL,NULL,NULL,'NONE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod_one','reg_tstart',13,1,6,1,'value',NULL,NULL,NULL,'NONE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod_one','reg_tstop',19,1,6,1,'value',NULL,NULL,NULL,'NONE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','lbl_emp',1,2,6,1,'label','Emp',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','emp_id',7,2,20,1,'option','','select emp.emp_id as k, concat(emp.emp_id, \' - \', emp.emp_firstname, \' \', emp.emp_lastname) as v from emp order by emp.emp_id',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_all','frm_reg_mgr_add',2,1,1,2,'form','edit','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','lbl_order',1,5,6,1,'label','Order',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','ord_code',7,5,10,1,'input',NULL,NULL,'','NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','lbl_shift',1,6,6,1,'label','Shift',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','reg_shift',7,6,20,1,'option','KEYTABLE','SHIFT',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','lbl_activity',1,7,6,1,'label','Activity',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','reg_activity',7,7,20,1,'option','KEYTABLE','ACTIVITY',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','lbl_workplace',1,8,6,1,'label','Workplace',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','reg_workplace',7,8,20,1,'option','KEYTABLE','WORKPLACE',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','lbl_start',1,3,6,1,'label','Start',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','lbl_stop',1,4,6,1,'label','Stop',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','reg_dstart',7,3,8,1,'input',NULL,NULL,'','NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','reg_dstop',7,4,8,1,'input',NULL,NULL,'','NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','reg_tstart',15,3,6,1,'input',NULL,NULL,NULL,'NONE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','reg_tstop',15,4,6,1,'input',NULL,NULL,NULL,'NONE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','lbl_order',1,6,6,1,'label','Order',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','ord_code',7,6,6,1,'input',NULL,NULL,NULL,'NONE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','btn_add',27,9,6,1,'button','Add','',NULL,'NONE',NULL,'global $thisform_reg_dstart, $thisform_reg_tstart, $thisform_reg_dstop, $thisform_reg_tstop, $glb_usercode, $brw_reg_mgr_prikey;\r\n$reg_start = cdate_sql($thisform_reg_dstart) . \" \" . $thisform_reg_tstart . \":00\";\r\n$reg_stop =  cdate_sql($thisform_reg_dstop) . \" \" . $thisform_reg_tstop . \":00\";\r\n\r\n$xdb = new DB_SDS;\r\n$xdb->query(\"USE NOXQS_DB\");\r\n\r\n$xdb->query(\"insert into reg (\r\nemp_id, \r\nreg_type, \r\nreg_start, \r\nreg_a_start, \r\nreg_stop, \r\nreg_a_stop, \r\nord_code, \r\nreg_shift, \r\nreg_activity, \r\nreg_workplace, \r\nreg_desc) values (\r\n\'$thisform_emp_id\', \r\n\'U\', \r\n\'$reg_start\', \r\n\'$reg_start\', \r\n\'$reg_stop\', \r\n\'$reg_stop\', \r\n\'$thisform_ord_code\', \r\n\'$thisform_reg_shift\', \r\n\'$thisform_reg_activity\', \r\n\'$thisform_reg_workplace\',\r\n\'$thisform_reg_desc\')\");\r\n$xdb->query(\"SELECT LAST_INSERT_ID() as code\");\r\n$xdb->next_record();\r\n$brw_reg_mgr_prikey = $xdb->f(\"code\");\r\nupd_mod_cre($glb_usercode, $xdb, \"reg\", \"reg_id\");\r\n','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selemp_mgr','select_emp_id2',1,1,6,1,'input',NULL,NULL,NULL,'NONE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selemp_mgr','select_emp_id',7,1,20,1,'option','','select emp.emp_id as k, concat(emp.emp_id, \' - \', emp.emp_firstname, \' \', emp.emp_lastname) as v from emp order by emp.emp_id',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selemp_mgr','btn_select',27,1,6,1,'button','Select','',NULL,'NONE',NULL,'global $thisform_select_emp_id2, $brw_reg_mgr_prikey, $brw_brw_reg_mgr_pos;\r\nfix_POST(\"thisform_select_emp_id\", \"select_emp_id\");\r\nif( !empty($thisform_select_emp_id2) ) {\r\n	$thisform_select_emp_id = $thisform_select_emp_id2;\r\n	$select_emp_id = $thisform_select_emp_id2;\r\n	$thisform_select_emp_id2 = \"\";\r\n}\r\n$brw_reg_mgr_prikey=\"\";\r\n$brw_brw_reg_mgr_pos=0;','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selemp_mgr','cde_glb',27,2,1,1,'g_code',NULL,'global $select_emp_id, \r\n	$thisform_select_emp_id,\r\n	$thisform_select_reg_shift,\r\n	$thisform_select_reg_activity,\r\n	$thisform_select_reg_workplace,\r\n	$thisform_select_ord_code,\r\n	$glb_emp_grp;\r\nfix_POST(\"thisform_select_emp_id\");\r\nfix_POST(\"thisform_select_reg_shift\");\r\nfix_POST(\"thisform_select_reg_activity\");\r\nfix_POST(\"thisform_select_reg_workplace\");\r\nfix_POST(\"thisform_select_ord_code\");\r\n\r\nfix_global(\"thisform_select_emp_id\", \"select_emp_id\", \"NOXQS_DB\", \"select emp.emp_id as k, emp.emp_id as v from emp order by emp.emp_id\", \"k\");\r\n\r\n$brw_cond = \"\";\r\nif( (\"x\") != (\"x\" . $thisform_select_emp_id) )			$brw_cond .= \" and emp_id = \'$thisform_select_emp_id\' \";\r\nif( (\"x\") != (\"x\" . $thisform_select_reg_shift) )		$brw_cond .= \" and reg_shift = \'$thisform_select_reg_shift\' \";\r\nif( (\"x\") != (\"x\" . $thisform_select_reg_activity) )		$brw_cond .= \" and reg_activity = \'$thisform_select_reg_activity\' \";\r\nif( (\"x\") != (\"x\" . $thisform_select_reg_workplace) )		$brw_cond .= \" and reg_workplace = \'$thisform_select_reg_workplace\' \";\r\nif( (\"x\") != (\"x\" . $thisform_select_ord_code) )		$brw_cond .= \" and ord_code = \'$thisform_select_ord_code\' \";\r\n\r\n',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selemp_mgr','cde_loc',27,3,1,1,'code',NULL,'?><script language=\"JavaScript\">\r\n        <!--\r\n        // Activate the appropriate input form field.\r\n        document.frm_selemp_mgr.thisform_select_emp_id2.focus();\r\n        // -->\r\n</script>\r\n<?php',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selemp_mgr','select_reg_shift',7,2,20,1,'option','KEYTABLE','SHIFT',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selemp_mgr','lbl_shift',1,2,6,1,'label','Shift',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selemp_mgr','lbl_activity',1,3,6,1,'label','Activity',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selemp_mgr','select_reg_activity',7,3,20,1,'option','KEYTABLE','ACTIVITY',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selemp_mgr','lbl_workplace',1,4,6,1,'label','Workplace',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selemp_mgr','select_reg_workplace',7,4,20,1,'option','KEYTABLE','WORKPLACE',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_keygrp_all','frm_selkey',1,1,1,1,'form','noclear','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_keygrp_all','brw_key_grp',1,2,1,1,'browse',NULL,NULL,NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_keygrp_all','cde_global',2,1,1,1,'g_code',NULL,'global $del_record, $del_record_prikey;\r\nif( $del_record == \"yes\") {\r\n	$xdb = new DB_DATA;\r\n	$xdb->query(\"delete from key_grp where prikey = \'$del_record_prikey\'\");\r\n	$xdb->restore_db();\r\n}',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_keygrp_add','lbl_code',1,2,6,1,'label','Code',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_keygrp_add','key_code',7,2,20,1,'option','','select key_code as k, key_value as v from keytable where key_type = \' \' and key_table = \'$thisform_sel_key\'',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_keygrp_add','lbl_grp',1,1,6,1,'label','Group',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_keygrp_add','grp_id',7,1,20,1,'option','KEYTABLE','GROUP',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_keygrp_all','frm_keygrp_add',2,2,1,1,'form','noclear','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_keygrp_add','btn_add',27,2,6,1,'button','Add','insert into key_grp (key_table, key_code, grp_id) values (\'$thisform_sel_key\', \'$thisform_key_code\', \'$thisform_grp_id\')',NULL,'NONE',NULL,'','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','lbl_date',22,3,6,1,'label','DD/MM/YYYY HH:MM',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_time_sel','select_emp_id',7,2,20,1,'option','','select emp.emp_id as k, concat(emp.emp_id, \' - \', emp.emp_firstname, \' \', emp.emp_lastname) as v from emp, emp_grp where emp.emp_id = emp_grp.emp_id and emp_grp.grp_id = \'$glb_emp_grp\' order by emp.emp_id',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_time_all','cde_cal',1,1,1,1,'code',NULL,'global $sess, $currYear, $currMonth, $startDay, $stopDay;\r\nfix_GET(\"currYear\");\r\nfix_GET(\"currMonth\");\r\nfix_GET(\"startDay\");\r\nfix_GET(\"stopDay\");\r\n$sess->register(\"currYear\");\r\n$sess->register(\"currMonth\");\r\n$sess->register(\"startDay\");\r\n$sess->register(\"stopDay\");\r\n$Calendar = new Calendar;\r\n$Calendar -> mkCalendar ($currYear, $currMonth, $startDay, $stopDay);\r\n\r\n',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_time_all','frm_time_sel',2,1,1,1,'form','noclear','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_time_sel','cde_glb',7,1,6,1,'g_code',NULL,'global $thisform_select_emp_passwd, $select_emp_passwd, $thisform_select_emp_id, $select_emp_id, $glb_emp_grp;\r\nfix_global(\"thisform_select_emp_id\", \"select_emp_id\", \"NOXQS_DB\", \"select emp.emp_id as k, emp.emp_id as v from emp, emp_grp where emp.emp_id = emp_grp.emp_id and emp_grp.grp_id = \'$glb_emp_grp\' order by emp.emp_id\", \"k\");\r\n',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_time_sel','btn_select',18,3,6,1,'button','Select','',NULL,'NONE',NULL,'fix_POST(\"thisform_select_emp_id\", \"select_emp_id\");\r\nfix_POST(\"thisform_select_emp_passwd\", \"select_emp_passwd\");\r\n','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_chk_all','cde_cal',3,1,1,2,'code',NULL,'global $sess, $currYear, $currMonth, $startDay, $stopDay;\r\nfix_GET(\"currYear\");\r\nfix_GET(\"currMonth\");\r\nfix_GET(\"startDay\");\r\nfix_GET(\"stopDay\");\r\n$sess->register(\"currYear\");\r\n$sess->register(\"currMonth\");\r\n$sess->register(\"startDay\");\r\n$sess->register(\"stopDay\");\r\n$Calendar = new Calendar;\r\n$Calendar -> mkCalendar ($currYear, $currMonth, $startDay, $stopDay);\r\n\r\n',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_time_sel','cde_loc',1,1,6,1,'code',NULL,'\r\nglobal $currYear, $currMonth, $startDay, $stopDay;\r\n\r\n$thisform_select_start_date = $startDay . \"/\" . $currMonth . \"/\" . $currYear;\r\n$thisform_select_stop_date = $stopDay . \"/\" . $currMonth . \"/\" . $currYear;\r\n',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_time_sel','lbl_pass',1,3,6,1,'label','Password',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_time_sel','select_emp_passwd',7,3,10,1,'password',NULL,NULL,'','NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_time_sel','lbl_emp',1,2,6,1,'label','Emp.',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_one','lbl_pass',1,4,6,1,'label','Password',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_emp_one','emp_passwd',7,4,10,1,'password',NULL,NULL,'','NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_time_sel','cde_tot',1,4,26,1,'code',NULL,'global $perm, $select_emp_id, $select_emp_passwd, $select_start_date, $select_stop_date;\r\n$xdb = new DB_DATA;\r\n$xdb->query(\"select * from emp where emp_id = \'$select_emp_id\' \");\r\n$xdb->next_record();\r\nif( $select_emp_passwd == $xdb->f(\"emp_passwd\") || $perm->have_perm(\"editor\")) {\r\n	list($sday,$smonth,$syear) = explode(\"/\",$thisform_select_start_date);\r\n	list($eday,$emonth,$eyear) = explode(\"/\",$thisform_select_stop_date);\r\n	$select_start_date = str_pad($syear, 4, \"0\", STR_PAD_LEFT) . \"-\" . str_pad($smonth, 2, \"0\", STR_PAD_LEFT) . \"-\" . str_pad($sday, 2, \"0\", STR_PAD_LEFT) . \"00:00:00\";\r\n	$select_stop_date =  str_pad($eyear, 4, \"0\", STR_PAD_LEFT) . \"-\" . str_pad($emonth, 2, \"0\", STR_PAD_LEFT) . \"-\" . str_pad($eday, 2, \"0\", STR_PAD_LEFT) . \"23:59:59\";\r\n	$xdb->query(\"select \r\n			reg_start, \r\n			reg_stop, \r\n			truncate((UNIX_TIMESTAMP(reg_stop) - UNIX_TIMESTAMP(reg_start)) / 60, 0) as diff,\r\n			reg_activity\r\n		     from\r\n			reg left join keytable on reg.reg_activity = keytable.key_code and keytable.key_table = \'NOTPAID\'\r\n		     where\r\n			reg_stop - reg_start > 0 and\r\n			emp_id = \'$select_emp_id\' and\r\n			reg_start >= \'$select_start_date\' and \r\n			reg_start <= \'$select_stop_date\' and\r\n			isnull(keytable.key_code)\");\r\n	$total = 0;\r\n	while($xdb->next_record()) {\r\n		$total = $total + $xdb->f(\"diff\");\r\n	}\r\n	$totu = intval($total / 60);\r\n	$totm = $total - $totu * 60;\r\n	echo \"<FONT SIZE=+2 COLOR=#000000>\" . cdate($select_start_date) . \" - \" . cdate($select_stop_date) . \" </FONT>\";\r\n	echo \"<FONT SIZE=+5 COLOR=#000000> \" . $totu . \":\" . str_pad($totm, 2, \"0\", STR_PAD_LEFT) . \"</FONT>\";\r\n	$brw = &new Browse(\"brw_reg_mgr\");\r\n	$brw->get_data();\r\n	$sql = \"select * from reg where reg_type = \'U\' and emp_id = \'$select_emp_id\' and reg_start >= \'$select_start_date\' and reg_start <= \'$select_stop_date\' order by reg_start desc\";\r\n	$brw->set_query($sql, 20);\r\n	$brw->set_field_pri_key(\"\", \"\");\r\n	echo $brw->show();\r\n} else {\r\n	echo \"<H1><FONT COLOR=#000000>Name/Password?</FONT></H1>\";\r\n}\r\n$xdb->restore_db();\r\n',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_controle','frm_selemp_mgr',1,1,1,1,'form','noclear','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selemp_mgr','lbl_ord_code',1,5,6,1,'label','Order',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selemp_mgr','select_ord_code',7,5,10,1,'input',NULL,NULL,'','NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_controle','brw_controle',1,2,1,1,'browse',NULL,NULL,NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_add','lbl_desc',1,7,10,1,'label','Description',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_add','reg_desc',11,7,20,1,'input',NULL,NULL,'','NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod_one','lbl_desc',1,6,6,1,'label','Description',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod_one','reg_desc',7,6,20,1,'input',NULL,NULL,'','NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','lbl_desc',1,10,6,1,'label','Description',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','reg_desc',7,10,20,1,'input',NULL,NULL,'','NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','lbl_desc',1,9,6,1,'label','Description',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','reg_desc',7,9,20,1,'input',NULL,NULL,'','NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mgr_add','cde_fix_data',1,1,6,1,'code',NULL,'global $sess, $thisform_emp_id;\r\n$sess->unregister(\"thisform_ord_code\");\r\n$thisform_reg_dstart = cdate($db->f(\"reg_start\"));\r\n$thisform_reg_tstart = ctime($db->f(\"reg_start\"));\r\n$thisform_reg_dstop = cdate($db->f(\"reg_stop\"));\r\n$thisform_reg_tstop = ctime($db->f(\"reg_stop\"));\r\n\r\n$thisform_emp_id = $db->f(\"emp_id\");\r\n$thisform_reg_tstart=$thisform_reg_tstop;\r\n$thisform_reg_tstop=\"\";',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_chk_all','cde_brw',1,2,2,4,'code',NULL,'global $currYear, $currMonth, $startDay, $stopDay;\r\nglobal $select_emp_id, $select_start_date, $select_stop_date, $brw_reg_mgr_prikey;\r\n\r\nif( isset($_GET[\"brw_reg_mgr_prikey\"]) ) {\r\n	$brw_reg_mgr_prikey=$_GET[\"brw_reg_mgr_prikey\"];\r\n}\r\n$sess->register(\"brw_reg_mgr_prikey\");\r\n\r\n$thisform_select_start_date = $startDay . \"/\" . $currMonth . \"/\" . $currYear;\r\n$thisform_select_stop_date = $stopDay . \"/\" . $currMonth . \"/\" . $currYear;\r\n\r\n$xdb = new DB_DATA;\r\nlist($sday,$smonth,$syear) = explode(\"/\",$thisform_select_start_date);\r\nlist($eday,$emonth,$eyear) = explode(\"/\",$thisform_select_stop_date);\r\n$select_start_date = str_pad($syear, 4, \"0\", STR_PAD_LEFT) . \"-\" . str_pad($smonth, 2, \"0\", STR_PAD_LEFT) . \"-\" . str_pad($sday, 2, \"0\", STR_PAD_LEFT) . \"00:00:00\";\r\n$select_stop_date =  str_pad($eyear, 4, \"0\", STR_PAD_LEFT) . \"-\" . str_pad($emonth, 2, \"0\", STR_PAD_LEFT) . \"-\" . str_pad($eday, 2, \"0\", STR_PAD_LEFT) . \"23:59:59\";\r\n\r\n$xdb->query(\"select \r\n		reg_start, \r\n		reg_stop, \r\n		truncate((UNIX_TIMESTAMP(reg_stop) - UNIX_TIMESTAMP(reg_start)) / 60, 0) as diff,\r\n		reg_activity\r\n		from\r\n		reg left join keytable on reg.reg_activity = keytable.key_code and keytable.key_table = \'NOTPAID\'\r\n		where\r\n		reg_stop - reg_start > 0 and\r\n		emp_id = \'$select_emp_id\' and\r\n		reg_start >= \'$select_start_date\' and \r\n		reg_start <= \'$select_stop_date\' and\r\n		isnull(keytable.key_code)\");\r\n$total = 0;\r\nwhile($xdb->next_record()) {\r\n	$total = $total + $xdb->f(\"diff\");\r\n}\r\n$totu = intval($total / 60);\r\n$totm = $total - $totu * 60;\r\necho \"<FONT SIZE=+2 COLOR=#000000>\" . cdate($select_start_date) . \" - \" . cdate($select_stop_date) . \" </FONT>\";\r\necho \"<FONT SIZE=+5 COLOR=#000000> \" . $totu . \":\" . str_pad($totm, 2, \"0\", STR_PAD_LEFT) . \"</FONT>\";\r\n\r\n\r\n\r\n$brw = &new Browse(\"brw_reg_mgr\");\r\n$brw->set_field_pri_key(\"reg_id\", \"brw_reg_mgr_prikey\");\r\n$brw->get_data();\r\n$sql = \"select * from reg where reg_type = \'U\' and emp_id = \'$select_emp_id\' and reg_start >= \'$select_start_date\' and reg_start <= \'$select_stop_date\' $brw_cond order by reg_start desc\";\r\n$brw->set_query($sql, 40);\r\necho $brw->show();\r\n$xdb->restore_db();\r\n',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_chk_all','frm_reg_mod',3,3,1,1,'form','edit','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_chk_all','cde_space',3,4,1,1,'code',NULL,'echo \"<br><br><br><br><br>\";\r\necho \"<br><br><br><br><br>\";\r\necho \"<br><br><br><br><br>\";\r\necho \"<br><br><br><br><br>\";\r\necho \"<br><br><br><br><br>\";\r\necho \"<br><br><br><br><br>\";\r\necho \"<br><br><br><br><br>\";\r\necho \"<br><br><br><br><br>\";\r\n',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_chk_all','frm_selemp_mgr',1,1,1,1,'form','noclear','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_filter','rep_search',1,1,12,1,'input',NULL,NULL,'','SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_filter','code_search',13,1,1,1,'g_code',NULL,'global $sess;\r\nif( isset($_POST[\"thisform_rep_search\"]) ) {\r\n	$thisform_rep_search=$_POST[\"thisform_rep_search\"];\r\n	$brw_report_all_pos = 0;\r\n}\r\n$sess->register(\"thisform_rep_search\");\r\nif( ! empty($thisform_rep_search) ) {\r\n	$report_all_filter = \"where name like \'%$thisform_rep_search%\'\";\r\n} else {\r\n	$report_all_filter = \"\";\r\n}',NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_all','report_filter',1,1,1,1,'form','noclear','',NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_all','report_all',1,2,1,3,'browse',NULL,NULL,NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_one','lbl_name',1,1,6,1,'label','Name',NULL,NULL,'SDS','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_one','name',7,1,10,1,'value',NULL,NULL,'','SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_all','report_one',2,1,2,2,'form','edit','',NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_one','report_col',1,8,6,1,'browse',NULL,NULL,NULL,'NONE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_one','lbl_database',18,1,6,1,'label','Database',NULL,NULL,'SDS','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_one','db',25,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_one','lbl_report',1,4,15,1,'label','Report SQL',NULL,NULL,'SDS','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_one','sql',1,5,52,3,'edit',NULL,NULL,NULL,'SDS',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_one','btn_save',54,1,6,1,'button','Save','update report set \r\ndb = \'$thisform_db\', \r\nperm = \'$thisform_perm\',\r\ntitle = \'$thisform_title\', \r\nsql = \'$thisform_sql\' where\r\nname = \'$report_all_prikey\'',NULL,'SDS',NULL,'','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_one','lbl_perm',1,3,10,1,'label','Permission',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_one','perm',11,3,15,1,'option','perm','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','width',8,4,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','lbl_fieldname',1,3,5,1,'label','Fieldname',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','lbl_header',1,2,5,1,'label','Header',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','header',8,2,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','lbl_width',1,4,5,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','fieldname',8,3,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','lbl_align',1,5,5,1,'label','Align',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','align',8,5,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','lbl_columnorder',1,1,7,1,'label','Order',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','columnorder',8,1,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_newcol','btn_new',19,1,5,1,'button','New','insert into report_detail (\r\nname, \r\ncolumnorder, \r\nheader, \r\nfieldname, \r\nwidth, \r\nalign) values (\r\n\'$report_all_prikey\', \'$thisform_columnorder\', \r\n\'$thisform_header\', \r\n\'$thisform_fieldname\', \r\n\'$thisform_width\', \r\n\'$thisform_align\')','','SDS',NULL,'global $sess;\r\n$report_col_prikey = $thisform_columnorder;\r\n$sess->register(\"report_col_prikey\");','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_all','report_newcol',3,4,1,1,'form','edit','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','btn_save',47,1,6,1,'button','Save','update report_detail set \r\ncolumnorder = \'$thisform_columnorder\', \r\nheader = \'$thisform_header\', \r\nwidth = \'$thisform_width\', \r\nfieldname = \'$thisform_fieldname\', \r\nalign = \'$thisform_align\', \r\nfieldcode = \'$thisform_fieldcode\' \r\nwhere name = \'$report_all_prikey\' and \r\ncolumnorder = \'$report_col_prikey\'','','SDS',NULL,'global $sess;\r\n$report_col_prikey = $thisform_columnorder;\r\n$sess->register(\"report_col_prikey\");\r\n','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','fieldname',26,2,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','btn_delete',47,2,6,1,'button','Delete','delete from report_detail  where name = \'$report_all_prikey\' and columnorder = \'$report_col_prikey\'','','SDS',NULL,'global $sess;\r\n$db =& new DB_SDS;\r\n$db->query(\"select min(columnorder) as val from report_detail where name = \'$report_all_prikey\'\");\r\n$db->next_record();\r\n$report_col_prikey = $db->f(\"val\");\r\n$sess->register(\"$report_col_prikey\");','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','lbl_align',20,3,5,1,'label','Align',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','align',26,3,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','lbl_fcode',1,3,10,1,'label','Field Code',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','fieldcode',1,4,52,4,'edit',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','width',8,2,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','lbl_fieldname',20,2,5,1,'label','Fieldname',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','lbl_width',1,2,5,1,'label','Width',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','header',26,1,20,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','lbl_header',20,1,5,1,'label','Header',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','columnorder',8,1,10,1,'input',NULL,NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_onecol','lbl_order',1,1,5,1,'label','Order',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_all','report_onecol',2,3,2,1,'form','edit','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_new','lbl_perm',1,3,7,1,'label','Permissions',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_new','lbl_db',1,2,7,1,'label','Database',NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_new','db',8,2,10,1,'input',NULL,NULL,NULL,'SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_new','perm',8,3,20,1,'option','perm','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_new','lbl_sql',1,4,15,1,'label','Report SQL',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_new','lbl_name',1,1,5,1,'label','Name',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_new','name',8,1,10,1,'input','',NULL,'','SDS',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_new','btn_new',25,1,6,1,'button','New','insert into report (\r\nname, \r\ndb,\r\nperm,\r\nsql) values (\r\n\'$thisform_name\', \r\n\'$thisform_db\',\r\n\'$thisform_perm\',\r\n\'$thisform_sql\')','','SDS',NULL,'global $sess;\r\n$report_all_prikey = $thisform_name;\r\n$sess->register(\"report_all_prikey\");','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_new','sql',1,5,30,3,'edit',NULL,NULL,NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_all','report_new',2,4,1,1,'form','edit','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_one','lbl_title',1,2,6,1,'label','Title',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_one','title',7,2,46,1,'input',NULL,NULL,'','NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_rep_dag','btn_overview',1,3,6,1,'button','Overview','',NULL,'NONE',NULL,'global $rep_cond, $sess, $currYear, $currMonth, $startDay, $stopDay, $select_emp_id;\r\n\r\n$select_start_date = str_pad($currYear, 4, \"0\", STR_PAD_LEFT) . \"-\" . str_pad($currMonth, 2, \"0\", STR_PAD_LEFT) . \"-\" . str_pad($startDay, 2, \"0\", STR_PAD_LEFT) . \"00:00:00\";\r\n$select_stop_date =  str_pad($currYear, 4, \"0\", STR_PAD_LEFT) . \"-\" . str_pad($currMonth, 2, \"0\", STR_PAD_LEFT) . \"-\" . str_pad($stopDay, 2, \"0\", STR_PAD_LEFT) . \"23:59:59\";\r\n\r\n$rep_cond = \"\";\r\nif( $select_emp_id . \"x\" != \"x\" ) $rep_cond .=  \" and reg.emp_id = \'$select_emp_id\' \";\r\n$rep_cond .= \" and reg_start >= \'$select_start_date\' and reg_start <= \'$select_stop_date\' \";\r\nob_clean();\r\n$rep =& new Report(\"rep_overview\");\r\n$rep->get_data();\r\n$rep->show();','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_rep_dag','btn_dag',1,1,6,1,'button','Reg Overview','',NULL,'NONE',NULL,'global $rep_cond, $sess, $currYear, $currMonth, $startDay, $stopDay, $select_emp_id;\r\n\r\n$select_start_date = str_pad($currYear, 4, \"0\", STR_PAD_LEFT) . \"-\" . str_pad($currMonth, 2, \"0\", STR_PAD_LEFT) . \"-\" . str_pad($startDay, 2, \"0\", STR_PAD_LEFT) . \"00:00:00\";\r\n$select_stop_date =  str_pad($currYear, 4, \"0\", STR_PAD_LEFT) . \"-\" . str_pad($currMonth, 2, \"0\", STR_PAD_LEFT) . \"-\" . str_pad($stopDay, 2, \"0\", STR_PAD_LEFT) . \"23:59:59\";\r\n\r\n$rep_cond = \"\";\r\nif( $select_emp_id . \"x\" != \"x\" ) $rep_cond .=  \" and reg.emp_id = \'$select_emp_id\' \";\r\n$rep_cond .= \" and reg_start >= \'$select_start_date\' and reg_start <= \'$select_stop_date\' \";\r\nob_clean();\r\n$rep =& new Report(\"dag\");\r\n$rep->get_data();\r\n$rep->show();','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_chk_all','frm_rep_dag',2,1,1,1,'form','noclear','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('report_one','btn_run',54,2,6,1,'button','Run','',NULL,'NONE',NULL,'ob_clean();\r\n$rep =& new Report($report_all_prikey);\r\n$rep->get_data();\r\n$rep->show();\r\n','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_rep_dag','btn_checkreg',1,2,6,1,'button','Check Time Reg','',NULL,'NONE',NULL,'ob_clean();\r\n$rep =& new Report(\"rep_checkreg\");\r\n$rep->get_data();\r\n$rep->show();','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','btn_delete',27,10,6,1,'button','Delete','update reg set \r\nreg_type = \'X\', \r\nmod_updtime = now(),\r\nmod_updusr = \'$glb_usercode\' where \r\nreg_id=\'$brw_reg_mgr_prikey\'',NULL,'NONE',NULL,'$brw_reg_mgr_prikey = \"\";','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mod','cde_glb',17,1,6,1,'g_code',NULL,'global $brw_reg_mgr_prikey;',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mat_all','brw_reg_prd',1,2,1,3,'browse',NULL,NULL,NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selord','ord_code',7,1,6,1,'input',NULL,NULL,NULL,'NONE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selord','btn_sel',13,1,6,1,'button','Select','',NULL,'NONE',NULL,'global $select_ord_code, $sess, $brw_reg_prd_prikey;\r\nfix_POST(\"thisform_ord_code\");\r\n$select_ord_code = $thisform_ord_code;\r\n$sess->register(\"select_ord_code\");\r\n$brw_reg_prd_prikey=0;','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selord','cde_chk',1,2,24,1,'code',NULL,'?><script language=\"JavaScript\">\r\n        <!--\r\n        // Activate the appropriate input form field.\r\n        document.frm_selord.thisform_ord_code.focus();\r\n        // -->\r\n</script>\r\n<?php\r\nglobal $select_ord_code, $brw_cond;\r\nif(!empty($select_ord_code)) {\r\n	$cdb = new DB_DATA();\r\n	$cdb->query(\"select ord_code, ord_name from ord where ord_code = \" . add_s_quotes($select_ord_code) );\r\n	if($cdb->num_rows() >= 1) {\r\n		$cdb->next_record();\r\n		$name = $cdb->f(\"ord_name\");\r\n		echo \"<DIV style=\" . add_quotes(\"white-space:nowrap;\") . \"><FONT SIZE=+5>\" . $name . \"</FONT></DIV>\";\r\n	} else {\r\n		echo \"<DIV style=\" . add_quotes(\"white-space:nowrap;\") . \"><FONT COLOR=#FF0000 SIZE=+5>Order \" . $select_ord_code . \" bestaat niet</FONT></DIV>\";\r\n	}\r\n	$cdb->restore_db();\r\n}\r\n$brw_cond = \" and ord_code = \'$select_ord_code\'\";\r\n',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selord','cde_glb',19,1,6,1,'g_code',NULL,'global $select_ord_code;\r\n$thisform_ord_code = $select_ord_code;\r\n',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mat_all','frm_selord',1,1,2,1,'form','noclear','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mat_add','lbl_mat',1,1,6,1,'label','Material',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mat_add','prd_code',7,1,25,1,'option','','select prd_code as k, prd_desc as v from prd order by prd_desc',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mat_add','lbl_quant',1,2,6,1,'label','Quantity',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mat_add','reg_mat_quant',7,2,6,1,'input',NULL,NULL,NULL,'NONE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mat_add','btn_add',32,1,6,1,'button','Add','insert into reg set reg_type = \'M\', prd_code = \'$thisform_prd_code\', reg_mat_quant = \'$thisform_reg_mat_quant\', ord_code = \'$select_ord_code\'',NULL,'NONE',NULL,'global $glb_usercode;\r\n\r\n$xdb = new DB_DATA();\r\n$xdb->query(\"SELECT LAST_INSERT_ID() as code\");\r\n$xdb->next_record();\r\n$brw_reg_prd_prikey = $xdb->f(\"code\");\r\nupd_mod_cre($glb_usercode, $xdb, \"reg\", \"reg_id\");\r\n$xdb->restore_db();\r\n','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mat_all','frm_reg_mat_add',2,2,1,1,'form','edit','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mat_one','lbl_mat',1,1,6,1,'label','Material',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mat_one','prd_code',7,1,25,1,'option','','select prd_code as k, prd_desc as v from prd order by prd_desc',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mat_one','lbl_quant',1,2,6,1,'label','Quantity',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mat_one','reg_mat_quant',7,2,6,1,'input',NULL,NULL,NULL,'NONE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mat_one','btn_save',32,1,6,1,'button','Save','update reg set \r\nprd_code = \'$thisform_prd_code\', \r\nreg_mat_quant = \'$thisform_reg_mat_quant\' where reg_id = \'$brw_reg_prd_prikey\'',NULL,'NONE',NULL,'','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mat_all','frm_reg_mat_one',2,3,1,1,'form','edit','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_mat_one','btn_delete',32,2,6,1,'button','Delete','delete from reg where reg_id = \'$brw_reg_prd_prikey\'',NULL,'NONE',NULL,'global $brw_reg_prd_prikey;\r\n$brw_reg_prd_prikey=0;\r\n','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_selord','lbl_ord_code',1,1,6,1,'label','Order Code',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_cst_all','brw_reg_dcp',1,2,1,3,'browse',NULL,NULL,NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_cst_all','frm_selord',1,1,2,1,'form','noclear','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_cst_add','lbl_mat',1,1,6,1,'label','Material',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_cst_add','dcp_code',7,1,25,1,'option','','select dcp_code as k, dcp_desc as v from dcp order by dcp_desc',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_cst_add','lbl_quant',1,2,6,1,'label','Quantity',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_cst_add','reg_mat_quant',7,2,6,1,'input',NULL,NULL,NULL,'NONE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_cst_add','btn_add',32,1,6,1,'button','Add','insert into reg set reg_type = \'P\', dcp_code = \'$thisform_dcp_code\', reg_mat_quant = \'$thisform_reg_mat_quant\', ord_code = \'$select_ord_code\'',NULL,'NONE',NULL,'global $glb_usercode;\r\n\r\n$xdb = new DB_DATA();\r\n$xdb->query(\"SELECT LAST_INSERT_ID() as code\");\r\n$xdb->next_record();\r\n$brw_reg_dcp_prikey = $xdb->f(\"code\");\r\nupd_mod_cre($glb_usercode, $xdb, \"reg\", \"reg_id\");\r\n$xdb->restore_db();\r\n','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_cst_all','frm_reg_cst_add',2,2,1,1,'form','edit','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_cst_one','lbl_mat',1,1,6,1,'label','Material',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_cst_one','dcp_code',7,1,25,1,'option','','select dcp_code as k, dcp_desc as v from dcp order by dcp_desc',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_cst_one','lbl_quant',1,2,6,1,'label','Quantity',NULL,NULL,'NONE','',NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_cst_one','reg_mat_quant',7,2,6,1,'input',NULL,NULL,NULL,'NONE',NULL,NULL,NULL,NULL);
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_cst_one','btn_save',32,1,6,1,'button','Save','update reg set \r\ndcp_code = \'$thisform_dcp_code\', \r\nreg_mat_quant = \'$thisform_reg_mat_quant\' where reg_id = \'$brw_reg_dcp_prikey\'',NULL,'NONE',NULL,'','','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_cst_all','frm_reg_cst_one',2,3,1,1,'form','edit','',NULL,'NONE',NULL,NULL,'','');
INSERT INTO form_detail (name, fieldname, posx, posy, width, height, fieldtype, text, sql, pri_key, system, class, code, perms, groups) VALUES ('frm_reg_cst_one','btn_delete',32,2,6,1,'button','Delete','delete from reg where reg_id = \'$brw_reg_dcp_prikey\'',NULL,'NONE',NULL,'global $brw_reg_dcp_prikey;\r\n$brw_reg_dcp_prikey=0;\r\n','','');

--
-- Table structure for table `gallery`
--

DROP TABLE IF EXISTS gallery;
CREATE TABLE gallery (
  name varchar(20) NOT NULL default '',
  title varchar(80) default NULL,
  description text,
  system varchar(10) default 'NONE',
  type varchar(10) default 'public',
  PRIMARY KEY  (name)
) TYPE=MyISAM;

--
-- Dumping data for table `gallery`
--



--
-- Table structure for table `gallery_images`
--

DROP TABLE IF EXISTS gallery_images;
CREATE TABLE gallery_images (
  name varchar(20) NOT NULL default '',
  filename varchar(50) NOT NULL default '',
  system varchar(10) default 'NONE',
  caption text,
  username text,
  ownername text,
  PRIMARY KEY  (name,filename)
) TYPE=MyISAM;

--
-- Dumping data for table `gallery_images`
--



--
-- Table structure for table `groups`
--

DROP TABLE IF EXISTS groups;
CREATE TABLE groups (
  groups varchar(32) NOT NULL default '',
  groupname varchar(32) default '',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (groups)
) TYPE=MyISAM;

--
-- Dumping data for table `groups`
--



--
-- Table structure for table `items`
--

DROP TABLE IF EXISTS items;
CREATE TABLE items (
  name varchar(20) NOT NULL default '',
  plugin varchar(20) default '',
  title varchar(80) default '',
  text text,
  link varchar(200) default NULL,
  perm varchar(30) default '',
  cached char(1) binary NOT NULL default 'N',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (name),
  KEY plugin (plugin)
) TYPE=MyISAM;

--
-- Dumping data for table `items`
--


INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('date','Date','',NULL,'','','N','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('time','Time','',NULL,'','','N','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('logo_itemedit','FormGroup','Edit Widget (Logo)',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('useredit','UserEdit','User Management',NULL,NULL,NULL,'N','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('browse_all','FormGroup','Browse Manipulation',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('login','Login','',NULL,'','','N','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('layout_all','FormGroup','Layout Edit',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('admin','Menu','Administration',NULL,'','supervisor','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('link_itemedit','FormGroup','Edit Widget (Links)',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('siteedit','Menu','Site Edit',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('article','Article','',NULL,'','','N','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('articles_itemedit','FormGroup','Edit Widget (Articles)',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('search','Search','Search',NULL,NULL,NULL,'N','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('art_edit','FormGroup','Edit Articles',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('headsearch','HeadSearch',NULL,NULL,NULL,NULL,'N','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('form_itemedit','FormGroup','Edit Widget (Form)',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('editor_text_itemedit','FormGroup','Edit Widget (Text)',NULL,'','editor','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('gallery','Gallery','Photo Galleries',NULL,NULL,NULL,'N','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('gallery_all','FormGroup','Gallery Management',NULL,NULL,'supervisor','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('text_itemedit','FormGroup','Edit Widget (Text)',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('form_all','FormGroup','Forms Manipulation',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('upd_cache','FormGroup','Update Cache',NULL,NULL,'admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('menu_itemedit','FormGroup','Edit Widget (Menu)',NULL,'','admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('login_stats','FormGroup','Login Statistics',NULL,NULL,'supervisor','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('txt_Debug','Text','Debug All Session Variables','<?php\r\nglobal $sess;\r\n$db = new DB_SDS;\r\n$name = $sess->name;\r\n$id = $sess->id;\r\n$db->query(\"select * from active_sessions where name = \'$name\' and sid = \'$id\'\");\r\n$db->next_record();\r\n$str = base64_decode($db->f(\"val\"));\r\necho ereg_replace(\"; \", \"; <BR>\", $str);\r\n?>',NULL,'admin','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('form_useredit','FormGroup','User Management',NULL,NULL,'user','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('form_group','FormGroup','Group Management',NULL,NULL,'supervisor','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('frm_keytable','FormGroup','Keytable Management',NULL,NULL,'supervisor','Y','KEYTABLE');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('mnu_admin','Menu','App Admin',NULL,NULL,'supervisor','Y','NONE');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('mnu_main','Menu','Main Menu',NULL,NULL,'user','Y','NONE');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('frm_emp','FormGroup','Employee Management',NULL,NULL,'editor','Y','NONE');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('frm_reg','FormGroup','Time Registration',NULL,NULL,'user','Y','NONE');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('frm_reg_mgr_all','FormGroup','Registration Management',NULL,NULL,'user','Y','NONE');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('noxqs_logo','Logo','NOXQS (oslo)','NOXQS (oslo)','images/noxqs_logo_sm.gif','','Y','NONE');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('mnu_edit','Menu','App Edit',NULL,NULL,'editor','Y','NONE');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('frm_keygrp_all','FormGroup','Keytable Grouping',NULL,NULL,'supervisor','Y','NONE');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('rep_all','FormGroup','NOXQS Reporting',NULL,NULL,'supervisor','Y','NONE');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('frm_reg_mat_all','FormGroup','Material Registration',NULL,NULL,'author','Y','NONE');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('frm_time_all','FormGroup','Time Overview',NULL,NULL,'user','Y','NONE');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('mnu_test','Menu','Test menu',NULL,NULL,'supervisor','Y','NONE');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('txt_contr_inp','Text','Controle Input','<a name=\"top\"><a href=\"#down\">einde</a></a>\r\n\r\n<?php\r\nglobal $show;\r\n\r\n$tbl_naam = \"reg\";\r\n$strqry = \"SELECT * FROM $tbl_naam LIMIT 1\";\r\n$db = new DB_SDS;\r\n$db->query(\"USE NOXQS_DB\");\r\n$db->query($strqry);\r\n$db->next_record();\r\n$scrnout = \"<table>\";\r\n$scrnout .= \"<tr>\";\r\n$scrnout .= \"<td valign=top> <font size=1> vb: </font></td>\";\r\n$scrnout .= \"<td valign=top> <font size=1> <b>\" . $db->f(\"ord_code\") . \"</b></font></td>\";\r\n$scrnout .= \"<td valign=top> <font size=1>  \" . $db->f(\"reg_id\") . \" : \" . $db->f(\"emp_id\") . \" ( \" . $db->f(\"reg_type\") . \" ) </font></td>\";\r\n$scrnout .= \"<td valign=top> <font size=1>  \" . $db->f(\"reg_shift\") . \"   </font></td>\";\r\n$scrnout .= \"<td valign=top> <font size=1>  \" . $db->f(\"reg_activity\") . \"   </font></td>\";\r\n$scrnout .= \"<td valign=top> <font size=1>  \" . $db->f(\"reg_workplace\") . \"   </font></td>\";\r\n$scrnout .= \"<td valign=top align=\\\"right\\\"> <font size=1>  cre \" . $db->f(\"reg_start\") . \" - \" . $db->f(\"reg_stop\") . \"  </font></td>\";\r\n$scrnout .= \"<td valign=top align=\\\"right\\\"> <font size=1>  cre \" . $db->f(\"reg_a_start\") . \" - \" . $db->f(\"reg_a_stop\") . \"  </font></td>\";\r\n$scrnout .= \"<td valign=top align=\\\"right\\\"> <font size=1>  cre \" . $db->f(\"mod_crusr\") . \" @ \" . $db->f(\"mod_crtime\") . \"  </font></td>\";\r\n$scrnout .= \"<td valign=top align=\\\"right\\\"> <font size=1>  upd \" . $db->f(\"mod_updusr\") . \" @ \" . $db->f(\"mod_updtime\") . \"  </font></td>\";\r\n$scrnout .= \"</tr>\";\r\n$scrnout .= \"</table>\";\r\necho (\"$scrnout\");\r\n\r\nglobal $Submit;\r\nif ($Submit == \"HaalOp\"){\r\n	reset($_POST);\r\n	$selveld = $_POST[\"veldnaam\"];\r\n	$selval = $_POST[\"waarde\"];\r\n	$ordveld = $_POST[\"vlgorde\"];\r\n	$selektie = stripslashes($selveld.\" = \".$selval);\r\n	$strqry = \"SELECT * FROM $tbl_naam WHERE $selektie ORDER BY $ordveld\";\r\n	echo(\'<font color=\"blue\">\'.\"<b>databank [NOXQS_DB] tabel [$tbl_naam] selektie [$selektie] volgens [$ordveld]</b></font><br>\");\r\n	$db->query($strqry);\r\n	$scrnout = \"<table>\";\r\n	while($db->next_record()) {\r\n		$scrnout .= \"<tr>\";\r\n		$scrnout .= \"<td valign=top> <font size=1> <b>\" . $db->f(\"ord_code\") . \"</b></font></td>\";\r\n		$scrnout .= \"<td valign=top> <font size=1>  \" . $db->f(\"reg_id\") . \" : \" . $db->f(\"emp_id\") . \" ( \" . $db->f(\"reg_type\") . \" ) </font></td>\";\r\n		$scrnout .= \"<td valign=top> <font size=1>  \" . $db->f(\"reg_shift\") . \"   </font></td>\";\r\n		$scrnout .= \"<td valign=top> <font size=1>  \" . $db->f(\"reg_activity\") . \"   </font></td>\";\r\n		$scrnout .= \"<td valign=top> <font size=1>  \" . $db->f(\"reg_workplace\") . \"   </font></td>\";\r\n		$scrnout .= \"<td valign=top align=\\\"right\\\"> <font size=1>  cre \" . $db->f(\"reg_start\") . \" - \" . $db->f(\"reg_stop\") . \"  </font></td>\";\r\n		$scrnout .= \"<td valign=top align=\\\"right\\\"> <font size=1>  cre \" . $db->f(\"reg_a_start\") . \" - \" . $db->f(\"reg_a_stop\") . \"  </font></td>\";\r\n		$scrnout .= \"<td valign=top align=\\\"right\\\"> <font size=1>  cre \" . $db->f(\"mod_crusr\") . \" @ \" . $db->f(\"mod_crtime\") . \"  </font></td>\";\r\n		$scrnout .= \"<td valign=top align=\\\"right\\\"> <font size=1>  upd \" . $db->f(\"mod_updusr\") . \" @ \" . $db->f(\"mod_updtime\") . \"  </font></td>\";\r\n		$scrnout .= \"</tr>\";\r\n	}\r\n	$scrnout .= \"</table>\";\r\n	echo (\"$scrnout\");\r\n}else{\r\n	echo (\"Geen keuze opgegeven;\");\r\n}\r\n\r\n$db->query(\"USE NOXQS\");\r\n\r\n?>\r\n\r\n<i>(waarde getal gewoon, tekst met aanhaling)</i><br>\r\n<form method=\"post\" action=\"<?php echo($_SERVER[\"PHP_SELF\"] . \"?show=$show\");?>\">\r\n  Veld   : <input name=\"veldnaam\" type=\"text\"> ,\r\n  Waarde : <input name=\"waarde\" type=\"text\">\r\n  Volgens: <input name=\"vlgorde\" type=\"text\">\r\n  <input type=\"submit\" name=\"Submit\" value=\"HaalOp\">\r\n  </form>\r\n<br>\r\n <div align=\"center\">\r\n <font size=\"-1\">\r\n <?php\r\n  $datum = date(\"d-m-Y\");\r\n  echo(\" $datum \");\r\n ?>\r\n </font>-\r\n <a name=\"down\"><a href=\"#top\">top</a></a>- <font size=\"-1\" color=\"gray\">versie 20040427 .50\r\n </font></div>\r\n',NULL,'','Y','NONE');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('frm_controle','FormGroup','Registration Controle',NULL,NULL,'admin','Y','NONE');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('frm_reg_chk_all','FormGroup','Registration Overview',NULL,NULL,'editor','Y','NONE');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('report_all','FormGroup','Report Management',NULL,NULL,'supervisor','Y','SDS');
INSERT INTO items (name, plugin, title, text, link, perm, cached, system) VALUES ('frm_reg_cst_all','FormGroup','Cost Registration',NULL,NULL,'author','Y','NONE');

--
-- Table structure for table `layout`
--

DROP TABLE IF EXISTS layout;
CREATE TABLE layout (
  layoutgroup varchar(20) NOT NULL default '',
  layoutorder int(4) NOT NULL default '0',
  layoutparam varchar(40) default '',
  place varchar(20) default '',
  name varchar(20) NOT NULL default '',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (layoutgroup,layoutorder),
  KEY name (name)
) TYPE=MyISAM;

--
-- Dumping data for table `layout`
--


INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('form_all',10,'','middle','form_all','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('link_itemedit',10,'','middle','link_itemedit','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('form_itemedit',10,'','middle','form_itemedit','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('browse_all',10,'','middle','browse_all','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('text_itemedit',10,'','middle','text_itemedit','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('layout_all',10,'','middle','layout_all','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('logo_itemedit',10,'','middle','logo_itemedit','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('useredit',30,'','middle','form_group','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('default',140,NULL,'right','siteedit','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('default',1,'','right','login','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('upd_cache',10,NULL,'middle','upd_cache','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('articles_itemedit',10,'','middle','articles_itemedit','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('art_edit',10,'','middle','art_edit','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('editor_text_itemedit',10,'','middle','editor_text_itemedit','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('default',130,NULL,'right','admin','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('article',10,'','middle','article','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('gallery_all',10,'','middle','gallery_all','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('gallery',10,'','middle','gallery','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('menu_itemedit',10,'','middle','menu_itemedit','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('login_stats',10,'','middle','login_stats','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('debug',10,'','middle','txt_Debug','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('useredit',20,'','middle','form_useredit','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('frm_keytable',10,'','middle','frm_keytable','KEYTABLE');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('default',110,'','right','mnu_admin','NONE');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('default',7,'','right','mnu_main','NONE');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('frm_emp',10,'','middle','frm_emp','NONE');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('frm_reg',10,'','middle','frm_reg','NONE');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('frm_reg_mgr_all',10,'','middle','frm_reg_mgr_all','NONE');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('default',10,'','right','mnu_edit','NONE');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('frm_keygrp_all',10,'','middle','frm_keygrp_all','NONE');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('rep_all',10,'','middle','rep_all','NONE');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('frm_time_all',10,'','middle','frm_time_all','NONE');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('home',10,'','middle','frm_reg','NONE');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('default',120,'','right','mnu_test','NONE');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('txt_contrl_inp',10,'','middle','txt_contr_inp','NONE');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('frm_controle',10,'','middle','frm_controle','NONE');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('default',150,'','header2','noxqs_logo','NONE');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('frm_reg_chk_all',10,'','middle','frm_reg_chk_all','NONE');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('report_all',10,'','middle','report_all','SDS');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('frm_reg_mat_all',10,'','middle','frm_reg_mat_all','NONE');
INSERT INTO layout (layoutgroup, layoutorder, layoutparam, place, name, system) VALUES ('frm_reg_cst_all',10,'','middle','frm_reg_cst_all','NONE');

--
-- Table structure for table `links`
--

DROP TABLE IF EXISTS links;
CREATE TABLE links (
  linkgroup varchar(20) NOT NULL default '',
  name varchar(20) NOT NULL default '',
  description text,
  link text,
  title varchar(40) default '',
  system varchar(10) default 'NONE',
  PRIMARY KEY  (linkgroup,name)
) TYPE=MyISAM;

--
-- Dumping data for table `links`
--



--
-- Table structure for table `login_stats`
--

DROP TABLE IF EXISTS login_stats;
CREATE TABLE login_stats (
  user_id varchar(32) default NULL,
  login_time datetime default NULL,
  system varchar(10) default NULL
) TYPE=MyISAM;

--
-- Dumping data for table `login_stats`
--



--
-- Table structure for table `menuitems`
--

DROP TABLE IF EXISTS menuitems;
CREATE TABLE menuitems (
  name varchar(20) NOT NULL default '',
  menuorder int(4) NOT NULL default '0',
  menutext varchar(80) default '',
  page varchar(250) default NULL,
  param varchar(40) default '',
  level int(2) default NULL,
  system varchar(10) default 'NONE',
  PRIMARY KEY  (name,menuorder)
) TYPE=MyISAM;

--
-- Dumping data for table `menuitems`
--


INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',70,'-',NULL,'default',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',1,'Layout Edit','','layout_all',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',30,'Form Widget Edit','','form_itemedit',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',20,'Text Widget Edit','','text_itemedit',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('admin',20,'User Management','','useredit',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',80,'Update Cache',NULL,'upd_cache',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',5,'-','','default',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',50,'Browse Edit','','browse_all',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',10,'Menu Widget Edit','','menu_itemedit',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',60,'Form Edit','','form_all',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('admin',50,'Gallery Management','','gallery_all',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('admin',30,'Articles Management','','art_edit',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',35,'Logo Widget Edit','','logo_itemedit',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',37,'Articles Widget Edit','','articles_itemedit',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',45,'-','','default',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',39,'Links Widget Edit','','link_itemedit',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('admin',60,'Login Statistics','','login_stats',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('siteedit',90,'Debug','','debug',NULL,'SDS');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('men_supervisor',10,'Keytable Management','','frm_keytable',NULL,'KEYTABLE');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('mnu_admin',10,'Keytable Management','','frm_keytable',NULL,'NONE');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('mnu_main',10,'Time Registration','','frm_reg',NULL,'NONE');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('mnu_admin',20,'Employee Management','','frm_emp',NULL,'NONE');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('mnu_admin',15,'Keytable Grouping','','frm_keygrp_all',NULL,'NONE');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('mnu_edit',10,'Time Registration Mgr','','frm_reg_mgr_all',NULL,'NONE');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('mnu_main',20,'Time Overview','','frm_time_all',NULL,'NONE');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('mnu_test',10,'Control inp','','txt_contrl_inp',NULL,'NONE');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('mnu_test',20,'Controle inp 2','','frm_controle',NULL,'NONE');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('mnu_test',30,'Export ord_code','/noxqs/utils/export.php','default',NULL,'NONE');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('mnu_edit',20,'Time Registration Overview','','frm_reg_chk_all',NULL,'NONE');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('mnu_edit',30,'Material Registration','','frm_reg_mat_all',NULL,'NONE');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('admin',25,'Report Management','','report_all',NULL,'NONE');
INSERT INTO menuitems (name, menuorder, menutext, page, param, level, system) VALUES ('mnu_edit',40,'Cost Registration','','frm_reg_cst_all',NULL,'NONE');

--
-- Table structure for table `report`
--

DROP TABLE IF EXISTS report;
CREATE TABLE report (
  name varchar(20) NOT NULL default '',
  sql text,
  db varchar(20) default NULL,
  system varchar(10) default 'NONE',
  perm varchar(30) default NULL,
  title varchar(250) default NULL,
  PRIMARY KEY  (name)
) TYPE=MyISAM;

--
-- Dumping data for table `report`
--


INSERT INTO report (name, sql, db, system, perm, title) VALUES ('dag','	select\r\n		reg.emp_id,\r\n		emp_firstname,\r\n		emp_lastname,\r\n		reg_shift,\r\n		date_format(reg_start, \'%Y/%m/%d\') as startdate,\r\n		min(reg_start) as start,\r\n		max(reg_stop) as stop\r\n	from\r\n		reg inner join emp on reg.emp_id = emp.emp_id\r\n	where\r\n		reg_type = \'U\' and\r\n		reg_activity != \'PAUSEUNP\'\r\n		$rep_cond\r\n	group by\r\n		reg.emp_id,\r\n		reg_shift,\r\n		startdate\r\n	order by\r\n		reg.emp_id,\r\n		startdate\r\n','%data%','NONE','supervisor','Dag Controle');
INSERT INTO report (name, sql, db, system, perm, title) VALUES ('rep_checkreg','select\r\n	reg.emp_id,\r\n	isnull(emp.emp_id) as null_emp_id,\r\n	emp_firstname,\r\n	emp_lastname,\r\n	reg_shift,\r\n	date_format(reg_start, \'%Y/%m/%d\') as startdate,\r\n	reg_start,\r\n	reg_stop,\r\n	date_format(reg_start, \'%Y/%m/%d %H:%i\') as start,\r\n	date_format(reg_stop, \'%Y/%m/%d %H:%i\') as stop\r\nfrom\r\n	reg left join emp on reg.emp_id = emp.emp_id\r\nwhere\r\n	reg_type = \'U\' and (\r\n		reg_stop < reg_start or\r\n		isnull(emp.emp_id) or\r\n		length(trim(reg.emp_id)) = 0 or\r\n		date_format(reg_start, \'%Y/%m/%d %H:%i\') = date_format(reg_stop, \'%Y/%m/%d %H:%i\')\r\n	)\r\n	$rep_cond\r\norder by\r\n	startdate,\r\n	reg.emp_id\r\n','%data%','NONE','','Time Registration check');
INSERT INTO report (name, sql, db, system, perm, title) VALUES ('rep_overview','select *, date_format(reg_start, \'%Y/%m/%d\') as startdate from reg where reg_type = \'U\' $rep_cond order by emp_id, reg_start','%data%','NONE','supervisor','Time Registration Overview');

--
-- Table structure for table `report_detail`
--

DROP TABLE IF EXISTS report_detail;
CREATE TABLE report_detail (
  name varchar(20) NOT NULL default '',
  fieldname varchar(50) NOT NULL default '',
  header varchar(50) default NULL,
  columnorder int(4) NOT NULL default '0',
  width int(4) default '10',
  align varchar(10) default NULL,
  fieldcode text,
  system varchar(10) default 'NONE',
  fieldsql longtext,
  PRIMARY KEY  (name,columnorder)
) TYPE=MyISAM;

--
-- Dumping data for table `report_detail`
--


INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('dag','emp_id','Emp',10,10,'','','NONE','emp.emp_id');
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('dag','','Name',20,25,'','$res = $db->f(\"emp_firstname\") . \" \" . $db->f(\"emp_lastname\");','NONE',NULL);
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('dag','reg_shift','Shift',30,10,'','','NONE',NULL);
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('dag','','Date',40,11,'','$res = cdate($db->f(\"start\"));','NONE',NULL);
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('dag','','Start',50,7,'','$res = ctime($db->f(\"start\"));','NONE',NULL);
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('dag','','Stop',60,7,'','$res = ctime($db->f(\"stop\"));','NONE',NULL);
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('rep_checkreg','emp_id','Emp',10,10,'',NULL,'NONE',NULL);
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('rep_checkreg','','Name',20,10,'','$res = $db->f(\"emp_firstname\") . \" \" . $db->f(\"emp_lastname\");','NONE',NULL);
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('rep_checkreg','reg_shift','Shift',30,10,'',NULL,'NONE',NULL);
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('rep_checkreg','','Date',40,11,'','$res = cdate($db->f(\"reg_start\"));','NONE',NULL);
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('rep_checkreg','','Start',50,6,'','$res = ctime($db->f(\"reg_start\"));','NONE',NULL);
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('rep_checkreg','','Stop',60,6,'','$res = ctime($db->f(\"reg_stop\"));','NONE',NULL);
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('rep_checkreg','','Error',70,35,'','$res = \"\";\r\nif( $db->f(\"reg_stop\") < $db->f(\"reg_start\") ) $res .= \"Stop < Start \";\r\nif( $db->f(\"null_emp_id\") == 1 ) $res .= \"Unknown Emp\";\r\nif( $db->f(\"emp_id\") . \"x\" == \"x\" ) $res .= \"Empty Emp \";\r\nif( $db->f(\"stop\") == $db->f(\"start\") ) $res .= \"Stop = Start \";\r\n','NONE',NULL);
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('rep_checkreg','','',25,1,'','$res = \" \";','NONE',NULL);
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('rep_overview','emp_id','Emp',10,10,'','','NONE',NULL);
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('rep_overview','','Date',70,13,'','$res = cdate($db->f(\"reg_start\"));','NONE',NULL);
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('rep_overview','','Start',80,8,'','$res = ctime($db->f(\"reg_start\"));','NONE',NULL);
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('rep_overview','','Stop',90,8,'','$res = ctime($db->f(\"reg_stop\"));','NONE',NULL);
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('rep_overview','reg_activity','Activity',50,10,'',NULL,'NONE',NULL);
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('rep_overview','reg_shift','Shift',45,10,'',NULL,'NONE',NULL);
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('rep_overview','reg_workplace','Wrk',55,10,'',NULL,'NONE',NULL);
INSERT INTO report_detail (name, fieldname, header, columnorder, width, align, fieldcode, system, fieldsql) VALUES ('rep_overview','ord_code','Order',60,11,'',NULL,'NONE',NULL);

--
-- Table structure for table `user_group`
--

DROP TABLE IF EXISTS user_group;
CREATE TABLE user_group (
  username varchar(32) default NULL,
  groups varchar(32) default NULL,
  system varchar(10) default 'NONE'
) TYPE=MyISAM;

--
-- Dumping data for table `user_group`
--



--
-- Table structure for table `user_ips`
--

DROP TABLE IF EXISTS user_ips;
CREATE TABLE user_ips (
  username varchar(32) default NULL,
  ip varchar(32) default NULL,
  system varchar(10) default 'NONE'
) TYPE=MyISAM;

--
-- Dumping data for table `user_ips`
--


INSERT INTO user_ips (username, ip, system) VALUES ('wdl','127.0.0.1','NONE');
INSERT INTO user_ips (username, ip, system) VALUES ('wdl','192.168.1.[10-254]','NONE');
INSERT INTO user_ips (username, ip, system) VALUES ('wdl','192.168.1.0/24','NONE');
INSERT INTO user_ips (username, ip, system) VALUES ('maria','192.168.1.[1-100]','NONE');
INSERT INTO user_ips (username, ip, system) VALUES ('maria','127.0.0.1','NONE');

